c#######################################################################
c
c     program Nim_bound (bound.f)
c
c     computes NIMROD-compatible ES potential for complex BC's
c
c     programmed by D. C. Barnes
c     Tibbar Plasma Technologies
c     04/06/17
c
c     converted to callable subroutine
c     04/13/17
c
c#######################################################################
c
      SUBROUTINE bound(a_i,ll_i,g_i,dl_i,k_i,vv_p_i,vv_s_i)
c modules, etc.
      USE glob_m
      USE mesh_m
      USE sten_m
      USE solv_m
c
      IMPLICIT NONE
      INCLUDE 'params.f'
c arguments
      REAL(rn),INTENT(IN)::a_i,ll_i,g_i,dl_i,k_i,vv_p_i,vv_s_i
c local variables
      INTEGER::it
      REAL(rn),DIMENSION(:),ALLOCATABLE::sl
      REAL(rn),DIMENSION(:,:),ALLOCATABLE::phi
      COMPLEX(rn),DIMENSION(:),ALLOCATABLE::zph
c begin
cc      CALL gnup_set('Nbnd',zero)
c get input
      CALL get_glob
      a=a_i; ll=ll_i; g=g_i; dl=dl_i; k=k_i; vv_p=vv_p_i; vv_s=vv_s_i
c make mesh
      CALL get_mesh
c get matrix and rhs
      CALL get_aandb
c solve for potential
      ALLOCATE(sl(n_unk)); sl=0; CALL solve(lapl,rh,sl)
      ALLOCATE(phi(nth+1,nt)); phi=vv_el+RESHAPE(sl,(/nth+1,nt/))
      phi(nth+1,:)=phi(1,:)
cc      CALL gnup_contplot(th,t,phi,nth+1,nt,23,'th','t','phi')
c Fourier transform and dump
      ALLOCATE(zph(nth))
      DO it=1,nt
         zph=phi(:nth,it); CALL four1(zph,nth,1)
         phi(1,it)=REAL(zph(1))
         phi(2:nth:2  ,it)= REAL(zph(2:nth/2+1))
         phi(3:nth+1:2,it)=AIMAG(zph(2:nth/2+1))
      ENDDO
      DEALLOCATE(zph)
c
      OPEN(UNIT=93,FILE='phibnd.dmp',FORM='unformatted')
      WRITE(93) nth,nt
      DO it=1,nt
         WRITE(93)phi(:,it)
      ENDDO
      CLOSE(93)
c terminate
cc      CALL gnup_wrap
      DEALLOCATE(sl,phi)
      WRITE(*,*) 'returning'
      RETURN
      END SUBROUTINE bound
