c#######################################################################
c
c     Nim_bound code suite
c     Copyright by Tibbar Plasma Technologies
c     2017
c
c     Programmed by D. C. Barnes
c     Tibbar Plasma Technologies
c
c#######################################################################
c
c     container for global variables (glob.f)
c
c#######################################################################
c
c     version 1.0 -- 04/06/15
c
c#######################################################################
c
      MODULE glob_m
c
      IMPLICIT NONE
      INCLUDE 'params.f'
      INCLUDE 'priv.f'
c input unit
      INTEGER,PARAMETER::u_glob=11
c input quantities
      INTEGER::mth=7,nt=500,np=10000,it_lim=1000,csr=1
      REAL(rn)::a=0.05,ll=0.3,g=0.05,dl=0.2,k=0.1,vv_p=200.,vv_s=30.
     .         ,eps=1.e-5
c derived variables
      INTEGER::nth
c (compatibility w. Cygnus)
      INTEGER::n_unk
      REAL(rn)::it_tol
c
      CHARACTER(LEN=80)::bs80
c namelist
      NAMELIST /glob/ mth,nt,it_lim,csr
     .               ,a,ll,g,dl,k,vv_p,vv_s
c
      CONTAINS
c
c#######################################################################
c     read global quantities and set some derived quantities
c-----------------------------------------------------------------------
      SUBROUTINE get_glob
c local variables
      INTEGER::i
c begin
cc      OPEN(UNIT=u_glob,FILE='Nim_bound.in')
cc      READ(u_glob,glob)
cc      CLOSE(u_glob)
c theta mesh count
      nth=2**mth
c backspace
      DO i=1,80
         bs80(i:i)=CHAR(8)
      ENDDO
c terminate
      RETURN
      END SUBROUTINE get_glob
c
      END MODULE glob_m
