c#######################################################################
c
c     Nim_bound code suite
c     Copyright by Tibbar Plasma Technologies
c     2017
c
c     Programmed by D. C. Barnes
c     Tibbar Plasma Technologies
c
c#######################################################################
c
c     container for global variables
c
c#######################################################################
c
c     version 1.0 -- 04/06/15
c
c#######################################################################
c
      MODULE global_m
c
      IMPLICIT NONE
      INCLUDE 'params.f'
      INCLUDE 'priv.f'
c input unit
      INTEGER,PARAMETER::u_glob=11
c input quantities
      INTEGER::nr=100,nt=10,np=10000,ndt=100,n_plt=10,n_pc=3,it_lim=20
     .        ,csr=0,n_hist=10,np_plt=0,cs_plt=0
      REAL(rn)::dt0=1.e-10,dtx=3.e-10,strx=0.6,th=0.1
     .         ,r0=0.01,rho=1.,rx=0.1,th0=0.,th1=1.,ph0=-100.
     .         ,vi0=9.8e3,ni0=1.e16,zi=1.,ai=1.,t0=1.,eex=0.
     .         ,rr=100.,eps=1.e-4,t_end=6.e-6,t_plt=1.e-7
c derived variables (compatibility w. Cygnus)
      INTEGER::n_unk
      REAL(rn)::it_tol,dt
c
      CHARACTER(LEN=80)::bs80
c namelist
      NAMELIST /glob/ nr,nt,np,ndt,n_plt,n_pc,it_lim,csr,n_hist
     .               ,np_plt,cs_plt
     .               ,dt0,dtx,strx,th
     .               ,r0,rho,rx,th0,th1,ph0,vi0,ni0,zi,ai,t0,eex
     .               ,rr,eps,t_end,t_plt
c
      CONTAINS
c
c#######################################################################
c     read global quantities and set some derived quantities
c-----------------------------------------------------------------------
      SUBROUTINE get_glob
c local variables
      INTEGER::i
c begin
      OPEN(UNIT=u_glob,FILE='Nim_bound.in')
      READ(u_glob,glob)
      CLOSE(u_glob)
c backspace
      DO i=1,80
         bs80(i:i)=CHAR(8)
      ENDDO
c terminate
      RETURN
      END SUBROUTINE get_glob
c
      END MODULE global_m
