c#######################################################################
c
c     CYGNUS code suite
c     Copyright by Coronado Consulting
c     2015
c
c     Programmed by D. C. Barnes
c     Coronado Consulting
c
c#######################################################################
c
c     sort routines for CutCell
c     this module and the matrix_m module are in file (matrix.f)
c
c#######################################################################
c
c     version 1.0 -- 04/22/15
c
c#######################################################################
c
      MODULE sort_m
c
      IMPLICIT NONE
      INCLUDE 'params.f'
      INCLUDE 'priv.f'
c
      INTERFACE indexx
         MODULE PROCEDURE indexx_1,indexx_2
      END INTERFACE
c
      INTERFACE shuf
         MODULE PROCEDURE shuf_r,shuf_i,shuf_ch
      END INTERFACE
c
      INTERFACE shufl
         MODULE PROCEDURE shuf_s_r,shuf_s_i,shuf_s_ch
      END INTERFACE
c
      CONTAINS
c
c#######################################################################
      FUNCTION shuf_r(a,ord) RESULT(b)
c
c modules
      IMPLICIT NONE
c
c arguments
      REAL(rn),DIMENSION(:),INTENT(IN)::a
      INTEGER,DIMENSION(:),INTENT(IN)::ord
c
c type function
      REAL(rn),DIMENSION(SIZE(a))::b
c
c local variables
      INTEGER::n,i
      REAL(rn),ALLOCATABLE,DIMENSION(:)::tmp
c
c begin subprogram
      n=SIZE(ord)
      ALLOCATE(tmp(n))
      DO i=1,n
         tmp(i)=a(ord(i))
      ENDDO
      b(:n)=tmp
      b(n+1:)=a(n+1:)
      DEALLOCATE(tmp)
c
c terminate subprogram
      RETURN
      END FUNCTION shuf_r
c
c#######################################################################
      FUNCTION shuf_i(a,ord) RESULT(b)
c
c modules
      IMPLICIT NONE
c
c arguments
      INTEGER,DIMENSION(:),INTENT(IN)::a
      INTEGER,DIMENSION(:),INTENT(IN)::ord
c
c type function
      INTEGER,DIMENSION(SIZE(a))::b
c
c local variables
      INTEGER::n,i
      INTEGER,ALLOCATABLE,DIMENSION(:)::tmp
c
c begin subprogram
      n=SIZE(ord)
      ALLOCATE(tmp(n))
      DO i=1,n
         tmp(i)=a(ord(i))
      ENDDO
      b(:n)=tmp
      b(n+1:)=a(n+1:)
      DEALLOCATE(tmp)
c
c terminate subprogram
      RETURN
      END FUNCTION shuf_i
c
c#######################################################################
      FUNCTION shuf_ch(a,ord) RESULT(b)
c
c modules
      IMPLICIT NONE
c
c arguments
      CHARACTER(1),DIMENSION(:),INTENT(IN)::a
      INTEGER,DIMENSION(:),INTENT(IN)::ord
c
c type function
      CHARACTER(1),DIMENSION(SIZE(a))::b
c
c local variables
      INTEGER::n,i
      CHARACTER(1),ALLOCATABLE,DIMENSION(:)::tmp
c
c begin subprogram
      n=SIZE(ord)
      ALLOCATE(tmp(n))
      DO i=1,n
         tmp(i)=a(ord(i))
      ENDDO
      b(:n)=tmp
      b(n+1:)=a(n+1:)
      DEALLOCATE(tmp)
c
c terminate subprogram
      RETURN
      END FUNCTION shuf_ch
c
c#######################################################################
      SUBROUTINE shuf_s_r(a,ord)
c
c modules
      IMPLICIT NONE
c
c arguments
      REAL(rn),DIMENSION(:),INTENT(INOUT)::a
      INTEGER,DIMENSION(:),INTENT(IN)::ord
c
c local variables
      INTEGER::n,i
      REAL(rn),DIMENSION(SIZE(ord))::tmp
c
c begin subprogram
      n=SIZE(ord)
      DO i=1,n
         tmp(i)=a(ord(i))
      ENDDO
      a(:n)=tmp
c
c terminate subprogram
      RETURN
      END SUBROUTINE shuf_s_r
c
c#######################################################################
      SUBROUTINE shuf_s_i(a,ord)
c
c modules
      IMPLICIT NONE
c
c arguments
      INTEGER,DIMENSION(:),INTENT(INOUT)::a
      INTEGER,DIMENSION(:),INTENT(IN)::ord
c
c local variables
      INTEGER::n,i
      INTEGER,DIMENSION(SIZE(ord))::tmp
c
c begin subprogram
      n=SIZE(ord)
      DO i=1,n
         tmp(i)=a(ord(i))
      ENDDO
      a(:n)=tmp
c
c terminate subprogram
      RETURN
      END SUBROUTINE shuf_s_i
c
c#######################################################################
      SUBROUTINE shuf_s_ch(a,ord)
c
c modules
      IMPLICIT NONE
c
c arguments
      CHARACTER(1),DIMENSION(:),INTENT(INOUT)::a
      INTEGER,DIMENSION(:),INTENT(IN)::ord
c
c local variables
      INTEGER::n,i
      CHARACTER(1),DIMENSION(SIZE(ord))::tmp
c
c begin subprogram
      n=SIZE(ord)
      DO i=1,n
         tmp(i)=a(ord(i))
      ENDDO
      a(:n)=tmp
c
c terminate subprogram
      RETURN
      END SUBROUTINE shuf_s_ch
c
c#######################################################################
      SUBROUTINE indexx_1(n,arr,indx)
      INTEGER:: n,indx(n),M,NSTACK
      REAL(rn):: arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER:: i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      REAL(rn):: a
      do 11 j=1,n
        indx(j)=j
11    continue
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 13 j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do 12 i=j-1,l,-1
            if(arr(indx(i)).le.a)goto 2
            indx(i+1)=indx(i)
12        continue
          i=l-1
2         indx(i+1)=indxt
13      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if(arr(indx(l)).gt.arr(indx(ir)))then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l+1)).gt.arr(indx(ir)))then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(l+1)))then
          itemp=indx(l)
          indx(l)=indx(l+1)
          indx(l+1)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l+1)
        a=arr(indxt)
3       continue
          i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
          j=j-1
        if(arr(indx(j)).gt.a)goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       indx(l+1)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in indexx'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END SUBROUTINE indexx_1
c
c#######################################################################
      SUBROUTINE indexx_2(n,arr,indx)
      INTEGER:: n,indx(n),M,NSTACK
      INTEGER:: arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER:: i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      REAL(rn):: a
      do 11 j=1,n
        indx(j)=j
11    continue
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 13 j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do 12 i=j-1,l,-1
            if(arr(indx(i)).le.a)goto 2
            indx(i+1)=indx(i)
12        continue
          i=l-1
2         indx(i+1)=indxt
13      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if(arr(indx(l)).gt.arr(indx(ir)))then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l+1)).gt.arr(indx(ir)))then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(l+1)))then
          itemp=indx(l)
          indx(l)=indx(l+1)
          indx(l+1)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l+1)
        a=arr(indxt)
3       continue
          i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
          j=j-1
        if(arr(indx(j)).gt.a)goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       indx(l+1)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in indexx'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END SUBROUTINE indexx_2
c
      END MODULE sort_m
c#######################################################################
c
c     CYGNUS code suite
c     Copyright by Coronado Consulting
c     2015
c
c     Programmed by D. C. Barnes
c     Coronado Consulting
c
c#######################################################################
c
c     Contains routines to manipulate matrices (matrix.f)
c
c#######################################################################
c
c     03/20/15                Version 1.0
c     08/31/15                Version 1.1
c         added support for row to csr conversion and diagonal handling
c
c#######################################################################
c
      MODULE matrix_m
c
      USE sort_m
      USE serv_m
c
      IMPLICIT NONE
      INCLUDE 'params.f'
      INCLUDE 'priv.f'
c
      TYPE::csr_t
         INTEGER::nel,nrw,of=0
         CHARACTER(LEN=1)::r0
         REAL(rn),DIMENSION(:),POINTER::a=>null(),diag=>null()
         INTEGER,DIMENSION(:),POINTER::ia=>null(),ja=>null()
      END TYPE csr_t
c
      TYPE::rw_t
         INTEGER::n_row
         INTEGER,DIMENSION(:),POINTER::col=>null()
         REAL(rn),DIMENSION(:),POINTER::a=>null()
      END TYPE rw_t
c
      INTERFACE clean
         MODULE PROCEDURE clean_csr,clean_rw1,clean_rwa
      END INTERFACE
c
      INTERFACE rw2csr
         MODULE PROCEDURE rw2csr0,rw2csrx
      END INTERFACE
c
      CONTAINS
c
c#######################################################################
c     "deallocate" csr matrix
c-----------------------------------------------------------------------
      SUBROUTINE clean_csr(mat)
c arguments
      TYPE(csr_t),INTENT(INOUT)::mat
c begin
      IF(ASSOCIATED(mat%ia)) DEALLOCATE(mat%ia)
      IF(ASSOCIATED(mat%ja)) DEALLOCATE(mat%ja)
      IF(ASSOCIATED(mat%a)) DEALLOCATE(mat%a)
      IF(.NOT.ASSOCIATED(mat%diag)) RETURN
      DEALLOCATE(mat%diag)
c terminate
      RETURN
      END SUBROUTINE clean_csr
c
c#######################################################################
c     "deallocate" single row
c-----------------------------------------------------------------------
      SUBROUTINE clean_rw1(rw)
c arguments
      TYPE(rw_t),INTENT(INOUT)::rw
c begin
      IF(ASSOCIATED(rw%a)) DEALLOCATE(rw%a)
      IF(ASSOCIATED(rw%col)) DEALLOCATE(rw%col)
c terminate
      RETURN
      END SUBROUTINE clean_rw1
c
c#######################################################################
c     "deallocate" rows array
c-----------------------------------------------------------------------
      SUBROUTINE clean_rwa(rws)
c arguments
      TYPE(rw_t),DIMENSION(:),INTENT(INOUT)::rws
c local variables
      INTEGER::nrw,irw
c begin
      nrw=SIZE(rws)
      DO irw=1,nrw
         IF(ASSOCIATED(rws(irw)%a)) DEALLOCATE(rws(irw)%a)
         IF(ASSOCIATED(rws(irw)%col)) DEALLOCATE(rws(irw)%col)
      ENDDO
c terminate
      RETURN
      END SUBROUTINE clean_rwa
c
c#######################################################################
c     equivalence statement for two csr matrices
c-----------------------------------------------------------------------
      SUBROUTINE mateq(a,b)
c arguments
      TYPE(csr_t),INTENT(OUT)::a
      TYPE(csr_t),INTENT(IN)::b
c local variables
      INTEGER::nrw,nel
c begin
      CALL clean(a); nrw=b%nrw; a%nrw=nrw; nel=b%nel; a%nel=nel
      a%of=b%of
      ALLOCATE(a%ia(nrw+1),a%ja(nel),a%a(nel))
      a%ia=b%ia; a%ja=b%ja; a%a=b%a
      IF(.NOT.ASSOCIATED(b%diag)) RETURN
      ALLOCATE(a%diag(nrw)); a%diag=b%diag
c terminate
      RETURN
      END SUBROUTINE mateq
c
c#######################################################################
c     transpose of csr matrix
c-----------------------------------------------------------------------
      SUBROUTINE trans(mat)
c arguments
      TYPE(csr_t),INTENT(INOUT)::mat
c local variables
      INTEGER::nrw,nel,irw,l1,l2,l,col,nrow
      TYPE(rw_t),DIMENSION(:),POINTER::rows
c begin
      nrw=mat%nrw; nel=mat%nel
      ALLOCATE(rows(nrw)); rows(:)%n_row=0
c count elements
      DO irw=1,nrw
         l1=mat%ia(irw); l2=mat%ia(irw+1)-1
         DO l=l1,l2
            col=mat%ja(l); rows(col)%n_row=rows(col)%n_row+1
         ENDDO
      ENDDO
c allocate space
      DO irw=1,nrw
         nrow=rows(irw)%n_row
         ALLOCATE(rows(irw)%col(nrow),rows(irw)%a(nrow))
      ENDDO
c fill rows = cols
      rows(:)%n_row=0
      DO irw=1,nrw
         l1=mat%ia(irw); l2=mat%ia(irw+1)-1
         DO l=l1,l2
            col=mat%ja(l); nrow=rows(col)%n_row+1; rows(col)%n_row=nrow
            rows(col)%col(nrow)=irw+mat%of; rows(col)%a(nrow)=mat%a(l)
         ENDDO
      ENDDO
c convert to csr
      CALL clean(mat); CALL rw2csr0(rows,mat)
c clean up
      CALL clean(rows); DEALLOCATE(rows)
c terminate
      RETURN
      END SUBROUTINE trans
c
c#######################################################################
c     add two csr matrices
c-----------------------------------------------------------------------
      SUBROUTINE matsum(a,b,sm)
c arguments
      TYPE(csr_t),INTENT(IN)::a,b
      TYPE(csr_t),INTENT(INOUT)::sm
c local variables
      INTEGER::nrw,irw,la1,la2,la,lb1,lb2,lb
      TYPE(rw_t),DIMENSION(:),POINTER::rows
      TYPE(rw_t),POINTER::r
c begin -- make improper matrix
      nrw=a%nrw; CALL clean(sm)
      IF(b%nrw/=nrw) CALL bomb("don't know how to add these matrices")
      IF(a%of/=b%of) CALL bomb("don't know how to add these matrices")
      ALLOCATE(rows(nrw))
cc$OMP PARALLEL DO PRIVATE(la1,la2,la,lb1,lb2,lb,r)
      DO irw=1,nrw
         la1=a%ia(irw); la2=a%ia(irw+1)-1; la=MAX(la2-la1+1,0)
         lb1=b%ia(irw); lb2=b%ia(irw+1)-1; lb=MAX(lb2-lb1+1,0)
         r=>rows(irw); r%n_row=la+lb
         ALLOCATE(r%a(la+lb),r%col(la+lb))
         IF(la>0) THEN
            r%a(:la)=a%a(la1:la2); r%col(:la)=a%ja(la1:la2)
         ENDIF
c
         IF(lb>0) THEN
            r%a(la+1:)=b%a(lb1:lb2); r%col(la+1:)=b%ja(lb1:lb2)
         ENDIF
c
         IF(la==0) CYCLE; IF(lb==0) CYCLE
         CALL properrow(irw,r)
      ENDDO
cc$OMP END PARALLEL DO
      CALL rw2csr(rows,sm); CALL clean(rows); DEALLOCATE(rows)
c fix diagonal
      IF(.NOT.ASSOCIATED(a%diag).AND..NOT.ASSOCIATED(b%diag)) RETURN
      ALLOCATE(sm%diag(nrw)); sm%diag=0
      IF(ASSOCIATED(a%diag)) sm%diag=sm%diag+a%diag
      IF(ASSOCIATED(b%diag)) sm%diag=sm%diag+b%diag
c terminate
      RETURN
      END SUBROUTINE matsum
c
c#######################################################################
c     "increment" csr matrix
c-----------------------------------------------------------------------
      SUBROUTINE pluseq(a,b)
c arguments
      TYPE(csr_t),INTENT(INOUT)::a
      TYPE(csr_t),INTENT(IN)::b
c local variables
      TYPE(csr_t)::work
c begin
      CALL matsum(a,b,work); CALL mateq(a,work); CALL clean(work)
c terminate
      RETURN
      END SUBROUTINE pluseq
c
c#######################################################################
c     matrix vector product -- csr storage
c-----------------------------------------------------------------------
      SUBROUTINE matvec(mat,vec,mvec)
c arguments
      TYPE(csr_t),INTENT(IN)::mat
      REAL(rn),DIMENSION(:),INTENT(IN)::vec
      REAL(rn),DIMENSION(:),INTENT(INOUT)::mvec
c local variables
      INTEGER::nrw,irw,i1,i2,irof
c begin
      nrw=mat%nrw; mvec=0
c$OMP PARALLEL DO PRIVATE(irof,i1,i2)
      DO irw=1,nrw
         irof=irw+mat%of; i1=mat%ia(irw); i2=mat%ia(irw+1)-1
         mvec(irof)=SUM(mat%a(i1:i2)*vec(mat%ja(i1:i2)))
      ENDDO
c$OMP END PARALLEL DO
c terminate
      RETURN
      END SUBROUTINE matvec
c
c#######################################################################
c     multiply two CSR matrices
c-----------------------------------------------------------------------
      SUBROUTINE matmat(a,b,pr)
c arguments
      TYPE(csr_t),INTENT(IN)::a,b
      TYPE(csr_t),INTENT(INOUT)::pr
c local variables
      INTEGER::nrw,iel,irw,l1,l2,l,jrw,m1,m2,m
      TYPE(rw_t),DIMENSION(:),POINTER::rows
      TYPE(rw_t),POINTER::r
c begin -- size
      nrw=a%nrw; ALLOCATE(rows(nrw))
      DO irw=1,nrw
         iel=0
         l1=a%ia(irw); l2=a%ia(irw+1)-1
         DO l=l1,l2
            jrw=a%ja(l)-b%of; m1=b%ia(jrw); m2=b%ia(jrw+1)-1
            DO m=m1,m2
               iel=iel+1
            ENDDO
         ENDDO
         r=>rows(irw); r%n_row=iel; ALLOCATE(r%a(iel),r%col(iel))
      ENDDO
c
c$OMP PARALLEL DO PRIVATE(iel,r,l1,l2,jrw,m1,m2)
      DO irw=1,nrw
         iel=0; r=>rows(irw)
         l1=a%ia(irw); l2=a%ia(irw+1)-1
         DO l=l1,l2
            jrw=a%ja(l)-b%of; m1=b%ia(jrw); m2=b%ia(jrw+1)-1
            DO m=m1,m2
               iel=iel+1; r%a(iel)=a%a(l)*b%a(m)
               r%col(iel)=b%ja(m)
            ENDDO
         ENDDO
         CALL properrow(irw,r)
      ENDDO
c$OMP END PARALLEL DO
      CALL rw2csr(rows,pr); CALL clean(rows); DEALLOCATE(rows)
c fix diagonal
      IF(.NOT.ASSOCIATED(a%diag).AND..NOT.ASSOCIATED(b%diag)) RETURN
      ALLOCATE(pr%diag(nrw)); pr%diag=0
      DO irw=1,nrw
         IF(pr%ia(irw+1)<=pr%ia(irw)) CYCLE
         pr%diag(irw)=pr%a(pr%ia(irw))
      ENDDO
c terminate
      RETURN
      END SUBROUTINE matmat
c
c#######################################################################
c     add diagonal to csr matrix
c     base diagonal stored with matrix
c----------------------------------------------------------------------
      SUBROUTINE pluseqd(mat,diag)
c arguments
      TYPE(csr_t),INTENT(INOUT)::mat
      REAL(rn),DIMENSION(:),INTENT(IN)::diag
c local variables
      INTEGER::nrw,irw,irof
c begin
      IF(.NOT.ASSOCIATED(mat%diag))
     .     CALL bomb("can't do +=diag on this matrix")
      nrw=mat%nrw
      DO irw=1,nrw
         IF(mat%ia(irw+1)<=mat%ia(irw)) CYCLE
         irof=irw+mat%of
         mat%a(mat%ia(irw))=mat%diag(irw)+diag(irof)
      ENDDO
c terminate
      RETURN
      END SUBROUTINE pluseqd
c
c#######################################################################
c     make row proper
c-----------------------------------------------------------------------
      SUBROUTINE properrow(irw,rw)
c arguments
      INTEGER,INTENT(IN)::irw
      TYPE(rw_t),INTENT(INOUT)::rw
c local variables
      INTEGER::n,ij,c,i,cs
      REAL(rn)::as
      INTEGER,DIMENSION(1)::l
      INTEGER,DIMENSION(:),ALLOCATABLE::col,cc,indx
      REAL(rn),DIMENSION(:),ALLOCATABLE::a,aa
c begin -- check for trivial case
      IF(rw%n_row==0) RETURN
c find discrete column values and sum
      n=rw%n_row; ALLOCATE(a(n),col(n),indx(n))
      CALL indexx(n,rw%col,indx)
      col=shuf(rw%col,indx); a=shuf(rw%a,indx)
      ij=0; c=0; ALLOCATE(aa(n),cc(n))
      DO i=1,n
         IF(a(i)==zero) CYCLE
         IF(col(i)/=c) THEN
            ij=ij+1; c=col(i); cc(ij)=c; aa(ij)=a(i)
         ELSE
            aa(ij)=aa(ij)+a(i)
         ENDIF
      ENDDO
      rw%n_row=ij; rw%a(:ij)=aa(:ij); rw%col(:ij)=cc(:ij)
c diagonal first
      DO i=2,ij
         IF(rw%col(i)/=irw) CYCLE
         as=rw%a(1); rw%a(1)=rw%a(i); rw%a(i)=as
         cs=rw%col(1); rw%col(1)=rw%col(i); rw%col(i)=cs
      ENDDO
c clean up
      DEALLOCATE(a,col,aa,cc,indx)
c terminate
      RETURN
      END SUBROUTINE properrow
c
c#######################################################################
c     convert matrix from from rw to csr type
c     vanilla version
c-----------------------------------------------------------------------
      SUBROUTINE rw2csr0(rw,csr)
c arguments
      TYPE(rw_t),DIMENSION(:),POINTER,INTENT(IN)::rw
      TYPE(csr_t),INTENT(INOUT)::csr
c local variables
      INTEGER::nrw,nel,i,iel,j
      LOGICAL::diag
c begin
      diag=ASSOCIATED(csr%diag); CALL clean(csr)
      nrw=SIZE(rw); csr%nrw=nrw; nel=SUM(rw(:)%n_row); csr%nel=nel
      csr%of=0
      ALLOCATE(csr%ia(nrw+1),csr%ja(nel),csr%a(nel))
c$OMP PARALLEL DO
      DO i=1,nrw
         CALL properrow(i,rw(i))
      ENDDO
c$OMP END PARALLEL DO
      iel=0
      DO i=1,nrw
         csr%ia(i)=iel+1
         DO j=1,rw(i)%n_row
            iel=iel+1; csr%ja(iel)=rw(i)%col(j); csr%a(iel)=rw(i)%a(j)
         ENDDO
      ENDDO
      csr%ia(nrw+1)=iel+1
c diagonal?
      IF(diag) ALLOCATE(csr%diag(nrw))
      IF(.NOT.ASSOCIATED(csr%diag)) RETURN
      csr%diag=0
      DO i=1,nrw
         IF(csr%ia(i)==csr%ia(i+1)) CYCLE
         csr%diag(i)=csr%a(csr%ia(i))
      ENDDO
c terminate
      RETURN
      END SUBROUTINE rw2csr0
c
c#######################################################################
c     convert matrix from from rw to csr type
c     mask/frame version
c-----------------------------------------------------------------------
      SUBROUTINE rw2csrx(rw,csr,mask,frame)
c arguments
      TYPE(rw_t),DIMENSION(:),POINTER,INTENT(IN)::rw
      TYPE(csr_t),INTENT(INOUT)::csr
      LOGICAL,DIMENSION(:),INTENT(IN)::mask
      TYPE(csr_t),DIMENSION(3),INTENT(OUT),OPTIONAL::frame
c local variables
      INTEGER::nrw,i,iel,ie1,ie2,ie3,j,cl
      REAL(rn)::a
      LOGICAL::diag,dgfrm
c begin
      diag=ASSOCIATED(csr%diag)
      IF(PRESENT(frame)) dgfrm=ASSOCIATED(frame(3)%diag); 
      CALL clean(csr)
      nrw=SIZE(rw); csr%nrw=nrw; IF(PRESENT(frame)) frame(:)%nrw=nrw
      csr%of=0; IF(PRESENT(frame)) frame(:)%of=0
c$OMP PARALLEL DO
      DO i=1,nrw
         CALL properrow(i,rw(i))
      ENDDO
c$OMP END PARALLEL DO
      iel=0; ie1=0; ie2=0; ie3=0
      DO i=1,nrw
         DO j=1,rw(i)%n_row
            cl=rw(i)%col(j)
            IF(mask(i)) THEN
               IF(mask(cl)) THEN
                  iel=iel+1
               ELSEIF(PRESENT(frame)) THEN
                  ie2=ie2+1
               ENDIF
            ELSEIF(PRESENT(frame)) THEN
               IF(mask(cl)) THEN
                  ie1=ie1+1
               ELSE
                  ie3=ie3+1
               ENDIF
            ENDIF
         ENDDO
      ENDDO
c
      ALLOCATE(csr%ia(nrw+1),csr%ja(iel),csr%a(iel))
      csr%nel=iel
      IF(PRESENT(frame)) THEN
         ALLOCATE(frame(1)%ia(nrw+1),frame(1)%ja(ie1),frame(1)%a(ie1)
     .           ,frame(2)%ia(nrw+1),frame(2)%ja(ie2),frame(2)%a(ie2)
     .           ,frame(3)%ia(nrw+1),frame(3)%ja(ie3),frame(3)%a(ie3))
         frame(1)%nel=ie1; frame(2)%nel=ie2; frame(3)%nel=ie3
      ENDIF
      iel=0; ie1=0; ie2=0; ie3=0
      DO i=1,nrw
         csr%ia(i)=iel+1
         IF(PRESENT(frame)) THEN
            frame(1)%ia(i)=ie1+1; frame(2)%ia(i)=ie2+1
            frame(3)%ia(i)=ie3+1
         ENDIF
         DO j=1,rw(i)%n_row
            cl=rw(i)%col(j); a=rw(i)%a(j)
            IF(mask(i)) THEN
               IF(mask(cl)) THEN
                  iel=iel+1; csr%ja(iel)=cl; csr%a(iel)=a
               ELSEIF(PRESENT(frame)) THEN
                  ie2=ie2+1; frame(2)%ja(ie2)=cl; frame(2)%a(ie2)=a
               ENDIF
            ELSEIF(PRESENT(frame)) THEN
               IF(mask(cl)) THEN
                  ie1=ie1+1; frame(1)%ja(ie1)=cl; frame(1)%a(ie1)=a
               ELSE
                  ie3=ie3+1; frame(3)%ja(ie3)=cl; frame(3)%a(ie3)=a
               ENDIF
            ENDIF
         ENDDO
      ENDDO
      csr%ia(nrw+1)=iel+1
      IF(PRESENT(frame)) THEN
         frame(1)%ia(nrw+1)=ie1+1; frame(2)%ia(nrw+1)=ie2+1
         frame(3)%ia(nrw+1)=ie3+1
      ENDIF
c diagonal?
      IF(diag) ALLOCATE(csr%diag(nrw))
      IF(ASSOCIATED(csr%diag)) THEN
         csr%diag=0
         DO i=1,nrw
            IF(csr%ia(i)==csr%ia(i+1)) CYCLE
            csr%diag(i)=csr%a(csr%ia(i))
         ENDDO
      ENDIF
      IF(.NOT.PRESENT(frame)) RETURN
      frame(1)%ia(nrw+1)=ie1+1; frame(2)%ia(nrw+1)=ie2+1
      frame(3)%ia(nrw+1)=ie3+1
      IF(dgfrm) ALLOCATE(frame(3)%diag(nrw))
      IF(.NOT.ASSOCIATED(frame(3)%diag)) RETURN
      frame(3)%diag=0
      DO i=1,nrw
         IF(frame(3)%ia(i)==frame(3)%ia(i+1)) CYCLE
         frame(3)%diag(i)=frame(3)%a(frame(3)%ia(i))
      ENDDO
c terminate
      RETURN
      END SUBROUTINE rw2csrx
c
c#######################################################################
c     invert full spd matrix using row/column CG
c-----------------------------------------------------------------------
      RECURSIVE SUBROUTINE inv_spd(mm,mi)
c arguments
      REAL(rn),DIMENSION(:,:),INTENT(IN)::mm
      REAL(rn),DIMENSION(:,:),INTENT(OUT)::mi
c local variables
      INTEGER,PARAMETER::small_n=400
      INTEGER::nn,i,nh,nhp,ih
      REAL(rn),DIMENSION(:,:),ALLOCATABLE::d1i,d1b,d2i,d2b
c begin
      nn=SIZE(mm,1)
      IF(SIZE(mm,2)/=nn.OR.SIZE(mi,1)/=nn.OR.SIZE(mi,2)/=nn)
     .     CALL bomb('size inconsistency in **inv_spd**')
c bisect matrix
      IF(nn>small_n) THEN
         nh=nn/2; nhp=nn-nh
c$OMP PARALLEL DO
         DO ih=1,2
            SELECT CASE(ih)
            CASE (1)
               ALLOCATE(d2i(nhp,nhp),d1b(nh,nh))
               CALL inv_spd(mm(nh+1:,nh+1:),d2i)
               d1b=mm(:nh,:nh)-matmul(mm(:nh,nh+1:)
     .                               ,matmul(d2i,mm(nh+1:,:nh)))
               CALL inv_spd(d1b,mi(:nh,:nh)); DEALLOCATE(d2i,d1b)
            CASE (2)
               ALLOCATE(d1i(nh,nh),d2b(nhp,nhp))
               CALL inv_spd(mm(:nh,:nh),d1i)
               d2b=mm(nh+1:,nh+1:)-matmul(mm(nh+1:,:nh)
     .                                   ,matmul(d1i,mm(:nh,nh+1:)))
               CALL inv_spd(d2b,mi(nh+1:,nh+1:)); DEALLOCATE(d2b)
            END SELECT
         ENDDO
c$OMP END PARALLEL DO
         mi(:nh,nh+1:)=-matmul(d1i
     .                        ,matmul(mm(:nh,nh+1:),mi(nh+1:,nh+1:)))
         DEALLOCATE(d1i)
         mi(nh+1:,:nh)=TRANSPOSE(mi(:nh,nh+1:))
      ELSE
         DO i=nn,1,-1
            CALL inv_rc(mm,i,mi,nn)
         ENDDO
      ENDIF
c terminate
      RETURN
      END SUBROUTINE inv_spd
c
c#######################################################################
c     find inverse of last row/column in symmetic ll_wk matrix
c-----------------------------------------------------------------------
      SUBROUTINE inv_rc(mm,i,mm_i,nn)
c arguments
      INTEGER,INTENT(IN)::nn,i
      REAL(rn),DIMENSION(nn,nn),INTENT(IN)::mm
      REAL(rn),DIMENSION(nn,nn),INTENT(INOUT)::mm_i
c local variables
      INTEGER::j,l,it
      REAL(rn)::rsmx
      REAL(rn),dimension(i)::ib,res,rd,ad,p,dl
      INTEGER,PARAMETER::itmax=999,nrst=99999
      REAL(rn),PARAMETER::tol=1.e-8
      INTEGER::irst
      REAL(rn)::err,btd,btn,bet,al
c begin -- residual for CG to give unit vector solution
      res=0; res(i)=1
      DO j=i+1,nn
         res=res-mm(:i,j)*mm_i(i,j)
      ENDDO
      ib=0; rsmx=MAX(tol,MAXVAL(ABS(res)))
c iteration
      DO l=1,i
         rd(l)=1/mm(l,l)
      ENDDO
      irst=nrst
c
      DO it=1,itmax
         err=SQRT(SUM(res**2)/i)/rsmx
         IF(err<=tol)  EXIT
c CG adjustment
         ad=-res
c preconditioner
         ad=rd*ad
c start CG
         IF(irst>=nrst)  THEN
            p=0; btd=1; irst=0
         ENDIF
         irst=irst+1
c dot products
         btn=SUM(res*ad); bet=btn/btd; btd=btn
c update p
         p=ad+bet*p
c mat-vec
         dl=MATMUL(mm(:i,:i),p)
c adjust solution and residual
         al=btd/SUM(p*dl)
         ib=ib+al*p; res=res-al*dl
      ENDDO
      IF(it>=itmax) CALL bomb('trouble inverting symm matrix')
      it=MIN(it,itmax)
c save solution
      mm_i(i,:i)=ib; mm_i(:i,i)=ib
c terminate
      RETURN
      END SUBROUTINE inv_rc
c
      END MODULE matrix_m
