c#######################################################################
c
c     Nim_bound code suite
c     Copyright by Tibbar Plasma Technologies
c     2017
c
c     Programmed by D. C. Barnes
c     Tibbar Plasma Technologies
c
c#######################################################################
c
c     get matrix (sten.f)
c
c#######################################################################
c
c     version 1.0 -- 04/06/15
c
c#######################################################################
c
      MODULE sten_m
c
      USE glob_m
      USE mesh_m
      USE matrix_m
c
      IMPLICIT NONE
      INCLUDE 'params.f'
      INCLUDE 'priv.f'
c
      TYPE(csr_t)::lapl
      REAL(rn),DIMENSION(:),ALLOCATABLE::rh
c
      CONTAINS
c
c#######################################################################
c     get matrix and r.h.s.
c-----------------------------------------------------------------------
      SUBROUTINE get_aandb
c local variables
      INTEGER::i_unk,it,ith,i_cut
      REAL(rn)::adt,del
      TYPE(rw_t),DIMENSION(:),POINTER::rows
      TYPE(rw_t),POINTER::rw
c begin -- size of system
      n_unk=(nth+1)*nt; it_tol=eps
c matrix
      ALLOCATE(rows(n_unk)); rows%n_row=0
c 1st, set matrix elements to edge lengths
c     interior matrix
      i_unk=nth+1; adt=a*dth
      DO it=2,nt-1
         DO ith=1,nth
            i_unk=i_unk+1; IF(.NOT.in(ith,it)) CYCLE
            rw=>rows(i_unk); rw%n_row=5; ALLOCATE(rw%col(5),rw%a(5))
            rw%col=(/i_unk,i_unk+1,i_unk+nth+1,i_unk-1,i_unk-nth-1/)
c     periodic boundary
            IF(ith==nth) rw%col(2)=rw%col(2)-nth
            IF(ith==1  ) rw%col(4)=rw%col(4)+nth
            rw%a(2:)=(/adt,dt,adt,dt/)
         ENDDO
         i_unk=i_unk+1
      ENDDO
c cut cell mods
      DO i_cut=1,n_cut
         i_unk=c_i(i_cut)+(nth+1)*(c_j(i_cut)-1); rw=>rows(i_unk)
         IF(c_d(i_cut)=='r') THEN; rw%a(2)=c_de(i_cut)
         ELSEIF(c_d(i_cut)=='u') THEN; rw%a(3)=c_de(i_cut)
         ELSEIF(c_d(i_cut)=='l') THEN; rw%a(4)=c_de(i_cut)
         ELSE; rw%a(5)=c_de(i_cut); ENDIF
         rw%a(1)=-SUM(rw%a(2:))
      ENDDO
c 2nd make matrix elements
      i_unk=nth+1
      DO it=2,nt-1
         DO ith=1,nth
            i_unk=i_unk+1; IF(.NOT.in(ith,it)) CYCLE
            rw=>rows(i_unk)
            rw%a(2)=-1/rw%a(2)/adt; rw%a(4)=-1/rw%a(4)/adt
            rw%a(3)=-1/rw%a(3)/dt ; rw%a(5)=-1/rw%a(5)/dt
            rw%a(1)=-SUM(rw%a(2:))
         ENDDO
         i_unk=i_unk+1
      ENDDO
c r.h.s.
      ALLOCATE(rh(n_unk)); rh=0
c Dirichlet contributions from end boundaries
      i_unk=nth+1;          rh(i_unk+1:i_unk+nth)=-vv_s/dt**2
      i_unk=(nt-2)*(nth+1); rh(i_unk+1:i_unk+nth)= vv_s/dt**2
c Dirichlet contributions from cut cell boundaries
      DO i_cut=1,n_cut
         i_unk=c_i(i_cut)+(nth+1)*(c_j(i_cut)-1)
         rw=>rows(i_unk)
         IF(c_d(i_cut)=='r') THEN; del=rw%a(2)
         ELSEIF(c_d(i_cut)=='u') THEN; del=rw%a(3)
         ELSEIF(c_d(i_cut)=='l') THEN; del=rw%a(4)
         ELSE; del=rw%a(5); ENDIF
         rh(i_unk)=rh(i_unk)-del*c_v(i_cut)
      ENDDO
c make csr matrix
      CALL rw2csr(rows,lapl,RESHAPE(in,(/n_unk/)))
c clean up
      CALL clean(rows); DEALLOCATE(rows)
c terminate
      RETURN
      END SUBROUTINE get_aandb
c
      END MODULE sten_m
