c#######################################################################
c
c     NIMbnd code suite
c     Copyright by Coronado Consulting
c     2017
c
c     Programmed by D. C. Barnes
c     Coronado Consulting
c
c#######################################################################
c
c     physical constants (pcon.f)
c
c#######################################################################
c
c     version 1.0 -- 09/17/16
c
c#######################################################################
c
      MODULE pcon_m
c
      IMPLICIT NONE
      INCLUDE 'params.f'
      INCLUDE 'priv.f'
c physical constants -- electromagnetic
      REAL(rn),PARAMETER::mu0=4.e-7*pi,ep0=8.8542e-12
c thermodynamic
      REAL(rn),PARAMETER::k_b=1.6021892e-19
c electron charge, mass
      REAL(rn),PARAMETER::q_ele=k_b,m_ele=9.1094e-31
c ion mass
      REAL(rn),PARAMETER::m_pro=1.6726e-27,m_ion=2*m_pro
c ionization energy
      REAL(rn),PARAMETER::w_ion_mult=4.
      REAL(rn),PARAMETER::ww_i=13.6*w_ion_mult
c Gamma
      REAL(rn),PARAMETER::gam=5./3.,gm1=gam-1
      REAL(rn),PARAMETER::gme=5./3.,gem1=gme-1
c neutral-neutral elastic cross section
      REAL(rn),PARAMETER::sig_nn=1.e-20
c
      END MODULE pcon_m
