#!MC 700

###########################################################################
##
##
##  MACRO'S WHICH ARE SHOWN ON THE QUICK MACRO PANEL
##
##
###########################################################################

####################################################

$!MacroFunction
   Name="fluxgrid Summary"
$!DRAWGRAPHICS FALSE
$!VarSet |MFBD| = '|$PWD|'
$!VarSet |MFBD2| = '../draw'
$!OPENLAYOUT  "|MFBD2|/fluxgrid.lay"
$!RunMacroFunction "DataFitAll"
$!RunMacroFunction "Fit Other Data"
$!RunMacroFunction "Load Fluxgrid Text"
$!DRAWGRAPHICS TRUE
$!REDRAWALL
$!EndMacroFunction

####################################################

$!MacroFunction
   Name="Stability Profiles"
$!DRAWGRAPHICS FALSE
$!VarSet |MFBD| = '|$PWD|'
$!VarSet |MFBD2| = '../draw'
$!OPENLAYOUT  "|MFBD2|/stability.lay"
$!RunMacroFunction "DataFitAll"
$!RunMacroFunction "Fit Stability Data"
$!DRAWGRAPHICS TRUE
$!REDRAWALL
$!EndMacroFunction

####################################################

$!MacroFunction
   Name="Field Contours"
$!DRAWGRAPHICS FALSE
$!VarSet |MFBD| = '|$PWD|'
$!VarSet |MFBD2| = '../draw'
$!OPENLAYOUT  "|MFBD2|/contour.lay"
$!RunMacroFunction "FitContourFrames"
$!DRAWGRAPHICS TRUE
$!REDRAWALL
$!EndMacroFunction

####################################################

$!MacroFunction
   Name="Field Slices"
$!DRAWGRAPHICS FALSE
$!VarSet |MFBD| = '|$PWD|'
$!VarSet |MFBD2| = '../draw'
$!OPENLAYOUT  "|MFBD2|/slice.lay"
$!RunMacroFunction "DataFitAll"
$!DRAWGRAPHICS TRUE
$!REDRAWALL
$!EndMacroFunction

####################################################

$!MacroFunction
   Name="          "
$!EndMacroFunction

####################################################

$!MacroFunction
   Name=" Fit Selected Frame"
$!WORKSPACEVIEW FITSELECTEDFRAMES
$!EndMacroFunction

######################################################

$!MacroFunction
   Name=" Fit Paper"
$!WORKSPACEVIEW FITPAPER
$!EndMacroFunction

####################################################

$!MacroFunction
   Name=" Data Fit"
$!VIEW DATAFIT
$!EndMacroFunction

####################################################

$!MacroFunction
   Name=" Data Fit All"
$!DRAWGRAPHICS NO
$!RunMacroFunction "DataFitAll"
$!DRAWGRAPHICS YES
$!REDRAWALL
$!EndMacroFunction

####################################################

$!MacroFunction
   Name="           "
$!EndMacroFunction

####################################################

$!MacroFunction
   Name=" Quit "
$!Quit
$!EndMacroFunction

####################################################


###########################################################################
##
##
##  MACRO'S WHICH ARE NOT SHOWN ON THE QUICK MACRO PANEL
##
##
###########################################################################


####################################################

$!MacroFunction
  Name="DataFitAll"
  ShowInMacroPanel = False
## Verify if you have more than one frame
  $!IF |NUMWIN| > 1
    $!VARSET |IFRM| = |NUMWIN|
    $!LOOP |IFRM|
## This takes the last frame and puts it on top
      $!FRAMECONTROL POP
        FRAME = 1
      $!VIEW DATAFIT
    $!ENDLOOP
  $!ENDIF
$!EndMacroFunction

####################################################

$!MacroFunction
  Name="Load Fluxgrid Text"
  ShowInMacroPanel = False
$!FRAMECONTROL POPBYNAME
  NAME="Text"
$!READDATASET  "|MFBD|/1d.dat "
  READDATAOPTION = NEW
  RESETSTYLE = YES
  INCLUDEGEOM = NO
  INCLUDECUSTOMLABELS = NO
  INCLUDEDATA = NO
$!EndMacroFunction
####################################################

$!MacroFunction
  Name= "Fit Other Data"
  ShowInMacroPanel = False
##
$!FRAMECONTROL POPBYNAME
  NAME = "safety factor"
##$!VIEW DATAFIT
$!VIEW ZOOM
   X1 = 0
   Y1 = 0
   X2 = |MAXX|
   Y2 = |MAXY|
##
$!FRAMECONTROL POPBYNAME
  NAME = "F"
#$!VIEW DATAFIT
$!VIEW ZOOM
   X1 = 0
   Y1 = 0
   X2 = |MAXX|
   Y2 = |MAXY|
$!EndMacroFunction

####################################################


$!MacroFunction
  Name= "Fit Stability Data"
  ShowInMacroPanel = False
##
$!FRAMECONTROL POPBYNAME
  NAME = "dideal"
  $!VarSet |MY1| = -10
  $!VarSet |MY2| = 0.1
  $!IF |MAXY| > 0
       $!VarSet |MY2| = |MAXY|
  $!ENDIF
  $!IF |MINY| > |MY1|
       $!VarSet |MY1| = |MINY|
  $!ENDIF
  $!VIEW ZOOM
     X1 = 0
     Y1 = |MY1|
     X2 = 1
     Y2 = |MY2|
##
$!FRAMECONTROL POPBYNAME
  NAME = "dres"
  $!VarSet |MY1| = -10
  $!VarSet |MY2| = 0.1
  $!IF |MAXY| > 0
       $!VarSet |MY2| = |MAXY|
  $!ENDIF
  $!IF |MINY| > |MY1|
       $!VarSet |MY1| = |MINY|
  $!ENDIF
  $!VIEW ZOOM
     X1 = 0
     Y1 = |MY1|
     X2 = 1
     Y2 = |MY2|
##
$!FRAMECONTROL POPBYNAME
  NAME = "dnc"
  $!VarSet |MY1| = -0.1
  $!VarSet |MY2| = 10
  $!IF |MINY| < |MY1|
       $!VarSet |MY1| = |MINY|
  $!ENDIF
  $!IF |MAXY| < |MY2|
       $!VarSet |MY2| = |MAXY|
  $!ENDIF
  $!VIEW ZOOM
     X1 = 0
     Y1 = |MY1|
     X2 = 1
     Y2 = |MY2|
##
$!FRAMECONTROL POPBYNAME
  NAME = "dtot"
  $!VarSet |MY1| = -0.1
  $!VarSet |MY2| = 10
  $!IF |MINY| < |MY1|
       $!VarSet |MY1| = |MINY|
  $!ENDIF
  $!IF |MAXY| < |MY2|
       $!VarSet |MY2| = |MAXY|
  $!ENDIF
  $!VIEW ZOOM
     X1 = 0
     Y1 = |MY1|
     X2 = 1
     Y2 = |MY2|
##
$!FRAMECONTROL POPBYNAME
  NAME = "fcirc"
#$!VIEW DATAFIT
$!VIEW ZOOM
   X1 = 0
   Y1 = 0
   X2 = 1
   Y2 = 1
##
$!FRAMECONTROL POPBYNAME
  NAME = "hegna"
#$!VIEW DATAFIT
$!VIEW ZOOM
   X1 = 0
   Y1 = 0
   X2 = 1
   Y2 = 2
$!EndMacroFunction

####################################################


$!MacroFunction
  Name="FitContourFrames"
  ShowInMacroPanel = False
## Verify if you have more than one frame
  $!IF |NUMWIN| > 1
    $!VARSET |IFRM| = |NUMWIN|
    $!LOOP |IFRM|
## This takes the last frame and puts it on top
      $!FRAMECONTROL POP
        FRAME = 1
      $!VIEW DATAFIT
      $!CONTOURLEVELS RESET
        NUMVALUES = 20
    $!ENDLOOP
  $!ENDIF
$!EndMacroFunction
