/*
 * -- SuperLU routine (version 2.0) --
 * Univ. of California Berkeley, Xerox Palo Alto Research Center,
 * and Lawrence Berkeley National Lab.
 * November 1, 1997
 *
 */
#ifndef __SUPERLU_CNAMES2 /* allow multiple inclusions */
#define __SUPERLU_CNAMES2

/*
 * These macros define how C routines will be called.  ADD_ assumes that
 * they will be called by fortran, which expects C routines to have an
 * underscore postfixed to the name (Suns, and the Intel expect this).
 * NOCHANGE indicates that fortran will be calling, and that it expects
 * the name called by fortran to be identical to that compiled by the C
 * (RS6K's do this).  UPCASE says it expects C routines called by fortran
 * to be in all upcase (CRAY wants this). 
 */

#define ADD_       0
#define NOCHANGE   1
#define UPCASE     2
#define C_CALL     3

#ifdef UpCase
#define F77_CALL_C UPCASE
#endif

#ifdef NoChange
#define F77_CALL_C NOCHANGE
#endif

#ifdef Add_
#define F77_CALL_C ADD_
#endif

#ifndef F77_CALL_C
#define F77_CALL_C ADD_
#endif

#if (F77_CALL_C == ADD_)
/*
 * These defines set up the naming scheme required to have a fortran 77
 * routine call a C routine
 * No redefinition necessary to have following Fortran to C interface:
 *           FORTRAN CALL               C DECLARATION
 *           call dgemm(...)           void dgemm_(...)
 *
 * This is the default.
 */
#endif

#if (F77_CALL_C == UPCASE)
/*
 * These defines set up the naming scheme required to have a fortran 77
 * routine call a C routine 
 * following Fortran to C interface:
 *           FORTRAN CALL               C DECLARATION
 *           call dgemm(...)           void DGEMM(...)
 */
#define c_bridge_dgssvx_    C_BRIDGE_DGSSVX
#define c_bridge_zgssvx_    C_BRIDGE_DGSSVX
#define c_bridge_zgssvx_    C_BRIDGE_DGSSVX
#define c_fortran_dgssv_    C_FORTRAN_DGSSV
#define c_fortran_zgssv_    C_FORTRAN_ZGSSV
#define c_fortran_slugrid_  C_FORTRAN_SLUGRID
#define c_fortran_pdglob_   C_FORTRAN_PDGLOB
#define c_fortran_pzglob_   C_FORTRAN_PZGLOB
#define c_fortran_pdloc_   C_FORTRAN_PDLOC
#define c_fortran_pzloc_   C_FORTRAN_PZLOC
#endif

#if (F77_CALL_C == NOCHANGE)
/*
 * These defines set up the naming scheme required to have a fortran 77
 * routine call a C routine 
 * for following Fortran to C interface:
 *           FORTRAN CALL               C DECLARATION
 *           call dgemm(...)           void dgemm(...)
 */

#define c_bridge_dgssvx_    c_bridge_dgssvx
#define c_bridge_zgssv_     c_bridge_zgssv
#define c_bridge_zgssvx_    c_bridge_zgssvx
#define c_fortran_dgssv_    c_fortran_dgssv
#define c_fortran_zgssv_    c_fortran_zgssv
#define c_fortran_slugrid_  c_fortran_slugrid
#define c_fortran_pdglob_   c_fortran_pdglob
#define c_fortran_pzglob_   c_fortran_pzglob
#define c_fortran_pdloc_   c_fortran_pdloc
#define c_fortran_pzloc_   c_fortran_pzloc
#endif

#endif /* __SUPERLU_CNAMES2 */
