/*
 * -- SuperLU routine (version 2.0) --
 * Univ. of California Berkeley, Xerox Palo Alto Research Center,
 * and Lawrence Berkeley National Lab.
 * November 1, 1997
 *
 */

#ifndef __SUPERLU_ENUM_DEFS /* allow multiple inclusions */
#define __SUPERLU_ENUM_DEFS

/* The supermatrix.h files on different machines have different
 * enum components.  The following definitions facilitate name
 * swapping without changing *.c files.  CRS, U-WI */

#define SLU_2	   0
#define SLU_1	   1

#ifdef SuperLU_2
#define ENUM_NAMES SLU_2
#endif

#ifdef SuperLU_1
#define ENUM_NAMES SLU_1
#endif

#if (ENUM_NAMES == SLU_2)
/*
 * This is the default set following the conventions listed in the
 * SuperLU V. 2 Users' Guide by Demmel, Gilbert and Li, updated March, 2003
 * 
 * The flags all have the SLU_ preface.
 */
#endif

#if (ENUM_NAMES == SLU_1)
/*
 * The following names are used in V. 1.
 */
#define SLU_NC      NC
#define SLU_NR      NR
#define SLU_SC      SC
#define SLU_SR      SR
#define SLU_NCP     NCP
#define SLU_DN      DN
#define SLU_S       _S
#define SLU_D       _D
#define SLU_C       _C
#define SLU_Z       _Z
#define SLU_GE      GE
#define SLU_TRLU    TRLU
#define SLU_TRUU    TRUU
#define SLU_TRL     TRL
#define SLU_TRU     TRU
#define SLU_SYL     SYL
#define SLU_SYU     SYU
#define SLU_HEL     HEL
#define SLU_HEU     HEL
#endif

#endif /* __SUPERLU_ENUM_DEFS */
