!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      SUBROUTINE DAGMG_MUMPS( id )
      USE DAGMG_MUMPS_OOC_MAIN
      USE DAGMG_MUMPS_STRUC_DF
      IMPLICIT NONE
!       matrix in assembled format (ICNTL(5)=0, and ICNTL(18) $\neq$ 3),
      INTERFACE
      SUBROUTINE DAGMG_MUMPS_26( id )
      USE DAGMG_MUMPS_STRUC_DF
      TYPE (DAGMG_MUMPS_STRUC), TARGET :: id
      END SUBROUTINE DAGMG_MUMPS_26
      SUBROUTINE DAGMG_MUMPS_142( id )
      USE DAGMG_MUMPS_STRUC_DF
      TYPE (DAGMG_MUMPS_STRUC), TARGET :: id
      END SUBROUTINE DAGMG_MUMPS_142
      SUBROUTINE DAGMG_MUMPS_301( id )
      USE DAGMG_MUMPS_STRUC_DF
      TYPE (DAGMG_MUMPS_STRUC), TARGET :: id
      END SUBROUTINE DAGMG_MUMPS_301
      SUBROUTINE DAGMG_MUMPS_349(id, LP)
      USE DAGMG_MUMPS_STRUC_DF
      TYPE (DAGMG_MUMPS_STRUC), TARGET, INTENT(IN) :: id
      INTEGER  :: LP
      END SUBROUTINE DAGMG_MUMPS_349
      END INTERFACE
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      INTEGER MASTER, ierr
      PARAMETER( MASTER = 0 )
      TYPE (DAGMG_MUMPS_STRUC) :: id
      INTEGER JOBMIN, JOBMAX, OLDJOB, NRHS_TMP
      INTEGER I, J, MP, LP, MPG
      LOGICAL LANAL, LFACTO, LSOLVE, PROK, FLAG, PROKG
      LOGICAL NOERRORBEFOREPERM
      LOGICAL UNS_PERM_DONE
      INTEGER COMM_SAVE
      INTEGER JOB, N, NZ, NELT
      INTEGER ICNTL20, ICNTL21, ICNTL26
      INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
      NOERRORBEFOREPERM = .FALSE.
      UNS_PERM_DONE = .FALSE.
      JOB  = id%JOB
      N    = id%N
      NZ   = id%NZ
      NELT = id%NELT
      id%INFO(1) = 0
      id%INFO(2) = 0
      IF ( JOB .NE. -1 ) THEN
        LP      = id%ICNTL(1)
        MP      = id%ICNTL(2)
        MPG     = id%ICNTL(3)
        PROK    = ((MP.GT.0).AND.(id%ICNTL(4).GE.3))
        PROKG   = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
        IF ((id%MYID .eq. MASTER) .AND. PROK .AND. (id%ICNTL(5).EQ.0 ) )&
     &       WRITE(MP,'(A,I4,I12,I15)')                                 &
     &       'Entering driver (DMUMPS) WITH JOB, N, NZ =', JOB,N,NZ
        IF ((id%MYID .eq. MASTER).AND. PROK .AND. (id%ICNTL(5).EQ.1 ) ) &
     &       WRITE(MP,'(A,I4,I12,I15)')                                 &
     &      'Entering driver (DMUMPS) WITH JOB, N, NELT =', JOB,N,NELT
      ELSE
        MPG = 0
        PROK = .FALSE.
        PROKG = .FALSE.
        LP = 6
        MP = 6
      END IF
      CALL AGMG_MPF_INITIALIZED( FLAG, ierr )
      IF ( .NOT. FLAG ) THEN
        WRITE(LP,990)
  990 FORMAT(' Error in DMUMPS initialization: MPI is not running.')
        id%INFO(1) = -23
        id%INFO(2) =   0
        GOTO 500
      END IF
       COMM_SAVE = id%COMM
       CALL AGMG_SETIERR( ierr )
      CALL AGMG_COPY(JOB,JOBMIN,1,AGMG_MPF_INTEGER,ierr)
      CALL AGMG_COPY(JOB,JOBMAX,1,AGMG_MPF_INTEGER,ierr)
      IF ( JOBMIN .NE. JOBMAX ) THEN
        id%INFO(1) = -3
        id%INFO(2) = JOB
        GOTO 499
      END IF
      IF ( JOB .EQ. -1 ) THEN
        id%INFO(1)=0
        id%INFO(2)=0
        IF ( id%KEEP(40) .EQ. 1 - 456789 .OR.                           &
     &      id%KEEP(40) .EQ. 2 - 456789 .OR.                            &
     &      id%KEEP(40) .EQ. 3 -456789 ) THEN
        IF ( id%N > 0 ) THEN
          id%INFO(1)=-3
          id%INFO(2)=JOB
        ENDIF
        ENDIF
        CALL AGMG_SETIERR2( id%MYID, IERR)
        CALL AGMG_MUMPS_276( id%ICNTL,                                       &
     &                       id%INFO,                                   &
     &                       id%COMM, id%MYID )
        IF ( id%INFO(1) .LT. 0 ) THEN
           IF (id%KEEP(201).GT.0) THEN
             CALL DAGMG_MUMPS_587(id, ierr)
           ENDIF
           GOTO 499
        ENDIF
        CALL DAGMG_MUMPS_163( id )
        GOTO 500
      END IF
      IF ( JOB .EQ. -2 ) THEN
        id%KEEP(40)= -2 - 456789
        CALL DAGMG_MUMPS_136( id )
        GOTO 500
      END IF
      IF ((JOB.LT.1).OR.(JOB.GT.6)) THEN
        id%INFO(1) = -3
        id%INFO(2) = JOB
        GOTO 499
      END IF
      IF (id%MYID.EQ.MASTER) THEN
        IF ( id%ICNTL(18) .eq. 0 ) THEN
        IF ((N.LE.0).OR.((N+N+N)/3.NE.N)) THEN
          id%INFO(1) = -16
          id%INFO(2) = N
        END IF
        IF (id%ICNTL(5).EQ.0) THEN
          IF (NZ.LE.0) THEN
            id%INFO(1) = -2
            id%INFO(2) = NZ
          END IF
        ELSE
          IF (NELT.LE.0) THEN
            id%INFO(1) = -24
            id%INFO(2) = NELT
          END IF
        ENDIF
        END IF
        IF ( (id%KEEP(46).EQ.0).AND.(id%NPROCS.LE.1) )                  &
     &     THEN
          id%INFO(1) = -21
          id%INFO(2) = id%NPROCS
        ENDIF
      END IF
      CALL AGMG_MUMPS_276( id%ICNTL,                                         &
     &                    id%INFO,                                      &
     &                    id%COMM, id%MYID )
      IF ( id%INFO(1) .LT. 0 ) GOTO 499
      LANAL  = .FALSE.
      LFACTO = .FALSE.
      LSOLVE = .FALSE.
      IF ((JOB.EQ.1).OR.(JOB.EQ.4).OR.                                  &
     &    (JOB.EQ.6))               LANAL  = .TRUE.
      IF ((JOB.EQ.2).OR.(JOB.EQ.4).OR.                                  &
     &    (JOB.EQ.5).OR.(JOB.EQ.6)) LFACTO = .TRUE.
      IF ((JOB.EQ.3).OR.(JOB.EQ.5).OR.                                  &
     &    (JOB.EQ.6))               LSOLVE = .TRUE.
      IF (MP.GT.0) CALL DAGMG_MUMPS_349(id, MP)
      OLDJOB = id%KEEP( 40 ) + 456789
      IF ( LANAL ) THEN
        IF ( OLDJOB .EQ. 0 .OR. OLDJOB .GT. 3 .OR. OLDJOB .LT. -1 ) THEN
          id%INFO(1) = -3
          id%INFO(2) = JOB
          GOTO 499
        END IF
        IF ( OLDJOB .GE. 2 ) THEN
          IF (associated(id%IS)) THEN
            DEALLOCATE  (id%IS)
            NULLIFY     (id%IS)
          END IF
          IF (associated(id%S)) THEN
            DEALLOCATE  (id%S)
            NULLIFY     (id%S)
          END IF
        END IF
      END IF
      IF ( LFACTO ) THEN
         IF ( OLDJOB .LT. 1 .and. .NOT. LANAL ) THEN
            id%INFO(1) = -3
            id%INFO(2) = JOB
            GOTO 499
         END IF
      END IF
      IF ( LSOLVE ) THEN
         IF ( OLDJOB .LT. 2 .AND. .NOT. LFACTO ) THEN
            id%INFO(1) = -3
            id%INFO(2) = JOB
            GOTO 499
         END IF
      END IF
      NOERRORBEFOREPERM =.TRUE.
      UNS_PERM_DONE=.FALSE.
      IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
        IF ( id%JOB .EQ. 2 .OR. id%JOB .EQ. 5 .OR.                      &
     &       (id%JOB .EQ. 3 .AND. (id%ICNTL(10) .NE.0 .OR.              &
     &        id%ICNTL(11).NE. 0))) THEN
          UNS_PERM_DONE = .TRUE.
          ALLOCATE(UNS_PERM_INV(id%N),stat=ierr)
          IF (ierr .GT. 0) THEN
              id%INFO(1)=-13
              id%INFO(2)=id%N
              IF (id%ICNTL(1) .GT.  0 .AND. id%ICNTL(4) .GE.1) THEN
                WRITE(id%ICNTL(2),99993)
              END IF
            GOTO 510
          ENDIF
          DO I = 1, id%N
            UNS_PERM_INV(id%UNS_PERM(I))=I
          END DO
          DO I = 1, id%NZ
            J = id%JCN(I)
            IF (J.LE.0.OR.J.GT.id%N) CYCLE
            id%JCN(I)=UNS_PERM_INV(J)
          END DO
          DEALLOCATE(UNS_PERM_INV)
        END IF
      END IF
        CALL AGMG_MUMPS_276( id%ICNTL,                                       &
     &                    id%INFO,                                      &
     &                    id%COMM, id%MYID )
        IF ( id%INFO( 1 ) .LT. 0 ) GO TO 499
      IF (LANAL) THEN
        id%KEEP(40)=-1 -456789
        IF (id%MYID.EQ.MASTER) THEN
          id%INFOG(7) = -9999
          id%INFOG(23) = 0
          id%INFOG(24) = 1
          IF (associated(id%IS1)) DEALLOCATE(id%IS1)
          IF ( id%ICNTL(5) .EQ. 0 ) THEN
             IF ( id%SYM .NE. 1                                         &
     &            .AND. (                                               &
     &            (id%ICNTL(6) .NE. 0 .AND. id%ICNTL(7) .NE.1)          &
     &            .OR.                                                  &
     &            id%ICNTL(12) .NE. 1) ) THEN
                id%MAXIS1 = 11 * N
             ELSE
              id%MAXIS1 = 10 * N
             END IF
          ELSE
            id%MAXIS1 = 6 * N + 2 * NELT + 2
          ENDIF
          ALLOCATE( id%IS1(id%MAXIS1), stat=ierr )
          IF (ierr.gt.0) THEN
            id%INFO(1) = -7
            id%INFO(2) = id%MAXIS1
            IF ( LP .GT.0 )                                             &
     &      WRITE(LP,*) 'Problem in allocating work array for analysis.'
            GO TO 100
          END IF
          IF ( associated( id%PROCNODE ) )                              &
     &          DEALLOCATE( id%PROCNODE )
          ALLOCATE( id%PROCNODE(id%N), stat=ierr )
          IF (ierr.gt.0) THEN
            id%INFO(1) = -7
            id%INFO(2) = id%N
            IF ( LP .GT. 0 ) THEN
              WRITE(LP,*) 'Problem in allocating work array PROCNODE'
            END IF
            GOTO 100
          END IF
          id%PROCNODE(1:id%N) = 0
          IF ( id%ICNTL(5) .NE. 0 ) THEN
            IF ( associated( id%ELTPROC ) )                             &
     &            DEALLOCATE( id%ELTPROC )
            ALLOCATE( id%ELTPROC(id%NELT), stat=ierr )
            IF (ierr.gt.0) THEN
              id%INFO(1) = -7
              id%INFO(2) = id%NELT
              IF ( LP .GT. 0 ) THEN
                WRITE(LP,*) 'Problem in allocating work array ELTPROC'
              END IF
              GOTO 100
            END IF
          END IF
          IF ( id%ICNTL(5) .EQ. 0 ) THEN
            id%NA_ELT=0
            IF ( id%ICNTL(18).EQ.0 ) THEN
             IF ( .not. associated( id%IRN ) ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 1
             ELSE IF ( size( id%IRN ) < id%NZ ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 1
             ELSE IF ( .not. associated( id%JCN ) ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 2
             ELSE IF ( size( id%JCN ) < id%NZ ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 2
             END IF
            END IF
            IF ( id%INFO( 1 ) .eq. -22 ) THEN
              IF (LP.GT.0) WRITE(LP,*)                                  &
     &           'Error in analysis: IRN/JCN badly allocated.'
            END IF
          ELSE
            IF ( .not. associated( id%ELTPTR ) ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 1
            ELSE IF ( size( id%ELTPTR ) < id%NELT+1 ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 1
            ELSE IF ( .not. associated( id%ELTVAR ) ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 2
            ELSE
              id%LELTVAR = id%ELTPTR( id%NELT+1 ) - 1
              IF ( size( id%ELTVAR ) < id%LELTVAR ) THEN
                id%INFO(1) = -22
                id%INFO(2) = 2
              ELSE
                id%NA_ELT = 0
                IF ( id%KEEP(50) .EQ. 0 ) THEN
                  DO I = 1,NELT
                    J = id%ELTPTR(I+1) - id%ELTPTR(I)
                    J = (J * J)
                    id%NA_ELT = id%NA_ELT + J
                  ENDDO
                ELSE
                  DO I = 1,NELT
                    J = id%ELTPTR(I+1) - id%ELTPTR(I)
                    J = (J * (J+1))/2
                    id%NA_ELT = id%NA_ELT + J
                  ENDDO
                ENDIF
              ENDIF
            END IF
            IF ( id%INFO( 1 ) .eq. -22 ) THEN
              IF (LP.GT.0) WRITE(LP,*)                                  &
     &           'Error in analysis: ELTPTR/ELTVAR badly allocated.'
            END IF
          ENDIF
  100   CONTINUE
        END IF
        CALL AGMG_MUMPS_276( id%ICNTL,                                       &
     &                    id%INFO,                                      &
     &                    id%COMM, id%MYID )
        IF ( id%INFO( 1 ) .LT. 0 ) GO TO 499
         id%KEEP(52) = id%ICNTL(8)
         IF ( id%KEEP(52) .GT. 8 .OR. id%KEEP(52).LT.-2)                &
     &        id%KEEP(52) = 77
         IF ((id%KEEP(52).EQ.77).AND.(id%SYM.EQ.1)) THEN
           id%KEEP(52) = 0
         ENDIF
         IF ( id%KEEP(52).EQ.77 .OR. id%KEEP(52).LE.-2) THEN
           IF (.not.associated(id%A)) id%KEEP(52) = 0
         ENDIF
         IF(id%KEEP(52) .EQ. -1) id%KEEP(52) = 0
         CALL DAGMG_MUMPS_26( id )
        IF (id%MYID .eq. MASTER) THEN
           IF (id%KEEP(52) .NE. 0) THEN
             id%INFOG(33)=id%KEEP(52)
           ELSE
             id%INFOG(33)=id%ICNTL(8)
           ENDIF
        ENDIF
        IF (id%MYID .eq. MASTER) id%INFOG(24)=id%KEEP(95)
        IF ( id%INFO( 1 ) .LT. 0 ) GO TO 499
        id%KEEP(40) = 1 -456789
      END IF
      IF (LFACTO) THEN
         id%KEEP(40) = 1 - 456789
        IF ( id%MYID .EQ. MASTER ) THEN
           IF (id%KEEP(60).EQ.1) THEN
             IF ( associated( id%SCHUR_CINTERFACE)) THEN
               id%SCHUR=>id%SCHUR_CINTERFACE                            &
     &          (1:id%SIZE_SCHUR*id%SIZE_SCHUR)
             ENDIF
             IF ( .NOT. associated (id%SCHUR)) THEN
              IF (LP.GT.0)                                              &
     &        write(LP,'(A)')                                           &
     &                      ' SCHUR not associated'
              id%INFO(1)=-22
              id%INFO(2)=9
             ELSE IF ( size(id%SCHUR) .LT.                              &
     &                id%SIZE_SCHUR * id%SIZE_SCHUR ) THEN
                IF (LP.GT.0)                                            &
     &          write(LP,'(A)')                                         &
     &                ' SCHUR allocated but too small'
                id%INFO(1)=-22
                id%INFO(2)=9
             END IF
          END IF
          IF ( id%KEEP(55) .EQ. 0 ) THEN
           IF ( id%KEEP(54).eq.0 ) THEN
            IF ( .not. associated( id%A ) ) THEN
              id%INFO( 1 ) = -22
              id%INFO( 2 ) = 4
            ELSE IF ( size( id%A ) < id%NZ ) THEN
              id%INFO( 1 ) = -22
              id%INFO( 2 ) = 4
            END IF
           END IF
          ELSE
            IF ( .not. associated( id%A_ELT ) ) THEN
              id%INFO( 1 ) = -22
              id%INFO( 2 ) = 4
            ELSE
              IF ( size( id%A_ELT ) < id%NA_ELT ) THEN
                id%INFO( 1 ) = -22
                id%INFO( 2 ) = 4
              ENDIF
            END IF
          ENDIF
          CALL AGMG_MUMPS_633(id%KEEP(12),id%ICNTL(14),                      &
     &         id%KEEP(50),id%KEEP(54),id%ICNTL(6),id%ICNTL(8))
          CALL DAGMG_MUMPS_635(N,id%KEEP,id%ICNTL,MPG)
          IF( id%KEEP(52) .EQ. -2 .AND. id%ICNTL(8) .NE. -2 .AND.       &
     &        id%ICNTL(8).NE. 77 ) THEN
             IF ( MPG .GT. 0 ) THEN
                WRITE(MPG,'(A)') ' ** WARNING : SCALING'
                WRITE(MPG,'(A)')                                        &
     &               ' ** scaling already computed during analysis'
                WRITE(MPG,'(A)')                                        &
     &               ' ** keeping the scaling from the analysis'
             ENDIF
          ENDIF
          IF (id%KEEP(52) .NE. -2) THEN
            id%KEEP(52)=id%ICNTL(8)
          ENDIF
          IF ( id%KEEP(52) .GT. 8 .OR. id%KEEP(52).LT.-2)               &
     &    id%KEEP(52) = 77
          IF (id%KEEP(52).EQ.77) THEN
            IF (id%SYM.EQ.1) THEN
              id%KEEP(52) = 0
            ELSE
              id%KEEP(52) = 7
            ENDIF
          ENDIF
          IF( id%KEEP(23) .NE. 0 .AND. id%ICNTL(8) .EQ. -1) THEN
             IF ( MPG .GT. 0 ) THEN
                WRITE(MPG,'(A)') ' ** WARNING : SCALING'
                WRITE(MPG,'(A)')                                        &
     &               ' ** column permutation applied:'
                WRITE(MPG,'(A)')                                        &
     &               ' ** column scaling has to be permuted'
             ENDIF
          ENDIF
          IF ( id%KEEP( 19 ) .ne. 0 .and. id%KEEP( 52 ).ne. 0 ) THEN
            IF ( MPG .GT. 0 ) THEN
              WRITE(MPG,'(A)') ' ** Warning: Scaling not applied.'
              WRITE(MPG,'(A)') ' ** (incompatibility with null space)'
            END IF
            id%KEEP(52) = 0
          END IF
          IF ( id%KEEP(60) .ne. 0 .and. id%KEEP(52) .ne. 0 ) THEN
            id%KEEP(52) = 0
            IF ( MPG .GT. 0 .AND. id%ICNTL(8) .NE. 0 ) THEN
              WRITE(MPG,'(A)') ' ** Warning: Scaling not applied.'
              WRITE(MPG,'(A)') ' ** (incompatibility with Schur)'
            END IF
          END IF
          IF (id%KEEP(54) .NE. 0 .AND.                                  &
     &        id%KEEP(52).NE.7 .AND. id%KEEP(52).NE.8 .AND.             &
     &        id%KEEP(52) .NE. 0 ) THEN
             id%KEEP(52) = 0
             IF ( MPG .GT. 0 .and. id%ICNTL(8) .ne. 0 ) THEN
               WRITE(MPG,'(A)')                                         &
     &         ' ** Warning: This scaling option not available'
               WRITE(MPG,'(A)') ' ** for distributed matrix entry'
             END IF
          END IF
          IF ( id%KEEP(50) .NE. 0 ) THEN
             IF ( id%KEEP(52).ne.  1 .and.                              &
     &            id%KEEP(52).ne. -1 .and.                              &
     &            id%KEEP(52).ne.  0 .and.                              &
     &            id%KEEP(52).ne.  7 .and.                              &
     &            id%KEEP(52).ne.  8 .and.                              &
     &            id%KEEP(52).ne. -2 .and.                              &
     &            id%KEEP(52).ne. 77) THEN
              IF ( MPG .GT. 0 ) THEN
                WRITE(MPG,'(A)')                                        &
     &  ' ** Warning: Scaling option n.a. for symmetric matrix'
              END IF
              id%KEEP(52) = 0
            END IF
          END IF
          IF (id%KEEP(55) .NE. 0 .AND.                                  &
     &        ( id%KEEP(52) .gt. 0 ) ) THEN
            id%KEEP(52) = 0
            IF ( MPG .GT. 0 ) THEN
              WRITE(MPG,'(A)') ' ** Warning: Scaling not applied.'
              WRITE(MPG,'(A)')                                          &
     &        ' ** (only user scaling av. for elt. entry)'
            END IF
          END IF
          IF ( id%KEEP(52) .eq. -1 ) THEN
            IF ( .not. associated( id%ROWSCA ) ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 5
            ELSE IF ( size( id%ROWSCA ) < id%N ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 5
            ELSE IF ( .not. associated( id%COLSCA ) ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 6
            ELSE IF ( size( id%COLSCA ) < id%N ) THEN
              id%INFO(1) = -22
              id%INFO(2) = 6
            END IF
          END IF
          IF (id%KEEP(52).GT.0 .AND.                                    &
     &        id%KEEP(52) .LE.8) THEN
            IF ( associated(id%COLSCA))                                 &
     &             DEALLOCATE( id%COLSCA )
            IF ( associated(id%ROWSCA))                                 &
     &             DEALLOCATE( id%ROWSCA )
            ALLOCATE( id%COLSCA(N), stat=ierr)
            IF (ierr .GT.0) id%INFO(1)=-13
            ALLOCATE( id%ROWSCA(N), stat=ierr)
            IF (ierr .GT.0) id%INFO(1)=-13
          END IF
          IF (.NOT. associated(id%COLSCA)) THEN
            ALLOCATE( id%COLSCA(1), stat=ierr)
          END IF
          IF (ierr .GT.0) id%INFO(1)=-13
          IF (.NOT. associated(id%ROWSCA))                              &
     &    ALLOCATE( id%ROWSCA(1), stat=ierr)
          IF (ierr .GT.0) id%INFO(1)=-13
          IF ( id%INFO(1) .eq. -13 ) THEN
            IF ( LP .GT. 0 )                                            &
     &      WRITE(LP,*) 'Problems in allocations before facto'
            GOTO 200
          END IF
  200     CONTINUE
        END IF
        IF (id%KEEP(60).EQ.2.OR.id%KEEP(60).EQ.3) THEN
          IF ( id%root%yes ) THEN
            IF ( associated( id%SCHUR_CINTERFACE )) THEN
              id%SCHUR=>id%SCHUR_CINTERFACE                             &
     &          (1:id%SCHUR_LLD*(id%root%SCHUR_NLOC-1)+                 &
     &          id%root%SCHUR_MLOC)
            ENDIF
            IF (id%SCHUR_LLD < id%root%SCHUR_MLOC) THEN
              IF (LP.GT.0) write(LP,*)                                  &
     &          ' SCHUR leading dimension SCHUR_LLD ',                  &
     &          id%SCHUR_LLD, 'too small with respect to',              &
     &          id%root%SCHUR_MLOC
              id%INFO(1)=-30
              id%INFO(2)=id%SCHUR_LLD
            ELSE IF ( .NOT. associated (id%SCHUR)) THEN
              IF (LP.GT.0) write(LP,'(A)')                              &
     &                      ' SCHUR not associated'
              id%INFO(1)=-22
              id%INFO(2)=9
            ELSE IF (size(id%SCHUR) <                                   &
     &          id%SCHUR_LLD*(id%root%SCHUR_NLOC-1)+                    &
     &          id%root%SCHUR_MLOC) THEN
              IF (LP.GT.0) THEN
                write(LP,'(A)')                                         &
     &                      ' SCHUR allocated but too small'
                write(LP,*) id%MYID, ' : Size Schur=',                  &
     &          size(id%SCHUR),                                         &
     &          ' SCHUR_LLD= ', id%SCHUR_LLD,                           &
     &          ' SCHUR_MLOC=', id%root%SCHUR_NLOC,                     &
     &          ' SCHUR_NLOC=', id%root%SCHUR_NLOC
              ENDIF
              id%INFO(1)=-22
              id%INFO(2)= 9
            ELSE
               id%root%SCHUR_LLD=id%SCHUR_LLD
               IF (id%root%SCHUR_NLOC==0) THEN
                 ALLOCATE(id%root%SCHUR_POINTER(1))
               ELSE
                id%root%SCHUR_POINTER=>id%SCHUR
               ENDIF
            ENDIF
          ENDIF
        ENDIF
        CALL AGMG_MUMPS_276( id%ICNTL,                                       &
     &                      id%INFO,                                    &
     &                      id%COMM, id%MYID )
        IF ( id%INFO(1) .LT. 0 ) GO TO 499
        CALL DAGMG_MUMPS_142(id)
        IF (id%MYID .eq. MASTER) id%INFOG(33)=id%KEEP(52)
        IF (id%KEEP(60).EQ.2.OR.id%KEEP(60).EQ.3) THEN
          IF (id%root%yes) THEN
            IF (id%root%SCHUR_NLOC==0) THEN
               DEALLOCATE(id%root%SCHUR_POINTER)
               NULLIFY(id%root%SCHUR_POINTER)
            ELSE
               NULLIFY(id%root%SCHUR_POINTER)
            ENDIF
          ENDIF
        ENDIF
        IF ( id%INFO(1) .LT. 0 ) GO TO 499
        id%KEEP(40) = 2 - 456789
      END IF
      IF (LSOLVE) THEN
        IF (id%MYID .EQ. MASTER) THEN
          ICNTL20 = id%ICNTL(20)
          ICNTL21 = id%ICNTL(21)
          ICNTL26 = id%ICNTL(26)
          IF (ICNTL20 .ne.0.and.ICNTL20.ne.1) ICNTL20=0
          IF (ICNTL21 .ne.0.and.ICNTL21.ne.1) ICNTL21=0
          IF (ICNTL26 .ne.0.and.ICNTL26.ne.1.and.ICNTL26.ne.2) ICNTL26=0
          id%KEEP(221)=ICNTL26
        ENDIF
        CALL AGMG_SETIERR( ierr )
        CALL AGMG_SETIERR( ierr )
        CALL AGMG_SETIERR(                            ierr )
        id%KEEP(40) = 2 -456789
        IF ( id%MYID .EQ. MASTER ) THEN
          IF (ICNTL20 == 0 .OR. ICNTL21==0) THEN
           IF ( .not. associated( id%RHS ) ) THEN
              id%INFO( 1 ) = -22
              id%INFO( 2 ) = 7
              GOTO 333
           ELSE IF (id%NRHS.EQ.1) THEN
               IF ( size( id%RHS ) < id%N ) THEN
                  id%INFO( 1 ) = -22
                  id%INFO( 2 ) = 7
                  GOTO 333
               ENDIF
           ELSE IF (id%LRHS < id%N)                                     &
     &            THEN
                  id%INFO( 1 ) = -26
                  id%INFO( 2 ) = id%LRHS
                  GOTO 333
           ELSE IF                                                      &
     &     (size(id%RHS)<(id%NRHS*id%LRHS-id%LRHS+id%N))                &
     &            THEN
                  id%INFO( 1 ) = -22
                  id%INFO( 2 ) = 7
                  GOTO 333
           END IF
          ENDIF
          IF (ICNTL20 == 1) THEN
            IF ( .not. associated(id%RHS_SPARSE) )THEN
              id%INFO(1)=-22
              id%INFO(2)=10
              GOTO 333
            ENDIF
            IF ( .not. associated(id%IRHS_SPARSE) )THEN
              id%INFO(1)=-22
              id%INFO(2)=11
              GOTO 333
            ENDIF
            IF ( .not. associated(id%IRHS_PTR) )THEN
              id%INFO(1)=-22
              id%INFO(2)=12
              GOTO 333
            ENDIF
            IF (size(id%IRHS_PTR) < id%NRHS + 1) THEN
              id%INFO(1)=-22
              id%INFO(2)=12
              GOTO 333
            END IF
            IF (id%IRHS_PTR(id%NRHS + 1).ne.id%NZ_RHS+1) THEN
              id%INFO(1)=-27
              id%INFO(2)=id%IRHS_PTR(id%NRHS+1)
              GOTO 333
            END IF
            IF (id%IRHS_PTR(1).ne.1) THEN
              id%INFO(1)=-28
              id%INFO(2)=id%IRHS_PTR(1)
              GOTO 333
            END IF
            IF (size(id%IRHS_SPARSE) < id%NZ_RHS) THEN
              id%INFO(1)=-22
              id%INFO(2)=11
              GOTO 333
            END IF
            IF (size(id%RHS_SPARSE) < id%NZ_RHS) THEN
              id%INFO(1)=-22
              id%INFO(2)=10
              GOTO 333
            END IF
          ENDIF
          IF ( ICNTL26 == 1 .or. ICNTL26 ==2 ) THEN
            IF ( id%KEEP(60).eq. 0 .or. id%SIZE_SCHUR.EQ.0 ) THEN
              id%INFO(1)=-33
              id%INFO(2)=ICNTL26
              GOTO 333
            ENDIF
            IF ( .NOT. associated( id%REDRHS)) THEN
              id%INFO(1)=-22
              id%INFO(2)=15
              GOTO 333
            ELSE IF (id%NRHS.EQ.1) THEN
              IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
                id%INFO(1)=-22
                id%INFO(2)=15
                GOTO 333
              ENDIF
            ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
              id%INFO(1)=-34
              id%INFO(2)=id%LREDRHS
              GOTO 333
            ELSE IF                                                     &
     &      (size(id%REDRHS)<                                           &
     &         id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)             &
     &      THEN
              id%INFO(1)=-22
              id%INFO(2)=15
              GOTO 333
            ENDIF
          ENDIF
        END IF
        IF (ICNTL21==1) THEN
          IF (id%MYID==MASTER) NRHS_TMP=id%NRHS
          CALL AGMG_SETIERR( ierr )
          IF ( id%MYID .ne. MASTER  .OR.                                &
     &       ( id%MYID .eq. MASTER .AND.                                &
     &               id%KEEP(46) .eq. 1 ) ) THEN
            IF ( id%LSOL_LOC < id%KEEP(89) ) THEN
              id%INFO(1)= -29
              id%INFO(2)= id%LSOL_LOC
            ENDIF
            IF ( .not. associated(id%ISOL_LOC) )THEN
              id%INFO(1)=-22
              id%INFO(2)=13
              GOTO 333
            ENDIF
            IF ( .not. associated(id%SOL_LOC) )THEN
              id%INFO(1)=-22
              id%INFO(2)=14
              GOTO 333
            ENDIF
            IF (id%LSOL_LOC < id%KEEP(89)) THEN
              id%INFO(1)=-29
              id%INFO(2)=id%LSOL_LOC
              GOTO 333
            ENDIF
            IF (size(id%ISOL_LOC) < id%KEEP(89) ) THEN
              id%INFO(1)=-22
              id%INFO(2)=13
              GOTO 333
            END IF
            IF (size(id%SOL_LOC) <                                      &
     &              (NRHS_TMP-1)*id%LSOL_LOC+id%KEEP(89)) THEN
              id%INFO(1)=-22
              id%INFO(2)=14
              GOTO 333
            END IF
          ENDIF
        ENDIF
        IF (id%MYID .NE. MASTER) THEN
          IF (ICNTL20 == 1) THEN
           IF ( associated( id%RHS ) ) THEN
             id%INFO( 1 ) = -22
             id%INFO( 2 ) = 7
             GOTO 333
           END IF
           IF ( associated( id%RHS_SPARSE ) ) THEN
             id%INFO( 1 ) = -22
             id%INFO( 2 ) = 10
             GOTO 333
           END IF
           IF ( associated( id%IRHS_SPARSE ) ) THEN
             id%INFO( 1 ) = -22
             id%INFO( 2 ) = 11
             GOTO 333
           END IF
           IF ( associated( id%IRHS_PTR ) ) THEN
             id%INFO( 1 ) = -22
             id%INFO( 2 ) = 12
             GOTO 333
           END IF
          END IF
        END IF
  333   CONTINUE
        CALL AGMG_MUMPS_276( id%ICNTL,                                       &
     &                      id%INFO,                                    &
     &                      id%COMM, id%MYID )
        IF ( id%INFO(1) .LT. 0 ) GO TO 499
        CALL DAGMG_MUMPS_301(id)
        IF (id%INFO(1).LT.0) GOTO 499
        id%KEEP(40) = 3 -456789
      ENDIF
      IF (MP.GT.0) CALL DAGMG_MUMPS_349(id, MP)
      GOTO 500
  499 PROK  = ((id%ICNTL(1).GT.0).AND.                                  &
     &         (id%ICNTL(4).GE.1))
      IF (PROK) WRITE (id%ICNTL(1),99995) id%INFO(1)
      IF (PROK) WRITE (id%ICNTL(1),99994) id%INFO(2)
  500 CONTINUE
      IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0                  &
     &    .AND. NOERRORBEFOREPERM) THEN
        IF (id%JOB .NE. 3 .OR. UNS_PERM_DONE) THEN
          DO I = 1, id%NZ
            J=id%JCN(I)
            IF (J.LE.0.OR.J.GT.id%N) CYCLE
            id%JCN(I)=id%UNS_PERM(J)
          END DO
        END IF
      END IF
  510 CONTINUE
      CALL DAGMG_MUMPS_300( id%INFO, id%INFOG, id%COMM, id%MYID )
      CALL AGMG_SETIERR( ierr )
      IF (id%MYID.EQ.MASTER.and.MPG.GT.0.and.                           &
     & id%INFOG(1).lt.0) THEN
        WRITE(MPG,'(A,I12)') ' On return from DMUMPS, INFOG(1)=',       &
     &      id%INFOG(1)
        WRITE(MPG,'(A,I12)') ' On return from DMUMPS, INFOG(2)=',       &
     &      id%INFOG(2)
      END IF
       CALL AGMG_SETIERR( ierr )
       id%COMM = COMM_SAVE
      RETURN
99995 FORMAT (' ** ERROR RETURN ** FROM DMUMPS INFO(1)=', I3)
99994 FORMAT (' ** INFO(2)=', I10)
99993 FORMAT (' ** Allocation error: could not permute JCN.')
      END SUBROUTINE DAGMG_MUMPS
      SUBROUTINE DAGMG_MUMPS_300( INFO, INFOG, COMM, MYID )
      IMPLICIT NONE
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      INTEGER INFO(40), INFOG(40), COMM, MYID
      INTEGER TMP1(2),TMP(2)
      INTEGER ROOT, ierr
      INTEGER MASTER
      PARAMETER (MASTER=0)
      IF ( INFO(1) .ge. 0  .and. INFO(2) .ge. 0 ) THEN
        INFOG(1) = INFO(1)
        INFOG(2) = INFO(2)
      ELSE
        INFOG(1) = INFO(1)
        TMP1(1) = INFO(1)
        TMP1(2) = MYID
        CALL AGMG_COPY(TMP1,TMP,1,AGMG_MPF_2INTEGER,ierr )
        INFOG(2) = INFO(2)
        ROOT = TMP(2)
        CALL AGMG_SETIERR( ierr )
        CALL AGMG_SETIERR( ierr )
      END IF
      CALL AGMG_SETIERR( ierr )
      RETURN
      END SUBROUTINE DAGMG_MUMPS_300
      SUBROUTINE DAGMG_MUMPS_349(id, LP)
      USE DAGMG_MUMPS_STRUC_DF
      TYPE (DAGMG_MUMPS_STRUC), TARGET, INTENT(IN) :: id
      INTEGER  :: LP
      INTEGER, POINTER :: JOB
      INTEGER,DIMENSION(:),POINTER::ICNTL
      INTEGER MASTER
      PARAMETER( MASTER = 0 )
      IF (LP.LT.0) RETURN
      JOB=>id%JOB
      ICNTL=>id%ICNTL
      IF (id%MYID.EQ.MASTER) THEN
         SELECT CASE (JOB)
         CASE(1);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),         &
     &          ICNTL(13),ICNTL(18),ICNTL(19),ICNTL(22)
           IF ((ICNTL(6).EQ.5).OR.(ICNTL(6).EQ.6).OR.                   &
     &          (ICNTL(12).NE.1) )  THEN
              WRITE (LP,992) ICNTL(8)
           ENDIF
           IF (id%ICNTL(19).NE.0)                                       &
     &      WRITE(LP,998) id%SIZE_SCHUR
           WRITE (LP,993) ICNTL(14)
         CASE(2);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,992) ICNTL(8)
           WRITE (LP,993) ICNTL(14)
         CASE(3);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,995)                                               &
     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
         CASE(4);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,992) ICNTL(8)
           IF (id%ICNTL(19).NE.0)                                       &
     &      WRITE(LP,998) id%SIZE_SCHUR
           WRITE (LP,993) ICNTL(14)
         CASE(5);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),         &
     &          ICNTL(13),ICNTL(18),ICNTL(19),ICNTL(22)
           WRITE (LP,992) ICNTL(8)
           WRITE (LP,993) ICNTL(14)
           WRITE (LP,995)                                               &
     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
         CASE(6);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),         &
     &          ICNTL(13),ICNTL(18),ICNTL(19),ICNTL(22)
           IF (id%ICNTL(19).NE.0)                                       &
     &      WRITE(LP,998) id%SIZE_SCHUR
           WRITE (LP,992) ICNTL(8)
           WRITE (LP,995)                                               &
     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
           WRITE (LP,993) ICNTL(14)
        END SELECT
      ENDIF
  980 FORMAT (/'***********CONTROL PARAMETERS (ICNTL)**************'/)
  990 FORMAT (                                                          &
     &     'ICNTL(1)   Output stream for error messages        =',I10/  &
     &     'ICNTL(2)   Output stream for diagnostic messages   =',I10/  &
     &     'ICNTL(3)   Output stream for global information    =',I10/  &
     &     'ICNTL(4)   Level of printing                       =',I10)
  991 FORMAT (                                                          &
     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/  &
     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/  &
     &     'ICNTL(7)   Ordering                                =',I10/  &
     &     'ICNTL(12)  LDLT ordering strat ( keep(95) )        =',I10/  &
     &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/  &
     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/  &
     &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/  &
     &     'ICNTL(22)  Out-off-core option (0=Off, >0=ON)      =',I10)
  992 FORMAT (                                                          &
     &     'ICNTL(8)   Scaling strategy                        =',I10)
  993 FORMAT (                                                          &
     &     'ICNTL(14)  Percent of memory increase              =',I10)
  995 FORMAT (                                                          &
     &     'ICNTL(9)   Solve A x=b (1) or A''x = b (else)       =',I10/ &
     &     'ICNTL(10)  Max steps iterative refinement          =',I10/  &
     &     'ICNTL(11)  Error analysis ( 0= off, else=on)       =',I10)
  998 FORMAT (                                                          &
     &     '      Size of SCHUR matrix (SIZE_SHUR)             =',I10)
      END SUBROUTINE DAGMG_MUMPS_349
      SUBROUTINE DAGMG_MUMPS_350(id, LP)
      USE DAGMG_MUMPS_STRUC_DF
      TYPE (DAGMG_MUMPS_STRUC), TARGET, INTENT(IN) :: id
      INTEGER ::LP
      INTEGER, POINTER :: JOB
      INTEGER,DIMENSION(:),POINTER::ICNTL, KEEP
      INTEGER MASTER
      PARAMETER( MASTER = 0 )
      IF (LP.LT.0) RETURN
      JOB=>id%JOB
      ICNTL=>id%ICNTL
      KEEP=>id%KEEP
      IF (id%MYID.EQ.MASTER) THEN
         SELECT CASE (JOB)
         CASE(1);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,991) KEEP(55),KEEP(23),ICNTL(7),KEEP(95),          &
     &          ICNTL(13),KEEP(54),KEEP(60),ICNTL(22)
           IF ((KEEP(23).EQ.5).OR.(KEEP(23).EQ.6))THEN
              WRITE (LP,992) KEEP(52)
           ENDIF
           WRITE (LP,993) KEEP(12)
         CASE(2);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           IF (KEEP(23).EQ.0)THEN
              WRITE (LP,992) KEEP(52)
           ENDIF
           WRITE (LP,993) KEEP(12)
         CASE(3);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,995)                                               &
     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
         CASE(4);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           IF (KEEP(23).NE.0)THEN
              WRITE (LP,992) KEEP(52)
           ENDIF
           WRITE (LP,991) KEEP(55),KEEP(23),ICNTL(7),KEEP(95),          &
     &          ICNTL(13),KEEP(54),KEEP(60),ICNTL(22)
           WRITE (LP,995)                                               &
     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
           WRITE (LP,993) KEEP(12)
         CASE(5);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,991) KEEP(55),KEEP(23),ICNTL(7),KEEP(95),          &
     &          ICNTL(13),KEEP(54),KEEP(60),ICNTL(22)
           IF ((KEEP(23).EQ.5).OR.(KEEP(23).EQ.6)                       &
     &       .OR. (KEEP(23).EQ.7)) THEN
              WRITE (LP,992) KEEP(52)
           ENDIF
           IF (KEEP(23).EQ.0)THEN
              WRITE (LP,992) KEEP(52)
           ENDIF
           WRITE (LP,993) KEEP(12)
         CASE(6);
           WRITE (LP,980)
           WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
           WRITE (LP,991) KEEP(55),KEEP(23),ICNTL(7),KEEP(95),          &
     &          ICNTL(13),KEEP(54),KEEP(60),ICNTL(22)
           IF ((KEEP(23).EQ.5).OR.(KEEP(23).EQ.6)                       &
     &       .OR. (KEEP(23).EQ.7)) THEN
              WRITE (LP,992) KEEP(52)
           ENDIF
           IF (KEEP(23).EQ.0)THEN
              WRITE (LP,992) KEEP(52)
           ENDIF
           WRITE (LP,995)                                               &
     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
           WRITE (LP,993) KEEP(12)
        END SELECT
      ENDIF
  980 FORMAT (/'******INTERNAL VALUE OF PARAMETERS (ICNTL/KEEP)****'/)
  990 FORMAT (                                                          &
     &     'ICNTL(1)   Output stream for error messages        =',I10/  &
     &     'ICNTL(2)   Output stream for diagnostic messages   =',I10/  &
     &     'ICNTL(3)   Output stream for global information    =',I10/  &
     &     'ICNTL(4)   Level of printing                       =',I10)
  991 FORMAT (                                                          &
     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/  &
     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/  &
     &     'ICNTL(7)   Ordering                                =',I10/  &
     &     'ICNTL(12)  LDLT ordering strat ( keep(95) )        =',I10/  &
     &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/  &
     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/  &
     &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/  &
     &     'ICNTL(22)  Out-off-core option (0=Off, >0=ON)      =',I10)
  992 FORMAT (                                                          &
     &     'ICNTL(8)   Scaling strategy ( keep(52) )           =',I10)
  993 FORMAT (                                                          &
     &     'ICNTL(14)  Percent of memory increase ( keep(12) ) =',I10)
  995 FORMAT (                                                          &
     &     'ICNTL(9)   Solve A x=b (1) or A''x = b (else)      =',I10/  &
     &     'ICNTL(10)  Max steps iterative refinement          =',I10/  &
     &     'ICNTL(11)  Error analysis ( 0= off, else=on)       =',I10/  &
     &     'ICNTL(20)  Dense (0) or sparse (1) RHS             =',I10/  &
     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
      END SUBROUTINE DAGMG_MUMPS_350
      SUBROUTINE DAGMG_MUMPS_24( MYID, SLAVEF, N,                            &
     &           PROCNODE, STEP, PTRAIW, PTRARW, ISTEP_TO_INIV2,        &
     &           I_AM_CAND,                                             &
     &           KEEP, KEEP8, ICNTL, id )
      USE DAGMG_MUMPS_STRUC_DF
      IMPLICIT NONE
      TYPE (DAGMG_MUMPS_STRUC) :: id
      INTEGER MYID, N, SLAVEF
      INTEGER KEEP( 500 ), ICNTL( 40 )
      INTEGER*8 KEEP8(150)
      INTEGER PROCNODE( KEEP(28) ), STEP( N ),                          &
     &        PTRAIW( N ), PTRARW( N )
      INTEGER ISTEP_TO_INIV2(KEEP(71))
      LOGICAL I_AM_CAND(max(1,KEEP(56)))
      LOGICAL I_AM_SLAVE
      LOGICAL I_AM_CAND_LOC
      INTEGER AGMG_MUMPS_330, AGMG_MUMPS_275
      EXTERNAL AGMG_MUMPS_330, AGMG_MUMPS_275
      INTEGER ISTEP, I, IPTRI, IPTRR, NCOL, NROW, allocok
      INTEGER TYPE_PARALL, ITYPE, IRANK
      TYPE_PARALL = KEEP(46)
      I_AM_SLAVE = (KEEP(46).EQ.1 .OR. MYID.NE.0)
      KEEP(14) = 0
      KEEP(13) = 0
      DO I = 1, N
        ISTEP=abs(STEP(I))
        ITYPE = AGMG_MUMPS_330( ISTEP, PROCNODE, SLAVEF )
        IRANK = AGMG_MUMPS_275( ISTEP, PROCNODE, SLAVEF )
        I_AM_CAND_LOC = .FALSE.
        IF (ITYPE.EQ.2.AND.I_AM_SLAVE) THEN
          I_AM_CAND_LOC = I_AM_CAND(ISTEP_TO_INIV2(ISTEP))
        ENDIF
        IF ( TYPE_PARALL .eq. 0 ) THEN
          IRANK = IRANK + 1
        END IF
        IF ( (ITYPE .EQ. 1.OR.ITYPE.EQ.2) .AND.                         &
     &            IRANK .EQ. MYID ) THEN
          KEEP( 14 ) = KEEP( 14 ) + 3 + PTRAIW( I ) + PTRARW( I )
          KEEP( 13 ) = KEEP( 13 ) + 1 + PTRAIW( I ) + PTRARW( I )
        ELSE IF ( ITYPE .EQ. 3 ) THEN
        ELSE IF ( ITYPE .EQ. 2 .AND. I_AM_CAND_LOC ) THEN
           PTRARW( I ) = 0
           KEEP(14) = KEEP(14) + 3 + PTRAIW( I ) + PTRARW( I )
           KEEP(13) = KEEP(13) + 1 + PTRAIW( I ) + PTRARW( I )
        END IF
      END DO
      IF ( associated( id%INTARR ) ) THEN
        DEALLOCATE( id%INTARR )
        NULLIFY( id%INTARR )
      END IF
      IF ( KEEP(14) > 0 ) THEN
      ALLOCATE( id%INTARR( KEEP(14) ), stat = allocok )
      IF ( allocok .GT. 0 ) THEN
        id%INFO(1) = -7
        id%INFO(2) = KEEP(14)
        RETURN
      END IF
      ELSE
      ALLOCATE( id%INTARR( 1 ), stat = allocok )
      IF ( allocok .GT. 0 ) THEN
        id%INFO(1) = -7
        id%INFO(2) = 1
        RETURN
      END IF
      END IF
      IPTRI = 1
      IPTRR = 1
      DO I = 1, N
        ISTEP = abs(STEP(I))
        ITYPE = AGMG_MUMPS_330( ISTEP, PROCNODE, SLAVEF )
        IRANK = AGMG_MUMPS_275( ISTEP, PROCNODE, SLAVEF )
        IF ( TYPE_PARALL .eq. 0 ) THEN
          IRANK =IRANK + 1
        END IF
        IF (                                                            &
     &      ( ITYPE .eq. 2 .and.                                        &
     &        IRANK .eq. MYID )                                         &
     & .or.                                                             &
     &      ( ITYPE .eq. 1 .and.                                        &
     &        IRANK .eq. MYID )                                         &
     &     )  THEN
          NCOL = PTRAIW( I )
          NROW = PTRARW( I )
          id%INTARR( IPTRI     ) = NCOL
          id%INTARR( IPTRI + 1 ) = -NROW
          id%INTARR( IPTRI + 2 ) = I
          PTRAIW( I ) = IPTRI
          PTRARW( I ) = IPTRR
          IPTRI = IPTRI + NCOL + NROW + 3
          IPTRR = IPTRR + NCOL + NROW + 1
        ELSE IF ( ITYPE .eq. 2 ) THEN
          IF ( I_AM_CAND(ISTEP_TO_INIV2(ISTEP)))                        &
     &    THEN
           NCOL = PTRAIW( I )
           NROW = 0
           id%INTARR( IPTRI     ) = NCOL
           id%INTARR( IPTRI + 1 ) = -NROW
           id%INTARR( IPTRI + 2 ) = I
           PTRAIW( I ) = IPTRI
           PTRARW( I ) = IPTRR
           IPTRI = IPTRI + NCOL + NROW + 3
           IPTRR = IPTRR + NCOL + NROW + 1
          ELSE
           PTRAIW(I)=0
           PTRARW(I)=0
          ENDIF
        ELSE
          PTRAIW(I) = 0
          PTRARW(I) = 0
        END IF
      END DO
      IF ( IPTRI - 1 .NE. KEEP(14) ) THEN
        WRITE(*,*) 'Error 1 in anal_arrowheads'
        CALL AGMG_MUMPS_ABORT()
      END IF
      IF ( IPTRR - 1 .NE. KEEP(13) ) THEN
        WRITE(*,*) 'Error 2 in anal_arrowheads'
        CALL AGMG_MUMPS_ABORT()
      END IF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_24
      SUBROUTINE DAGMG_MUMPS_148(N, NZ, ASPK,                                &
     &   IRN, ICN, PERM,                                                &
     &   LSCAL,COLSCA,ROWSCA,                                           &
     &   MYID, SLAVEF, PROCNODE_STEPS, NBRECORDS,                       &
     &   LP, COMM, root, KEEP, KEEP8, FILS, RG2L,                       &
     &   INTARR, DBLARR, PTRAIW, PTRARW, FRERE_STEPS,                   &
     &   STEP, A, LA, ISTEP_TO_INIV2, I_AM_CAND, CANDIDATES )
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
      INTEGER N,NZ, COMM, NBRECORDS
      INTEGER KEEP( 500 )
      INTEGER*8 KEEP8(150)
      DOUBLE PRECISION ASPK(NZ)
      DOUBLE PRECISION COLSCA(*), ROWSCA(*)
      INTEGER IRN(NZ), ICN(NZ)
      INTEGER PERM(N), PROCNODE_STEPS(KEEP(28))
      INTEGER RG2L( N ), FILS( N )
      INTEGER ISTEP_TO_INIV2(KEEP(71))
      LOGICAL I_AM_CAND(max(1,KEEP(56)))
      INTEGER LP, SLAVEF, MYID
      INTEGER CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
      LOGICAL LSCAL
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER(8) :: LA
      INTEGER PTRAIW( N ), PTRARW( N ), FRERE_STEPS( KEEP(28) )
      INTEGER STEP(N)
      INTEGER INTARR( max(1,KEEP(14)) )
      DOUBLE PRECISION A( LA ), DBLARR(max(1,KEEP(13)))
      INTEGER, DIMENSION(:,:), ALLOCATABLE :: BUFI
      DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: BUFR
      INTEGER AGMG_MUMPS_275, AGMG_MUMPS_330, NUMROC_FOOL
      EXTERNAL AGMG_MUMPS_275, AGMG_MUMPS_330, NUMROC_FOOL
      DOUBLE PRECISION VAL
      INTEGER IOLD,JOLD,INEW,JNEW,ISEND,JSEND,DEST,I,K,IARR
      INTEGER IPOSROOT, JPOSROOT
      INTEGER IROW_GRID, JCOL_GRID
      INTEGER INODE, ISTEP
      INTEGER NBUFS
      INTEGER ARROW_ROOT, TAILLE
      INTEGER LOCAL_M, LOCAL_N
      INTEGER(8) :: PTR_ROOT
      INTEGER TYPENODE_TMP, MASTER_NODE
      LOGICAL I_AM_CAND_LOC, I_AM_SLAVE
      INTEGER I1, IA, JARR, ILOCROOT, JLOCROOT
      INTEGER IS1, ISHIFT, IIW, IS, IAS, IPROC
      INTEGER allocok
      DOUBLE PRECISION ZERO
      PARAMETER( ZERO = 0.0D0 )
      INTEGER, POINTER, DIMENSION(:,:) :: IW4
      ARROW_ROOT = 0
      I_AM_SLAVE=(MYID.NE.0.OR.KEEP(46).EQ.1)
      IF ( KEEP(46) .eq. 0 ) THEN
        NBUFS = SLAVEF
      ELSE
        NBUFS = SLAVEF - 1
        ALLOCATE( IW4( N, 2 ), stat = allocok )
        IF ( allocok .GT. 0 ) THEN
          WRITE(*,*) 'Error allocating IW4'
          CALL AGMG_MUMPS_ABORT()
        END IF
        DO I = 1, N
          I1 = PTRAIW( I )
          IA = PTRARW( I )
          IF ( IA .GT. 0 ) THEN
            DBLARR( IA ) = dble(ZERO)
            IW4( I, 1 ) = INTARR( I1 )
            IW4( I, 2 ) = -INTARR( I1 + 1 )
            INTARR( I1 + 2 ) = I
          END IF
        END DO
        IF ( KEEP(38) .NE. 0 ) THEN
          IF (KEEP(60)==0) THEN
            LOCAL_M = NUMROC_FOOL( root%ROOT_SIZE, root%MBLOCK,              &
     &               root%MYROW, 0, root%NPROW )
            LOCAL_M = max( 1, LOCAL_M )
            LOCAL_N = NUMROC_FOOL( root%ROOT_SIZE, root%NBLOCK,              &
     &               root%MYCOL, 0, root%NPCOL )
            PTR_ROOT = LA - int(LOCAL_M,8) * int(LOCAL_N,8) + 1_8
            IF ( PTR_ROOT .LE. LA ) THEN
              A( PTR_ROOT:LA ) = dble(ZERO)
            END IF
          ELSE
            DO I = 1, root%SCHUR_NLOC
              root%SCHUR_POINTER(int(I-1,8)*int(root%SCHUR_LLD,8)+1_8:  &
     &        int(I-1,8)*int(root%SCHUR_LLD,8)+int(root%SCHUR_MLOC,8))= &
     &        dble(ZERO)
            ENDDO
          ENDIF
        END IF
      END IF
      IF (NBUFS.GT.0) THEN
       ALLOCATE( BUFI(NBRECORDS*2+1,NBUFS),stat=allocok )
       IF ( allocok .GT. 0 ) THEN
        WRITE(*,*) 'Error allocating BUFI'
        CALL AGMG_MUMPS_ABORT()
       END IF
       ALLOCATE( BUFR( NBRECORDS, NBUFS ), stat=allocok )
       IF ( allocok .GT. 0 ) THEN
         WRITE(*,*) 'Error allocating BUFR'
         CALL AGMG_MUMPS_ABORT()
       END IF
       DO I = 1, NBUFS
        BUFI( 1, I ) = 0
       ENDDO
      ENDIF
      INODE = KEEP(38)
      I     = 1
      DO WHILE ( INODE .GT. 0 )
        RG2L( INODE ) = I
        INODE = FILS( INODE )
        I = I + 1
      END DO
      DO 120 K=1,NZ
        IOLD = IRN(K)
        JOLD = ICN(K)
        IF ( (IOLD.GT.N).OR.(JOLD.GT.N).OR.(IOLD.LT.1)                  &
     &                 .OR.(JOLD.LT.1) ) THEN
!           GOTO 120
           CYCLE
        END IF
        IF (LSCAL) THEN
          VAL = ASPK(K)*ROWSCA(IOLD)*COLSCA(JOLD)
        ELSE
          VAL = ASPK(K)
        ENDIF
        IF (IOLD.EQ.JOLD) THEN
          ISEND = IOLD
          JSEND = JOLD
        ELSE
          INEW = PERM(IOLD)
          JNEW = PERM(JOLD)
          IF (INEW.LT.JNEW) THEN
            ISEND = IOLD
            IF ( KEEP(50) .NE. 0 ) ISEND = -IOLD
            JSEND = JOLD
          ELSE
            ISEND = -JOLD
            JSEND = IOLD
          ENDIF
        ENDIF
        IARR  = abs( ISEND )
        ISTEP = abs( STEP(IARR) )
        TYPENODE_TMP = AGMG_MUMPS_330( ISTEP,                                &
     &       PROCNODE_STEPS, SLAVEF )
        MASTER_NODE  = AGMG_MUMPS_275( ISTEP,                                &
     &             PROCNODE_STEPS, SLAVEF )
        I_AM_CAND_LOC = .FALSE.
        IF (TYPENODE_TMP .EQ. 2 .AND. I_AM_SLAVE) THEN
          I_AM_CAND_LOC = I_AM_CAND(ISTEP_TO_INIV2(ISTEP))
        END IF
        IF ( TYPENODE_TMP .EQ. 1 ) THEN
          IF ( KEEP(46) .eq. 0 ) THEN
            DEST = MASTER_NODE + 1
          ELSE
            DEST = MASTER_NODE
          END IF
        ELSE IF ( TYPENODE_TMP .EQ. 2 ) THEN
          IF ( ISEND .LT. 0  ) THEN
            DEST = -1
          ELSE
            IF ( KEEP( 46 ) .eq. 0 ) THEN
              DEST = MASTER_NODE + 1
            ELSE
              DEST = MASTER_NODE
            END IF
          END IF
        ELSE
          IF ( ISEND .LT. 0 ) THEN
            IPOSROOT = RG2L(JSEND)
            JPOSROOT = RG2L(IARR)
          ELSE
            IPOSROOT = RG2L( IARR )
            JPOSROOT = RG2L( JSEND )
          END IF
          IROW_GRID = mod( ( IPOSROOT - 1 )/root%MBLOCK, root%NPROW )
          JCOL_GRID = mod( ( JPOSROOT - 1 )/root%NBLOCK, root%NPCOL )
          IF ( KEEP( 46 ) .eq. 0 ) THEN
            DEST = IROW_GRID * root%NPCOL + JCOL_GRID + 1
          ELSE
            DEST = IROW_GRID * root%NPCOL + JCOL_GRID
          END IF
        END IF
        IF ( DEST .eq. 0 .or.                                           &
     &     ( DEST .eq. -1 .and. KEEP( 46 ) .eq. 1 .AND.                 &
     &       ( I_AM_CAND_LOC .OR. MASTER_NODE .EQ. 0 ) )) THEN
          IARR = ISEND
          JARR = JSEND
          IF ( TYPENODE_TMP .eq. 3 ) THEN
            ARROW_ROOT = ARROW_ROOT + 1
            IF ( IROW_GRID .EQ. root%MYROW .AND.                        &
     &         JCOL_GRID .EQ. root%MYCOL ) THEN
              ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /             &
     &                 ( root%MBLOCK * root%NPROW ) )                   &
     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
              JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /             &
     &                 ( root%NBLOCK * root%NPCOL ) )                   &
     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
             IF (KEEP(60)==0) THEN
               A( PTR_ROOT                                              &
     &           + int(JLOCROOT - 1,8) * int(LOCAL_M,8)                 &
     &           + int(ILOCROOT - 1,8) )                                &
     &         =  A( PTR_ROOT                                           &
     &           + int(JLOCROOT - 1,8) * int(LOCAL_M,8)                 &
     &           + int(ILOCROOT - 1,8) )                                &
     &         + VAL
             ELSE
               root%SCHUR_POINTER( int(JLOCROOT - 1,8)                  &
     &                           * int(root%SCHUR_LLD,8)                &
     &                           + int(ILOCROOT,8) )                    &
     &          = root%SCHUR_POINTER( int(JLOCROOT - 1,8)               &
     &                           *    int(root%SCHUR_LLD,8)             &
     &                           +    int(ILOCROOT,8))                  &
     &          + VAL
             ENDIF
            ELSE
              WRITE(*,*) MYID,':INTERNAL Error: root arrowhead '
              WRITE(*,*) MYID,':is not belonging to me. IARR,JARR='     &
     &        ,IARR,JARR
              CALL AGMG_MUMPS_ABORT()
            END IF
          ELSE IF ( IARR .GE. 0 ) THEN
            IF ( IARR .eq. JARR ) THEN
              IA = PTRARW( IARR )
              DBLARR( IA ) = DBLARR( IA ) + VAL
            ELSE
              IS1 =  PTRAIW(IARR)
              ISHIFT      = INTARR(IS1) + IW4(IARR,2)
              IW4(IARR,2) = IW4(IARR,2) - 1
              IIW         = IS1 + ISHIFT + 2
              INTARR(IIW)     = JARR
              IS          = PTRARW(IARR)
              IAS         = IS + ISHIFT
              DBLARR(IAS) = VAL
            END IF
          ELSE
            IARR = -IARR
            ISHIFT      = PTRAIW(IARR)+IW4(IARR,1)+2
            INTARR(ISHIFT)  = JARR
            IAS         = PTRARW(IARR)+IW4(IARR,1)
            IW4(IARR,1) = IW4(IARR,1) - 1
            DBLARR(IAS)      = VAL
            IF ( (KEEP(50) .NE. 0 .OR. KEEP(234).NE.0 )                 &
     &           .AND.  IW4(IARR,1) .EQ. 0 .AND.                        &
     &           STEP( IARR) > 0 ) THEN
              IF (AGMG_MUMPS_275( abs(STEP(IARR)),                           &
     &              PROCNODE_STEPS,SLAVEF ) == MYID) THEN
                TAILLE = INTARR( PTRAIW(IARR) )
                CALL DAGMG_MUMPS_310( N, PERM,                               &
     &             INTARR( PTRAIW(IARR) + 3 ),                          &
     &             DBLARR( PTRARW(IARR) + 1 ),                          &
     &             TAILLE, 1, TAILLE )
              END IF
            END IF
          ENDIF
        END IF
        IF ( DEST.EQ. -1 ) THEN
         DO I=1, CANDIDATES(SLAVEF+1,ISTEP_TO_INIV2(ISTEP))
           DEST=CANDIDATES(I,ISTEP_TO_INIV2(ISTEP))
           IF (KEEP(46).EQ.0) DEST=DEST+1
           IF (DEST.NE.0)                                               &
     &     CALL DAGMG_MUMPS_34( ISEND, JSEND, VAL,                           &
     &     DEST, BUFI, BUFR, NBRECORDS, NBUFS,                          &
     &     LP, COMM, KEEP(46))
         ENDDO
         DEST = MASTER_NODE
         IF (KEEP(46).EQ.0) DEST=DEST+1
         IF ( DEST .NE. 0 ) THEN
           CALL DAGMG_MUMPS_34( ISEND, JSEND, VAL,                           &
     &     DEST, BUFI, BUFR, NBRECORDS, NBUFS,                          &
     &     LP, COMM, KEEP(46))
         ENDIF
        ELSE IF ( DEST .GT. 0 ) THEN
         CALL DAGMG_MUMPS_34( ISEND, JSEND, VAL,                             &
     &    DEST, BUFI, BUFR, NBRECORDS, NBUFS,                           &
     &    LP, COMM, KEEP(46))
        END IF
  120 END DO
      KEEP(49) = ARROW_ROOT
      IF (NBUFS.GT.0) THEN
       CALL DAGMG_MUMPS_18(                                                  &
     &   BUFI, BUFR, NBRECORDS, NBUFS,                                  &
     &   LP, COMM, KEEP( 46 ) )
      ENDIF
      IF ( KEEP( 46 ) .NE. 0 ) DEALLOCATE( IW4 )
      IF (NBUFS.GT.0) THEN
        DEALLOCATE( BUFI )
        DEALLOCATE( BUFR )
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_148
      SUBROUTINE DAGMG_MUMPS_34(ISEND, JSEND, VAL,                           &
     &   DEST, BUFI, BUFR, NBRECORDS, NBUFS, LP, COMM,                  &
     &   TYPE_PARALL )
      IMPLICIT NONE
      INTEGER ISEND, JSEND, DEST, NBUFS, NBRECORDS, TYPE_PARALL
      INTEGER BUFI( NBRECORDS * 2 + 1, NBUFS )
      DOUBLE PRECISION BUFR( NBRECORDS, NBUFS )
      INTEGER COMM
      INTEGER LP
      DOUBLE PRECISION VAL
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      INTEGER IBEG,IEND, IERR
      INTEGER TAILLE_SENDI, TAILLE_SENDR, IREQ
         IF (BUFI(1,DEST)+1.GT.NBRECORDS) THEN
          TAILLE_SENDI = BUFI(1,DEST) * 2 + 1
          TAILLE_SENDR = BUFI(1,DEST)
          CALL AGMG_NOCALL('MPI_SEND')
          CALL AGMG_NOCALL('MPI_SEND')
          BUFI(1,DEST) = 0
         ENDIF
         IREQ = BUFI(1,DEST) + 1
         BUFI(1,DEST) = IREQ
         BUFI( IREQ * 2, DEST )     = ISEND
         BUFI( IREQ * 2 + 1, DEST ) = JSEND
         BUFR( IREQ, DEST )         = VAL
  500 CONTINUE
      RETURN
      END SUBROUTINE DAGMG_MUMPS_34
      SUBROUTINE DAGMG_MUMPS_18(                                             &
     &   BUFI, BUFR, NBRECORDS, NBUFS, LP, COMM,                        &
     &   TYPE_PARALL )
      IMPLICIT NONE
      INTEGER NBUFS, NBRECORDS, TYPE_PARALL
      INTEGER BUFI( NBRECORDS * 2 + 1, NBUFS )
      DOUBLE PRECISION BUFR( NBRECORDS, NBUFS )
      INTEGER COMM
      INTEGER LP
      INTEGER ISLAVE, TAILLE_SENDI, TAILLE_SENDR, IERR
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
        DO ISLAVE = 1,NBUFS
          TAILLE_SENDI = BUFI(1,ISLAVE) * 2 + 1
          TAILLE_SENDR = BUFI(1,ISLAVE)
          BUFI(1,ISLAVE) = - BUFI(1,ISLAVE)
          CALL AGMG_NOCALL('MPI_SEND')
          IF ( TAILLE_SENDR .NE. 0 ) THEN
            CALL AGMG_NOCALL('MPI_SEND')
          END IF
        ENDDO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_18
      RECURSIVE SUBROUTINE DAGMG_MUMPS_310( N, PERM,                         &
     &            INTLIST, DBLLIST, TAILLE, LO, HI )
      IMPLICIT NONE
      INTEGER N, TAILLE
      INTEGER PERM( N )
      INTEGER INTLIST( TAILLE )
      DOUBLE PRECISION DBLLIST( TAILLE )
      INTEGER LO, HI
      INTEGER I,J
      INTEGER ISWAP, PIVOT
      DOUBLE PRECISION DSWAP
      I = LO
      J = HI
      PIVOT = PERM(INTLIST((I+J)/2))
   10 IF (PERM(INTLIST(I)) < PIVOT) THEN
        I=I+1
        GOTO 10
      ENDIF
   20 IF (PERM(INTLIST(J)) > PIVOT) THEN
        J=J-1
        GOTO 20
      ENDIF
      IF (I < J) THEN
        ISWAP = INTLIST(I)
        INTLIST(I) = INTLIST(J)
        INTLIST(J)=ISWAP
        DSWAP = DBLLIST(I)
        DBLLIST(I) = DBLLIST(J)
        DBLLIST(J) = DSWAP
      ENDIF
      IF ( I <= J) THEN
        I = I+1
        J = J-1
      ENDIF
      IF ( I <= J ) GOTO 10
      IF ( LO < J ) CALL DAGMG_MUMPS_310(N, PERM,                            &
     &              INTLIST, DBLLIST, TAILLE, LO, J)
      IF ( I < HI ) CALL DAGMG_MUMPS_310(N, PERM,                            &
     &              INTLIST, DBLLIST, TAILLE, I, HI)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_310
      SUBROUTINE DAGMG_MUMPS_145(  N,                                        &
     &    DBLARR, LDBLARR, INTARR, LINTARR, PTRAIW, PTRARW,             &
     &    KEEP, KEEP8, MYID,  COMM, NBRECORDS,                          &
     &    A, LA, root,                                                  &
     &    PROCNODE_STEPS,                                               &
     &    SLAVEF, PERM, FRERE_STEPS, STEP, INFO1, INFO2                 &
     &   )
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
      INTEGER N, MYID, LDBLARR, LINTARR,                                &
     &        COMM
      INTEGER INTARR(LINTARR)
      INTEGER PTRAIW(N), PTRARW(N)
      INTEGER   KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER(8), intent(IN) :: LA
      INTEGER PROCNODE_STEPS( KEEP(28) ), PERM( N )
      INTEGER SLAVEF, NBRECORDS
      DOUBLE PRECISION A( LA )
      INTEGER INFO1, INFO2
      DOUBLE PRECISION DBLARR(LDBLARR)
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER, POINTER, DIMENSION(:) :: BUFI
      DOUBLE PRECISION, POINTER, DIMENSION(:) :: BUFR
      INTEGER, POINTER, DIMENSION(:,:) :: IW4
      LOGICAL FINI
      INTEGER IREC, NB_REC, IARR, JARR, IA, I1, I, allocok
      INTEGER IS, IS1, ISHIFT, IIW, IAS
      INTEGER LOCAL_M, LOCAL_N, ILOCROOT, JLOCROOT,                     &
     &        IPOSROOT, JPOSROOT, TAILLE,                               &
     &        IPROC
      INTEGER FRERE_STEPS( KEEP(28) ), STEP(N)
      INTEGER(8) :: PTR_ROOT
      INTEGER ARROW_ROOT, TYPE_PARALL
      INTEGER AGMG_MUMPS_330, AGMG_MUMPS_275
      EXTERNAL AGMG_MUMPS_330, AGMG_MUMPS_275
      DOUBLE PRECISION VAL
      DOUBLE PRECISION  ZERO
      PARAMETER( ZERO = 0.0D0 )
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      INTEGER MASTER
      PARAMETER(MASTER=0)
      INTEGER STATUS( AGMG_MPF_STATUS_SIZE )
      INTEGER IERR
      INTEGER NUMROC_FOOL
      EXTERNAL NUMROC_FOOL
      TYPE_PARALL = KEEP(46)
      ARROW_ROOT=0
      ALLOCATE( BUFI( NBRECORDS * 2 + 1 ), stat = allocok )
      IF ( allocok .GT. 0 ) THEN
        INFO1 = -13
        INFO2 = NBRECORDS * 2 + 1
        WRITE(*,*) MYID,': Could not allocate BUFI: goto 500'
        GOTO 500
      END IF
      ALLOCATE( BUFR( NBRECORDS )        , stat = allocok )
      IF ( allocok .GT. 0 ) THEN
        INFO1 = -13
        INFO2 = NBRECORDS
        WRITE(*,*) MYID,': Could not allocate BUFR: goto 500'
        GOTO 500
      END IF
      ALLOCATE( IW4(N,2), stat = allocok )
      IF ( allocok .GT. 0 ) THEN
        INFO1 = -13
        INFO2 = 2 * N
        WRITE(*,*) MYID,': Could not allocate IW4: goto 500'
        GOTO 500
      END IF
      IF ( KEEP(38).NE.0) THEN
        IF (KEEP(60)==0) THEN
         LOCAL_M = NUMROC_FOOL( root%ROOT_SIZE, root%MBLOCK,                 &
     &             root%MYROW, 0, root%NPROW )
         LOCAL_M = max( 1, LOCAL_M )
         LOCAL_N = NUMROC_FOOL( root%ROOT_SIZE, root%NBLOCK,                 &
     &             root%MYCOL, 0, root%NPCOL )
         PTR_ROOT = LA - int(LOCAL_M,8) * int(LOCAL_N,8) + 1_8
         IF ( PTR_ROOT .LE. LA ) THEN
           A( PTR_ROOT:LA ) = dble(ZERO)
         END IF
        ELSE
         DO I=1, root%SCHUR_NLOC
           root%SCHUR_POINTER((I-1)*root%SCHUR_LLD+1:                   &
     &     (I-1)*root%SCHUR_LLD+root%SCHUR_MLOC)=dble(ZERO)
         ENDDO
        ENDIF
      END IF
      FINI = .FALSE.
      DO I=1,N
       I1 = PTRAIW(I)
       IA = PTRARW(I)
       IF (IA.GT.0) THEN
        DBLARR(IA) = dble(ZERO)
        IW4(I,1) = INTARR(I1)
        IW4(I,2) = -INTARR(I1+1)
        INTARR(I1+2)=I
       ENDIF
      ENDDO
      DO WHILE (.NOT.FINI)
       CALL AGMG_NOCALL('MPI_RECV')
       NB_REC = BUFI(1)
       IF (NB_REC.LE.0) THEN
         FINI = .TRUE.
         NB_REC = -NB_REC
       ENDIF
       IF (NB_REC.EQ.0) EXIT
       CALL AGMG_NOCALL('MPI_RECV')
       DO IREC=1, NB_REC
        IARR = BUFI( IREC * 2 )
        JARR = BUFI( IREC * 2 + 1 )
        VAL  = BUFR( IREC )
        IF ( AGMG_MUMPS_330( abs(STEP(abs(IARR))),                           &
     &       PROCNODE_STEPS, SLAVEF ) .eq. 3 ) THEN
          ARROW_ROOT = ARROW_ROOT + 1
          IF ( IARR .GT. 0 ) THEN
            IPOSROOT = root%RG2L_ROW( IARR )
            JPOSROOT = root%RG2L_COL( JARR )
          ELSE
            IPOSROOT = root%RG2L_ROW( JARR )
            JPOSROOT = root%RG2L_COL( -IARR )
          END IF
            ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /               &
     &                 ( root%MBLOCK * root%NPROW ) )                   &
     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
            JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /               &
     &                 ( root%NBLOCK * root%NPCOL ) )                   &
     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
           IF (KEEP(60)==0) THEN
             A( PTR_ROOT + int(JLOCROOT - 1,8) * int(LOCAL_M,8)         &
     &                   + int(ILOCROOT - 1,8) )                        &
     &       =  A( PTR_ROOT + int(JLOCROOT - 1,8)                       &
     &                      * int(LOCAL_M,8)                            &
     &                      + int(ILOCROOT - 1,8))                      &
     &        + VAL
           ELSE
             root%SCHUR_POINTER( int(JLOCROOT-1,8)                      &
     &                         * int(root%SCHUR_LLD,8)                  &
     &                         + int(ILOCROOT,8) )                      &
     &       = root%SCHUR_POINTER( int(JLOCROOT - 1,8)                  &
     &                         * int(root%SCHUR_LLD,8)                  &
     &                         + int(ILOCROOT,8))                       &
     &       + VAL
           ENDIF
        ELSE IF (IARR.GE.0) THEN
         IF (IARR.EQ.JARR) THEN
          IA = PTRARW(IARR)
          DBLARR(IA) = DBLARR(IA) + VAL
         ELSE
          IS1 =  PTRAIW(IARR)
          ISHIFT      = INTARR(IS1) + IW4(IARR,2)
          IW4(IARR,2) = IW4(IARR,2) - 1
          IIW         = IS1 + ISHIFT + 2
          INTARR(IIW)     = JARR
          IS          = PTRARW(IARR)
          IAS         = IS + ISHIFT
          DBLARR(IAS) = VAL
         ENDIF
        ELSE
           IARR = -IARR
           ISHIFT      = PTRAIW(IARR)+IW4(IARR,1)+2
           INTARR(ISHIFT)  = JARR
           IAS         = PTRARW(IARR)+IW4(IARR,1)
           IW4(IARR,1) = IW4(IARR,1) - 1
           DBLARR(IAS)      = VAL
           IF ( (KEEP(50) .NE. 0 .OR. KEEP(234).NE.0)                   &
     &          .AND.  IW4(IARR,1) .EQ. 0                               &
     &          .AND. STEP(IARR) > 0 ) THEN
              IPROC = AGMG_MUMPS_275( abs(STEP(IARR)),                       &
     &        PROCNODE_STEPS,SLAVEF )
              IF ( TYPE_PARALL .eq. 0 ) THEN
                IPROC = IPROC + 1
              END IF
              IF (IPROC .EQ. MYID) THEN
                TAILLE = INTARR( PTRAIW(IARR) )
                CALL DAGMG_MUMPS_310( N, PERM,                               &
     &            INTARR( PTRAIW(IARR) + 3 ),                           &
     &            DBLARR( PTRARW(IARR) + 1 ),                           &
     &            TAILLE, 1, TAILLE )
              END IF
           END IF
        ENDIF
       ENDDO
      END DO
      DEALLOCATE( BUFI )
      DEALLOCATE( BUFR )
      DEALLOCATE( IW4 )
  500 CONTINUE
      KEEP(49) = ARROW_ROOT
      RETURN
      END SUBROUTINE DAGMG_MUMPS_145
      SUBROUTINE DAGMG_MUMPS_266( MYID, BUFR, LBUFR,                         &
     &     LBUFR_BYTES,                                                 &
     &     IWPOS, IWPOSCB,                                              &
     &     IPTRLU, LRLU, LRLUS,                                         &
     &     TNBPROCFILS, N, IW, LIW, A, LA,                              &
     &     PTRIST, PTRAST, STEP, PIMASTER, PAMASTER, COMP,              &
     &     KEEP,KEEP8, ITLOC,                                           &
     &     IFLAG, IERROR )
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
      INTEGER MYID
      INTEGER KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER BUFR( LBUFR )
      INTEGER(8) :: IPTRLU, LRLU, LRLUS, LA
      INTEGER IWPOS, IWPOSCB, N, LIW
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER PTRIST(KEEP(28)), STEP(N),                                &
     & PIMASTER(KEEP(28)),                                              &
     & TNBPROCFILS( KEEP(28) ), ITLOC( N )
      INTEGER COMP, IFLAG, IERROR
      INTEGER INODE, NBPROCFILS, NCOL, NROW, NASS, NSLAVES
      INTEGER NSLAVES_RECU, NFRONT
      INTEGER LREQ
      INTEGER(8) :: LREQCB
      DOUBLE PRECISION FLOP1
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      INODE = BUFR( 1 )
      NBPROCFILS = BUFR( 2 )
      NROW = BUFR( 3 )
      NCOL = BUFR( 4 )
      NASS = BUFR( 5 )
      NFRONT = BUFR( 6 )
      NSLAVES_RECU = BUFR( 7 )
      IF ( KEEP(50) .eq. 0 ) THEN
         FLOP1 = dble( NASS * NROW ) +                                  &
     &     dble(NROW*NASS)*dble(2*NCOL-NASS-1)
      ELSE
         FLOP1 = dble( NASS ) * dble( NROW )                            &
     &            * dble( 2 * NCOL - NROW - NASS + 1)
      END IF
      CALL DAGMG_MUMPS_190(1,.TRUE.,FLOP1, KEEP,KEEP8)
      IF ( KEEP(50) .eq. 0 ) THEN
        NSLAVES = NSLAVES_RECU + XTRA_SLAVES_UNSYM
      ELSE
        NSLAVES = NSLAVES_RECU + XTRA_SLAVES_SYM
      END IF
      LREQ   = NROW + NCOL + 6 + NSLAVES + KEEP(IXSZ)
      LREQCB = int(NCOL,8) * int(NROW,8)
      CALL DAGMG_MUMPS_22(.FALSE., 0_8, .FALSE.,.TRUE.,                      &
     &   MYID,N, KEEP,KEEP8, IW, LIW, A, LA,                            &
     &   LRLU, IPTRLU,IWPOS,IWPOSCB,                                    &
     &   PTRIST,PTRAST, STEP, PIMASTER,PAMASTER, ITLOC,                 &
     &   LREQ, LREQCB, INODE, S_ACTIVE, .TRUE.,                         &
     &   COMP, LRLUS, IFLAG, IERROR                                     &
     &     )
      IF ( IFLAG .LT. 0 ) RETURN
      PTRIST(STEP(INODE)) = IWPOSCB + 1
      PTRAST(STEP(INODE)) = IPTRLU  + 1_8
      IW( IWPOSCB + 1+KEEP(IXSZ) ) = NCOL
      IW( IWPOSCB + 2+KEEP(IXSZ) ) = - NASS
      IW( IWPOSCB + 3+KEEP(IXSZ) ) = NROW
      IW( IWPOSCB + 4+KEEP(IXSZ) ) = 0
      IW( IWPOSCB + 5+KEEP(IXSZ) ) = NASS
      IW( IWPOSCB + 6+KEEP(IXSZ) ) = NSLAVES
      IW( IWPOSCB + 7+KEEP(IXSZ)+NSLAVES :                              &
     &           IWPOSCB + 6+KEEP(IXSZ)+NSLAVES + NROW + NCOL )         &
     &= BUFR( 8 + NSLAVES_RECU : 7 + NSLAVES_RECU + NROW + NCOL )
      IF ( KEEP(50) .eq. 0 ) THEN
        IW( IWPOSCB + 7+KEEP(IXSZ) ) = 0
        IF (NSLAVES_RECU.GT.0)                                          &
     &  IW( IWPOSCB + 7+XTRA_SLAVES_UNSYM+KEEP(IXSZ):                   &
     &       IWPOSCB+6+KEEP(IXSZ)+NSLAVES_RECU ) =                      &
     &       BUFR( 8: 7 + NSLAVES_RECU )
      ELSE
        IW( IWPOSCB + 7+KEEP(IXSZ) ) = 0
        IW( IWPOSCB + 8+KEEP(IXSZ) ) = NFRONT
        IW( IWPOSCB + 9+KEEP(IXSZ) ) = 0
        IW( IWPOSCB + 7+XTRA_SLAVES_SYM+KEEP(IXSZ):                     &
     &      IWPOSCB + 6+XTRA_SLAVES_SYM+KEEP(IXSZ)+NSLAVES_RECU ) =     &
     &       BUFR( 8: 7 + NSLAVES_RECU )
      END IF
      TNBPROCFILS(STEP( INODE )) = NBPROCFILS
      RETURN
      END SUBROUTINE DAGMG_MUMPS_266
      SUBROUTINE DAGMG_MUMPS_163( id )
      USE DAGMG_MUMPS_STRUC_DF
      USE DAGMG_MUMPS_COMM_BUFF
      IMPLICIT NONE
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      TYPE (DAGMG_MUMPS_STRUC) id
      INTEGER MASTER, IERR
      PARAMETER( MASTER = 0 )
      INTEGER color
      CALL AGMG_SETIERR12( id%NPROCS, IERR )
      IF ( id%PAR .eq. 0 ) THEN
        IF ( id%MYID .eq. MASTER ) THEN
          color = AGMG_MPF_UNDEFINED
        ELSE
          color = 0
        END IF
        CALL AGMG_SETIERR( IERR )
        id%NSLAVES = id%NPROCS - 1
      ELSE
        CALL AGMG_SETIERR( IERR )
        id%NSLAVES = id%NPROCS
      END IF
      IF (id%PAR .ne. 0 .or. id%MYID .NE. MASTER) THEN
        CALL AGMG_SETIERR( IERR )
      ENDIF
      CALL DAGMG_MUMPS_20( id%NSLAVES, id%LWK_USER,                          &
     &    id%CNTL, id%ICNTL,                                            &
     &    id%KEEP, id%KEEP8, id%INFO, id%INFOG,                         &
     &    id%RINFO, id%RINFOG,                                          &
     &    id%SYM, id%PAR, id%DKEEP )
      id%WRITE_PROBLEM="NAME_NOT_INITIALIZED"
      CALL AGMG_MUMPS_SET_VERSION( id%VERSION_NUMBER )
      id%OOC_TMPDIR="NAME_NOT_INITIALIZED"
      id%OOC_PREFIX="NAME_NOT_INITIALIZED"
      id%NRHS = 1
      id%LRHS = 1
      CALL DAGMG_MUMPS_61( id%KEEP( 34 ), id%KEEP(35) )
      NULLIFY(id%BUFR)
      id%NZ_loc = 0
      id%MAXIS1 = 0
      id%INST_Number = -1
      NULLIFY(id%IRN)
      NULLIFY(id%JCN)
      NULLIFY(id%A)
      NULLIFY(id%IRN_loc)
      NULLIFY(id%JCN_loc)
      NULLIFY(id%A_loc)
      NULLIFY(id%MAPPING)
      NULLIFY(id%RHS)
      NULLIFY(id%REDRHS)
      NULLIFY(id%RHS_SPARSE)
      NULLIFY(id%IRHS_SPARSE)
      NULLIFY(id%IRHS_PTR)
      NULLIFY(id%ISOL_LOC)
      NULLIFY(id%SOL_LOC)
      NULLIFY(id%COLSCA)
      NULLIFY(id%ROWSCA)
      NULLIFY(id%PERM_IN)
      NULLIFY(id%IS)
      NULLIFY(id%IS1)
      NULLIFY(id%STEP)
      NULLIFY(id%Step2node)
      NULLIFY(id%DAD_STEPS)
      NULLIFY(id%NE_STEPS)
      NULLIFY(id%ND_STEPS)
      NULLIFY(id%FRERE_STEPS)
      NULLIFY(id%SYM_PERM)
      NULLIFY(id%UNS_PERM)
      NULLIFY(id%PIVNUL_LIST)
      NULLIFY(id%FILS)
      NULLIFY(id%PTRAR)
      NULLIFY(id%FRTPTR)
      NULLIFY(id%FRTELT)
      NULLIFY(id%NA)
      id%LNA=0
      NULLIFY(id%PROCNODE_STEPS)
      NULLIFY(id%S)
      NULLIFY(id%PROCNODE)
      NULLIFY(id%POIDS)
      NULLIFY(id%PTLUST_S)
      NULLIFY(id%PTRFAC)
      NULLIFY(id%INTARR)
      NULLIFY(id%DBLARR)
      NULLIFY(id%NULL_SPACE)
      NULLIFY(id%DEPTH_FIRST)
      NULLIFY(id%MEM_SUBTREE)
      NULLIFY(id%MEM_SUBTREE)
      NULLIFY(id%MY_ROOT_SBTR)
      NULLIFY(id%MY_FIRST_LEAF)
      NULLIFY(id%MY_NB_LEAF)
      NULLIFY(id%COST_TRAV)
      NULLIFY(id%RHSCOMP)
      NULLIFY(id%POSINRHSCOMP)
      NULLIFY(id%OOC_INODE_SEQUENCE)
      NULLIFY(id%OOC_TOTAL_NB_NODES)
      NULLIFY(id%OOC_SIZE_OF_BLOCK)
      NULLIFY(id%OOC_FILE_NAME_LENGTH)
      NULLIFY(id%OOC_FILE_NAMES)
      NULLIFY(id%OOC_VADDR)
      NULLIFY(id%OOC_NB_FILES)
      NULLIFY(id%CB_SON_SIZE)
      NULLIFY(id%root%RG2L_ROW)
      NULLIFY(id%root%RG2L_COL)
      NULLIFY(id%root%IPIV)
      NULLIFY(id%root%SCHUR_POINTER)
      NULLIFY(id%SCHUR_CINTERFACE)
      NULLIFY(id%ELTPTR)
      NULLIFY(id%ELTVAR)
      NULLIFY(id%A_ELT)
      NULLIFY(id%ELTPROC)
      id%SIZE_SCHUR = 0
      NULLIFY( id%LISTVAR_SCHUR )
      NULLIFY( id%SCHUR )
      id%NPROW      = 0
      id%NPCOL      = 0
      id%MBLOCK     = 0
      id%NBLOCK     = 0
      id%SCHUR_MLOC = 0
      id%SCHUR_NLOC = 0
      id%SCHUR_LLD  = 0
      NULLIFY(id%ISTEP_TO_INIV2)
      NULLIFY(id%I_AM_CAND)
      NULLIFY(id%FUTURE_NIV2)
      NULLIFY(id%TAB_POS_IN_PERE)
      NULLIFY(id%CANDIDATES)
      CALL DAGMG_MUMPS_637(id)
      NULLIFY(id%MEM_DIST)
      NULLIFY(id%SUP_PROC)
      id%Deficiency = 0
      id%root%LPIV = -1
      id%root%yes  = .FALSE.
      id%root%gridinit_done  = .FALSE.
        IF ( id%KEEP( 46 ) .ne. 0  .OR.                                 &
     &     id%MYID .ne. MASTER ) THEN
          CALL AGMG_SETIERR2( id%MYID_NODES, IERR )
        ELSE
          id%MYID_NODES = -464646
        ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_163
      SUBROUTINE DAGMG_MUMPS_252( COMM_LOAD, ASS_IRECV,                      &
     &    N, INODE, IW, LIW, A, LA, IFLAG,                              &
     &    IERROR, ND,                                                   &
     &    FILS, FRERE, DAD, MAXFRW, root,                               &
     &    OPASSW, OPELIW, PTRIST, PTLUST_S, PTRFAC, PTRAST,             &
     &    STEP, PIMASTER, PAMASTER,PTRARW,                              &
     &    PTRAIW, ITLOC, NSTEPS, SON_LEVEL2,                            &
     &    COMP, LRLU, IPTRLU, IWPOS, IWPOSCB, POSFAC, LRLUS,            &
     &    ICNTL, KEEP,KEEP8,INTARR,DBLARR,                              &
     &    NSTK_S,NBPROCFILS, PROCNODE_STEPS, SLAVEF, COMM,MYID,         &
     &    BUFR, LBUFR, LBUFR_BYTES, NBFIN, IPOOL, LPOOL, LEAF,          &
     &    PERM,                                                         &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE, JOBASS, ETATASS              &
     &    )
      USE DAGMG_MUMPS_COMM_BUFF
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      INTEGER STATUS( AGMG_MPF_STATUS_SIZE ), IERR
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER COMM_LOAD, ASS_IRECV
      INTEGER IZERO
      PARAMETER (IZERO=0)
      INTEGER N,LIW,NSTEPS
      INTEGER(8) LA, LRLU, LRLUS, IPTRLU, POSFAC
      INTEGER KEEP(500), ICNTL(40)
      INTEGER*8 KEEP8(150)
      INTEGER IFLAG,IERROR,INODE,MAXFRW,                                &
     &        IWPOS, IWPOSCB, COMP, IERR_MPI
      INTEGER JOBASS,ETATASS
      LOGICAL SON_LEVEL2
      DOUBLE PRECISION A(LA)
      DOUBLE PRECISION  OPASSW, OPELIW
      INTEGER COMM, NBFIN, SLAVEF, MYID
      INTEGER LPOOL, LEAF
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER NBPROCFILS(KEEP(28))
      INTEGER NSTK_S(KEEP(28)),PROCNODE_STEPS(KEEP(28))
      INTEGER IPOOL( LPOOL )
      INTEGER BUFR( LBUFR )
      INTEGER IDUMMY(1)
      INTEGER IW(LIW), ITLOC(N),                                        &
     &        PTRARW(N), PTRAIW(N), ND(KEEP(28)), PERM(N),              &
     &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),                  &
     &        PTRIST(KEEP(28)), PTLUST_S(KEEP(28)),                     &
     &        STEP(N), PIMASTER(KEEP(28))
      INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),                 &
     &              PAMASTER(KEEP(28))
      INTEGER   ISTEP_TO_INIV2(KEEP(71)),                               &
     &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      INTEGER      INTARR(max(1,KEEP(14)))
      DOUBLE PRECISION DBLARR(max(1,KEEP(13)))
      INTEGER AGMG_MUMPS_275, AGMG_MUMPS_330
      EXTERNAL AGMG_MUMPS_275, AGMG_MUMPS_330
      INTEGER LP, HS, HF
      INTEGER NBPANELS_L, NBPANELS_U
      INTEGER IN,NUMSTK,NASS,ISON,IFSON,NASS1,IELL
      INTEGER NFS4FATHER
      INTEGER(8) NFRONT8, LAELL8, LAELL_REQ8
      INTEGER NFRONT,NFRONT_EFF,ISTCHK,LSTK,LREQ
      INTEGER LREQ_OOC
      INTEGER(8) :: SIZFR
      INTEGER SIZFI, NCB
      INTEGER J1,J2
      INTEGER NCOL, NROW, NCOLS, NROWS, LDA_SON
      INTEGER(8) :: JJ2, JJ3, ICT13
      INTEGER NELIM,JJ,JJ1,J3,                                          &
     &        IBROT,IORG
      INTEGER JPOS,ICT11
      INTEGER JK,IJROW,NBCOL,NUMORG,IOLDPS,J4
      INTEGER(8) IACHK, JJ8, POSELT, LAPOS2
      INTEGER(8) APOS, APOS2, APOS3, POSEL1, ICT12
      INTEGER AINPUT
      INTEGER NSLAVES, NSLSON, NPIVS,NPIV_ANA,NPIV
      INTEGER PTRCOL, ISLAVE, PDEST,LEVEL
      INTEGER ISON_IN_PLACE
      INTEGER ISON_TOP
      INTEGER(8) SIZE_ISON_TOP8
      LOGICAL RESET_TO_ZERO, RISK_OF_SAME_POS,                          &
     &        RISK_OF_SAME_POS_THIS_LINE
      LOGICAL LEVEL1, NIV1
      INTEGER TROW_SIZE
      INTEGER INDX, FIRST_INDEX, SHIFT_INDEX
      LOGICAL FLAG, BLOCKING, SET_IRECV, MESSAGE_RECEIVED
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      INTEGER NCBSON
      LOGICAL FREE, SAME_PROC
      INTRINSIC real
      DOUBLE PRECISION ZERO
      DATA ZERO /0.0D0/
      INTEGER NELT, LPTRAR
      EXTERNAL AGMG_MUMPS_167
      LOGICAL AGMG_MUMPS_167
      LOGICAL SSARBR
      LOGICAL COMPRESSCB
      INTEGER(8) :: LCB
      DOUBLE PRECISION FLOP1,FLOP1_EFF
      EXTERNAL AGMG_MUMPS_170
      LOGICAL AGMG_MUMPS_170
      COMPRESSCB =.FALSE.
      NELT       = 1
      LPTRAR     = N
      NFS4FATHER = -1
      IN         = INODE
      NBPROCFILS(STEP(IN)) = 0
      LEVEL = AGMG_MUMPS_330(STEP(INODE),PROCNODE_STEPS,SLAVEF)
      IF (LEVEL.NE.1) THEN
       write(6,*) 'Error1 in mpi51f_niv1 '
       CALL AGMG_MUMPS_ABORT()
      ENDIF
      NSLAVES = 0
      HF =  6 + NSLAVES + KEEP(IXSZ)
      IF (JOBASS.EQ.0) THEN
        ETATASS= 0
      ELSE
        ETATASS= 2
        IOLDPS = PTLUST_S(STEP(INODE))
        NFRONT = IW(IOLDPS + KEEP(IXSZ))
        NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
        ICT11 = IOLDPS + HF - 1 + NFRONT
        SSARBR=AGMG_MUMPS_167(STEP(INODE),PROCNODE_STEPS,                    &
     &                        SLAVEF)
        NUMORG = 0
        DO WHILE (IN.GT.0)
          NUMORG = NUMORG + 1
          IN = FILS(IN)
        ENDDO
        NUMSTK = 0
        IFSON = -IN
        ISON = IFSON
        IF (ISON .NE. 0) THEN
         DO WHILE (ISON .GT. 0)
           NUMSTK = NUMSTK + 1
           ISON = FRERE(STEP(ISON))
         ENDDO
        ENDIF
        GOTO 123
      ENDIF
      NUMORG = 0
      DO WHILE (IN.GT.0)
        NUMORG = NUMORG + 1
        IN = FILS(IN)
      ENDDO
      NPIV_ANA=NUMORG
      NSTEPS = NSTEPS + 1
      NUMSTK = 0
      NASS = 0
      IFSON = -IN
      ISON = IFSON
      IF (ISON .NE. 0) THEN
        DO WHILE (ISON .GT. 0)
         NUMSTK = NUMSTK + 1
         NASS = NASS + IW(PIMASTER(STEP(ISON))+1+KEEP(IXSZ))
         ISON = FRERE(STEP(ISON))
         ENDDO
      ENDIF
      NFRONT = ND(STEP(INODE)) + NASS
      NASS1 = NASS + NUMORG
      LREQ_OOC = 0
      IF (KEEP(201).EQ.1) THEN
        CALL DAGMG_MUMPS_684( KEEP(50), NFRONT, NFRONT, NASS1,               &
     &                                NBPANELS_L, NBPANELS_U, LREQ_OOC)
      ENDIF
      LREQ = HF + 2 * NFRONT + LREQ_OOC
      IF ((IWPOS + LREQ -1) .GT. IWPOSCB) THEN
          CALL DAGMG_MUMPS_94(N, KEEP(28),                                   &
     &        IW, LIW, A, LA,                                           &
     &        LRLU, IPTRLU,                                             &
     &        IWPOS, IWPOSCB, PTRIST, PTRAST,                           &
     &        STEP, PIMASTER, PAMASTER, ITLOC,KEEP(216),LRLUS,          &
     &        KEEP(IXSZ))
          COMP = COMP+1
          IF (LRLU .NE. LRLUS) THEN
            WRITE( *, * ) 'PB compress ass..mpi51f_niv1.F'
            WRITE( *, * ) 'LRLU,LRLUS=',LRLU,LRLUS
            GOTO 270
          ENDIF
          IF ((IWPOS + LREQ -1) .GT. IWPOSCB) GOTO 270
      ENDIF
      IOLDPS = IWPOS
      IWPOS = IWPOS + LREQ
      ISON_TOP      = -9999
      ISON_IN_PLACE = -9999
      SIZE_ISON_TOP8 = 0_8
      IF (KEEP(234).NE.0) THEN
        IF ( IWPOSCB .NE. LIW ) THEN
        IF ( IWPOSCB+IW(IWPOSCB+1+XXI).NE.LIW) THEN
          ISON = IW( IWPOSCB + 1 + XXN )
          IF ( DAD( STEP( ISON ) ) .EQ. INODE .AND.                     &
     &    AGMG_MUMPS_330(STEP(ISON),PROCNODE_STEPS,SLAVEF)                   &
     &    .EQ. 1 )                                                      &
     &    THEN
            ISON_TOP = ISON
            CALL AGMG_MUMPS_729(SIZE_ISON_TOP8,IW(IWPOSCB + 1 + XXR))
            IF (LRLU .LT. int(NFRONT,8) * int(NFRONT,8)) THEN
              ISON_IN_PLACE = ISON
            ENDIF
          END IF
        END IF
        END IF
      END IF
      NIV1 = .TRUE.
      IF (KEEP(50).EQ.0 .AND. KEEP(234) .EQ. 0) THEN
        CALL  AGMG_MUMPS_81(MYID, INODE, N, IOLDPS, HF, NFRONT,              &
     &        NFRONT_EFF,                                               &
     &        NASS1, NASS, NUMSTK, NUMORG, IWPOSCB,                     &
     &        IFSON, STEP, PIMASTER, PTRAIW, IW, LIW,                   &
     &        INTARR, ITLOC, FILS, FRERE,                               &
     &        SON_LEVEL2, NIV1, NBPROCFILS, KEEP, KEEP8, IFLAG)
      ELSE
        CALL AGMG_MUMPS_86( MYID, INODE, N, IOLDPS, HF,                      &
     &        NFRONT, NFRONT_EFF, PERM,                                 &
     &        NASS1, NASS, NUMSTK, NUMORG, IWPOSCB,                     &
     &        IFSON, STEP, PIMASTER, PTRAIW, IW, LIW,                   &
     &        INTARR, ITLOC, FILS, FRERE,                               &
     &        SON_LEVEL2, NIV1, NBPROCFILS, KEEP, KEEP8, IFLAG,         &
     &        ISON_IN_PLACE)
        IF (IFLAG.LT.0) GOTO 300
      ENDIF
      IF (NFRONT_EFF.NE.NFRONT) THEN
        IF (NFRONT.GT.NFRONT_EFF) THEN
           IF(AGMG_MUMPS_170(STEP(INODE),PROCNODE_STEPS,                     &
     &          SLAVEF))THEN
              NPIV=NASS1-(NFRONT_EFF-ND(STEP(INODE)))
              CALL AGMG_MUMPS_511(ND(STEP(INODE)),NPIV,NPIV,                 &
     &                                 KEEP(50),1,FLOP1)
              NPIV=NPIV_ANA
              CALL AGMG_MUMPS_511(ND(STEP(INODE)),NPIV,NPIV,                 &
     &                                 KEEP(50),1,FLOP1_EFF)
              CALL DAGMG_MUMPS_190(0,.FALSE.,FLOP1-FLOP1_EFF,                &
     &             KEEP,KEEP8)
           ENDIF
           IWPOS = IWPOS - ((2*NFRONT)-(2*NFRONT_EFF))
           NFRONT = NFRONT_EFF
           LREQ = HF + 2 * NFRONT + LREQ_OOC
        ELSE
           Write(*,*) ' ERROR 1 during ass_niv1', NFRONT, NFRONT_EFF
           GOTO 270
        ENDIF
      ENDIF
      NFRONT8=int(NFRONT,8)
      IF (KEEP(201).EQ.1.AND.KEEP(50).NE.1) THEN
        CALL DAGMG_MUMPS_691(KEEP(50),                                       &
     &       NBPANELS_L, NBPANELS_U, NASS1,                             &
     &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
      ENDIF
      NCB   = NFRONT - NASS1
      MAXFRW = max0(MAXFRW, NFRONT)
      ICT11 = IOLDPS + HF - 1 + NFRONT
      LAELL8 = NFRONT8 * NFRONT8
      LAELL_REQ8 = LAELL8
      IF ( ISON_IN_PLACE > 0 ) THEN
        LAELL_REQ8 = LAELL8 - SIZE_ISON_TOP8
      ENDIF
      IF (LRLU .LT. LAELL_REQ8) THEN
        IF (LRLUS .LT. LAELL_REQ8) THEN
          GOTO 280
        ELSE
          CALL DAGMG_MUMPS_94                                                &
     &        (N, KEEP(28), IW, LIW, A, LA, LRLU, IPTRLU,               &
     &         IWPOS, IWPOSCB, PTRIST, PTRAST, STEP, PIMASTER,          &
     &         PAMASTER,ITLOC,KEEP(216),LRLUS,KEEP(IXSZ))
          COMP = COMP + 1
          IF (LRLU .NE. LRLUS) THEN
            WRITE( *, * ) 'PB compress ass..mpi51f_niv1.F'
            WRITE( *, * ) 'LRLU,LRLUS=',LRLU,LRLUS
            GOTO 280
          ENDIF
        ENDIF
      ENDIF
      LRLU = LRLU - LAELL8
      LRLUS = LRLUS - LAELL8 + SIZE_ISON_TOP8
      KEEP8(67) = min(LRLUS, KEEP8(67))
      POSELT = POSFAC
      POSFAC = POSFAC + LAELL8
      SSARBR=AGMG_MUMPS_167(STEP(INODE),PROCNODE_STEPS,SLAVEF)
      CALL DAGMG_MUMPS_471(SSARBR,.FALSE.,                                   &
     &     LA-LRLUS,                                                    &
     &     0_8,                                                         &
     &     LAELL8-SIZE_ISON_TOP8,                                       &
     &     KEEP,KEEP8,                                                  &
     &     LRLU)
      LAPOS2 = min(POSELT + LAELL8 - 1_8, IPTRLU)
      A(POSELT:LAPOS2) = dble(ZERO)
      PTRAST(STEP(INODE)) = POSELT
      PTRFAC(STEP(INODE)) = POSELT
      PTLUST_S(STEP(INODE)) = IOLDPS
      IW(IOLDPS+XXI)   = LREQ
      CALL AGMG_MUMPS_730(LAELL8,IW(IOLDPS+XXR))
      IW(IOLDPS+XXS) =-9999
      IW(IOLDPS+XXS+1:IOLDPS+KEEP(IXSZ)-1)=-99999
      IW(IOLDPS + KEEP(IXSZ))   = NFRONT
      IW(IOLDPS + KEEP(IXSZ) + 1) = 0
      IW(IOLDPS + KEEP(IXSZ) + 2) = -NASS1
      IW(IOLDPS + KEEP(IXSZ) + 3) = -NASS1
      IW(IOLDPS + KEEP(IXSZ) + 4) = STEP(INODE)
      IW(IOLDPS + KEEP(IXSZ) + 5)   = NSLAVES
  123 CONTINUE
      IF (NUMSTK.NE.0) THEN
        IF (ISON_TOP > 0) THEN
          ISON = ISON_TOP
        ELSE
          ISON = IFSON
        ENDIF
        DO 220 IELL = 1, NUMSTK
          ISTCHK    = PIMASTER(STEP(ISON))
          LSTK      = IW(ISTCHK + KEEP(IXSZ))
          NELIM     = IW(ISTCHK + KEEP(IXSZ) + 1)
          NPIVS     = IW(ISTCHK + KEEP(IXSZ) + 3)
          IF ( NPIVS .LT. 0 ) NPIVS = 0
          NSLSON    = IW(ISTCHK + KEEP(IXSZ) + 5)
          HS        = 6 + KEEP(IXSZ) + NSLSON
          NCOLS     = NPIVS + LSTK
          SAME_PROC     = (ISTCHK.LE.IWPOS)
          IF ( SAME_PROC ) THEN
            COMPRESSCB=( IW(PTRIST(STEP(ISON))+XXS) .EQ. S_CB1COMP )
          ELSE
            COMPRESSCB=( IW(ISTCHK + XXS) .EQ. S_CB1COMP )
          ENDIF
          LEVEL1    = NSLSON.EQ.0
          IF (.NOT.SAME_PROC) THEN
           NROWS = IW( ISTCHK + KEEP(IXSZ) + 2)
          ELSE
           NROWS = NCOLS
          ENDIF
          SIZFI   = HS + NROWS + NCOLS
          J1 = ISTCHK + HS + NROWS + NPIVS
          IF ( .NOT. LEVEL1 .AND. NELIM.EQ.0 ) GOTO 205
          IF (LEVEL1) THEN
           J2 = J1 + LSTK - 1
           SIZFR  = int(LSTK,8)*int(LSTK,8)
           IF (COMPRESSCB) SIZFR = (int(LSTK,8)*int(LSTK+1,8))/2_8
          ELSE
           IF ( KEEP(50).eq.0 ) THEN
             SIZFR = int(NELIM,8) * int(LSTK,8)
           ELSE
             SIZFR = int(NELIM,8) * int(NELIM,8)
           END IF
           J2 = J1 + NELIM - 1
          ENDIF
          IF (JOBASS.EQ.0) OPASSW = OPASSW + dble(SIZFR)
          IACHK = PAMASTER(STEP(ISON))
          IF ( KEEP(50) .eq. 0 ) THEN
            POSEL1 = PTRAST(STEP(INODE)) - NFRONT8
            IF (NFRONT .EQ. LSTK.AND. ISON.EQ.ISON_IN_PLACE             &
     &          .AND.IACHK + SIZFR - 1_8 .EQ. POSFAC - 1_8 ) THEN
               GOTO 205
            ENDIF
            IF (J2.GE.J1) THEN
              RESET_TO_ZERO = (IACHK .LT. POSFAC)
              RISK_OF_SAME_POS = IACHK + SIZFR - 1_8 .EQ. POSFAC - 1_8
              RISK_OF_SAME_POS_THIS_LINE = .FALSE.
              DO 170 JJ = J1, J2
                APOS = POSEL1 + int(IW(JJ),8) * int(NFRONT,8)
                IF (RISK_OF_SAME_POS) THEN
                  IF (JJ.EQ.J2) THEN
                    RISK_OF_SAME_POS_THIS_LINE =                        &
     &                  (ISON .EQ. ISON_IN_PLACE)                       &
     &                  .AND. ( APOS + int(IW(J1+LSTK-1)-1,8).EQ.       &
     &                          IACHK+int(LSTK-1,8) )
                  ENDIF
                ENDIF
                IF (RESET_TO_ZERO) THEN
                  IF (RISK_OF_SAME_POS_THIS_LINE) THEN
                    DO JJ1 = 1, LSTK
                      JJ2 = APOS + int(IW(J1 + JJ1 - 1) - 1,8)
                      IF ( IACHK+int(JJ1-1,8) .NE. JJ2 ) THEN
                        A(JJ2) = A(IACHK + int(JJ1 - 1,8))
                        A(IACHK + int(JJ1 -1,8)) = dble(ZERO)
                      ENDIF
                    ENDDO
                  ELSE
                    DO JJ1 = 1, LSTK
                      JJ2 = APOS + int(IW(J1+JJ1-1),8) - 1_8
                      A(JJ2) = A(IACHK + int(JJ1 - 1,8))
                      A(IACHK + int(JJ1 -1,8)) = dble(ZERO)
                    ENDDO
                  ENDIF
                ELSE
                  DO JJ1 = 1, LSTK
                    JJ2 = APOS + int(IW(J1+JJ1-1),8) - 1_8
                    A(JJ2) = A(JJ2) + A(IACHK + int(JJ1 - 1,8))
                  ENDDO
                ENDIF
                IACHK = IACHK + int(LSTK,8)
                IF (IACHK .GE. POSFAC) RESET_TO_ZERO =.FALSE.
  170         CONTINUE
            END IF
          ELSE
            IF (LEVEL1) THEN
             LDA_SON = LSTK
            ELSE
             LDA_SON = NELIM
            ENDIF
            IF (COMPRESSCB) THEN
              LCB = SIZFR
            ELSE
              LCB = int(LDA_SON,8)* int(J2-J1+1,8)
            ENDIF
            CALL DAGMG_MUMPS_178(A, LA,                                      &
     &           PTRAST(STEP( INODE )), NFRONT, NASS1,                  &
     &           IACHK, LDA_SON, LCB,                                   &
     &           IW( J1 ), J2 - J1 + 1, NELIM, ETATASS,                 &
     &           COMPRESSCB, (ISON.EQ.ISON_IN_PLACE)                    &
     &          )
          ENDIF
  205     IF (LEVEL1) THEN
           IF (SAME_PROC) ISTCHK = PTRIST(STEP(ISON))
           IF ((SAME_PROC).AND.ETATASS.NE.1) THEN
             IF (KEEP(50).NE.0) THEN
              J2 = J1 + LSTK - 1
              DO JJ = J1, J2
               IW(JJ) = IW(JJ - NROWS)
              ENDDO
             ELSE
              J2 = J1 + LSTK - 1
              J3 = J1 + NELIM
              DO JJ = J3, J2
               IW(JJ) = IW(JJ - NROWS)
              ENDDO
              IF (NELIM .NE. 0) THEN
                J3 = J3 - 1
                DO JJ = J1, J3
                 JPOS = IW(JJ) + ICT11
                 IW(JJ) = IW(JPOS)
                ENDDO
              ENDIF
             ENDIF
           ENDIF
           IF (ETATASS.NE.1) THEN
             IF ( SAME_PROC ) THEN
               PTRIST(STEP(ISON))   = -99999999
             ELSE
               PIMASTER(STEP( ISON )) = -99999999
             ENDIF
             CALL DAGMG_MUMPS_152(SSARBR, MYID, N, ISTCHK,                   &
     &          PAMASTER(STEP(ISON)),                                   &
     &          IW, LIW, LRLU, LRLUS, IPTRLU,                           &
     &          IWPOSCB, LA, KEEP,KEEP8,                                &
     &          (ISON .EQ. ISON_TOP)                                    &
     &          )
           ENDIF
          ELSE
           PDEST = ISTCHK + 6 + KEEP(IXSZ)
           NCBSON  = LSTK - NELIM
           PTRCOL   = ISTCHK +  HS + NROWS + NPIVS + NELIM
           DO ISLAVE = 0, NSLSON-1
             IF (IW(PDEST+ISLAVE).EQ.MYID) THEN
              CALL AGMG_MUMPS_49(                                            &
     &                KEEP, KEEP8, ISON, STEP, N, SLAVEF,               &
     &                ISTEP_TO_INIV2, TAB_POS_IN_PERE,                  &
     &                ISLAVE+1, NCBSON,                                 &
     &                NSLSON,                                           &
     &                TROW_SIZE, FIRST_INDEX  )
              SHIFT_INDEX = FIRST_INDEX - 1
              INDX = PTRCOL + SHIFT_INDEX
              CALL DAGMG_MUMPS_210( COMM_LOAD, ASS_IRECV,                    &
     &             BUFR, LBUFR, LBUFR_BYTES,                            &
     &             INODE, ISON, NSLAVES, IDUMMY,                        &
     &             NFRONT, NASS1,NFS4FATHER,                            &
     &             TROW_SIZE, IW( INDX ),                               &
     &         PROCNODE_STEPS,                                          &
     &         SLAVEF, POSFAC, IWPOS, IWPOSCB, IPTRLU, LRLU,            &
     &         LRLUS, N, IW,                                            &
     &         LIW, A, LA,                                              &
     &         PTRIST, PTLUST_S, PTRFAC, PTRAST, STEP,                  &
     &         PIMASTER, PAMASTER, NSTK_S, COMP,                        &
     &         IFLAG, IERROR, MYID, COMM, NBPROCFILS, IPOOL, LPOOL,     &
     &         LEAF, NBFIN, ICNTL, KEEP, KEEP8,  root,                  &
     &         OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,             &
     &         INTARR, DBLARR, ND, FRERE,                               &
     &         LPTRAR, NELT, IW, IW,                                    &
     &         ISTEP_TO_INIV2, TAB_POS_IN_PERE )
              IF ( IFLAG .LT. 0 ) GOTO 500
              EXIT
             ENDIF
           ENDDO
           IF (PIMASTER(STEP(ISON)).GT.0) THEN
           IERR = -1
           DO WHILE (IERR.EQ.-1)
            PTRCOL = PIMASTER(STEP(ISON)) + HS + NROWS + NPIVS + NELIM
            PDEST  = PIMASTER(STEP(ISON)) + 6 + KEEP(IXSZ)
            CALL  DAGMG_MUMPS_71(                                            &
     &           INODE, NFRONT, NASS1, NFS4FATHER,                      &
     &           ISON, MYID,                                            &
     &       IZERO, IDUMMY, IW(PTRCOL), NCBSON,                         &
     &       COMM, IERR, IW(PDEST), NSLSON, SLAVEF,                     &
     &       KEEP, KEEP8, STEP, N,                                      &
     &       ISTEP_TO_INIV2, TAB_POS_IN_PERE                            &
     &        )
            IF (IERR.EQ.-1) THEN
             BLOCKING  = .FALSE.
             SET_IRECV = .TRUE.
             MESSAGE_RECEIVED = .FALSE.
             CALL DAGMG_MUMPS_329(                                           &
     &         COMM_LOAD, ASS_IRECV,                                    &
     &         BLOCKING, SET_IRECV, MESSAGE_RECEIVED,                   &
     &         AGMG_MPF_ANY_SOURCE, AGMG_MPF_ANY_TAG,                             &
     &         STATUS,                                                  &
     &         BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,        &
     &         IWPOS, IWPOSCB, IPTRLU,                                  &
     &         LRLU, LRLUS, N, IW, LIW, A, LA,                          &
     &         PTRIST, PTLUST_S, PTRFAC,                                &
     &         PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,          &
     &         IFLAG, IERROR, COMM,                                     &
     &         NBPROCFILS,                                              &
     &         IPOOL, LPOOL, LEAF,                                      &
     &         NBFIN, MYID, SLAVEF,                                     &
     &         root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,       &
     &         INTARR, DBLARR, ICNTL, KEEP, KEEP8, ND, FRERE,           &
     &         LPTRAR, NELT, IW, IW,                                    &
     &         ISTEP_TO_INIV2, TAB_POS_IN_PERE, .TRUE. )
               IF ( IFLAG .LT. 0 ) GOTO 500
            ENDIF
           ENDDO
           IF (IERR .EQ. -2) GOTO 290
           IF (IERR .EQ. -3) GOTO 295
           ENDIF
          ENDIF
  210   ISON = FRERE(STEP(ISON))
        IF (ISON .LE. 0) THEN
          ISON = IFSON
        ENDIF
  220 END DO
      END IF
      IF (ETATASS.EQ.2) GOTO 500
      POSELT = PTRAST(STEP(INODE))
      IBROT = INODE
      DO 260 IORG = 1, NUMORG
        JK = PTRAIW(IBROT)
        AINPUT = PTRARW(IBROT)
        IBROT = FILS(IBROT)
        JJ = JK + 1
        J1 = JJ + 1
        J2 = J1 + INTARR(JK)
        J3 = J2 + 1
        J4 = J2 - INTARR(JJ)
        IJROW = INTARR(J1)
        ICT12 = POSELT + int(IJROW - NFRONT - 1,8)
!duplicates --> CVD$ DEPCHK
        DO 240 JJ = J1, J2
           APOS2 = ICT12 + int(INTARR(JJ),8) * NFRONT8
           IF (APOS2 .LT.0_8) THEN
             WRITE(*,*) "APOS2=",APOS2
             WRITE(*,*) "INTARR(JJ)=",INTARR(JJ)
             WRITE(*,*) "ICT12=",ICT12
           ENDIF
           A(APOS2) = A(APOS2) + DBLARR(AINPUT)
          AINPUT = AINPUT + 1
  240   CONTINUE
        IF (J3 .LE. J4) THEN
          ICT13 = POSELT + int(IJROW - 1,8) * NFRONT8
          NBCOL = J4 - J3 + 1
!duplicates--> CVD$ DEPCHK
!duplicatesCVD$ NODEPCHK
          DO 250 JJ = 1, NBCOL
            APOS3 = ICT13 + int(INTARR(J3 + JJ - 1) - 1,8)
            A(APOS3) = A(APOS3) + DBLARR(AINPUT + JJ - 1)
  250     CONTINUE
        ENDIF
  260 END DO
      GOTO 500
  270 CONTINUE
      IFLAG = -8
      IERROR = LREQ
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE IN INTEGER ALLOCATION DURING DMUMPS_252'
      ENDIF
      GOTO 490
  280 CONTINUE
      IFLAG = -9
      IF (LAELL_REQ8 - LRLUS .GT. int(huge(IERROR),8)) THEN
        WRITE(*,*) "I8: OVERFLOW",LAELL_REQ8, LRLUS
        CALL AGMG_MUMPS_ABORT()
      ENDIF
      IERROR = int(LAELL_REQ8 - LRLUS, 4)
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE, WORKSPACE TOO SMALL DURING DMUMPS_252'
      ENDIF
      GOTO 490
  290 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &  ' FAILURE, SEND BUFFER TOO SMALL DURING DMUMPS_252'
      ENDIF
      IFLAG = -17
      LREQ = NCBSON + 6+NSLSON+KEEP(IXSZ)
      IERROR =  LREQ  * KEEP( 34 )
      GOTO 490
  295 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &  ' FAILURE, SEND BUFFER TOO SMALL DURING DMUMPS_252'
      ENDIF
      IFLAG = -17
      LREQ = NCBSON + 6+NSLSON+KEEP(IXSZ)
      IERROR =  LREQ  * KEEP( 34 )
      GOTO 490
  300 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     & ' FAILURE IN INTEGER DYNAMIC ALLOCATION DURING DMUMPS_252'
      ENDIF
      IFLAG   = -13
      IERROR  = NUMSTK + 1
  490 CALL  DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
  500 CONTINUE
      RETURN
      END SUBROUTINE DAGMG_MUMPS_252
      SUBROUTINE DAGMG_MUMPS_253(COMM_LOAD, ASS_IRECV,                       &
     &    N, INODE, IW, LIW, A, LA, IFLAG,                              &
     &    IERROR, ND, FILS, FRERE,                                      &
     &    CAND,                                                         &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE,                              &
     &    MAXFRW, root,                                                 &
     &    OPASSW, OPELIW, PTRIST, PTLUST_S,  PTRFAC,                    &
     &    PTRAST, STEP, PIMASTER, PAMASTER, PTRARW, NSTK_S,             &
     &    PTRAIW, ITLOC, NSTEPS,                                        &
     &    COMP, LRLU, IPTRLU, IWPOS, IWPOSCB, POSFAC, LRLUS,            &
     &    ICNTL, KEEP, KEEP8,INTARR,DBLARR,                             &
     &    NBPROCFILS, PROCNODE_STEPS, SLAVEF, COMM,MYID,                &
     &    BUFR, LBUFR, LBUFR_BYTES, NBFIN, LEAF, IPOOL, LPOOL,          &
     &    PERM , MEM_DISTRIB)
      USE DAGMG_MUMPS_COMM_BUFF
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      INTEGER IERR, STATUS( AGMG_MPF_STATUS_SIZE )
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER COMM_LOAD, ASS_IRECV
      INTEGER N,LIW,NSTEPS, NBFIN
      INTEGER(8) :: LA
      INTEGER KEEP(500), ICNTL(40)
      INTEGER*8 KEEP8(150)
      INTEGER IFLAG,IERROR,INODE,MAXFRW,                                &
     &        LPOOL, LEAF, IWPOS, IWPOSCB, COMP
      INTEGER(8) :: LRLUS, LRLU, IPTRLU, POSFAC
      DOUBLE PRECISION A(LA)
      DOUBLE PRECISION  OPASSW, OPELIW
      INTEGER COMM, SLAVEF, MYID,  LBUFR, LBUFR_BYTES
      INTEGER, DIMENSION(0:SLAVEF - 1) :: MEM_DISTRIB
      INTEGER IPOOL(LPOOL)
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER IW(LIW), ITLOC(N),                                        &
     &        PTRARW(N), PTRAIW(N), ND(KEEP(28)),                       &
     &        FILS(N), FRERE(KEEP(28)),                                 &
     &        PTRIST(KEEP(28)), PTLUST_S(KEEP(28)),                     &
     &        STEP(N),                                                  &
     & PIMASTER(KEEP(28)),                                              &
     &        NSTK_S(KEEP(28)), PERM(N)
      INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
      INTEGER   ISTEP_TO_INIV2(KEEP(71)),                               &
     &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      INTEGER NBPROCFILS(KEEP(28)),                                     &
     &        PROCNODE_STEPS(KEEP(28)), BUFR(LBUFR)
      INTEGER      INTARR(max(1,KEEP(14)))
      DOUBLE PRECISION DBLARR(max(1,KEEP(13)))
      INTEGER LP, HS, HF, HF_OLD,NCBSON, NSLAVES_OLD
      INTEGER IN,NUMSTK,NASS,ISON,IFSON,NASS1,IELL
      INTEGER NFS4FATHER,I
      INTEGER NFRONT,NFRONT_EFF,ISTCHK,LSTK,LREQ
      INTEGER(8) :: NFRONT8, LAELL8
      INTEGER LREQ_OOC
      LOGICAL COMPRESSCB
      INTEGER(8) :: LCB
      INTEGER NCB, IERR_MPI
      INTEGER J1,J2,J3,MP
      INTEGER(8) :: JJ8, LAPOS2, JJ2, JJ3
      INTEGER NELIM,JJ,JJ1,NPIVS,NCOLS,NROWS,                           &
     &        IBROT,IORG
      INTEGER LDAFS, LDA_SON
      INTEGER JK,IJROW,NBCOL,NUMORG,IOLDPS,J4
      INTEGER(8) :: ICT13
      INTEGER(8) :: IACHK, APOS, APOS2, POSELT, ICT12, POSEL1
      INTEGER AINPUT
      INTEGER NSLAVES, NSLSON
      INTEGER NBLIG, PTRCOL, PTRROW, ISLAVE, PDEST
      INTEGER PDEST1(1)
      INTEGER NSLAVES_less, ITEMP, NMB_OF_CAND
      INTEGER ISON_IN_PLACE
      LOGICAL FLAG, SAME_PROC, NIV1, SON_LEVEL2
      LOGICAL BLOCKING, SET_IRECV, MESSAGE_RECEIVED
      INTEGER TROW_SIZE, INDX, FIRST_INDEX, SHIFT_INDEX
      INTEGER IZERO
      INTEGER IDUMMY(1)
      PARAMETER( IZERO = 0 )
      INTEGER AGMG_MUMPS_275, AGMG_MUMPS_330
      EXTERNAL AGMG_MUMPS_275, AGMG_MUMPS_330
      INTRINSIC real
      DOUBLE PRECISION ZERO
      DATA ZERO /0.0D0/
      INTEGER NELT, LPTRAR, NCBSON_MAX
      logical :: force_cand
      INTEGER ETATASS
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      INTEGER (8) :: APOSMAX
      DOUBLE PRECISION  MAXARR
      INTEGER INIV2, SIZE_TMP_SLAVES_LIST, allocok
      INTEGER, ALLOCATABLE, DIMENSION(:) :: TMP_SLAVES_LIST
      INTEGER NBPANELS_L, NBPANELS_U
      MP         = ICNTL(2)
      COMPRESSCB = .FALSE.
      ETATASS    = 0
      IN         = INODE
      NBPROCFILS(STEP(IN)) = 0
      NSTEPS = NSTEPS + 1
      NUMORG = 0
      DO WHILE (IN.GT.0)
        NUMORG = NUMORG + 1
        IN = FILS(IN)
      ENDDO
      NUMSTK = 0
      NASS = 0
      IFSON = -IN
      ISON = IFSON
      NCBSON_MAX = 0
      NELT = 1
      LPTRAR = 1
      DO WHILE (ISON .GT. 0)
        NUMSTK = NUMSTK + 1
        IF ( KEEP(48)==5 .AND. AGMG_MUMPS_330(STEP(ISON),                    &
     &       PROCNODE_STEPS,SLAVEF) .EQ. 1) THEN
          NCBSON_MAX = max                                              &
     &      (                                                           &
     &       IW(PIMASTER(STEP(ISON))+KEEP(IXSZ)), NCBSON_MAX            &
     &       )
        ENDIF
        NASS = NASS + IW(PIMASTER(STEP(ISON)) + 1 + KEEP(IXSZ))
        ISON = FRERE(STEP(ISON))
      ENDDO
      NFRONT = ND(STEP(INODE)) + NASS
      NASS1 = NASS + NUMORG
      NCB   = NFRONT - NASS1
      if((KEEP(24).eq.0).or.(KEEP(24).eq.1)) then
         force_cand=.FALSE.
      else
         force_cand=(mod(KEEP(24),2).eq.0)
      end if
      IF (force_cand) THEN
         INIV2 = ISTEP_TO_INIV2( STEP( INODE ))
         SIZE_TMP_SLAVES_LIST = CAND( SLAVEF+1, INIV2 )
      ELSE
         INIV2 = 1
         SIZE_TMP_SLAVES_LIST = SLAVEF - 1
      ENDIF
      ALLOCATE(TMP_SLAVES_LIST(SIZE_TMP_SLAVES_LIST),stat=allocok)
      IF (allocok > 0 ) THEN
        GOTO 265
      ENDIF
      CALL DAGMG_MUMPS_472( NCBSON_MAX, SLAVEF, KEEP,KEEP8,                  &
     &     ICNTL, CAND(1,INIV2),                                        &
     &     MEM_DISTRIB(0), NCB, NFRONT, NSLAVES,                        &
     &     TAB_POS_IN_PERE(1,ISTEP_TO_INIV2(STEP(INODE))),              &
     &     TMP_SLAVES_LIST,                                             &
     &     SIZE_TMP_SLAVES_LIST,INODE )
      HF   = NSLAVES + 6 + KEEP(IXSZ)
      LREQ_OOC = 0
      IF (KEEP(201).EQ.1) THEN
        CALL DAGMG_MUMPS_684(KEEP(50), NASS1, NFRONT, NASS1,                 &
     &                               NBPANELS_L, NBPANELS_U, LREQ_OOC)
      ENDIF
      LREQ = HF + 2 * NFRONT + LREQ_OOC
      IF ((IWPOS + LREQ -1) .GT. IWPOSCB) THEN
          CALL DAGMG_MUMPS_94(N, KEEP(28),                                   &
     &        IW, LIW, A, LA,                                           &
     &        LRLU, IPTRLU,                                             &
     &        IWPOS, IWPOSCB, PTRIST, PTRAST,                           &
     &        STEP, PIMASTER, PAMASTER, ITLOC,                          &
     &        KEEP(216),LRLUS,KEEP(IXSZ))
          COMP = COMP+1
          IF (LRLU .NE. LRLUS) THEN
            WRITE( *, * ) 'PB compress ass..mpi51f_niv2'
            WRITE( *, * ) 'LRLU,LRLUS=',LRLU,LRLUS
            GOTO 270
          ENDIF
          IF ((IWPOS + LREQ -1) .GT. IWPOSCB) GOTO 270
      ENDIF
      IOLDPS = IWPOS
      IWPOS = IWPOS + LREQ
      NIV1 = .FALSE.
      IF (KEEP(50).EQ.0 .AND. KEEP(234).EQ.0) THEN
        CALL  AGMG_MUMPS_81(MYID, INODE, N, IOLDPS, HF, NFRONT,              &
     &        NFRONT_EFF,                                               &
     &        NASS1, NASS, NUMSTK, NUMORG, IWPOSCB,                     &
     &        IFSON, STEP, PIMASTER, PTRAIW, IW, LIW,                   &
     &        INTARR, ITLOC, FILS, FRERE,                               &
     &        SON_LEVEL2, NIV1, NBPROCFILS, KEEP,KEEP8, IFLAG)
      ELSE
        ISON_IN_PLACE = -9999
        CALL AGMG_MUMPS_86( MYID, INODE, N, IOLDPS, HF,                      &
     &        NFRONT, NFRONT_EFF, PERM,                                 &
     &        NASS1, NASS, NUMSTK, NUMORG, IWPOSCB,                     &
     &        IFSON, STEP, PIMASTER, PTRAIW, IW, LIW,                   &
     &        INTARR, ITLOC, FILS, FRERE,                               &
     &        SON_LEVEL2, NIV1, NBPROCFILS, KEEP,KEEP8, IFLAG,          &
     &        ISON_IN_PLACE)
        IF (IFLAG.LT.0) GOTO 250
      ENDIF
      IF ( NFRONT .NE. NFRONT_EFF ) THEN
        IF (NFRONT.GT.NFRONT_EFF) THEN
            NCB    = NFRONT_EFF - NASS1
            NSLAVES_OLD = NSLAVES
            HF_OLD      = HF
            CALL DAGMG_MUMPS_472( NCBSON_MAX,                                &
     &      SLAVEF, KEEP,KEEP8, ICNTL,                                  &
     &      CAND(1,INIV2),                                              &
     &      MEM_DISTRIB(0), NCB, NFRONT_EFF, NSLAVES,                   &
     &      TAB_POS_IN_PERE(1,ISTEP_TO_INIV2(STEP(INODE))),             &
     &      TMP_SLAVES_LIST, SIZE_TMP_SLAVES_LIST,INODE )
            HF = NSLAVES + 6 + KEEP(IXSZ)
            IWPOS = IWPOS - ((2*NFRONT)-(2*NFRONT_EFF)) -               &
     &                   (NSLAVES_OLD - NSLAVES)
            IF (NSLAVES_OLD .NE. NSLAVES) THEN
              IF (NSLAVES_OLD > NSLAVES) THEN
               IW(IOLDPS+HF: IOLDPS+HF+2*NFRONT_EFF-1) =                &
     &         IW(IOLDPS+HF_OLD: IOLDPS+HF_OLD+2*NFRONT_EFF-1)
              ELSE
               IF (IWPOS - 1 > IWPOSCB ) GOTO 270
               DO JJ=2*NFRONT_EFF-1, 0, -1
                 IW(IOLDPS+HF+JJ) = IW(IOLDPS+HF_OLD+JJ)
               ENDDO
              END IF
            END IF
            NFRONT = NFRONT_EFF
            LREQ = HF + 2 * NFRONT + LREQ_OOC
        ELSE
          Write(*,*) ' ERROR 2 during ass_niv2'
          GOTO 270
        ENDIF
      ENDIF
      IF (KEEP(201).EQ.1.AND.KEEP(50).NE.1) THEN
        CALL DAGMG_MUMPS_691(KEEP(50),                                       &
     &       NBPANELS_L, NBPANELS_U, NASS1,                             &
     &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
      ENDIF
      MAXFRW = max0(MAXFRW, NFRONT)
      PTLUST_S(STEP(INODE)) = IOLDPS
      IW(IOLDPS + 1+KEEP(IXSZ)) = 0
      IW(IOLDPS + 2+KEEP(IXSZ)) = -NASS1
      IW(IOLDPS + 3+KEEP(IXSZ)) = -NASS1
      IW(IOLDPS + 4+KEEP(IXSZ)) = STEP(INODE)
      IW(IOLDPS+KEEP(IXSZ))   = NFRONT
      IW(IOLDPS+5+KEEP(IXSZ)) = NSLAVES
      IW(IOLDPS+6+KEEP(IXSZ):IOLDPS+5+KEEP(IXSZ)+NSLAVES)=              &
     &             TMP_SLAVES_LIST(1:NSLAVES)
      CALL DAGMG_MUMPS_461(MYID, SLAVEF, COMM_LOAD,                          &
     &     TAB_POS_IN_PERE(1,ISTEP_TO_INIV2(STEP(INODE))),              &
     &     NASS1, KEEP,KEEP8, IW(IOLDPS+6+KEEP(IXSZ)), NSLAVES,INODE)
      IF(KEEP(86).EQ.1)THEN
         IF(mod(KEEP(24),2).eq.0)THEN
            CALL DAGMG_MUMPS_533(SLAVEF,CAND(SLAVEF+1,INIV2),                &
     &           TAB_POS_IN_PERE(1,ISTEP_TO_INIV2(STEP(INODE))),        &
     &           NASS1, KEEP,KEEP8, TMP_SLAVES_LIST, NSLAVES,INODE)
         ELSEIF((KEEP(24).EQ.0).OR.(KEEP(24).EQ.1))THEN
            CALL DAGMG_MUMPS_533(SLAVEF,SLAVEF-1,                            &
     &           TAB_POS_IN_PERE(1,ISTEP_TO_INIV2(STEP(INODE))),        &
     &           NASS1, KEEP,KEEP8, TMP_SLAVES_LIST, NSLAVES,INODE)
         ENDIF
      ENDIF
      DEALLOCATE(TMP_SLAVES_LIST)
      IF (KEEP(50).EQ.0) THEN
        LAELL8 = int(NASS1,8) * int(NFRONT,8)
        LDAFS = NFRONT
      ELSE
        LAELL8 = int(NASS1,8)*int(NASS1,8)
        IF(KEEP(219).NE.0.AND.KEEP(50) .EQ. 2)                          &
     &     LAELL8 = LAELL8+int(NASS1,8)
        LDAFS = NASS1
      ENDIF
      IF (LRLU .LT. LAELL8) THEN
        IF (LRLUS .LT. LAELL8) THEN
          GOTO 280
        ELSE
         CALL DAGMG_MUMPS_94(N, KEEP(28),                                    &
     &      IW, LIW, A, LA,                                             &
     &      LRLU, IPTRLU,                                               &
     &      IWPOS, IWPOSCB, PTRIST, PTRAST,                             &
     &      STEP, PIMASTER, PAMASTER, ITLOC,KEEP(216),LRLUS,            &
     &      KEEP(IXSZ))
         IF (LRLU .NE. LRLUS) THEN
          WRITE( *, * ) 'PB compress ass..mpi51f_niv2'
          WRITE( *, * ) 'LRLU,LRLUS=',LRLU,LRLUS
          GOTO 280
         ENDIF
        ENDIF
      ENDIF
      LRLU = LRLU - LAELL8
      LRLUS = LRLUS - LAELL8
      KEEP8(67) = min(LRLUS, KEEP8(67))
      POSELT = POSFAC
      PTRAST(STEP(INODE)) = POSELT
      PTRFAC(STEP(INODE)) = POSELT
      POSFAC = POSFAC + LAELL8
      IW(IOLDPS+XXI)   = LREQ
      CALL AGMG_MUMPS_730(LAELL8,IW(IOLDPS+XXR))
      IW(IOLDPS+XXS) =-9999
      IW(IOLDPS+XXS+1:IOLDPS+KEEP(IXSZ)-1)=-99999
      CALL DAGMG_MUMPS_471(.FALSE.,.FALSE.,LA-LRLUS,0_8,LAELL8,              &
     &     KEEP,KEEP8,LRLU)
      POSEL1 = POSELT - int(LDAFS,8)
      LAPOS2 = POSELT + LAELL8 - 1_8
      A(POSELT:LAPOS2) = dble(ZERO)
      IF ((NUMSTK.NE.0).AND.(NASS.NE.0)) THEN
        ISON = IFSON
        DO 220 IELL = 1, NUMSTK
          ISTCHK = PIMASTER(STEP(ISON))
          NELIM = IW(ISTCHK + 1+KEEP(IXSZ))
          IF (NELIM.EQ.0) GOTO 210
          LSTK    = IW(ISTCHK+KEEP(IXSZ))
          NPIVS   = IW(ISTCHK + 3+KEEP(IXSZ))
          IF (NPIVS.LT.0) NPIVS=0
          NSLSON  = IW(ISTCHK + 5+KEEP(IXSZ))
          HS      = 6 + NSLSON  + KEEP(IXSZ)
          NCOLS     = NPIVS + LSTK
          SAME_PROC     = (ISTCHK.LE.IWPOS)
          IF ( SAME_PROC ) THEN
           COMPRESSCB=( IW(PTRIST(STEP(ISON))+XXS) .EQ. S_CB1COMP )
          ELSE
           COMPRESSCB=( IW(ISTCHK + XXS) .EQ. S_CB1COMP )
          ENDIF
          IF (.NOT.SAME_PROC) THEN
           NROWS = IW(ISTCHK + 2+KEEP(IXSZ))
          ELSE
           NROWS = NCOLS
          ENDIF
          OPASSW = OPASSW + dble(NELIM*LSTK)
          J1 = ISTCHK + HS + NROWS + NPIVS
          J2 = J1 + NELIM - 1
          IACHK = PAMASTER(STEP(ISON))
          IF (KEEP(50).eq.0) THEN
           DO 170 JJ = J1, J2
            APOS = POSEL1 + int(IW(JJ),8) * int(LDAFS,8)
            DO 160 JJ1 = 1, LSTK
              JJ2 = APOS + int(IW(J1 + JJ1 - 1),8) - 1_8
              A(JJ2) = A(JJ2) + A(IACHK + int(JJ1 - 1,8))
  160       CONTINUE
            IACHK = IACHK + int(LSTK,8)
  170      CONTINUE
          ELSE
            IF (NSLSON.EQ.0) THEN
             LDA_SON = LSTK
            ELSE
             LDA_SON = NELIM
            ENDIF
            IF (COMPRESSCB) THEN
              LCB = (int(NELIM,8)*int(NELIM+1,8))/2_8
            ELSE
              LCB = int(LDA_SON,8)*int(NELIM,8)
            ENDIF
            CALL DAGMG_MUMPS_178( A, LA,                                     &
     &           POSELT, LDAFS, NASS1,                                  &
     &           IACHK, LDA_SON, LCB,                                   &
     &           IW( J1 ), NELIM, NELIM, ETATASS,                       &
     &           COMPRESSCB,                                            &
     &           .FALSE.                                                &
     &          )
          ENDIF
  210     ISON = FRERE(STEP(ISON))
  220   CONTINUE
      ENDIF
      IBROT = INODE
      APOSMAX = POSELT + int(NASS1,8)*int(NASS1,8)
      DO 260 IORG = 1, NUMORG
        JK = PTRAIW(IBROT)
        AINPUT = PTRARW(IBROT)
        IBROT = FILS(IBROT)
        JJ = JK + 1
        J1 = JJ + 1
        J2 = J1 + INTARR(JK)
        J3 = J2 + 1
        J4 = J2 - INTARR(JJ)
        IJROW = INTARR(J1)
        ICT12 = POSELT + int(IJROW - 1 - LDAFS, 8)
        MAXARR = ZERO
!duplicatesCVD$ NODEPCHK
        DO 240 JJ = J1, J2
          IF (KEEP(219).NE.0) THEN
            IF (INTARR(JJ).LE.NASS1) THEN
              APOS2 = ICT12 + int(INTARR(JJ),8) * int(LDAFS,8)
              A(APOS2) = A(APOS2) + DBLARR(AINPUT)
            ELSEIF (KEEP(50).EQ.2) THEN
              MAXARR = max(MAXARR,abs(DBLARR(AINPUT)))
            ENDIF
          ELSE
            IF (INTARR(JJ).LE.NASS1) THEN
              APOS2 = ICT12 + int(INTARR(JJ),8) * int(LDAFS,8)
              A(APOS2) = A(APOS2) + DBLARR(AINPUT)
            ENDIF
          ENDIF
          AINPUT = AINPUT + 1
  240   CONTINUE
        IF(KEEP(219).NE.0.AND.KEEP(50) .EQ. 2) THEN
           A(APOSMAX+int(IJROW-1,8)) = dble(MAXARR)
        ENDIF
!        IF (J3 .GT. J4) GOTO 260
        IF (J3 .GT. J4) CYCLE
        ICT13 = POSELT + int(IJROW - 1,8) * int(LDAFS,8)
        NBCOL = J4 - J3 + 1
!duplicatesCVD$ NODEPCHK
!duplicatesCVD$ NODEPCHK
        DO JJ = 1, NBCOL
          JJ3 = ICT13 + int(INTARR(J3 + JJ - 1),8) - 1_8
          A(JJ3) = A(JJ3) + DBLARR(AINPUT + JJ - 1)
        ENDDO
  260 END DO
      PTRCOL = IOLDPS + HF + NFRONT
      PTRROW = IOLDPS + HF + NASS1
      PDEST  = IOLDPS + 6 + KEEP(IXSZ)
      DO ISLAVE = 1, NSLAVES
              CALL AGMG_MUMPS_49(                                            &
     &                KEEP,KEEP8, INODE, STEP, N, SLAVEF,               &
     &                ISTEP_TO_INIV2, TAB_POS_IN_PERE,                  &
     &                ISLAVE, NCB,                                      &
     &                NSLAVES,                                          &
     &                NBLIG, FIRST_INDEX  )
              SHIFT_INDEX = FIRST_INDEX - 1
        IERR = -1
        DO WHILE (IERR .EQ.-1)
         IF ( KEEP(50) .eq. 0 ) THEN
           NBCOL =  NFRONT
           CALL DAGMG_MUMPS_68( INODE,                                       &
     &      NBPROCFILS(STEP(INODE)),                                    &
     &      NBLIG, IW(PTRROW), NBCOL, IW(PTRCOL), NASS1,                &
     &      IZERO, IDUMMY,                                              &
     &      IW(PDEST), NFRONT, COMM, IERR)
         ELSE
           NBCOL = NASS1+SHIFT_INDEX+NBLIG
           CALL DAGMG_MUMPS_68( INODE,                                       &
     &      NBPROCFILS(STEP(INODE)),                                    &
     &      NBLIG, IW(PTRROW), NBCOL, IW(PTRCOL), NASS1,                &
     &      NSLAVES-ISLAVE,                                             &
     &      IW( PTLUST_S(STEP(INODE))+6+KEEP(IXSZ)+ISLAVE),             &
     &      IW(PDEST), NFRONT, COMM, IERR)
         ENDIF
         IF (IERR.EQ.-1) THEN
          BLOCKING  = .FALSE.
          SET_IRECV = .TRUE.
          MESSAGE_RECEIVED = .FALSE.
          CALL DAGMG_MUMPS_329( COMM_LOAD, ASS_IRECV,                        &
     &     BLOCKING, SET_IRECV, MESSAGE_RECEIVED,                       &
     &     AGMG_MPF_ANY_SOURCE, AGMG_MPF_ANY_TAG,                                 &
     &     STATUS, BUFR, LBUFR,                                         &
     &     LBUFR_BYTES,                                                 &
     &     PROCNODE_STEPS, POSFAC, IWPOS, IWPOSCB, IPTRLU,              &
     &     LRLU, LRLUS, N, IW, LIW, A, LA,                              &
     &     PTRIST, PTLUST_S, PTRFAC,                                    &
     &     PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP, IFLAG,       &
     &     IERROR, COMM,                                                &
     &     NBPROCFILS,                                                  &
     &     IPOOL, LPOOL, LEAF, NBFIN, MYID, SLAVEF,                     &
     &     root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,           &
     &     INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,                &
     &     LPTRAR, NELT, IW, IW,                                        &
     &     ISTEP_TO_INIV2, TAB_POS_IN_PERE, .TRUE. )
          IF ( IFLAG .LT. 0 ) GOTO 500
          IF (MESSAGE_RECEIVED) THEN
           IOLDPS = PTLUST_S(STEP(INODE))
           PTRCOL = IOLDPS + HF + NFRONT
           PTRROW = IOLDPS + HF + NASS1 + SHIFT_INDEX
          ENDIF
         ENDIF
        ENDDO
        IF (IERR .EQ. -2) GOTO 300
        IF (IERR .EQ. -3) GOTO 305
        PTRROW = PTRROW + NBLIG
        PDEST  = PDEST + 1
      ENDDO
      IF (NUMSTK.EQ.0) GOTO 500
      ISON = IFSON
      DO IELL = 1, NUMSTK
        ISTCHK = PIMASTER(STEP(ISON))
        NELIM = IW(ISTCHK + 1+KEEP(IXSZ))
        LSTK    = IW(ISTCHK+KEEP(IXSZ))
        NPIVS   = IW(ISTCHK + 3+KEEP(IXSZ))
        IF ( NPIVS .LT. 0 ) NPIVS = 0
        NSLSON  = IW(ISTCHK + 5+KEEP(IXSZ))
        HS      = 6 + NSLSON + KEEP(IXSZ)
        NCOLS     = NPIVS + LSTK
        SAME_PROC     = (ISTCHK.LE.IWPOS)
        IF (.NOT.SAME_PROC) THEN
         NROWS = IW(ISTCHK + 2+KEEP(IXSZ))
        ELSE
         NROWS = NCOLS
        ENDIF
        PDEST   = ISTCHK + 6 + KEEP(IXSZ)
        NCBSON  = LSTK - NELIM
        PTRCOL   = ISTCHK +  HS + NROWS + NPIVS + NELIM
        IF (KEEP(219).NE.0) THEN
          IF(KEEP(50) .EQ. 2) THEN
           NFS4FATHER = NCBSON
           DO I=0,NCBSON-1
              IF(IW(PTRCOL+I) .GT. NASS1) THEN
                 NFS4FATHER = I
                 EXIT
              ENDIF
           ENDDO
           NFS4FATHER = NFS4FATHER+NELIM
          ELSE
           NFS4FATHER = 0
          ENDIF
        ELSE
          NFS4FATHER = 0
        ENDIF
        IF (NSLSON.EQ.0) THEN
          NSLSON = 1
          PDEST1(1)  = AGMG_MUMPS_275(STEP(ISON),                            &
     &                 PROCNODE_STEPS, SLAVEF)
          IF (PDEST1(1).EQ.MYID) THEN
            CALL DAGMG_MUMPS_211( COMM_LOAD, ASS_IRECV,                      &
     &      BUFR, LBUFR, LBUFR_BYTES,                                   &
     &      INODE, ISON, NSLAVES,                                       &
     &      IW( PTLUST_S(STEP(INODE)) + 6 +KEEP(IXSZ)),                 &
     &      NFRONT, NASS1, NFS4FATHER, NCBSON,                          &
     &           IW( PTRCOL ),                                          &
     &      PROCNODE_STEPS,                                             &
     &      SLAVEF, POSFAC, IWPOS, IWPOSCB, IPTRLU, LRLU,               &
     &      LRLUS, N, IW,                                               &
     &      LIW, A, LA,                                                 &
     &      PTRIST, PTLUST_S, PTRFAC, PTRAST, STEP,                     &
     &      PIMASTER, PAMASTER, NSTK_S, COMP,                           &
     &      IFLAG, IERROR, MYID, COMM, NBPROCFILS, IPOOL, LPOOL, LEAF,  &
     &      NBFIN, ICNTL, KEEP,KEEP8, root,                             &
     &      OPASSW, OPELIW,                                             &
     &      ITLOC, FILS, PTRARW, PTRAIW, INTARR, DBLARR,                &
     &      ND, FRERE, LPTRAR, NELT, IW, IW,                            &
     &      ISTEP_TO_INIV2, TAB_POS_IN_PERE                             &
     &      )
           IF ( IFLAG .LT. 0 ) GOTO 500
          ELSE
           IERR = -1
           DO WHILE (IERR.EQ.-1)
            PTRCOL = PIMASTER(STEP(ISON))+HS+NROWS+NPIVS+NELIM
            CALL  DAGMG_MUMPS_71(                                            &
     &           INODE, NFRONT,NASS1,NFS4FATHER,                        &
     &           ISON, MYID,                                            &
     &      NSLAVES, IW( PTLUST_S(STEP(INODE))+6+KEEP(IXSZ) ),          &
     &      IW(PTRCOL), NCBSON,                                         &
     &      COMM, IERR, PDEST1, NSLSON, SLAVEF,                         &
     &      KEEP,KEEP8, STEP, N,                                        &
     &      ISTEP_TO_INIV2, TAB_POS_IN_PERE                             &
     &      )
            IF (IERR.EQ.-1) THEN
             BLOCKING  = .FALSE.
             SET_IRECV = .TRUE.
             MESSAGE_RECEIVED = .FALSE.
             CALL DAGMG_MUMPS_329( COMM_LOAD, ASS_IRECV,                     &
     &        BLOCKING, SET_IRECV, MESSAGE_RECEIVED,                    &
     &        AGMG_MPF_ANY_SOURCE, AGMG_MPF_ANY_TAG,                              &
     &        STATUS, BUFR, LBUFR, LBUFR_BYTES,                         &
     &        PROCNODE_STEPS, POSFAC, IWPOS, IWPOSCB, IPTRLU,           &
     &        LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                   &
     &        PTLUST_S, PTRFAC,                                         &
     &        PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP, IFLAG,    &
     &        IERROR, COMM,                                             &
     &        NBPROCFILS,                                               &
     &        IPOOL, LPOOL, LEAF, NBFIN, MYID, SLAVEF,                  &
     &        root,OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,         &
     &        INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE, LPTRAR,     &
     &        NELT, IW, IW,                                             &
     &        ISTEP_TO_INIV2, TAB_POS_IN_PERE, .TRUE. )
              IF ( IFLAG .LT. 0 ) GOTO 500
            ENDIF
           ENDDO
           IF (IERR .EQ. -2) GOTO 290
           IF (IERR .EQ. -3) GOTO 295
          ENDIF
        ELSE
          DO ISLAVE = 0, NSLSON-1
            IF (IW(PDEST+ISLAVE).EQ.MYID) THEN
            CALL AGMG_MUMPS_49(                                              &
     &                KEEP,KEEP8, ISON, STEP, N, SLAVEF,                &
     &                ISTEP_TO_INIV2, TAB_POS_IN_PERE,                  &
     &                ISLAVE+1, NCBSON,                                 &
     &                NSLSON,                                           &
     &                TROW_SIZE, FIRST_INDEX  )
              SHIFT_INDEX = FIRST_INDEX - 1
              INDX        = PTRCOL + SHIFT_INDEX
              CALL DAGMG_MUMPS_210( COMM_LOAD, ASS_IRECV,                    &
     &        BUFR, LBUFR, LBUFR_BYTES,                                 &
     &        INODE, ISON, NSLAVES,                                     &
     &        IW( PTLUST_S(STEP(INODE))+6+KEEP(IXSZ)),                  &
     &        NFRONT, NASS1,NFS4FATHER,                                 &
     &        TROW_SIZE, IW( INDX ),                                    &
     &        PROCNODE_STEPS,                                           &
     &        SLAVEF, POSFAC, IWPOS, IWPOSCB, IPTRLU, LRLU,             &
     &        LRLUS, N, IW,                                             &
     &        LIW, A, LA,                                               &
     &        PTRIST, PTLUST_S, PTRFAC, PTRAST, STEP,                   &
     &        PIMASTER, PAMASTER, NSTK_S, COMP,                         &
     &        IFLAG, IERROR, MYID, COMM, NBPROCFILS, IPOOL, LPOOL, LEAF,&
     &        NBFIN, ICNTL, KEEP,KEEP8, root,                           &
     &        OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,              &
     &        INTARR, DBLARR, ND, FRERE, LPTRAR, NELT, IW,              &
     &        IW,                                                       &
     &        ISTEP_TO_INIV2, TAB_POS_IN_PERE                           &
     &        )
              IF ( IFLAG .LT. 0 ) GOTO 500
              EXIT
            ENDIF
          ENDDO
          IF (PIMASTER(STEP(ISON)).GT.0) THEN
          IERR = -1
          DO WHILE (IERR.EQ.-1)
            PTRCOL = PIMASTER(STEP(ISON)) + HS + NROWS + NPIVS + NELIM
            PDEST  =  PIMASTER(STEP(ISON)) + 6 + KEEP(IXSZ)
            CALL  DAGMG_MUMPS_71(                                            &
     &           INODE, NFRONT,NASS1, NFS4FATHER,                       &
     &           ISON, MYID,                                            &
     &      NSLAVES, IW(PTLUST_S(STEP(INODE))+6+KEEP(IXSZ)),            &
     &      IW(PTRCOL), NCBSON,                                         &
     &      COMM, IERR, IW(PDEST), NSLSON, SLAVEF,                      &
     &      KEEP,KEEP8, STEP, N,                                        &
     &      ISTEP_TO_INIV2, TAB_POS_IN_PERE                             &
     &       )
            IF (IERR.EQ.-1) THEN
             BLOCKING  = .FALSE.
             SET_IRECV = .TRUE.
             MESSAGE_RECEIVED = .FALSE.
             CALL DAGMG_MUMPS_329( COMM_LOAD, ASS_IRECV,                     &
     &        BLOCKING, SET_IRECV, MESSAGE_RECEIVED,                    &
     &        AGMG_MPF_ANY_SOURCE, AGMG_MPF_ANY_TAG,                              &
     &        STATUS, BUFR, LBUFR,                                      &
     &        LBUFR_BYTES,                                              &
     &        PROCNODE_STEPS, POSFAC, IWPOS, IWPOSCB, IPTRLU,           &
     &        LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                   &
     &        PTLUST_S, PTRFAC,                                         &
     &        PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP, IFLAG,    &
     &        IERROR, COMM,                                             &
     &        NBPROCFILS,                                               &
     &        IPOOL, LPOOL, LEAF, NBFIN, MYID, SLAVEF,                  &
     &        root,OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,         &
     &        INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,             &
     &        LPTRAR, NELT, IW, IW,                                     &
     &        ISTEP_TO_INIV2, TAB_POS_IN_PERE, .TRUE. )
              IF ( IFLAG .LT. 0 ) GOTO 500
            ENDIF
          ENDDO
          IF (IERR .EQ. -2) GOTO 290
          IF (IERR .EQ. -3) GOTO 295
          ENDIF
        ENDIF
       ISON = FRERE(STEP(ISON))
      ENDDO
      GOTO 500
  250 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE IN INTEGER DYNAMIC ALLOCATION DURING                    &
     & DAGMG_MUMPS_253'
      ENDIF
      IFLAG   = -13
      IERROR  = NUMSTK + 1
      GOTO 490
  265 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * ) ' FAILURE ALLOCATING TMP_SLAVES_LIST',           &
     &                 ' DURING DMUMPS_253'
      ENDIF
      IFLAG  = -13
      IERROR = SIZE_TMP_SLAVES_LIST
      GOTO 490
  270 CONTINUE
      IFLAG = -8
      IERROR = LREQ
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE IN INTEGER ALLOCATION DURING DMUMPS_253'
      ENDIF
      GOTO 490
  280 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE, WORKSPACE TOO SMALL DURING DMUMPS_253'
      ENDIF
      IFLAG = -9
      CALL AGMG_MUMPS_731(LAELL8-LRLUS, IERROR)
      GOTO 490
  290 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE, SEND BUFFER TOO SMALL (1) DURING DMUMPS_253'
      ENDIF
      IFLAG = -17
      LREQ = NCBSON + 6 + NSLSON+KEEP(IXSZ)
      IERROR =  LREQ  * KEEP( 34 )
      GOTO 490
  295 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE, RECV BUFFER TOO SMALL (1) DURING DMUMPS_253'
      ENDIF
      IFLAG = -20
      LREQ = NCBSON + 6 + NSLSON+KEEP(IXSZ)
      IERROR =  LREQ  * KEEP( 34 )
      GOTO 490
  300 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE, SEND BUFFER TOO SMALL (2) DURING DMUMPS_253'
      ENDIF
      IFLAG = -17
      LREQ = NBLIG + NBCOL + 4 + KEEP(IXSZ)
      IERROR =  LREQ  * KEEP( 34 )
      GOTO 490
  305 CONTINUE
      IF ((ICNTL(1) .GT. 0) .AND. (ICNTL(4) .GE. 1)) THEN
        LP = ICNTL(1)
        WRITE( LP, * )                                                  &
     &' FAILURE, RECV BUFFER TOO SMALL (2) DURING DMUMPS_253'
      ENDIF
      IFLAG = -17
      LREQ = NBLIG + NBCOL + 4 + KEEP(IXSZ)
      IERROR =  LREQ  * KEEP( 34 )
  490 CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
  500 CONTINUE
      RETURN
      END SUBROUTINE DAGMG_MUMPS_253
      SUBROUTINE DAGMG_MUMPS_39(N, INODE, IW, LIW, A, LA,                    &
     &    ISON, NBROWS, NBCOLS, ROWLIST,                                &
     &    VALSON, PTLUST_S, PTRAST, STEP, PIMASTER,                     &
     &    OPASSW, IWPOSCB, MYID, KEEP,KEEP8 )
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
      INTEGER KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER(8) :: LA
      INTEGER N,LIW,MYID
      INTEGER INODE,ISON, IWPOSCB
      INTEGER NBROWS, NBCOLS
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER IW(LIW), STEP(N), PIMASTER(KEEP(28)),                     &
     &        PTLUST_S(KEEP(28)), ROWLIST(NBROWS)
      DOUBLE PRECISION A(LA), VALSON(NBCOLS,NBROWS)
      DOUBLE PRECISION OPASSW
      INTEGER(8) :: POSELT, POSEL1, APOS, JJ2
      INTEGER HF,HS, NSLAVES, NFRONT, NASS1,                            &
     &        IOLDPS, ISTCHK,                                           &
     &        LSTK, NSLSON,NELIM,NPIVS,NCOLS, J1,J2,J3, JJ,             &
     &        JJ1, JPOS, SIZFI, NCOL, NROW,                             &
     &        NROWS, LDAFS_PERE, IBEG
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      LOGICAL SAME_PROC, FREE
      INTRINSIC real
      IOLDPS = PTLUST_S(STEP(INODE))
      POSELT = PTRAST(STEP(INODE))
      NFRONT = IW(IOLDPS+KEEP(IXSZ))
      NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
      NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
      IF (KEEP(50).EQ.0) THEN
        LDAFS_PERE = NFRONT
      ELSE
        IF ( NSLAVES .eq. 0 ) THEN
          LDAFS_PERE = NFRONT
        ELSE
          LDAFS_PERE = NASS1
        ENDIF
      ENDIF
      HF      = 6 + NSLAVES + KEEP(IXSZ)
      POSEL1 = POSELT - int(LDAFS_PERE,8)
      ISTCHK = PIMASTER(STEP(ISON))
      LSTK = IW(ISTCHK+KEEP(IXSZ))
      NSLSON  = IW(ISTCHK + 5+KEEP(IXSZ))
      HS      = 6 + NSLSON + KEEP(IXSZ)
      OPASSW = OPASSW + dble(NBROWS*NBCOLS)
      NELIM = IW(ISTCHK + 1+KEEP(IXSZ))
      NPIVS = IW(ISTCHK + 3+KEEP(IXSZ))
      IF (NPIVS.LT.0) NPIVS = 0
      NCOLS = NPIVS + LSTK
      SAME_PROC = (ISTCHK.LT.IWPOSCB)
      IF (SAME_PROC) THEN
       NROWS = NCOLS
      ELSE
       NROWS = IW(ISTCHK+2+KEEP(IXSZ))
      ENDIF
      J1 = ISTCHK + NROWS + HS + NPIVS
      IF (KEEP(50).EQ.0) THEN
       DO 170 JJ = 1, NBROWS
        APOS = POSEL1 + int(ROWLIST(JJ),8) * int(LDAFS_PERE,8)
        DO 160 JJ1 = 1, NBCOLS
          JJ2 = APOS + int(IW(J1 + JJ1 - 1) - 1,8)
          A(JJ2) = A(JJ2) + VALSON(JJ1,JJ)
  160   CONTINUE
  170  CONTINUE
      ELSE
       DO JJ = 1, NBROWS
        IF (ROWLIST(JJ).LE.NASS1) THEN
         APOS = POSEL1 + int(ROWLIST(JJ) - 1,8)
         DO JJ1 = 1, NELIM
          JJ2 = APOS + int(IW(J1+JJ1-1),8)*int(LDAFS_PERE,8)
           A(JJ2) = A(JJ2) + VALSON(JJ1,JJ)
         ENDDO
         IBEG = NELIM+1
        ELSE
         IBEG = 1
        ENDIF
        APOS = POSEL1 + int(ROWLIST(JJ),8) * int(LDAFS_PERE,8)
        DO JJ1 = IBEG, NBCOLS
          IF (ROWLIST(JJ).LT.IW(J1 + JJ1 - 1)) EXIT
          JJ2 = APOS + int(IW(J1 + JJ1 - 1) - 1,8)
          A(JJ2) = A(JJ2) + VALSON(JJ1,JJ)
        ENDDO
       ENDDO
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_39
      SUBROUTINE DAGMG_MUMPS_539                                             &
     &    (N, INODE, IW, LIW, A, LA,                                    &
     &    NBROWS, NBCOLS,                                               &
     &    OPASSW, OPELIW, STEP, PTRIST, PTRAST, ITLOC,                  &
     &    FILS, PTRARW, PTRAIW, INTARR, DBLARR,                         &
     &    ICNTL, KEEP,KEEP8, MYID)
      IMPLICIT NONE
      INTEGER N,LIW
      INTEGER(8) :: LA
      INTEGER KEEP(500), ICNTL(40)
      INTEGER*8 KEEP8(150)
      INTEGER INODE, MYID
      INTEGER NBROWS, NBCOLS
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER IW(LIW), ITLOC(N), STEP(N),                               &
     &        PTRIST(KEEP(28)), FILS(N), PTRARW(N), PTRAIW(N)
      INTEGER INTARR(max(1,KEEP(14)))
      DOUBLE PRECISION A(LA),                                           &
     &        DBLARR(max(1,KEEP(13)))
      DOUBLE PRECISION OPASSW, OPELIW
      INTEGER IOLDPS, NBCOLF, NBROWF, NSLAVES, HF,                      &
     &        K1,K2,K,I,J,JPOS,NASS,JJ,                                 &
     &        IN,AINPUT,JK,J1,J2,IJROW, ILOC
      INTEGER(8) :: POSELT, ICT12, APOS
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      IOLDPS  = PTRIST(STEP(INODE))
      POSELT  = PTRAST(STEP(INODE))
      NBCOLF  = IW(IOLDPS+KEEP(IXSZ))
      NBROWF  = IW(IOLDPS+2+KEEP(IXSZ))
      NASS    = IW(IOLDPS+1+KEEP(IXSZ))
      NSLAVES = IW(IOLDPS+5+KEEP(IXSZ))
      HF      = 6 + NSLAVES + KEEP(IXSZ)
      IF (NASS.LT.0) THEN
          NASS         = -NASS
          IW(IOLDPS+1+KEEP(IXSZ)) = NASS
          A(POSELT:POSELT+int(NBROWF,8)*int(NBCOLF,8)-1_8) =            &
     &    dble(ZERO)
          K1 = IOLDPS + HF
          K2 = K1 + NBROWF - 1
          JPOS = 1
          DO K = K1, K2
           J        = IW(K)
           ITLOC(J) = JPOS
           JPOS     = JPOS + 1
          ENDDO
          K1 = IOLDPS + HF + NBROWF
          K2 = K1 + NASS - 1
          JPOS = 1
          DO K = K1, K2
           J        = IW(K)
           ITLOC(J) = -JPOS
           JPOS     = JPOS + 1
          ENDDO
          IN = INODE
          DO WHILE (IN.GT.0)
           AINPUT = PTRARW(IN)
           JK     = PTRAIW(IN)
           JJ     = JK + 1
           J1     = JJ + 1
           J2 = J1 + INTARR(JK)
           IJROW = -ITLOC(INTARR(J1))
           ICT12 = POSELT +int(- NBCOLF + IJROW - 1,8)
           DO JJ= J1,J2
            ILOC = ITLOC(INTARR(JJ))
            IF (ILOC.GT.0) THEN
              APOS = ICT12 + int(ILOC,8)*int(NBCOLF,8)
              A(APOS) = A(APOS) + DBLARR(AINPUT)
            ENDIF
            AINPUT  = AINPUT + 1
           ENDDO
           IN = FILS(IN)
          ENDDO
          K1 = IOLDPS + HF
          K2 = K1 + NBROWF + NASS - 1
          DO K = K1, K2
           J = IW(K)
           ITLOC(J) = 0
          ENDDO
      ENDIF
      IF (NBROWS.GT.0) THEN
          K1 = IOLDPS + HF + NBROWF
          K2 = K1 + NBCOLF - 1
          JPOS = 1
          DO K = K1, K2
           J        = IW(K)
           ITLOC(J) = JPOS
           JPOS     = JPOS + 1
          ENDDO
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_539
      SUBROUTINE DAGMG_MUMPS_531                                             &
     & (N, INODE, IW, LIW, NBROWS, STEP, PTRIST, ITLOC, KEEP,KEEP8)
      IMPLICIT NONE
      INTEGER N, LIW
      INTEGER KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER INODE, MYID
      INTEGER NBROWS
      INTEGER IW(LIW), ITLOC(N), STEP(N),                               &
     &        PTRIST(KEEP(28))
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      INTEGER IOLDPS, NBCOLF, NBROWF, NSLAVES, HF,                      &
     &        K1,K2,K,J
      IOLDPS  = PTRIST(STEP(INODE))
      NBCOLF  = IW(IOLDPS+KEEP(IXSZ))
      NBROWF  = IW(IOLDPS+2+KEEP(IXSZ))
      NSLAVES = IW(IOLDPS+5+KEEP(IXSZ))
      HF      = 6 + NSLAVES+KEEP(IXSZ)
      IF (NBROWS.GT.0) THEN
          K1 = IOLDPS + HF + NBROWF
          K2 = K1 + NBCOLF - 1
          DO K = K1, K2
           J        = IW(K)
           ITLOC(J) = 0
          ENDDO
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_531
      SUBROUTINE DAGMG_MUMPS_40(N, INODE, IW, LIW, A, LA,                    &
     &    NBROWS, NBCOLS, ROWLIST, COLLIST, VALSON,                     &
     &    OPASSW, OPELIW, STEP, PTRIST, PTRAST, ITLOC,                  &
     &    FILS,                                                         &
     &    ICNTL, KEEP,KEEP8, MYID)
      IMPLICIT NONE
      INTEGER N,LIW
      INTEGER(8) :: LA
      INTEGER KEEP(500), ICNTL(40)
      INTEGER*8 KEEP8(150)
      INTEGER INODE, MYID
      INTEGER NBROWS, NBCOLS
      INTEGER ROWLIST(NBROWS), COLLIST(NBCOLS)
      INTEGER IW(LIW), ITLOC(N), STEP(N),                               &
     &        PTRIST(KEEP(28)), FILS(N)
      INTEGER(8) :: PTRAST(KEEP(28))
      DOUBLE PRECISION A(LA), VALSON(NBCOLS,NBROWS)
      DOUBLE PRECISION OPASSW, OPELIW
      INTEGER(8) :: POSEL1, POSELT, APOS, ICT12, K8
      INTEGER IOLDPS, NBCOLF, NBROWF, NSLAVES, HF,                      &
     &        I,J,JPOS,NASS,JJ,                                         &
     &        IN,AINPUT,JK,J1,J2,IJROW,ILOC
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      INTRINSIC real
      IOLDPS  = PTRIST(STEP(INODE))
      POSELT  = PTRAST(STEP(INODE))
      NBCOLF  = IW(IOLDPS+KEEP(IXSZ))
      NBROWF  = IW(IOLDPS+2+KEEP(IXSZ))
      NASS    = IW(IOLDPS+1+KEEP(IXSZ))
       IF ( NBROWS .GT. NBROWF ) THEN
          WRITE(*,*) ' ERR: ERROR : NBROWS > NBROWF'
          WRITE(*,*) ' ERR: INODE =', INODE
          WRITE(*,*) ' ERR: NBROW=',NBROWS,'NBROWF=',NBROWF
          WRITE(*,*) ' ERR: ROW_LIST=', ROWLIST
          CALL AGMG_MUMPS_ABORT()
       END IF
      NSLAVES = IW(IOLDPS+5+KEEP(IXSZ))
      HF      = 6 + NSLAVES+KEEP(IXSZ)
      IF (NBROWS.GT.0) THEN
          POSEL1 = POSELT - int(NBCOLF,8)
          IF (KEEP(50).EQ.0) THEN
           DO I=1,NBROWS
            APOS = POSEL1 + int(ROWLIST(I),8) * int(NBCOLF,8)
            DO J=1,NBCOLS
             K8 = APOS + int(ITLOC(COLLIST(J)),8) - 1_8
             A(K8) = A(K8) + VALSON(J,I)
            ENDDO
           ENDDO
          ELSE
           DO I=1,NBROWS
            APOS = POSEL1 + int(ROWLIST(I),8) * int(NBCOLF,8)
            DO J=1,NBCOLS
             IF (ITLOC(COLLIST(J)) .EQ. 0) EXIT
             K8 = APOS + int(ITLOC(COLLIST(J)),8) - 1_8
             A(K8) = A(K8) + VALSON(J,I)
            ENDDO
           ENDDO
          ENDIF
          OPASSW = OPASSW + dble(NBROWS*NBCOLS)
      ENDIF
  500 CONTINUE
      RETURN
      END SUBROUTINE DAGMG_MUMPS_40
      SUBROUTINE DAGMG_MUMPS_178( A, LA,                                     &
     &             IAFATH, NFRONT, NASS1,                               &
     &             IACB, NCOLS, LCB,                                    &
     &             IW, NROWS, NELIM, ETATASS,                           &
     &             CB_IS_COMPRESSED, IS_INPLACE                         &
     &             )
      IMPLICIT NONE
      INTEGER NFRONT, NASS1
      INTEGER(8) :: LA
      INTEGER NCOLS, NROWS, NELIM
      INTEGER(8) :: LCB
      DOUBLE PRECISION A( LA )
      INTEGER(8) :: IAFATH, IACB
      INTEGER IW( NCOLS )
      INTEGER ETATASS
      DOUBLE PRECISION ZERO
      LOGICAL CB_IS_COMPRESSED, IS_INPLACE
      PARAMETER(ZERO=0.0D0)
      LOGICAL RESET_TO_ZERO, RISK_OF_SAME_POS,                          &
     &        RISK_OF_SAME_POS_THIS_LINE
      INTEGER I, J
      INTEGER(8) :: APOS, POSELT
      INTEGER(8) :: IPOSCB, IBEGCBROW, IENDFRONT
      IENDFRONT =  IAFATH+int(NFRONT,8)*int(NFRONT,8)-1_8
      IF ( IS_INPLACE ) THEN
        IPOSCB=1_8
        RESET_TO_ZERO    = IACB .LT. IENDFRONT + 1_8
        RISK_OF_SAME_POS = IACB + LCB .EQ. IENDFRONT + 1_8
        RISK_OF_SAME_POS_THIS_LINE = .FALSE.
        DO I=1, NROWS
          POSELT = int(IW(I)-1,8) * int(NFRONT,8)
          IF (.NOT. CB_IS_COMPRESSED ) THEN
            IPOSCB = 1_8 + int(I - 1,8) * int(NCOLS,8)
            IF (IACB+IPOSCB-1_8 .GE. IENDFRONT + 1_8) THEN
              RESET_TO_ZERO = .FALSE.
            ENDIF
          ENDIF
          IF ( RISK_OF_SAME_POS ) THEN
            IF (I.EQ.NROWS .OR. .NOT. CB_IS_COMPRESSED) THEN
              IF ( IAFATH + POSELT + int(IW(I)-1,8) .EQ.                &
     &             IACB+IPOSCB+int(I-1-1,8)) THEN
                 RISK_OF_SAME_POS_THIS_LINE = .TRUE.
              ENDIF
            ENDIF
          ENDIF
          IF (RESET_TO_ZERO) THEN
            IF ( RISK_OF_SAME_POS_THIS_LINE ) THEN
              DO J=1, I
                APOS = POSELT + int(IW( J ),8)
                IF (IAFATH + APOS - 1_8.NE. IACB+IPOSCB-1_8) THEN
                  A(IAFATH+ APOS -1_8) = A(IACB+IPOSCB-1_8)
                  A(IACB+IPOSCB-1_8) = dble(ZERO)
                ENDIF
                IPOSCB = IPOSCB + 1_8
              ENDDO
            ELSE
              DO J=1, I
                APOS = POSELT + int(IW( J ),8)
                A(IAFATH+ APOS -1_8) = A(IACB+IPOSCB-1_8)
                A(IACB+IPOSCB-1_8)=dble(ZERO)
                IPOSCB = IPOSCB + 1_8
              ENDDO
            ENDIF
          ELSE
            DO J=1, I
              APOS = POSELT + int(IW( J ),8)
              A(IAFATH+ APOS -1_8) = A(IACB+IPOSCB-1_8)
              IPOSCB = IPOSCB + 1_8
            ENDDO
          ENDIF
          IF (.NOT. CB_IS_COMPRESSED ) THEN
            IBEGCBROW = IACB+IPOSCB-1_8
            IF ( IBEGCBROW .LE. IENDFRONT ) THEN
              A(IBEGCBROW:IBEGCBROW+int(NCOLS-I,8)-1_8)=dble(ZERO)
            ENDIF
          ENDIF
          IF (IACB+IPOSCB-1_8 .GE. IENDFRONT + 1_8) THEN
            RESET_TO_ZERO = .FALSE.
          ENDIF
        ENDDO
        RETURN
      ENDIF
      IF ((ETATASS.EQ.0) .OR. (ETATASS.EQ.1)) THEN
        IPOSCB = 1_8
        DO I = 1, NELIM
          POSELT = int( IW( I ) - 1, 8 ) * int(NFRONT, 8)
          IF (.NOT. CB_IS_COMPRESSED) THEN
            IPOSCB = 1_8 + int( I - 1, 8 ) * int(NCOLS,8)
          ENDIF
          DO J = 1, I
            APOS = POSELT + int(IW( J ),8)
            A(IAFATH+ APOS -1_8) = A(IAFATH+ APOS -1_8)                 &
     &                           + A(IACB+IPOSCB-1_8)
            IPOSCB = IPOSCB + 1_8
          END DO
        END DO
      ENDIF
      IF ((ETATASS.EQ.0).OR.(ETATASS.EQ.1)) THEN
        DO I = NELIM + 1, NROWS
          IF (CB_IS_COMPRESSED) THEN
            IPOSCB = (int(I,8) * int(I-1,8)) / 2_8 + 1_8
          ELSE
            IPOSCB = int(I-1,8) * int(NCOLS,8) + 1_8
          ENDIF
          POSELT = int(IW( I ),8)
          IF (POSELT.LE. int(NASS1,8) .AND. .NOT. IS_INPLACE) THEN
            DO J = 1, NELIM
              APOS = POSELT + int( IW( J ) - 1, 8 ) * int(NFRONT,8)
              A(IAFATH+APOS-1_8) = A(IAFATH+APOS-1_8) +                 &
     &                             A(IACB+IPOSCB-1_8)
              IPOSCB = IPOSCB + 1_8
            END DO
          ELSE
            POSELT = int( IW( I ) - 1, 8 ) * int(NFRONT, 8)
            DO J = 1, NELIM
             APOS = POSELT + int(IW( J ), 8)
             A(IAFATH+APOS-1_8) = A(IAFATH+APOS-1_8)                    &
     &                          + A(IACB+IPOSCB-1_8)
             IPOSCB = IPOSCB + 1_8
            END DO
          ENDIF
          IF (ETATASS.EQ.1) THEN
            POSELT = int( IW( I ) - 1, 8 ) * int(NFRONT, 8)
            DO J = NELIM + 1, I
                 IF (IW(J).GT.NASS1) EXIT
                 APOS = POSELT + int(IW( J ), 8)
                 A(IAFATH+APOS-1_8) = A(IAFATH+APOS-1_8)                &
     &                              + A(IACB+IPOSCB-1_8)
                 IPOSCB = IPOSCB +1_8
            END DO
          ELSE
            POSELT = int( IW( I ) - 1, 8 ) * int(NFRONT, 8)
            DO J = NELIM + 1, I
             APOS = POSELT + int(IW( J ), 8)
             A(IAFATH+APOS-1_8) = A(IAFATH+APOS-1_8)                    &
     &                          + A(IACB+IPOSCB-1_8)
             IPOSCB = IPOSCB + 1_8
            END DO
          ENDIF
        END DO
      ELSE
        DO I= NROWS, NELIM+1, -1
          IF (CB_IS_COMPRESSED) THEN
            IPOSCB = (int(I,8)*int(I+1,8))/2_8
          ELSE
            IPOSCB = int(I-1,8) * int(NCOLS,8) + int(I,8)
          ENDIF
          POSELT = int(IW( I ),8)
          IF (POSELT.LE.int(NASS1,8)) EXIT
          POSELT = int( IW( I ) - 1, 8 ) * int(NFRONT, 8)
          DO J=I,NELIM+1, -1
            IF (IW(J).LE.NASS1) EXIT
            APOS = POSELT + int(IW( J ), 8)
            A(IAFATH+APOS-1_8) = A(IAFATH+APOS-1_8)                     &
     &                         + A(IACB+IPOSCB-1_8)
            IPOSCB = IPOSCB - 1_8
          ENDDO
        ENDDO
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_178
      SUBROUTINE DAGMG_MUMPS_530(N, ISON, INODE, IWPOSCB,                    &
     &           PIMASTER, PTLUST_S, IW, LIW, STEP, KEEP,KEEP8)
      IMPLICIT NONE
      INTEGER N, ISON, INODE, IWPOSCB
      INTEGER KEEP(500), STEP(N)
      INTEGER*8 KEEP8(150)
      INTEGER PIMASTER(KEEP(28)), PTLUST_S(KEEP(28))
      INTEGER LIW
      INTEGER IW(LIW)
      INTEGER ISTCHK, LSTK, NSLSON, HS, NROWS, NCOLS, NPIVS, NELIM
      INTEGER IOLDPS, NFRONT, NSLAVES, ICT11, HF
      INTEGER J1, J2, J3, JJ, JPOS
      LOGICAL SAME_PROC
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      ISTCHK = PIMASTER(STEP(ISON))
      LSTK   = IW(ISTCHK+KEEP(IXSZ))
      NSLSON = IW(ISTCHK+5+KEEP(IXSZ))
      HS     = 6 + NSLSON + KEEP(IXSZ)
      NELIM  = IW(ISTCHK + 1+KEEP(IXSZ))
      NPIVS  = IW(ISTCHK + 3+KEEP(IXSZ))
      NCOLS  = NPIVS + LSTK
      IF ( NPIVS < 0 ) NPIVS = 0
      SAME_PROC = ISTCHK < IWPOSCB
      IF (SAME_PROC) THEN
       NROWS = NCOLS
      ELSE
       NROWS = IW(ISTCHK+2+KEEP(IXSZ))
      ENDIF
      J1 = ISTCHK + NROWS + HS + NPIVS
      IF (KEEP(50).NE.0) THEN
          J2 = J1 +  LSTK - 1
          DO JJ = J1, J2
            IW(JJ) = IW(JJ - NROWS)
          ENDDO
      ELSE
            J2 = J1 + LSTK - 1
            J3 = J1 + NELIM
            DO JJ = J3, J2
             IW(JJ) = IW(JJ - NROWS)
            ENDDO
            IF (NELIM .NE. 0) THEN
              IOLDPS = PTLUST_S(STEP(INODE))
              NFRONT = IW(IOLDPS+KEEP(IXSZ))
              NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
              HF     = 6 + NSLAVES+KEEP(IXSZ)
              ICT11 = IOLDPS + HF - 1 + NFRONT
              J3 = J3 - 1
              DO 190 JJ = J1, J3
               JPOS = IW(JJ) + ICT11
               IW(JJ) = IW(JPOS)
  190         CONTINUE
            ENDIF
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_530
      SUBROUTINE DAGMG_MUMPS_619(                                            &
     &     N, INODE, IW, LIW, A, LA,                                    &
     &     ISON, NBCOLS,                                                &
     &     VALSON, PTLUST_S, PTRAST, STEP, PIMASTER,                    &
     &     OPASSW, IWPOSCB,MYID, KEEP,KEEP8 )
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
      INTEGER KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER(8) :: LA
      INTEGER N,LIW,MYID
      INTEGER INODE,ISON,IWPOSCB
      INTEGER NBCOLS
      INTEGER IW(LIW), STEP(N),                                         &
     &     PIMASTER(KEEP(28)),                                          &
     &     PTLUST_S(KEEP(28))
      INTEGER(8) PTRAST(KEEP(28))
      DOUBLE PRECISION A(LA)
      DOUBLE PRECISION VALSON(NBCOLS)
      DOUBLE PRECISION OPASSW
      INTEGER HF,HS, NSLAVES, NASS1,                                    &
     &     IOLDPS, ISTCHK,                                              &
     &     LSTK, NSLSON,NELIM,NPIVS,NCOLS, J1,                          &
     &     JJ1,JPOS, NROWS
      INTEGER(8) POSELT, APOS, JJ2
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      LOGICAL SAME_PROC, FREE
      INTRINSIC real
      IOLDPS = PTLUST_S(STEP(INODE))
      POSELT = PTRAST(STEP(INODE))
      NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
      NSLAVES= IW(IOLDPS+5 + KEEP(IXSZ))
      HF      = 6 + NSLAVES + KEEP(IXSZ)
      ISTCHK = PIMASTER(STEP(ISON))
      LSTK = IW(ISTCHK + KEEP(IXSZ))
      NSLSON  = IW(ISTCHK + 5 + KEEP(IXSZ))
      HS      = 6 + NSLSON + KEEP(IXSZ)
      NELIM = IW(ISTCHK + 1 + KEEP(IXSZ))
      NPIVS = IW(ISTCHK + 3 + KEEP(IXSZ))
      IF (NPIVS.LT.0) NPIVS = 0
      NCOLS = NPIVS + LSTK
      SAME_PROC = (ISTCHK.LT.IWPOSCB)
      IF (SAME_PROC) THEN
       NROWS = NCOLS
      ELSE
       NROWS = IW(ISTCHK+2 + KEEP(IXSZ))
      ENDIF
      J1 = ISTCHK + NROWS + HS + NPIVS
      APOS = POSELT + int(NASS1,8)*int(NASS1,8) - 1_8
      DO JJ1 = 1, NBCOLS
         JJ2 = APOS+int(IW(J1 + JJ1 - 1),8)
         IF(abs(A(JJ2)) .LT. VALSON(JJ1))                               &
     &         A(JJ2) = dble(VALSON(JJ1))
      ENDDO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_619
      RECURSIVE SUBROUTINE DAGMG_MUMPS_264(                                  &
     &   COMM_LOAD, ASS_IRECV,                                          &
     &   BUFR, LBUFR,                                                   &
     &   LBUFR_BYTES, PROCNODE_STEPS, MSGSOU,                           &
     &   SLAVEF, IWPOS, IWPOSCB, IPTRLU, LRLU, LRLUS, N, IW, LIW,       &
     &   A, LA, PTRIST, PTRAST, NSTK_S, NBPROCFILS,                     &
     &   COMP, STEP, PIMASTER, PAMASTER, POSFAC,                        &
     &   MYID, COMM, IFLAG, IERROR, NBFIN,                              &
     &    PTLUST_S, PTRFAC, root, OPASSW, OPELIW, ITLOC, FILS,          &
     &    PTRARW, PTRAIW, INTARR, DBLARR,                               &
     &    ICNTL, KEEP,KEEP8, IPOOL, LPOOL, LEAF, ND, FRERE_STEPS,       &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE                               &
     &    )
      USE DAGMG_MUMPS_OOC_MAIN
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER ICNTL( 40 ), KEEP( 500 )
      INTEGER*8 KEEP8(150)
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER COMM_LOAD, ASS_IRECV
      INTEGER BUFR( LBUFR )
      INTEGER N, SLAVEF, IWPOS, IWPOSCB, LIW
      INTEGER(8) :: IPTRLU, LRLU, LRLUS, LA
      INTEGER(8) :: POSFAC
      INTEGER COMP
      INTEGER IFLAG, IERROR, NBFIN, MSGSOU
      INTEGER PROCNODE_STEPS(KEEP(28)), PTRIST(KEEP(28)),               &
     &        NSTK_S(KEEP(28))
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER NBPROCFILS( KEEP(28) ), STEP(N),                          &
     & PIMASTER(KEEP(28))
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER COMM, MYID
      INTEGER NELT, LPTRAR
      INTEGER FRTPTR( N+1 ), FRTELT( NELT )
      INTEGER PTLUST_S(KEEP(28)),                                       &
     &        ITLOC(N), FILS(N), ND(KEEP(28))
      INTEGER PTRAIW( LPTRAR ), PTRARW( LPTRAR )
      INTEGER FRERE_STEPS(KEEP(28))
      INTEGER INTARR( max(1,KEEP(14)) )
      DOUBLE PRECISION OPASSW, OPELIW
      DOUBLE PRECISION FLOP1
      DOUBLE PRECISION  DBLARR(max(1,KEEP(13)))
      INTEGER LEAF, LPOOL
      INTEGER IPOOL( LPOOL )
      INTEGER ISTEP_TO_INIV2(KEEP(71)),                                 &
     &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      INTEGER STATUS( AGMG_MPF_STATUS_SIZE )
      INTEGER INODE, POSITION, NPIV, IERR, LP
      INTEGER NCOL, NROW
      INTEGER(8) :: POSBLOCFACTO
      INTEGER(8) :: LAELL
      INTEGER(8) :: MEM_GAIN
      INTEGER(8) :: POSELT
      INTEGER IOLDPS, LCONT1, NASS1, NROW1, NCOL1, NPIV1
      INTEGER NSLAV1, HS, ISW
      INTEGER (8) :: LPOS, LPOS1, LPOS2, IPOS, KPOS
      INTEGER ICT11
      INTEGER I, IPIV, FPERE
      INTEGER LCONT,NELIM,NASS, LDA, NCOL_TO_SEND,                      &
     &        SHIFT_LIST_ROW_SON, SHIFT_LIST_COL_SON
      INTEGER(8) :: SHIFT_VAL_SON
      INTEGER ITYPE2
      PARAMETER(ITYPE2=2)
      LOGICAL LASTBL
      LOGICAL BLOCKING, SET_IRECV, MESSAGE_RECEIVED
      DOUBLE PRECISION ONE,ALPHA
      PARAMETER (ONE = 1.0D0, ALPHA=-1.0D0)
      INTEGER(8) :: LAFAC
      INTEGER LIWFAC, STRAT, NextPivDummy
      TYPE(IO_BLOCK) :: MonBloc
      LOGICAL LAST_CALL
      INTEGER AGMG_MUMPS_275
      EXTERNAL AGMG_MUMPS_275
      FPERE    = -1
      POSITION = 0
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      LASTBL = (NPIV.LE.0)
      IF (LASTBL) THEN
         NPIV = -NPIV
         CALL AGMG_NOCALL('MPI_UNPACK')
      ENDIF
      CALL AGMG_NOCALL('MPI_UNPACK')
      LAELL = int(NPIV,8) * int(NCOL,8)
      IF ( LRLU .LT. LAELL .OR. IWPOS + NPIV - 1 .GT. IWPOSCB ) THEN
        IF ( LRLUS .LT. LAELL ) THEN
          IF (LAELL - LRLUS .GT. int(huge(IERROR),8)) THEN
            write(*,*) "I8 OVERFLOW, LAELL-LRLUS=",LAELL-LRLUS
            CALL AGMG_MUMPS_ABORT()
          ENDIF
          IFLAG = -9
          IERROR = int(LAELL - LRLUS,kind(IERROR))
          IF (ICNTL(1).GT.0 .AND. ICNTL(4).GE.1) THEN
            LP=ICNTL(1)
            WRITE(LP,*)                                                 &
     &" FAILURE, WORKSPACE TOO SMALL DURING DAGMG_MUMPS_264"
          ENDIF
          GOTO 700
        END IF
        CALL DAGMG_MUMPS_94(N, KEEP(28), IW, LIW, A, LA,                     &
     &      LRLU, IPTRLU,                                               &
     &      IWPOS, IWPOSCB, PTRIST, PTRAST,                             &
     &      STEP, PIMASTER, PAMASTER, ITLOC,KEEP(216),LRLUS,            &
     &      KEEP(IXSZ))
        COMP = COMP+1
        IF ( LRLU .NE. LRLUS ) THEN
             WRITE(*,*) 'PB compress ass..blocfacto: LRLU,LRLUS='       &
     &       ,LRLU,LRLUS
             IFLAG = -9
             CALL AGMG_MUMPS_731( LAELL-LRLUS, IERROR )
             IF (LAELL - LRLUS .GT. int(huge(IERROR),8)) THEN
               write(*,*) "I8 OVERFLOW, LAELL-LRLUS=",LAELL-LRLUS
               CALL AGMG_MUMPS_ABORT()
             ENDIF
             IERROR = int(LAELL - LRLUS,kind(IERROR))
             GOTO 700
        END IF
        IF ( IWPOS + NPIV - 1 .GT. IWPOSCB ) THEN
          IF (ICNTL(1).GT.0 .AND. ICNTL(4).GE.1) THEN
            LP=ICNTL(1)
            WRITE(LP,*)                                                 &
     &" FAILURE IN INTEGER ALLOCATION DURING DAGMG_MUMPS_264"
          ENDIF
          IFLAG = -8
          IERROR = IWPOS + NPIV - 1 - IWPOSCB
          GOTO 700
        END IF
      END IF
      LRLU  = LRLU - LAELL
      LRLUS = LRLUS - LAELL
      KEEP8(67) = min(LRLUS, KEEP8(67))
      POSBLOCFACTO = POSFAC
      POSFAC = POSFAC + LAELL
      CALL DAGMG_MUMPS_471(.FALSE., .FALSE.,                                 &
     &               LA-LRLUS,0_8,LAELL,KEEP,KEEP8,LRLU)
      IPIV = IWPOS
      IWPOS = IWPOS + NPIV
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      IF (PTRIST(STEP( INODE )) .EQ. 0) THEN
         DO WHILE ( PTRIST(STEP(INODE)) .EQ. 0 )
          BLOCKING = .TRUE.
          SET_IRECV= .FALSE.
          MESSAGE_RECEIVED = .FALSE.
          CALL DAGMG_MUMPS_329( COMM_LOAD,                                   &
     &    ASS_IRECV, BLOCKING, SET_IRECV, MESSAGE_RECEIVED,             &
     &    MSGSOU, MAITRE_DESC_BANDE,                                    &
     &    STATUS,                                                       &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM,                                          &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,            &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE_STEPS,           &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE, .TRUE.                       &
     &    )
          IF ( IFLAG .LT. 0 ) GOTO 600
        END DO
      ENDIF
      DO WHILE ( NBPROCFILS( STEP(INODE)) .NE. 0 )
        BLOCKING = .TRUE.
        SET_IRECV = .FALSE.
        MESSAGE_RECEIVED = .FALSE.
        CALL DAGMG_MUMPS_329( COMM_LOAD,                                     &
     &    ASS_IRECV, BLOCKING, SET_IRECV, MESSAGE_RECEIVED,             &
     &    AGMG_MPF_ANY_SOURCE, CONTRIB_TYPE2,                                &
     &    STATUS,                                                       &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM,                                          &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,            &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE_STEPS,           &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE, .TRUE. )
        IF ( IFLAG .LT. 0 ) GOTO 600
      END  DO
        SET_IRECV = .TRUE.
        BLOCKING  = .FALSE.
        MESSAGE_RECEIVED = .TRUE.
        CALL DAGMG_MUMPS_329( COMM_LOAD, ASS_IRECV,                          &
     &    BLOCKING, SET_IRECV, MESSAGE_RECEIVED,                        &
     &    AGMG_MPF_ANY_SOURCE, AGMG_MPF_ANY_TAG,                                  &
     &    STATUS,                                                       &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM,                                          &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,            &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE_STEPS,           &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE, .TRUE.  )
      IOLDPS = PTRIST(STEP(INODE))
      POSELT = PTRAST(STEP(INODE))
      LCONT1 = IW( IOLDPS +KEEP(IXSZ))
      NASS1  = IW( IOLDPS + 1 +KEEP(IXSZ))
      NROW1  = IW( IOLDPS + 2 +KEEP(IXSZ))
      NPIV1  = IW( IOLDPS + 3 +KEEP(IXSZ))
      NSLAV1 = IW( IOLDPS + 5 +KEEP(IXSZ))
      HS     = 6 + NSLAV1 + KEEP(IXSZ)
      NCOL1  = LCONT1 + NPIV1
      IF (NPIV.GT.0) THEN
        ICT11 = IOLDPS+HS+NROW1+NPIV1 - 1
        DO I = 1, NPIV
          IF (IW(IPIV+I-1).EQ.I) CYCLE
          ISW = IW(ICT11+I)
          IW(ICT11+I) = IW(ICT11+IW(IPIV+I-1))
          IW(ICT11+IW(IPIV+I-1)) = ISW
          IPOS = POSELT + int(NPIV1 + I - 1,8)
          KPOS = POSELT + int(NPIV1 + IW(IPIV+I-1) - 1,8)
          CALL DSWAP(NROW1, A(IPOS), NCOL1, A(KPOS), NCOL1)
        ENDDO
        LPOS2 = POSELT + int(NPIV1,8)
        CALL DTRSM('L','L','N','N',NPIV, NROW1, ONE,                    &
     &           A(POSBLOCFACTO), NCOL, A(LPOS2), NCOL1)
        LPOS1 = POSBLOCFACTO+int(NPIV,8)
        LPOS  = LPOS2 + int(NPIV,8)
      ENDIF
      IF (KEEP(201).eq.1) THEN
        MonBloc%INODE = INODE
        MonBloc%MASTER = .FALSE.
        MonBloc%TypeNode = 2
        MonBloc%NROW = NROW1
        MonBloc%NCOL = NCOL1
        MonBloc%NFS  = NASS1
        MonBloc%LastPiv = NPIV1 + NPIV
        NULLIFY(MonBloc%INDICES)
        MonBloc%LAST = LASTBL
        STRAT = STRAT_TRY_WRITE
        NextPivDummy      = -8888
        LIWFAC = IW(IOLDPS+XXI)
        CALL AGMG_MUMPS_729(LAFAC, IW(IOLDPS+XXR))
        LAST_CALL = .FALSE.
        CALL DAGMG_MUMPS_688( STRAT, TYPEF_L, A(POSELT),                     &
     &       LAFAC, MonBloc, NextPivDummy, NextPivDummy,                &
     &       IW(IOLDPS), LIWFAC, MYID, KEEP8(31), IFLAG,LAST_CALL)
      ENDIF
      IF ( NPIV .GT. 0 ) THEN
        CALL DGEMM('N','N', NCOL-NPIV,NROW1,NPIV,                       &
     &             ALPHA,A(LPOS1),NCOL,                                 &
     &             A(LPOS2),NCOL1,ONE, A(LPOS),NCOL1)
      ENDIF
  200 CONTINUE
      IW(IOLDPS+KEEP(IXSZ) ) = IW(IOLDPS+KEEP(IXSZ) ) - NPIV
      IW(IOLDPS + 3+KEEP(IXSZ) ) = IW(IOLDPS+3+KEEP(IXSZ) ) + NPIV
      IF (LASTBL) IW(IOLDPS+1+KEEP(IXSZ) ) = IW(IOLDPS + 3+KEEP(IXSZ) )
      IF ( .not. LASTBL .AND.                                           &
     &  (IW(IOLDPS+1+KEEP(IXSZ)) .EQ. IW(IOLDPS + 3+KEEP(IXSZ))) ) THEN
        write(*,*) ' ERROR 1 **** IN BLACFACTO '
        CALL AGMG_MUMPS_ABORT()
      ENDIF
      LRLU  = LRLU + LAELL
      LRLUS = LRLUS + LAELL
      POSFAC = POSFAC - LAELL
      CALL DAGMG_MUMPS_471(.FALSE.,.FALSE.,                                  &
     &             LA-LRLUS,0_8,-LAELL,KEEP,KEEP8,LRLU)
      IWPOS = IWPOS - NPIV
      FLOP1 = dble( NPIV1*NROW1 ) +                                     &
     &        dble(NROW1*NPIV1)*dble(2*NCOL1-NPIV1-1)                   &
     &   -                                                              &
     &        dble((NPIV1+NPIV)*NROW1 ) -                               &
     &        dble(NROW1*(NPIV1+NPIV))*dble(2*NCOL1-NPIV1-NPIV-1)
      CALL DAGMG_MUMPS_190( 1, .FALSE., FLOP1, KEEP,KEEP8 )
      IF (LASTBL) THEN
        IW(IOLDPS+XXS)=S_ALL
        IF (KEEP(214).EQ.1) THEN
          CALL DAGMG_MUMPS_314( N, INODE,                                    &
     &    PTRIST, PTRAST, PTLUST_S, PTRFAC, IW, LIW, A, LA,             &
     &    LRLU, LRLUS, IWPOS, IWPOSCB, POSFAC, COMP,                    &
     &    IPTRLU, OPELIW, STEP, PIMASTER, PAMASTER, ITLOC,              &
     &    IFLAG, IERROR, SLAVEF, MYID, COMM, KEEP,KEEP8, ITYPE2         &
     &     )
          IF (KEEP(38).NE.FPERE) THEN
            IW(PTRIST(STEP(INODE))+XXS)=S_NOLCBNOCONTIG
            IF (KEEP(216).NE.3) THEN
              MEM_GAIN=int(IW(PTRIST(STEP(INODE))+2+KEEP(IXSZ)),8)*     &
     &                 int(IW(PTRIST(STEP(INODE))+3+KEEP(IXSZ)),8)
              LRLUS = LRLUS+MEM_GAIN
              CALL DAGMG_MUMPS_471(.FALSE.,.FALSE.,                          &
     &                LA-LRLUS,0_8,-MEM_GAIN,KEEP,KEEP8,LRLU)
            ENDIF
          ENDIF
          IF (KEEP(216).EQ.2) THEN
           IF (KEEP(38).NE.FPERE) THEN
           CALL DAGMG_MUMPS_627(A,LA,PTRAST(STEP(INODE)),                    &
     &         IW( PTRIST(STEP( INODE )) + 2 + KEEP(IXSZ) ),            &
     &         IW( PTRIST(STEP( INODE )) + KEEP(IXSZ) ),                &
     &         IW( PTRIST(STEP( INODE )) + 3 + KEEP(IXSZ) )+            &
     &         IW( PTRIST(STEP( INODE )) + KEEP(IXSZ) ),0,              &
     &         IW( PTRIST(STEP( INODE )) + XXS ),0_8)
           IW(PTRIST(STEP(INODE))+XXS)=S_NOLCBCONTIG
           ENDIF
          ENDIF
         ENDIF
      ENDIF
      IOLDPS = PTRIST(STEP(INODE))
      IF ( LASTBL  .AND. (KEEP(38).EQ.FPERE) ) THEN
       LCONT  = IW(IOLDPS+KEEP(IXSZ))
       NROW   = IW(IOLDPS+2+KEEP(IXSZ))
       NPIV   = IW(IOLDPS+3+KEEP(IXSZ))
       NASS   = IW(IOLDPS+4+KEEP(IXSZ))
       NELIM  = NASS-NPIV
       NCOL_TO_SEND =  LCONT-NELIM
       SHIFT_LIST_ROW_SON = 6 + IW(IOLDPS+5+KEEP(IXSZ)) + KEEP(IXSZ)
       SHIFT_LIST_COL_SON = SHIFT_LIST_ROW_SON + NROW + NASS
       SHIFT_VAL_SON      = int(NASS,8)
       LDA                = LCONT + NPIV
      IF (IW(IOLDPS+6+KEEP(IXSZ)).EQ.S_ROOTBAND_INIT) THEN
        IW(IOLDPS+6+KEEP(IXSZ)) = S_REC_CONTSTATIC
      ELSE
      ENDIF
       CALL DAGMG_MUMPS_80(                                                  &
     &    COMM_LOAD, ASS_IRECV,                                         &
     &    N, INODE, FPERE,                                              &
     &    PTRIST, PTRAST,                                               &
     &    root, NROW, NCOL_TO_SEND, SHIFT_LIST_ROW_SON,                 &
     &    SHIFT_LIST_COL_SON , SHIFT_VAL_SON, LDA,                      &
     &    ROOT_CONT_STATIC, MYID, COMM,                                 &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU, LRLU, LRLUS, IW, LIW, A, LA,          &
     &    PTRIST, PTLUST_S, PTRFAC,                                     &
     &    PTRAST, STEP, PIMASTER, PAMASTER,                             &
     &    NSTK_S, COMP, IFLAG, IERROR, NBPROCFILS,                      &
     &    IPOOL, LPOOL, LEAF, NBFIN, SLAVEF,                            &
     &    OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,                  &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8,                            &
     &    .FALSE., ND, FRERE_STEPS,                                     &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE )
       IF ( IFLAG < 0 ) GOTO 600
       IF (NELIM.EQ.0) THEN
        IF (KEEP(214).EQ.2) THEN
          CALL DAGMG_MUMPS_314( N, INODE,                                    &
     &         PTRIST, PTRAST, PTLUST_S, PTRFAC, IW, LIW, A, LA,        &
     &         LRLU, LRLUS, IWPOS, IWPOSCB, POSFAC, COMP,               &
     &         IPTRLU, OPELIW, STEP, PIMASTER, PAMASTER, ITLOC,         &
     &         IFLAG, IERROR, SLAVEF, MYID, COMM, KEEP,KEEP8, ITYPE2    &
     &         )
        ENDIF
         CALL DAGMG_MUMPS_626( N, INODE,                                     &
     &         PTRIST, PTRAST, IW, LIW, A, LA,                          &
     &         LRLU, LRLUS, IWPOSCB,                                    &
     &         IPTRLU, STEP,                                            &
     &         MYID, KEEP                                               &
     &         )
       ELSE
        IOLDPS = PTRIST(STEP(INODE))
        IF  (IW(IOLDPS+6+KEEP(IXSZ)).EQ.S_ROOT2SON_CALLED) THEN
           CALL DAGMG_MUMPS_626( N, INODE, PTRIST, PTRAST, IW, LIW,          &
     &        A, LA, LRLU, LRLUS, IWPOSCB, IPTRLU, STEP,                &
     &        MYID, KEEP                                                &
     &         )
        ELSE
          IW(IOLDPS+6+KEEP(IXSZ)) = S_ROOTBAND_INIT
         IF (KEEP(214).EQ.1.AND.KEEP(216).NE.3) THEN
           IW(PTRIST(STEP(INODE))+XXS)=S_NOLCBNOCONTIG38
           CALL DAGMG_MUMPS_628( IW(PTRIST(STEP(INODE))),                    &
     &                     LIW-PTRIST(STEP(INODE))+1,                   &
     &                     MEM_GAIN, KEEP(IXSZ) )
           LRLUS = LRLUS + MEM_GAIN
              CALL DAGMG_MUMPS_471(.FALSE.,.FALSE.,                          &
     &                LA-LRLUS,0_8,-MEM_GAIN,KEEP,KEEP8,LRLU)
            IF (KEEP(216).EQ.2) THEN
              CALL DAGMG_MUMPS_627(A,LA,PTRAST(STEP(INODE)),                 &
     &         IW( PTRIST(STEP( INODE )) + 2 + KEEP(IXSZ) ),            &
     &         IW( PTRIST(STEP( INODE )) + KEEP(IXSZ) ),                &
     &         IW( PTRIST(STEP( INODE )) + 3 + KEEP(IXSZ) )+            &
     &         IW( PTRIST(STEP( INODE )) + KEEP(IXSZ) ),                &
     &         IW( PTRIST(STEP( INODE )) + 4 + KEEP(IXSZ) ) -           &
     &         IW( PTRIST(STEP( INODE )) + 3 + KEEP(IXSZ) ),            &
     &         IW( PTRIST(STEP( INODE )) + XXS ),0_8)
              IW(PTRIST(STEP(INODE))+XXS)=S_NOLCBCONTIG38
            ENDIF
         ENDIF
        ENDIF
       ENDIF
      ENDIF
  600 CONTINUE
      RETURN
  700 CONTINUE
      CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
      RETURN
      END SUBROUTINE DAGMG_MUMPS_264
      SUBROUTINE DAGMG_MUMPS_699( COMM_LOAD, ASS_IRECV,                      &
     &   MSGLEN, BUFR, LBUFR,                                           &
     &   LBUFR_BYTES, PROCNODE_STEPS,                                   &
     &   SLAVEF, IWPOS, IWPOSCB, IPTRLU, LRLU, LRLUS, POSFAC,           &
     &   N, IW, LIW, A, LA, PTRIST, PTLUST_S, PTRFAC, PTRAST,           &
     &   STEP, PIMASTER, PAMASTER, NBPROCFILS,                          &
     &   COMP, root, OPASSW, OPELIW, ITLOC, NSTK_S,                     &
     &   FILS, PTRARW, PTRAIW, INTARR, DBLARR, NBFIN,                   &
     &   MYID, COMM, ICNTL, KEEP,KEEP8, IFLAG, IERROR,                  &
     &   IPOOL, LPOOL, LEAF, ND, FRERE_STEPS, LPTRAR, NELT,             &
     &   FRTPTR, FRTELT,                                                &
     &   ISTEP_TO_INIV2, TAB_POS_IN_PERE )
      USE DAGMG_MUMPS_LD
      USE DAGMG_MUMPS_COMM_BUFF
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER ICNTL( 40 ), KEEP( 500 )
      INTEGER*8 KEEP8(150)
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER COMM_LOAD, ASS_IRECV, MSGLEN
      INTEGER BUFR( LBUFR )
      INTEGER(8) :: LRLU, IPTRLU, LRLUS, LA, POSFAC
      INTEGER N, SLAVEF, IWPOS, IWPOSCB, LIW
      INTEGER NBFIN
      INTEGER COMP
      INTEGER NELT, LPTRAR
      INTEGER PROCNODE_STEPS( KEEP(28) ), PTRIST(KEEP(28))
      INTEGER(8) :: PTRAST(KEEP(28)), PAMASTER(KEEP(28))
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER STEP(N), PIMASTER(KEEP(28))
      INTEGER PTLUST_S( KEEP(28) )
      INTEGER NBPROCFILS( KEEP(28) )
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER ITLOC( N ), NSTK_S( KEEP(28) ), FILS( N )
      INTEGER ND(KEEP(28)), FRERE_STEPS( KEEP(28) )
      INTEGER PTRARW( LPTRAR ), PTRAIW( LPTRAR )
      INTEGER INTARR( max(1,KEEP(14)) )
      DOUBLE PRECISION DBLARR( max( 1,KEEP(13)) )
      DOUBLE PRECISION OPASSW, OPELIW
      INTEGER COMM, MYID, IFLAG, IERROR
      INTEGER LEAF, LPOOL
      INTEGER IPOOL( LPOOL )
      INTEGER FRTPTR(N+1), FRTELT( NELT )
      INTEGER ISTEP_TO_INIV2(KEEP(71)),                                 &
     &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      INTEGER NFS4FATHER
      LOGICAL COMPUTE_MAX
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      INTEGER STATUS( AGMG_MPF_STATUS_SIZE )
      INTEGER AGMG_MUMPS_275
      EXTERNAL AGMG_MUMPS_275
      INTEGER IERR
      INTEGER NBROWS_ALREADY_SENT, NBROWS_PACKET
      INTEGER I, INODE, ISON, POSITION, NBROW, LROW, IROW, INDCOL
      INTEGER LREQI
      INTEGER(8) :: LREQA, POSCONTRIB
      INTEGER ROW_LENGTH
      INTEGER MASTER
      INTEGER ISTCHK
      LOGICAL SAME_PROC
      LOGICAL SLAVE_NODE
      LOGICAL BLOCKING, SET_IRECV, MESSAGE_RECEIVED
      INTEGER ISHIFT_BUFR, LBUFR_LOC, LBUFR_BYTES_LOC
      POSITION = 0
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      MASTER     = AGMG_MUMPS_275(STEP(INODE),PROCNODE_STEPS,SLAVEF)
      SLAVE_NODE = MASTER .NE. MYID
      IF (SLAVE_NODE .AND. PTRIST(STEP(INODE)) ==0) THEN
        ISHIFT_BUFR     = ( MSGLEN + KEEP(34) ) / KEEP(34)
        LBUFR_LOC       = LBUFR - ISHIFT_BUFR + 1
        LBUFR_BYTES_LOC = LBUFR_LOC * KEEP(34)
        DO WHILE ( PTRIST( STEP(INODE) ) .EQ. 0 )
          MASTER = AGMG_MUMPS_275(STEP(INODE),PROCNODE_STEPS,SLAVEF)
          BLOCKING = .TRUE.
          SET_IRECV = .FALSE.
          MESSAGE_RECEIVED = .FALSE.
          CALL DAGMG_MUMPS_329( COMM_LOAD, ASS_IRECV,                        &
     &     BLOCKING, SET_IRECV, MESSAGE_RECEIVED,                       &
     &     MASTER, MAITRE_DESC_BANDE,                                   &
     &     STATUS,                                                      &
     &     BUFR(ISHIFT_BUFR), LBUFR_LOC, LBUFR_BYTES_LOC,               &
     &     PROCNODE_STEPS, POSFAC,                                      &
     &     IWPOS, IWPOSCB, IPTRLU,                                      &
     &     LRLU, LRLUS, N, IW, LIW, A, LA,                              &
     &     PTRIST, PTLUST_S, PTRFAC,                                    &
     &     PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,              &
     &     IFLAG, IERROR, COMM,                                         &
     &     NBPROCFILS, IPOOL, LPOOL, LEAF,                              &
     &     NBFIN, MYID, SLAVEF,                                         &
     &     root, OPASSW, OPELIW, ITLOC, FILS,                           &
     &     PTRARW, PTRAIW,                                              &
     &     INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE_STEPS,          &
     &     LPTRAR, NELT, FRTPTR, FRTELT,                                &
     &     ISTEP_TO_INIV2, TAB_POS_IN_PERE, .TRUE. )
          IF (IFLAG.LT.0) RETURN
        END DO
      ENDIF
      IF ( SLAVE_NODE ) THEN
         LREQI = LROW + NBROWS_PACKET
      ELSE
         LREQI = NBROWS_PACKET
      END IF
         LREQA = int(LROW,8)
         IF ( LRLU .LT. LREQA .OR. IWPOS + LREQI                        &
     &        - 1 .GT. IWPOSCB ) THEN
            IF ( LRLUS .LT. LREQA ) THEN
               IFLAG = -9
               CALL AGMG_MUMPS_731( LREQA - LRLUS, IERROR )
               CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
               RETURN
            END IF
            CALL DAGMG_MUMPS_94(N, KEEP(28), IW, LIW, A, LA,                 &
     &           LRLU, IPTRLU,                                          &
     &           IWPOS, IWPOSCB, PTRIST, PTRAST,                        &
     &           STEP, PIMASTER, PAMASTER, ITLOC,KEEP(216),LRLUS,       &
     &           KEEP(IXSZ))
            COMP = COMP+1
            IF ( LRLU .NE. LRLUS ) THEN
               WRITE(*,*) 'PB compress ass..process_contrib'
               WRITE(*,*) 'LRLU,LRLUS=',LRLU,LRLUS
               IFLAG = -9
               CALL AGMG_MUMPS_731( LREQA - LRLUS, IERROR )
               CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
               RETURN
            END IF
            IF ( IWPOS + LREQI - 1 .GT. IWPOSCB ) THEN
               IFLAG  = -8
               IERROR = IWPOS + LREQI - 1 - IWPOSCB
               CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
               RETURN
            END IF
         END IF
         LRLU  = LRLU - LREQA
         LRLUS = LRLUS - LREQA
         POSCONTRIB = POSFAC
         POSFAC = POSFAC + LREQA
         KEEP8(67) = min(LRLUS, KEEP8(67))
         CALL DAGMG_MUMPS_471(.FALSE.,.FALSE.,                               &
     &        LA-LRLUS,0_8,LREQA,KEEP,KEEP8,LRLU)
         IF  ( SLAVE_NODE ) THEN
            IROW   = IWPOS
            INDCOL = IWPOS + NBROWS_PACKET
         ELSE
            IROW   = IWPOS
            INDCOL = -1
         END IF
         IWPOS = IWPOS + LREQI
         IF ( SLAVE_NODE ) THEN
            CALL AGMG_NOCALL('MPI_UNPACK')
         END IF
         DO I = 1, NBROWS_PACKET
            CALL AGMG_NOCALL('MPI_UNPACK')
         END DO
         IF ( SLAVE_NODE ) THEN
            IF ( NBROWS_ALREADY_SENT + NBROWS_PACKET == NBROW ) THEN
              NBPROCFILS(STEP(INODE))=NBPROCFILS(STEP(INODE))-1
            ENDIF
            IF ( KEEP(55) .eq. 0 ) THEN
               CALL DAGMG_MUMPS_539                                          &
     &              (N, INODE, IW, LIW, A, LA,                          &
     &              NBROW, LROW,                                        &
     &              OPASSW, OPELIW, STEP, PTRIST, PTRAST, ITLOC,        &
     &              FILS, PTRARW, PTRAIW, INTARR, DBLARR, ICNTL,        &
     &              KEEP,KEEP8, MYID )
            ELSE
               CALL DAGMG_MUMPS_123(                                         &
     &              NELT, FRTPTR, FRTELT,                               &
     &              N, INODE, IW, LIW, A, LA,                           &
     &              NBROW, LROW,                                        &
     &              OPASSW, OPELIW, STEP, PTRIST, PTRAST, ITLOC,        &
     &              FILS, PTRARW, PTRAIW, INTARR, DBLARR, ICNTL,        &
     &              KEEP,KEEP8, MYID )
            ENDIF
            DO I=1,NBROWS_PACKET
               IF(KEEP(50).NE.0)THEN
                  CALL AGMG_NOCALL('MPI_UNPACK')
               ELSE
                 ROW_LENGTH=LROW
               ENDIF
               CALL AGMG_NOCALL('MPI_UNPACK')
               CALL DAGMG_MUMPS_40(N, INODE, IW, LIW, A, LA,                 &
     &              1, ROW_LENGTH, IW( IROW+I-1 ),IW(INDCOL),           &
     &              A(POSCONTRIB),                                      &
     &              OPASSW, OPELIW, STEP, PTRIST, PTRAST, ITLOC,        &
     &              FILS, ICNTL, KEEP,KEEP8, MYID )
            ENDDO
            CALL DAGMG_MUMPS_531                                             &
     &           (N, INODE, IW, LIW,                                    &
     &           NBROWS_PACKET, STEP, PTRIST, ITLOC, KEEP,KEEP8)
         ELSE
            DO I=1,NBROWS_PACKET
               IF(KEEP(50).NE.0)THEN
                  CALL AGMG_NOCALL('MPI_UNPACK')
               ELSE
                 ROW_LENGTH=LROW
               ENDIF
               CALL AGMG_NOCALL('MPI_UNPACK')
               CALL DAGMG_MUMPS_39(N, INODE, IW, LIW, A, LA,                 &
     &              ISON, 1, ROW_LENGTH, IW( IROW +I-1 ),               &
     &              A(POSCONTRIB), PTLUST_S, PTRAST,                    &
     &              STEP, PIMASTER, OPASSW,                             &
     &              IWPOSCB, MYID, KEEP,KEEP8)
            ENDDO
          IF (NBROWS_ALREADY_SENT .EQ. 0) THEN
          IF (KEEP(219).NE.0) THEN
            IF(KEEP(50) .EQ. 2) THEN
               CALL AGMG_NOCALL('MPI_UNPACK')
               IF(NFS4FATHER .GT. 0) THEN
                  CALL DAGMG_MUMPS_617(NFS4FATHER,IERR)
                  IF (IERR .NE. 0) THEN
                        IERROR         = BUF_LMAX_ARRAY
                        IFLAG          = -13
                        CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
                        RETURN
                  ENDIF
                  CALL AGMG_NOCALL('MPI_UNPACK')
                  CALL DAGMG_MUMPS_619(N, INODE, IW, LIW, A, LA,             &
     &                 ISON, NFS4FATHER,                                &
     &                 BUF_MAX_ARRAY, PTLUST_S, PTRAST,                 &
     &                 STEP, PIMASTER, OPASSW,                          &
     &                 IWPOSCB, MYID, KEEP,KEEP8)
               ENDIF
            ENDIF
          ENDIF
          ENDIF
          IF (NBROWS_ALREADY_SENT + NBROWS_PACKET == NBROW ) THEN
            NBPROCFILS(STEP(INODE)) = NBPROCFILS(STEP(INODE)) - 1
            NBPROCFILS(STEP(ISON))  = NBPROCFILS(STEP(ISON)) - 1
            IF ( NBPROCFILS(STEP(ISON)) .EQ. 0) THEN
               ISTCHK = PIMASTER(STEP(ISON))
               SAME_PROC= ISTCHK .LT. IWPOSCB
               IF (SAME_PROC) THEN
                  CALL DAGMG_MUMPS_530(N, ISON, INODE, IWPOSCB,              &
     &                 PIMASTER, PTLUST_S, IW, LIW, STEP, KEEP,KEEP8)
               ENDIF
               IF (SAME_PROC) THEN
                  ISTCHK = PTRIST(STEP(ISON))
                  PTRIST(STEP( ISON) ) = -99999999
               ELSE
                  PIMASTER(STEP( ISON )) = -99999999
               ENDIF
               CALL DAGMG_MUMPS_152(.FALSE., MYID, N, ISTCHK,                &
     &              PAMASTER(STEP(ISON)),                               &
     &              IW, LIW, LRLU, LRLUS, IPTRLU, IWPOSCB,              &
     &              LA, KEEP,KEEP8, .FALSE.                             &
     &              )
            ENDIF
            IF ( NBPROCFILS(STEP(INODE)) .EQ. 0 ) THEN
               CALL DAGMG_MUMPS_507( N, IPOOL, LPOOL,                        &
     &              PROCNODE_STEPS,                                     &
     &              SLAVEF, KEEP(28), KEEP(76), KEEP(80),               &
     &              KEEP(47), STEP, INODE+N )
               IF (KEEP(47) .GE. 3) THEN
                  CALL DAGMG_MUMPS_500(                                      &
     &          IPOOL, LPOOL,                                           &
     &                 PROCNODE_STEPS, KEEP,KEEP8, SLAVEF, COMM_LOAD,   &
     &                 MYID, STEP, N, ND, FILS )
               ENDIF
            ENDIF
          ENDIF
      END IF
         IWPOS = IWPOS - LREQI
         LRLU = LRLU + LREQA
         LRLUS = LRLUS + LREQA
         POSFAC = POSFAC - LREQA
         CALL DAGMG_MUMPS_471(.FALSE.,.FALSE.,                               &
     &        LA-LRLUS,0_8,-LREQA,KEEP,KEEP8,LRLU)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_699
      SUBROUTINE DAGMG_MUMPS_143( N, INODE, IW, LIW, A, LA,                  &
     &                           IOLDPS, POSELT, IFLAG, UU, NOFFW,      &
     &                           NPVW,                                  &
     &                           KEEP,KEEP8, STEP,                      &
     &                           PROCNODE_STEPS, MYID, SLAVEF, SEUIL,   &
     &                           AVOID_DELAYED, ETATASS,                &
     &     DKEEP,PIVNUL_LIST,LPN_LIST,                                  &
     &     IWPOS )
      USE DAGMG_MUMPS_OOC_MAIN
      IMPLICIT NONE
      INTEGER(8) :: LA, POSELT
      INTEGER N, INODE, LIW, IFLAG, NOFFW, NPVW
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER MYID, SLAVEF, IOLDPS
      INTEGER KEEP( 500 )
      INTEGER*8 KEEP8(150)
      INTEGER PROCNODE_STEPS( KEEP(28) ), STEP(N)
      DOUBLE PRECISION UU, SEUIL
      LOGICAL AVOID_DELAYED
      INTEGER ETATASS, IWPOS
      INTEGER LPN_LIST
      INTEGER PIVNUL_LIST(LPN_LIST)
      DOUBLE PRECISION DKEEP(30)
      INTEGER INOPV, IFINB, NFRONT, NPIV, IBEG_BLOCK
      INTEGER NASS, NEL1, NPIVB, NPIVE, NBOLKJ, NBTLKJ
      DOUBLE PRECISION UUTEMP
      INTEGER(8) :: LAFAC
      INTEGER LIWFAC, STRAT, TYPEFile, LNextPiv2beWritten,              &
     &        UNextPiv2beWritten, IFLAG_OOC,                            &
     &        PP_FIRST2SWAP_L, PP_FIRST2SWAP_U,                         &
     &        PP_LastPIVRPTRFilled_L,                                   &
     &        PP_LastPIVRPTRFilled_U
      TYPE(IO_BLOCK) :: MonBloc
      LOGICAL LAST_CALL
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      EXTERNAL AGMG_MUMPS_330, DAGMG_MUMPS_221, DAGMG_MUMPS_233,                       &
     &         DAGMG_MUMPS_229,                                              &
     &         DAGMG_MUMPS_225, DAGMG_MUMPS_232, DAGMG_MUMPS_231,                      &
     &         DAGMG_MUMPS_220,                                              &
     &         DAGMG_MUMPS_228, DAGMG_MUMPS_236
      INTEGER  AGMG_MUMPS_330
      LOGICAL STATICMODE
      DOUBLE PRECISION SEUIL_LOC
      INOPV = 0
      SEUIL_LOC = SEUIL
      IF(KEEP(97) .EQ. 0) THEN
         STATICMODE = .FALSE.
      ELSE
         STATICMODE = .TRUE.
      ENDIF
      IF (AVOID_DELAYED) THEN
         STATICMODE = .TRUE.
         UUTEMP=UU
         SEUIL_LOC = max(SEUIL,epsilon(SEUIL))
      ELSE
         UUTEMP=UU
      ENDIF
      IBEG_BLOCK=1
      NFRONT = IW(IOLDPS+KEEP(IXSZ))
      NASS   = iabs(IW(IOLDPS+2+KEEP(IXSZ)))
      IF (NASS .GT. KEEP(3)) THEN
        NBOLKJ = min( KEEP(6), NASS )
      ELSE
        NBOLKJ = min( KEEP(5), NASS )
      ENDIF
      NBTLKJ = NBOLKJ
        IF (KEEP(201).EQ.1) THEN
          CALL AGMG_MUMPS_729(LAFAC,IW(IOLDPS+XXR))
          LIWFAC    = IW(IOLDPS+XXI)
          TYPEFile     = TYPEF_BOTH_LU
          LNextPiv2beWritten = 1
          UNextPiv2beWritten = 1
          PP_FIRST2SWAP_L = LNextPiv2beWritten
          PP_FIRST2SWAP_U = UNextPiv2beWritten
          MonBloc%LastPanelWritten_L = 0
          MonBloc%LastPanelWritten_U = 0
          PP_LastPIVRPTRFilled_L = 0
          PP_LastPIVRPTRFilled_U = 0
          MonBloc%INODE    = INODE
          MonBloc%MASTER   = .TRUE.
          MonBloc%Typenode = 1
          MonBloc%NROW     = NFRONT
          MonBloc%NCOL     = NFRONT
          MonBloc%NFS      = NASS
          MonBloc%Last     = .FALSE.
          MonBloc%LastPiv  = -88877
          NULLIFY(MonBloc%INDICES)
        ENDIF
   50 CONTINUE
      CALL DAGMG_MUMPS_221(NFRONT,NASS,N,INODE,IW,LIW,A,LA,INOPV,NOFFW,      &
     &     IFLAG,IOLDPS,POSELT,UU,SEUIL_LOC,KEEP,KEEP8,                 &
     &     DKEEP(1),PIVNUL_LIST(1),LPN_LIST,                            &
     &     PP_FIRST2SWAP_L,  MonBloc%LastPanelWritten_L,                &
     &     PP_LastPIVRPTRFilled_L,                                      &
     &     PP_FIRST2SWAP_U,  MonBloc%LastPanelWritten_U,                &
     &     PP_LastPIVRPTRFilled_U)
      IF (IFLAG.LT.0) GOTO 500
      IF (INOPV.EQ.1) THEN
         IF(STATICMODE) THEN
            INOPV = -1
            GOTO 50
         ENDIF
         GOTO 80
      ENDIF
      IF (INOPV.EQ.2) THEN
         CALL DAGMG_MUMPS_233(IBEG_BLOCK,                                    &
     &            NFRONT,NASS,N,INODE,IW,LIW,A,LA,                      &
     &            IOLDPS,POSELT,NBOLKJ, NBTLKJ,KEEP(4),KEEP(IXSZ))
         GOTO 50
      ENDIF
      NPVW = NPVW + 1
      IF (NASS.LE.1) THEN
       CALL DAGMG_MUMPS_229(NFRONT,N,INODE,IW,LIW,A,LA,                      &
     &                 IOLDPS,POSELT,KEEP(IXSZ))
       IW(IOLDPS+1+KEEP(IXSZ)) = IW(IOLDPS+1+KEEP(IXSZ)) + 1
       GO TO 500
      ENDIF
       CALL DAGMG_MUMPS_225(IBEG_BLOCK,NFRONT, NASS, N,INODE,IW,LIW,A,LA,    &
     &             IOLDPS,POSELT,IFINB,                                 &
     &             NBTLKJ,KEEP(4),KEEP(IXSZ))
       IW(IOLDPS+1+KEEP(IXSZ)) = IW(IOLDPS+1+KEEP(IXSZ)) + 1
       IF (IFINB.EQ.0) GOTO 50
       IF (KEEP(201).EQ.1) THEN
           MonBloc%LastPiv= IW(IOLDPS+1+KEEP(IXSZ))
           STRAT          = STRAT_TRY_WRITE
           TYPEFile       = TYPEF_U
           LAST_CALL      = .FALSE.
           CALL DAGMG_MUMPS_688                                              &
     &          ( STRAT, TYPEFile,                                      &
     &           A(POSELT), LAFAC, MonBloc,                             &
     &           LNextPiv2beWritten, UNextPiv2beWritten,                &
     &           IW(IOLDPS), LIWFAC,                                    &
     &           MYID, KEEP8(31), IFLAG_OOC,LAST_CALL )
          IF (IFLAG_OOC < 0 ) IFLAG=IFLAG_OOC
        ENDIF
       IF (IFINB.EQ.(-1)) GOTO 80
       NPIV   = IW(IOLDPS+1+KEEP(IXSZ))
       NEL1   = NASS - NPIV
      CALL DAGMG_MUMPS_232(A,LA,                                             &
     &           NFRONT,NPIV,NASS,POSELT,NBTLKJ)
      GO TO 50
   80 CONTINUE
      NPIV   = IW(IOLDPS+1+KEEP(IXSZ))
      IF (NPIV.LE.0) GO TO 110
      NEL1   = NFRONT - NASS
      IF (NEL1.LE.0) GO TO 110
        IF (KEEP(201).EQ.1) THEN
         STRAT          = STRAT_TRY_WRITE
         TYPEFile     = TYPEF_BOTH_LU
         MonBloc%LastPiv= NPIV
         CALL DAGMG_MUMPS_642(A(POSELT), LAFAC, NFRONT,                      &
     &      NPIV, NASS, IW(IOLDPS), LIWFAC,                             &
     &      MonBloc, TYPEFile, MYID, KEEP8,                             &
     &      STRAT, IFLAG_OOC,                                           &
     &      LNextPiv2beWritten, UNextPiv2beWritten)
          IF (IFLAG_OOC < 0 ) IFLAG=IFLAG_OOC
        ELSE
          CALL DAGMG_MUMPS_231(A,LA,NFRONT, NPIV,NASS,POSELT)
        ENDIF
  110 CONTINUE
      IF (AGMG_MUMPS_330(STEP(INODE),PROCNODE_STEPS,SLAVEF)                  &
     &                   .EQ.1) THEN
        NPIV   = IW(IOLDPS+1+KEEP(IXSZ))
        IBEG_BLOCK = NPIV
        IF (NASS.EQ.NPIV) GOTO 500
  120   CALL DAGMG_MUMPS_220(NFRONT,NASS,N,INODE,IW,LIW,A,LA,                &
     &     INOPV,NOFFW,IOLDPS,POSELT,UU,SEUIL,                          &
     &     KEEP,                                                        &
     &     PP_FIRST2SWAP_L,  MonBloc%LastPanelWritten_L,                &
     &     PP_LastPIVRPTRFilled_L,                                      &
     &     PP_FIRST2SWAP_U,  MonBloc%LastPanelWritten_U,                &
     &     PP_LastPIVRPTRFilled_U)
        IF (INOPV.NE.1) THEN
         NPVW = NPVW + 1
         CALL DAGMG_MUMPS_228(NFRONT,NASS,N,INODE,IW,LIW,A,LA,               &
     &                 IOLDPS,POSELT,IFINB,KEEP(IXSZ))
         IW(IOLDPS+1+KEEP(IXSZ)) = IW(IOLDPS+1+KEEP(IXSZ)) + 1
       IF (IFINB.EQ.0) GOTO 120
        ENDIF
        NPIV   = IW(IOLDPS+1+KEEP(IXSZ))
        NPIVB  = IBEG_BLOCK
        NPIVE  = NPIV - NPIVB
        NEL1   = NFRONT - NASS
        IF ((NPIVE.LE.0).OR.(NEL1.EQ.0)) GO TO 500
        CALL DAGMG_MUMPS_236(A,LA,NPIVB,                                     &
     &                NFRONT,NPIV,NASS,POSELT)
      ENDIF
  500 CONTINUE
       IF (KEEP(201).EQ.1) THEN
          STRAT            = STRAT_WRITE_MAX
          MonBloc%Last     = .TRUE.
          MonBloc%LastPiv  = IW(IOLDPS+1+KEEP(IXSZ))
          TYPEFile     = TYPEF_BOTH_LU
          LAST_CALL    = .TRUE.
          CALL DAGMG_MUMPS_688                                               &
     &          ( STRAT, TYPEFile,                                      &
     &           A(POSELT), LAFAC, MonBloc,                             &
     &           LNextPiv2beWritten, UNextPiv2beWritten,                &
     &           IW(IOLDPS), LIWFAC,                                    &
     &           MYID, KEEP8(31), IFLAG_OOC, LAST_CALL )
          IF (IFLAG_OOC < 0 ) IFLAG=IFLAG_OOC
          CALL DAGMG_MUMPS_644(IWPOS,                                        &
     &      IOLDPS, IW, LIW, MonBloc , NFRONT, KEEP)
       ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_143
      RECURSIVE SUBROUTINE DAGMG_MUMPS_322(                                  &
     &    COMM_LOAD, ASS_IRECV,                                         &
     &    MSGSOU, MSGTAG, MSGLEN,                                       &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM,                                          &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,            &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,                 &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE                               &
     &    )
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER MSGSOU, MSGTAG, MSGLEN
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER BUFR( LBUFR )
      INTEGER KEEP(500), ICNTL( 40 )
      INTEGER*8 KEEP8(150)
      INTEGER(8) :: POSFAC, IPTRLU, LRLU, LRLUS, LA
      INTEGER IWPOS, IWPOSCB
      INTEGER N, LIW
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER PTRIST(KEEP(28)), PTLUST_S(KEEP(28))
      INTEGER STEP(N), PIMASTER(KEEP(28))
      INTEGER COMP
      INTEGER NSTK_S(KEEP(28)), PROCNODE_STEPS( KEEP(28) )
      INTEGER NBPROCFILS( KEEP(28) )
      INTEGER IFLAG, IERROR, COMM
      INTEGER LPOOL, LEAF
      INTEGER IPOOL( LPOOL )
      INTEGER COMM_LOAD, ASS_IRECV
      INTEGER MYID, SLAVEF, NBFIN
      DOUBLE PRECISION OPASSW, OPELIW
      INTEGER NELT, LPTRAR
      INTEGER FRTPTR( N+1), FRTELT( NELT )
      INTEGER ITLOC( N ), FILS( N )
      INTEGER PTRARW( LPTRAR ), PTRAIW( LPTRAR )
      INTEGER ND( KEEP(28) ), FRERE( KEEP(28) )
      INTEGER ISTEP_TO_INIV2(KEEP(71)),                                 &
     &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      INTEGER INTARR( max(1,KEEP(14)) )
      DOUBLE PRECISION DBLARR( max(1,KEEP(13)) )
      INTEGER INIV2, ISHIFT, IBEG
      INTEGER AGMG_MUMPS_275
      EXTERNAL AGMG_MUMPS_275
      LOGICAL FLAG
      INTEGER MP, LP
      INTEGER TMP( 2 )
      INTEGER NBRECU, POSITION, INODE, ISON, IROOT
      INTEGER NSLAVES_PERE, NFRONT_PERE, NASS_PERE,                     &
     &     LASTBL_PERE, LMAP, FPERE, NELIM,                             &
     &     HDMAPLIG,NFS4FATHER,                                         &
     &     TOT_ROOT_SIZE, TOT_CONT_TO_RECV
      DOUBLE PRECISION FLOP1
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      INTEGER IERR, STATUS( AGMG_MPF_STATUS_SIZE )
      CHARACTER(LEN=35)::SUBNAME
      MP = ICNTL(2)
      LP = ICNTL(1)
      SUBNAME="??????"
      CALL DAGMG_MUMPS_467(COMM_LOAD, KEEP)
      IF ( MSGTAG .EQ. RACINE ) THEN
          POSITION = 0
          CALL AGMG_NOCALL('MPI_UNPACK')
          NBRECU = BUFR( 1 )
          NBFIN =  NBFIN - NBRECU
      ELSEIF ( MSGTAG .EQ. NOEUD ) THEN
          CALL DAGMG_MUMPS_269( MYID,KEEP,KEEP8,                             &
     &    BUFR, LBUFR, LBUFR_BYTES,                                     &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST, PTRAST,               &
     &    STEP, PIMASTER, PAMASTER,                                     &
     &    NSTK_S, COMP, FPERE, FLAG, IFLAG, IERROR, COMM, ITLOC )
          SUBNAME="DAGMG_MUMPS_269"
          IF ( IFLAG .LT. 0 ) GO TO 500
          IF ( FLAG ) THEN
            CALL DAGMG_MUMPS_507(N, IPOOL, LPOOL,                            &
     &           PROCNODE_STEPS, SLAVEF, KEEP(28), KEEP(76),            &
     &           KEEP(80), KEEP(47), STEP, FPERE )
            IF (KEEP(47) .GE. 3) THEN
               CALL DAGMG_MUMPS_500(                                         &
     &              IPOOL, LPOOL,                                       &
     &              PROCNODE_STEPS, KEEP,KEEP8, SLAVEF, COMM_LOAD,      &
     &              MYID, STEP, N, ND, FILS )
            ENDIF
            CALL AGMG_MUMPS_137( FPERE, N,                                   &
     &           PROCNODE_STEPS,SLAVEF,                                 &
     &           ND, FILS, FRERE, STEP, PIMASTER,                       &
     &           KEEP(28), KEEP(50), FLOP1,                             &
     &           IW, LIW, KEEP(IXSZ) )
            IF (FPERE.NE.KEEP(20))                                      &
     &        CALL DAGMG_MUMPS_190(1,.FALSE.,FLOP1,KEEP,KEEP8)
          ENDIF
      ELSEIF ( MSGTAG .EQ. END_NIV2_LDLT ) THEN
          INODE = BUFR( 1 )
          CALL DAGMG_MUMPS_507(N, IPOOL, LPOOL,                              &
     &         PROCNODE_STEPS, SLAVEF, KEEP(28), KEEP(76),              &
     &         KEEP(80), KEEP(47),                                      &
     &         STEP, -INODE )
          IF (KEEP(47) .GE. 3) THEN
             CALL DAGMG_MUMPS_500(                                           &
     &            IPOOL, LPOOL,                                         &
     &            PROCNODE_STEPS, KEEP,KEEP8, SLAVEF, COMM_LOAD,        &
     &            MYID, STEP, N, ND, FILS )
          ENDIF
      ELSEIF ( MSGTAG .EQ. TERREUR ) THEN
          IFLAG  = -001
          IERROR = MSGSOU
          GOTO 100
      ELSEIF ( MSGTAG .EQ. MAITRE_DESC_BANDE ) THEN
        CALL DAGMG_MUMPS_266( MYID,BUFR, LBUFR,                              &
     &    LBUFR_BYTES, IWPOS,                                           &
     &    IWPOSCB,                                                      &
     &    IPTRLU, LRLU, LRLUS, NBPROCFILS,                              &
     &    N, IW, LIW, A, LA,                                            &
     &    PTRIST, PTRAST, STEP, PIMASTER, PAMASTER, COMP,               &
     &    KEEP,KEEP8, ITLOC,                                            &
     &    IFLAG, IERROR )
          SUBNAME="DAGMG_MUMPS_266"
        IF ( IFLAG .LT. 0 ) GO to 500
      ELSEIF ( MSGTAG .EQ. MAITRE2           ) THEN
        CALL DAGMG_MUMPS_268(MYID,BUFR, LBUFR, LBUFR_BYTES,                  &
     &    PROCNODE_STEPS, SLAVEF, IWPOS, IWPOSCB,                       &
     &    IPTRLU, LRLU, LRLUS, N, IW, LIW, A, LA,                       &
     &    PTRIST, PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,       &
     &    IFLAG, IERROR, COMM, COMM_LOAD, NBPROCFILS,                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    KEEP,KEEP8, ND, FILS, FRERE, ITLOC,                           &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE )
          SUBNAME="DAGMG_MUMPS_268"
        IF ( IFLAG .LT. 0 ) GO to 500
      ELSEIF ( MSGTAG .EQ. BLOC_FACTO        ) THEN
        CALL DAGMG_MUMPS_264( COMM_LOAD, ASS_IRECV,                          &
     &   BUFR,  LBUFR, LBUFR_BYTES,                                     &
     &   PROCNODE_STEPS, MSGSOU,                                        &
     &   SLAVEF, IWPOS, IWPOSCB, IPTRLU, LRLU, LRLUS, N, IW, LIW,       &
     &   A, LA, PTRIST, PTRAST, NSTK_S, NBPROCFILS,                     &
     &   COMP, STEP, PIMASTER, PAMASTER, POSFAC,                        &
     &   MYID, COMM , IFLAG, IERROR, NBFIN,                             &
     &    PTLUST_S, PTRFAC, root, OPASSW, OPELIW, ITLOC, FILS,          &
     &    PTRARW, PTRAIW, INTARR, DBLARR,                               &
     &    ICNTL, KEEP,KEEP8, IPOOL, LPOOL, LEAF, ND, FRERE,             &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE  )
      ELSEIF ( MSGTAG .EQ. BLOC_FACTO_SYM_SLAVE    ) THEN
        CALL DAGMG_MUMPS_263( COMM_LOAD, ASS_IRECV,                          &
     &   BUFR, LBUFR,                                                   &
     &   LBUFR_BYTES, PROCNODE_STEPS, MSGSOU,                           &
     &   SLAVEF, IWPOS, IWPOSCB, IPTRLU, LRLU, LRLUS, N, IW, LIW,       &
     &   A, LA, PTRIST, PTRAST, NSTK_S, NBPROCFILS,                     &
     &   COMP, STEP, PIMASTER, PAMASTER, POSFAC,                        &
     &   MYID, COMM, IFLAG, IERROR, NBFIN,                              &
     &    PTLUST_S, PTRFAC, root, OPASSW, OPELIW, ITLOC, FILS,          &
     &    PTRARW, PTRAIW, INTARR, DBLARR,                               &
     &    ICNTL, KEEP,KEEP8, IPOOL, LPOOL, LEAF, ND, FRERE,             &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE  )
      ELSEIF ( MSGTAG .EQ. BLOC_FACTO_SYM    ) THEN
        CALL DAGMG_MUMPS_274( COMM_LOAD, ASS_IRECV,                          &
     &   BUFR, LBUFR,                                                   &
     &   LBUFR_BYTES, PROCNODE_STEPS, MSGSOU,                           &
     &   SLAVEF, IWPOS, IWPOSCB, IPTRLU, LRLU, LRLUS, N, IW, LIW,       &
     &   A, LA, PTRIST, PTRAST, NSTK_S, NBPROCFILS,                     &
     &   COMP, STEP, PIMASTER, PAMASTER, POSFAC,                        &
     &   MYID, COMM, IFLAG, IERROR, NBFIN,                              &
     &    PTLUST_S, PTRFAC, root, OPASSW, OPELIW, ITLOC, FILS,          &
     &    PTRARW, PTRAIW, INTARR, DBLARR,                               &
     &    ICNTL, KEEP,KEEP8, IPOOL, LPOOL, LEAF, ND, FRERE,             &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE )
      ELSEIF ( MSGTAG .EQ. CONTRIB_TYPE2    ) THEN
        CALL DAGMG_MUMPS_699( COMM_LOAD, ASS_IRECV,                          &
     &       MSGLEN, BUFR, LBUFR,                                       &
     &       LBUFR_BYTES, PROCNODE_STEPS,                               &
     &       SLAVEF, IWPOS, IWPOSCB, IPTRLU, LRLU, LRLUS, POSFAC,       &
     &       N, IW, LIW, A, LA, PTRIST,                                 &
     &       PTLUST_S, PTRFAC, PTRAST,                                  &
     &       STEP, PIMASTER, PAMASTER, NBPROCFILS, COMP, root,          &
     &       OPASSW, OPELIW, ITLOC, NSTK_S,                             &
     &       FILS, PTRARW, PTRAIW, INTARR, DBLARR, NBFIN, MYID, COMM,   &
     &       ICNTL, KEEP,KEEP8, IFLAG, IERROR, IPOOL, LPOOL, LEAF,      &
     &       ND, FRERE, LPTRAR, NELT, FRTPTR, FRTELT,                   &
     &       ISTEP_TO_INIV2, TAB_POS_IN_PERE )
        IF ( IFLAG .LT. 0 ) GO TO 100
      ELSEIF ( MSGTAG .EQ. MAPLIG            ) THEN
         HDMAPLIG = 7
         INODE        = BUFR( 1 )
         ISON         = BUFR( 2 )
         NSLAVES_PERE = BUFR( 3 )
         NFRONT_PERE  = BUFR( 4 )
         NASS_PERE    = BUFR( 5 )
         LMAP         = BUFR( 6 )
         NFS4FATHER = BUFR(7)
         IF ( (NSLAVES_PERE.NE.0).AND.(KEEP(48).NE.0) ) THEN
            INIV2 = ISTEP_TO_INIV2 ( STEP(INODE) )
            ISHIFT = NSLAVES_PERE+1
            TAB_POS_IN_PERE(1:NSLAVES_PERE+1, INIV2) =                  &
     &           BUFR(HDMAPLIG+1:HDMAPLIG+1+NSLAVES_PERE)
            TAB_POS_IN_PERE(SLAVEF+2, INIV2) = NSLAVES_PERE
         ELSE
            ISHIFT = 0
         ENDIF
         IBEG = HDMAPLIG+1+ISHIFT
         CALL DAGMG_MUMPS_210( COMM_LOAD, ASS_IRECV,                         &
     &    BUFR, LBUFR, LBUFR_BYTES,                                     &
     &    INODE, ISON, NSLAVES_PERE,                                    &
     &    BUFR(IBEG),                                                   &
     &    NFRONT_PERE, NASS_PERE, NFS4FATHER,LMAP,                      &
     &    BUFR(IBEG+NSLAVES_PERE),                                      &
     &    PROCNODE_STEPS, SLAVEF, POSFAC, IWPOS, IWPOSCB,               &
     &    IPTRLU, LRLU, LRLUS, N, IW, LIW, A, LA,                       &
     &    PTRIST, PTLUST_S, PTRFAC, PTRAST, STEP, PIMASTER, PAMASTER,   &
     &    NSTK_S, COMP,                                                 &
     &    IFLAG, IERROR, MYID, COMM, NBPROCFILS,                        &
     &    IPOOL, LPOOL, LEAF, NBFIN, ICNTL, KEEP,KEEP8, root,           &
     &    OPASSW, OPELIW,                                               &
     &    ITLOC, FILS, PTRARW, PTRAIW, INTARR, DBLARR,                  &
     &    ND, FRERE, LPTRAR, NELT, FRTPTR, FRTELT,                      &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE                               &
     &    )
         IF ( IFLAG .LT. 0 ) GO TO 100
      ELSE IF ( MSGTAG .EQ. ROOT_CONT_STATIC ) THEN
        CALL DAGMG_MUMPS_700(                                                &
     &        BUFR, LBUFR, LBUFR_BYTES,                                 &
     &        root, N, IW, LIW, A, LA, NBPROCFILS,                      &
     &        LRLU, IPTRLU, IWPOS, IWPOSCB,                             &
     &        PTRIST, PTLUST_S, PTRFAC, PTRAST,                         &
     &        STEP, PIMASTER, PAMASTER,                                 &
     &        COMP, LRLUS, IPOOL, LPOOL, LEAF,                          &
     &        FILS, MYID, PTRAIW, PTRARW, INTARR, DBLARR,               &
     &        KEEP,KEEP8, IFLAG, IERROR, COMM, COMM_LOAD, ITLOC,        &
     &        ND, PROCNODE_STEPS, SLAVEF)
        SUBNAME="DAGMG_MUMPS_700"
        IF ( IFLAG .LT. 0 ) GO TO 500
      ELSE IF ( MSGTAG .EQ. ROOT_NON_ELIM_CB ) THEN
        IROOT  = KEEP( 38 )
        MSGSOU = AGMG_MUMPS_275( STEP(IROOT), PROCNODE_STEPS,                &
     &           SLAVEF )
        IF ( PTLUST_S( STEP(IROOT)) .EQ. 0 ) THEN
          CALL AGMG_NOCALL('MPI_RECV')
          CALL DAGMG_MUMPS_270( TMP( 1 ), TMP( 2 ),                          &
     &    root,                                                         &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM, COMM_LOAD,                               &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,                  &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND )
          SUBNAME="DAGMG_MUMPS_270"
          IF ( IFLAG .LT. 0 ) GOTO 500
        END IF
        CALL DAGMG_MUMPS_700(                                                &
     &       BUFR, LBUFR, LBUFR_BYTES,                                  &
     &       root, N, IW, LIW, A, LA, NBPROCFILS,                       &
     &       LRLU, IPTRLU, IWPOS, IWPOSCB,                              &
     &       PTRIST, PTLUST_S, PTRFAC, PTRAST, STEP, PIMASTER, PAMASTER,&
     &       COMP, LRLUS, IPOOL, LPOOL, LEAF,                           &
     &       FILS, MYID, PTRAIW, PTRARW, INTARR, DBLARR,                &
     &       KEEP,KEEP8, IFLAG, IERROR, COMM, COMM_LOAD, ITLOC,         &
     &       ND, PROCNODE_STEPS, SLAVEF )
          SUBNAME="DAGMG_MUMPS_700"
        IF ( IFLAG .LT. 0 ) GO TO 500
      ELSE IF ( MSGTAG .EQ. ROOT_2SON ) THEN
         ISON = BUFR( 1 )
         NELIM = BUFR( 2 )
         CALL DAGMG_MUMPS_271( COMM_LOAD, ASS_IRECV,                         &
     &    ISON, NELIM, root,                                            &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM,                                          &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,                  &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,                 &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE )
          IF ( IFLAG .LT. 0 ) GO TO 100
         IF (MYID.NE.AGMG_MUMPS_275(STEP(ISON),                              &
     &          PROCNODE_STEPS, SLAVEF)) THEN
          IF (KEEP(50).EQ.0) THEN
            IF (IW(PTRIST(STEP(ISON))+6+KEEP(IXSZ)).EQ.                 &
     &                                 S_REC_CONTSTATIC) THEN
             IW(PTRIST(STEP(ISON))+6+KEEP(IXSZ)) = S_ROOT2SON_CALLED
            ELSE
             CALL DAGMG_MUMPS_626( N, ISON, PTRIST, PTRAST,                  &
     &       IW, LIW, A, LA, LRLU, LRLUS, IWPOSCB,                      &
     &       IPTRLU, STEP, MYID, KEEP                                   &
     &    )
            ENDIF
          ELSE
           IF (IW(PTRIST(STEP(ISON))+8+KEEP(IXSZ)).EQ.                  &
     &                                 S_REC_CONTSTATIC) THEN
             IW(PTRIST(STEP(ISON))+8+KEEP(IXSZ)) = S_ROOT2SON_CALLED
           ELSE
             CALL DAGMG_MUMPS_626( N, ISON, PTRIST, PTRAST,                  &
     &       IW, LIW, A, LA, LRLU, LRLUS, IWPOSCB,                      &
     &       IPTRLU, STEP, MYID, KEEP                                   &
     &    )
           ENDIF
          ENDIF
         ENDIF
      ELSE IF ( MSGTAG .EQ. ROOT_2SLAVE ) THEN
          TOT_ROOT_SIZE    = BUFR( 1 )
          TOT_CONT_TO_RECV = BUFR( 2 )
          CALL DAGMG_MUMPS_270( TOT_ROOT_SIZE,                               &
     &    TOT_CONT_TO_RECV, root,                                       &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM, COMM_LOAD,                               &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,                  &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND )
          IF ( IFLAG .LT. 0 ) GO TO 100
      ELSE IF ( MSGTAG .EQ. ROOT_NELIM_INDICES ) THEN
         ISON         = BUFR( 1 )
         NELIM        = BUFR( 2 )
         NSLAVES_PERE = BUFR( 3 )
         CALL DAGMG_MUMPS_273( root,                                         &
     &    ISON, NELIM, NSLAVES_PERE, BUFR(4), BUFR(4+BUFR(2)),          &
     &    BUFR(4+2*BUFR(2)),                                            &
     &    PROCNODE_STEPS,                                               &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, ITLOC, COMP,        &
     &    IFLAG, IERROR,                                                &
     &    IPOOL, LPOOL, LEAF, MYID, SLAVEF, KEEP,KEEP8,                 &
     &    COMM, COMM_LOAD, FILS, ND)
          SUBNAME="DAGMG_MUMPS_273"
         IF ( IFLAG .LT. 0 ) GO TO 500
      ELSE IF ( MSGTAG .EQ. UPDATE_LOAD ) THEN
         WRITE(*,*) "Internal error 3 in DAGMG_MUMPS_322"
         CALL AGMG_MUMPS_ABORT()
      ELSE IF ( MSGTAG .EQ. TAG_DUMMY   ) THEN
      ELSE
         IF ( LP > 0 )                                                  &
     &     WRITE(LP,*) MYID,                                            &
     &': Internal error, routine DMUMPS_322.',MSGTAG
         IFLAG = -100
         IERROR= MSGTAG
         GOTO 500
      ENDIF
  100 CONTINUE
      RETURN
  500 CONTINUE
      IF ( ICNTL(1) .GT. 0 .AND. ICNTL(4).GE.1 ) THEN
        LP=ICNTL(1)
        IF (IFLAG.EQ.-9) THEN
         WRITE(LP,*) 'FAILURE, WORKSPACE TOO SMALL DURING ',SUBNAME
        ENDIF
        IF (IFLAG.EQ.-8) THEN
         WRITE(LP,*) 'FAILURE IN INTEGER ALLOCATION DURING ',SUBNAME
        ENDIF
        IF (IFLAG.EQ.-13) THEN
         WRITE(LP,*) 'FAILURE IN DYNAMIC ALLOCATION DURING ',SUBNAME
        ENDIF
      ENDIF
      CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
      RETURN
      END SUBROUTINE DAGMG_MUMPS_322
      RECURSIVE SUBROUTINE DAGMG_MUMPS_280(                                  &
     &    COMM_LOAD, ASS_IRECV,                                         &
     &    STATUS,                                                       &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM,                                          &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,            &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,                 &
     &    LPTRAR, NELT, FRTPTR, FRTELT ,                                &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE                               &
     &    )
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER STATUS( AGMG_MPF_STATUS_SIZE )
      INTEGER KEEP(500), ICNTL(40)
      INTEGER*8 KEEP8(150)
      INTEGER COMM_LOAD, ASS_IRECV
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER BUFR( LBUFR )
      INTEGER(8) :: POSFAC, LA, IPTRLU, LRLU, LRLUS
      INTEGER IWPOS, IWPOSCB
      INTEGER N, LIW
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER PTRIST( KEEP(28) ),                                       &
     &        PTLUST_S(KEEP(28))
      INTEGER STEP(N), PIMASTER(KEEP(28))
      INTEGER COMP
      INTEGER NSTK_S(KEEP(28)), PROCNODE_STEPS( KEEP(28) )
      INTEGER NBPROCFILS( KEEP(28) )
      INTEGER IFLAG, IERROR, COMM
      INTEGER LPOOL, LEAF
      INTEGER IPOOL( LPOOL )
      INTEGER MYID, SLAVEF, NBFIN
      DOUBLE PRECISION OPASSW, OPELIW
      INTEGER NELT, LPTRAR
      INTEGER FRTPTR( N+1 ), FRTELT( NELT )
      INTEGER ITLOC( N ), FILS( N )
      INTEGER PTRARW( LPTRAR ), PTRAIW( LPTRAR )
      INTEGER ND( KEEP(28) ), FRERE( KEEP(28) )
      INTEGER ISTEP_TO_INIV2(KEEP(71)),                                 &
     &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      INTEGER INTARR( max(1,KEEP(14)) )
      DOUBLE PRECISION DBLARR( max(1,KEEP(13)) )
      INTEGER MSGSOU, MSGTAG, MSGLEN, IERR
      INTEGER allocok, OLDSIZE
      MSGSOU = STATUS( AGMG_MPF_SOURCE )
      MSGTAG = STATUS( AGMG_MPF_TAG )
      CALL AGMG_NOCALL('MPI_GET_COUNT')
      IF ( MSGLEN .GT. LBUFR_BYTES ) THEN
        IFLAG  = -20
        IERROR = MSGLEN
         WRITE(*,*) ' RECEPTION BUF TOO SMALL, Msgtag/len=',            &
     &                MSGTAG,MSGLEN
        CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
        RETURN
       ENDIF
       CALL AGMG_NOCALL('MPI_RECV')
       CALL DAGMG_MUMPS_322(                                                 &
     &      COMM_LOAD, ASS_IRECV,                                       &
     &      MSGSOU, MSGTAG, MSGLEN, BUFR, LBUFR,                        &
     &      LBUFR_BYTES,                                                &
     &      PROCNODE_STEPS, POSFAC,                                     &
     &      IWPOS, IWPOSCB, IPTRLU,                                     &
     &      LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                     &
     &      PTLUST_S, PTRFAC,                                           &
     &      PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP, IFLAG,      &
     &      IERROR, COMM,                                               &
     &      NBPROCFILS,                                                 &
     &      IPOOL, LPOOL, LEAF, NBFIN, MYID, SLAVEF,                    &
     &      root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,          &
     &      INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,               &
     &      LPTRAR, NELT, FRTPTR, FRTELT,                               &
     &      ISTEP_TO_INIV2, TAB_POS_IN_PERE                             &
     &      )
      RETURN
      END SUBROUTINE DAGMG_MUMPS_280
      RECURSIVE SUBROUTINE DAGMG_MUMPS_329(                                  &
     &    COMM_LOAD, ASS_IRECV, BLOCKING, SET_IRECV,                    &
     &    MESSAGE_RECEIVED, MSGSOU, MSGTAG,                             &
     &    STATUS,                                                       &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM,                                          &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    root, OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,            &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,                 &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE,                              &
     &    STACK_RIGHT_AUTHORIZED                                        &
     &    )
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER STATUS( AGMG_MPF_STATUS_SIZE )
      LOGICAL, INTENT (IN)  :: BLOCKING
      LOGICAL, INTENT (IN)  :: SET_IRECV
      LOGICAL, INTENT (INOUT) :: MESSAGE_RECEIVED
      INTEGER, INTENT (IN) :: MSGSOU, MSGTAG
      INTEGER KEEP(500), ICNTL(40)
      INTEGER*8 KEEP8(150)
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER COMM_LOAD, ASS_IRECV
      INTEGER BUFR( LBUFR )
      INTEGER(8) :: LA, POSFAC, IPTRLU, LRLU, LRLUS
      INTEGER IWPOS, IWPOSCB
      INTEGER N, LIW
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER PTRIST( KEEP(28) ),                                       &
     &        PTLUST_S(KEEP(28))
      INTEGER STEP(N),                                                  &
     & PIMASTER(KEEP(28))
      INTEGER COMP
      INTEGER NSTK_S(KEEP(28)), PROCNODE_STEPS( KEEP(28) )
      INTEGER NBPROCFILS( KEEP(28) )
      INTEGER IFLAG, IERROR, COMM
      INTEGER LPOOL, LEAF
      INTEGER IPOOL( LPOOL )
      INTEGER MYID, SLAVEF, NBFIN
      DOUBLE PRECISION OPASSW, OPELIW
      INTEGER NELT, LPTRAR
      INTEGER FRTPTR( N+1 ), FRTELT( NELT )
      INTEGER ITLOC( N ), FILS( N )
      INTEGER PTRARW( LPTRAR ), PTRAIW( LPTRAR )
      INTEGER ND( KEEP(28) ), FRERE( KEEP(28) )
      INTEGER ISTEP_TO_INIV2(KEEP(71)),                                 &
     &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      INTEGER INTARR( max(1,KEEP(14)) )
      DOUBLE PRECISION DBLARR( max(1,KEEP(13)) )
      LOGICAL, intent(in) :: STACK_RIGHT_AUTHORIZED
       LOGICAL FLAG, RIGHT_MESS, FLAGbis
       INTEGER LP, MSGSOU_LOC, MSGTAG_LOC, MSGLEN_LOC
       INTEGER IERR
       INTEGER STATUS_BIS( AGMG_MPF_STATUS_SIZE )
       INTEGER, SAVE :: RECURS = 0
      CALL DAGMG_MUMPS_467(COMM_LOAD, KEEP)
      IF ( .NOT. STACK_RIGHT_AUTHORIZED ) THEN
          RETURN
      ENDIF
      RECURS = RECURS + 1
      LP = ICNTL(1)
      IF (ICNTL(4).LT.1) LP=-1
      IF ( MESSAGE_RECEIVED ) THEN
        MSGSOU_LOC = AGMG_MPF_ANY_SOURCE
        MSGTAG_LOC = AGMG_MPF_ANY_TAG
        GOTO 250
      ENDIF
      IF ( ASS_IRECV .NE. AGMG_MPF_REQUEST_NULL) THEN
      RIGHT_MESS = .TRUE.
       IF (BLOCKING) THEN
         CALL AGMG_NOCALL('MPI_WAIT')
         FLAG = .TRUE.
         IF ( ( (MSGSOU.NE.AGMG_MPF_ANY_SOURCE) .OR.                         &
     &      (MSGTAG.NE.AGMG_MPF_ANY_TAG) )  ) THEN
           IF ( MSGSOU.NE.AGMG_MPF_ANY_SOURCE) THEN
             RIGHT_MESS = MSGSOU.EQ.STATUS(AGMG_MPF_SOURCE)
           ENDIF
           IF ( MSGTAG.NE.AGMG_MPF_ANY_TAG) THEN
             RIGHT_MESS =                                               &
     &       ( (MSGTAG.EQ.STATUS(AGMG_MPF_TAG)).AND.RIGHT_MESS )
           ENDIF
           IF (.NOT.RIGHT_MESS) THEN
             CALL AGMG_NOCALL('MPI_PROBE')
           ENDIF
         ENDIF
       ELSE
        CALL AGMG_MPF_TEST(ASS_IRECV,                                        &
     &             FLAG, STATUS, IERR)
       ENDIF
       IF (IERR.LT.0) THEN
        IFLAG = -20
        IF (LP.GT.0)                                                    &
     &  write(LP,*) ' Error return from MPI_TEST ',                     &
     &     IFLAG, ' in DMUMPS_329'
        CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
        RETURN
       ENDIF
       IF ( FLAG ) THEN
         MESSAGE_RECEIVED = .TRUE.
         MSGSOU_LOC = STATUS( AGMG_MPF_SOURCE )
         MSGTAG_LOC = STATUS( AGMG_MPF_TAG )
         CALL AGMG_NOCALL('MPI_GET_COUNT')
           IF (.NOT.RIGHT_MESS) RECURS = RECURS + 10
         CALL DAGMG_MUMPS_322( COMM_LOAD, ASS_IRECV,                         &
     &      MSGSOU_LOC, MSGTAG_LOC, MSGLEN_LOC, BUFR, LBUFR,            &
     &      LBUFR_BYTES,                                                &
     &      PROCNODE_STEPS, POSFAC,                                     &
     &      IWPOS, IWPOSCB, IPTRLU,                                     &
     &      LRLU, LRLUS, N, IW, LIW, A, LA,                             &
     &      PTRIST, PTLUST_S, PTRFAC,                                   &
     &      PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP, IFLAG,      &
     &      IERROR, COMM,                                               &
     &      NBPROCFILS,                                                 &
     &      IPOOL, LPOOL, LEAF, NBFIN, MYID, SLAVEF,                    &
     &      root, OPASSW, OPELIW, ITLOC, FILS,                          &
     &      PTRARW, PTRAIW,                                             &
     &      INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,               &
     &      LPTRAR, NELT, FRTPTR, FRTELT,                               &
     &      ISTEP_TO_INIV2, TAB_POS_IN_PERE  )
           IF (.NOT.RIGHT_MESS) RECURS = RECURS - 10
          IF ( IFLAG .LT. 0 ) RETURN
           IF (.NOT.RIGHT_MESS) THEN
              IF (ASS_IRECV .NE. AGMG_MPF_REQUEST_NULL) THEN
                CALL AGMG_MUMPS_ABORT()
              ENDIF
             CALL AGMG_MPF_IPROBE(MSGSOU,MSGTAG,                             &
     &           COMM, FLAGbis, STATUS, IERR)
             IF (FLAGbis) THEN
               MSGSOU_LOC = STATUS( AGMG_MPF_SOURCE )
               MSGTAG_LOC = STATUS( AGMG_MPF_TAG )
               CALL DAGMG_MUMPS_280( COMM_LOAD, ASS_IRECV,                   &
     &            STATUS, BUFR, LBUFR,                                  &
     &            LBUFR_BYTES,                                          &
     &            PROCNODE_STEPS, POSFAC,                               &
     &            IWPOS, IWPOSCB, IPTRLU,                               &
     &            LRLU, LRLUS, N, IW, LIW, A, LA,                       &
     &            PTRIST, PTLUST_S, PTRFAC,                             &
     &            PTRAST, STEP, PIMASTER, PAMASTER,                     &
     &            NSTK_S, COMP, IFLAG,                                  &
     &            IERROR, COMM,                                         &
     &            NBPROCFILS,                                           &
     &            IPOOL, LPOOL, LEAF,                                   &
     &            NBFIN, MYID, SLAVEF,                                  &
     &            root, OPASSW, OPELIW, ITLOC,                          &
     &            FILS, PTRARW, PTRAIW,                                 &
     &            INTARR, DBLARR, ICNTL,                                &
     &            KEEP,KEEP8, ND, FRERE,                                &
     &            LPTRAR, NELT, FRTPTR, FRTELT,                         &
     &            ISTEP_TO_INIV2, TAB_POS_IN_PERE  )
                  IF ( IFLAG .LT. 0 ) RETURN
             ENDIF
           ENDIF
       ENDIF
      ELSE
         IF (BLOCKING) THEN
           CALL AGMG_NOCALL('MPI_PROBE')
           FLAG = .TRUE.
         ELSE
           CALL AGMG_MPF_IPROBE(AGMG_MPF_ANY_SOURCE,AGMG_MPF_ANY_TAG,                  &
     &           COMM, FLAG, STATUS, IERR)
         ENDIF
         IF (FLAG) THEN
          MSGSOU_LOC = STATUS( AGMG_MPF_SOURCE )
          MSGTAG_LOC = STATUS( AGMG_MPF_TAG )
          MESSAGE_RECEIVED = .TRUE.
          CALL DAGMG_MUMPS_280( COMM_LOAD, ASS_IRECV,                        &
     &      STATUS, BUFR, LBUFR,                                        &
     &      LBUFR_BYTES,                                                &
     &      PROCNODE_STEPS, POSFAC,                                     &
     &      IWPOS, IWPOSCB, IPTRLU,                                     &
     &      LRLU, LRLUS, N, IW, LIW, A, LA,                             &
     &      PTRIST, PTLUST_S, PTRFAC,                                   &
     &      PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP, IFLAG,      &
     &      IERROR, COMM,                                               &
     &      NBPROCFILS,                                                 &
     &      IPOOL, LPOOL, LEAF, NBFIN, MYID, SLAVEF,                    &
     &      root, OPASSW, OPELIW, ITLOC,                                &
     &      FILS, PTRARW, PTRAIW,                                       &
     &      INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,               &
     &      LPTRAR, NELT, FRTPTR, FRTELT,                               &
     &      ISTEP_TO_INIV2, TAB_POS_IN_PERE  )
          IF ( IFLAG .LT. 0 ) RETURN
         ENDIF
      ENDIF
  250 CONTINUE
      RECURS  = RECURS - 1
      IF ( NBFIN .EQ. 0 ) RETURN
      IF ( RECURS .GT. 3 ) RETURN
      IF ( KEEP(36).EQ.1 .AND. SET_IRECV  .AND.                         &
     &      (ASS_IRECV.EQ.AGMG_MPF_REQUEST_NULL) .AND.                       &
     &    MESSAGE_RECEIVED ) THEN
       CALL AGMG_SETIERR( IERR )
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_329
      SUBROUTINE DAGMG_MUMPS_255( INFO1,                                     &
     &    ASS_IRECV,                                                    &
     &    BUFR, LBUFR, LBUFR_BYTES,                                     &
     &    COMM,                                                         &
     &    MYID, SLAVEF)
      USE DAGMG_MUMPS_COMM_BUFF
      IMPLICIT NONE
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER ASS_IRECV
      INTEGER BUFR( LBUFR )
      INTEGER COMM
      INTEGER MYID, SLAVEF, INFO1, DEST
      INTEGER STATUS( AGMG_MPF_STATUS_SIZE )
      LOGICAL NO_ACTIVE_IRECV
      INTEGER LP, MSGSOU_LOC, MSGTAG_LOC
      INTEGER IERR, DUMMY
      INTRINSIC mod
      IF (SLAVEF .EQ. 1) RETURN
      IF (ASS_IRECV.EQ.AGMG_MPF_REQUEST_NULL) THEN
        NO_ACTIVE_IRECV=.TRUE.
      ELSE
        CALL AGMG_MPF_TEST(ASS_IRECV, NO_ACTIVE_IRECV,                       &
     &                STATUS, IERR)
      ENDIF
      CALL AGMG_SETIERR(IERR)
      DUMMY = 1
      DEST = mod(MYID+1, SLAVEF)
      CALL DAGMG_MUMPS_62                                                    &
     &    (DUMMY, DEST, TAG_DUMMY, COMM, IERR)
      IF (NO_ACTIVE_IRECV) THEN
        CALL AGMG_NOCALL('MPI_RECV')
      ELSE
        CALL AGMG_NOCALL('MPI_WAIT')
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_255
      SUBROUTINE DAGMG_MUMPS_180(                                            &
     &    INFO1, BUFR, LBUFR, LBUFR_BYTES,                              &
     &    COMM_NODES, COMM_LOAD, SLAVEF, MP )
      USE DAGMG_MUMPS_COMM_BUFF
      IMPLICIT NONE
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER BUFR( LBUFR )
      INTEGER COMM_NODES, COMM_LOAD, SLAVEF, INFO1, MP
      INTEGER STATUS( AGMG_MPF_STATUS_SIZE )
      LOGICAL FLAG, BUFFERS_EMPTY, BUFFERS_EMPTY_ON_ALL_PROCS
      INTEGER MSGSOU_LOC, MSGTAG_LOC, COMM_EFF
      INTEGER IERR, DUMMY
      INTEGER IBUF_EMPTY, IBUF_EMPTY_ON_ALL_PROCS
      IF (SLAVEF.EQ.1) RETURN
      BUFFERS_EMPTY_ON_ALL_PROCS = .FALSE.
   10 CONTINUE
      FLAG = .TRUE.
      DO WHILE ( FLAG )
        COMM_EFF = COMM_NODES
        CALL AGMG_MPF_IPROBE(AGMG_MPF_ANY_SOURCE,AGMG_MPF_ANY_TAG,                     &
     &       COMM_NODES, FLAG, STATUS, IERR)
        IF ( .NOT. FLAG ) THEN
          COMM_EFF = COMM_LOAD
          CALL AGMG_MPF_IPROBE( AGMG_MPF_ANY_SOURCE, AGMG_MPF_ANY_TAG,                 &
     &         COMM_LOAD, FLAG, STATUS, IERR)
        END IF
        IF (FLAG) THEN
            MSGSOU_LOC = STATUS( AGMG_MPF_SOURCE )
            MSGTAG_LOC = STATUS( AGMG_MPF_TAG )
               CALL AGMG_NOCALL('MPI_RECV')
           ENDIF
         END DO
        IF (BUFFERS_EMPTY_ON_ALL_PROCS) THEN
        RETURN
        ENDIF
        CALL DAGMG_MUMPS_469(BUFFERS_EMPTY)
        IF ( BUFFERS_EMPTY ) THEN
          IBUF_EMPTY = 0
        ELSE
          IBUF_EMPTY = 1
        ENDIF
        CALL AGMG_COPY(IBUF_EMPTY,                           IBUF_EMPTY_ON_ALL_PROCS,              1, AGMG_MPF_INTEGER, IERR)
        IF ( IBUF_EMPTY_ON_ALL_PROCS == 0) THEN
          BUFFERS_EMPTY_ON_ALL_PROCS = .TRUE.
        ELSE
          BUFFERS_EMPTY_ON_ALL_PROCS = .FALSE.
        ENDIF
        GOTO 10
      END SUBROUTINE DAGMG_MUMPS_180
      INTEGER FUNCTION DAGMG_MUMPS_748                                       &
     &     ( HBUF_SIZE, NNMAX, K227, K50 )
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NNMAX, K227, K50
      INTEGER(8), INTENT(IN) :: HBUF_SIZE
      INTEGER K227_LOC
      INTEGER NBCOL_MAX
      INTEGER EFFECTIVE_SIZE
      NBCOL_MAX=int(HBUF_SIZE / int(NNMAX,8))
      K227_LOC = abs(K227)
      IF (K50.EQ.2) THEN
         K227_LOC=max(K227_LOC,2)
         EFFECTIVE_SIZE =  min(NBCOL_MAX-1, K227_LOC-1)
      ELSE
         EFFECTIVE_SIZE =  min(NBCOL_MAX, K227_LOC)
      ENDIF
      IF (EFFECTIVE_SIZE.LE.0) THEN
         write(6,*) 'Internal buffers too small to store ',             &
     &        ' ONE col/row of size', NNMAX
         CALL AGMG_MUMPS_ABORT()
      ENDIF
      DAGMG_MUMPS_748 = EFFECTIVE_SIZE
      RETURN
      END FUNCTION DAGMG_MUMPS_748
      SUBROUTINE DAGMG_MUMPS_698( IPIV, LPIV, ISHIFT,                        &
     &     THE_PANEL, NBROW, NBCOL, KbeforePanel )
      IMPLICIT NONE
      INTEGER LPIV, ISHIFT, NBROW, NBCOL, KbeforePanel
      INTEGER IPIV(LPIV)
      DOUBLE PRECISION THE_PANEL(NBROW, NBCOL)
      INTEGER I, IPERM
      DO I = 1, LPIV
         IPERM=IPIV(I)
         IF ( I+ISHIFT.NE.IPERM) THEN
            CALL DSWAP(NBCOL,                                           &
     &           THE_PANEL(I+ISHIFT-KbeforePanel,1), NBROW,             &
     &           THE_PANEL(IPERM-KbeforePanel,1), NBROW)
         ENDIF
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_698
      SUBROUTINE DAGMG_MUMPS_667(TYPEF,                                      &
     &     NBPANELS,                                                    &
     &     I_PIVPTR, I_PIV, IPOS, IW, LIW)
      IMPLICIT NONE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      INTEGER, intent(out) :: NBPANELS, I_PIVPTR, I_PIV
      INTEGER, intent(in) :: TYPEF
      INTEGER, intent(in) :: LIW, IPOS
      INTEGER IW(LIW)
      INTEGER I_NBPANELS, I_NASS
      I_NASS       = IPOS
      I_NBPANELS   = I_NASS + 1
      NBPANELS     = IW(I_NBPANELS)
      I_PIVPTR     = I_NBPANELS + 1
      I_PIV        = I_PIVPTR + NBPANELS
      IF (TYPEF==2) THEN
         I_NBPANELS   = I_PIV+IW(I_NASS)
         NBPANELS     = IW(I_NBPANELS)
         I_PIVPTR     = I_NBPANELS + 1
         I_PIV        = I_PIVPTR + NBPANELS
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_667
      SUBROUTINE DAGMG_MUMPS_691(K50,NBPANELS_L,NBPANELS_U,                  &
     &     NASS, IPOS, IW, LIW )
      IMPLICIT NONE
      INTEGER K50
      INTEGER IPOS, NASS, NBPANELS_L, NBPANELS_U, LIW
      INTEGER IW(LIW)
      INTEGER IPOS_U
      IF (K50.EQ.1) THEN
         WRITE(*,*) "Internal error: DAGMG_MUMPS_691 called"
      ENDIF
      IW(IPOS)=NASS
      IW(IPOS+1)=NBPANELS_L
      IW(IPOS+2:IPOS+1+NBPANELS_L)=NASS+1
      IF (K50 == 0) THEN
         IPOS_U=IPOS+2+NASS+NBPANELS_L
         IW(IPOS_U)=NBPANELS_U
         IW(IPOS_U+1:IPOS_U+NBPANELS_U)=NASS+1
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_691
      SUBROUTINE DAGMG_MUMPS_644(                                            &
     &     IWPOS, IOLDPS, IW, LIW, MonBloc, NFRONT, KEEP                &
     &     )
      USE DAGMG_MUMPS_OOC_MAIN
      IMPLICIT NONE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      INTEGER, INTENT(IN)    :: IOLDPS, LIW, NFRONT,                    &
     &     KEEP(500)
      INTEGER, INTENT(INOUT) :: IWPOS, IW(LIW)
      TYPE(IO_BLOCK), INTENT(IN):: MonBloc
      INTEGER :: LREQ_OOC
      INTEGER :: NBPANELS_L,I_PIVRPTR_L, I_PIVR_L, NBPANELS_U,          &
     &     I_PIVRPTR_U, I_PIVR_U, XSIZE, IBEGOOC
      LOGICAL FREESPACE
      IF (KEEP(50).EQ.1) RETURN
      IF ((IOLDPS+IW(IOLDPS+XXI)).NE.IWPOS) RETURN
      XSIZE   = KEEP(IXSZ)
      IBEGOOC = IOLDPS+2*NFRONT+6+IW(IOLDPS+5+XSIZE)+XSIZE
      CALL DAGMG_MUMPS_667(TYPEF_L, NBPANELS_L,                              &
     &     I_PIVRPTR_L, I_PIVR_L,                                       &
     &     IBEGOOC, IW, LIW)
      FREESPACE =                                                       &
     &     (MonBloc%LastPiv.EQ.(IW(I_PIVRPTR_L)-1))
      IF (KEEP(50).EQ.0) THEN
         CALL DAGMG_MUMPS_667(TYPEF_U, NBPANELS_U,                           &
     &        I_PIVRPTR_U, I_PIVR_U,                                    &
     &        IBEGOOC, IW, LIW)
         FREESPACE =  FREESPACE .AND.                                   &
     &        (MonBloc%LastPiv.EQ.(IW(I_PIVRPTR_U)-1))
      ENDIF
      IF (FREESPACE) THEN
         IW(IBEGOOC) = -7777
         IW(IOLDPS+XXI) = IBEGOOC - IOLDPS + 1
         IWPOS = IBEGOOC+1
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_644
      SUBROUTINE DAGMG_MUMPS_684(K50, NBROW_L, NBCOL_U, NASS,                &
     &     NBPANELS_L, NBPANELS_U, LREQ)
      USE DAGMG_MUMPS_OOC_MAIN
      IMPLICIT NONE
      INTEGER, intent(IN)  :: K50, NBROW_L, NBCOL_U, NASS
      INTEGER, intent(OUT) :: NBPANELS_L, NBPANELS_U, LREQ
      NBPANELS_L=-99999
      NBPANELS_U=-99999
      IF (K50.EQ.1) THEN
         LREQ = 0
         RETURN
      ENDIF
      NBPANELS_L = (NASS / DAGMG_MUMPS_690(NBROW_L))+1
      LREQ =    1                                                       &
     &     + 1                                                          &
     &     + NASS                                                       &
     &     + NBPANELS_L
      IF (K50.eq.0) THEN
         NBPANELS_U = (NASS / DAGMG_MUMPS_690(NBCOL_U) ) +1
         LREQ = LREQ + 1                                                &
     &        + NASS                                                    &
     &        + NBPANELS_U
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_684
      SUBROUTINE DAGMG_MUMPS_755                                             &
     &           (IW_LOCATION, MUST_BE_PERMUTED)
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: IW_LOCATION
      LOGICAL, INTENT(INOUT) :: MUST_BE_PERMUTED
      IF (IW_LOCATION .EQ. -7777) THEN
        MUST_BE_PERMUTED = .FALSE.
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_755
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      SUBROUTINE DAGMG_MUMPS_152(SSARBR, MYID, N, IPOSBLOCK,                 &
     &       RPOSBLOCK,                                                 &
     &       IW, LIW,                                                   &
     &       LRLU, LRLUS, IPTRLU,                                       &
     &       IWPOSCB, LA, KEEP, KEEP8, IN_PLACE_STATS                   &
     &     )
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
      INTEGER(8) :: RPOSBLOCK
      INTEGER IPOSBLOCK,                                                &
     &         LIW, IWPOSCB, N
      INTEGER(8) :: LA, LRLU, LRLUS, IPTRLU
      LOGICAL IN_PLACE_STATS
      INTEGER IW( LIW ), KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER MYID
      LOGICAL SSARBR
      INTEGER SIZFI_BLOCK, SIZFI
      INTEGER IPOSSHIFT
      INTEGER(8) :: SIZFR, SIZFR_BLOCK, SIZFR_BLOCK_EFF,                &
     &              SIZEHOLE, MEM_INC
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      IPOSSHIFT = IPOSBLOCK + KEEP(IXSZ)
      SIZFI_BLOCK=IW(IPOSBLOCK+XXI)
      CALL AGMG_MUMPS_729( SIZFR_BLOCK,IW(IPOSBLOCK+XXR) )
      IF (KEEP(216).eq.3) THEN
        SIZFR_BLOCK_EFF=SIZFR_BLOCK
      ELSE
        CALL DAGMG_MUMPS_628( IW(IPOSBLOCK),                                 &
     &                     LIW-IPOSBLOCK+1,                             &
     &                     SIZEHOLE, KEEP(IXSZ))
        SIZFR_BLOCK_EFF=SIZFR_BLOCK-SIZEHOLE
      ENDIF
      IF ( IPOSBLOCK .eq. IWPOSCB + 1 ) THEN
         IPTRLU  = IPTRLU  + SIZFR_BLOCK
         IWPOSCB = IWPOSCB + SIZFI_BLOCK
         LRLU    = LRLU  + SIZFR_BLOCK
         IF (.NOT. IN_PLACE_STATS) THEN
           LRLUS   = LRLUS + SIZFR_BLOCK_EFF
         ENDIF
      MEM_INC = -SIZFR_BLOCK_EFF
      IF (IN_PLACE_STATS) THEN
        MEM_INC= 0_8
      ENDIF
      CALL DAGMG_MUMPS_471(SSARBR,.FALSE.,                                   &
     &         LA-LRLUS,0_8,MEM_INC,KEEP,KEEP8,LRLU)
   90    IF ( IWPOSCB .eq. LIW ) GO TO 100
         IPOSSHIFT = IWPOSCB + KEEP(IXSZ)
         SIZFI = IW( IWPOSCB+1+XXI )
         CALL AGMG_MUMPS_729( SIZFR,IW(IWPOSCB+1+XXR) )
         IF ( IW( IWPOSCB+1+XXS ) .EQ. S_FREE ) THEN
              IPTRLU  = IPTRLU + SIZFR
              LRLU    = LRLU + SIZFR
              IWPOSCB = IWPOSCB + SIZFI
              GO TO 90
         ENDIF
  100    CONTINUE
         IW( IWPOSCB+1+XXP)=TOP_OF_STACK
      ELSE
         IW( IPOSBLOCK +XXS)=S_FREE
         IF (.NOT. IN_PLACE_STATS) LRLUS = LRLUS + SIZFR_BLOCK_EFF
      CALL DAGMG_MUMPS_471(SSARBR,.FALSE.,                                   &
     &            LA-LRLUS,0_8,-SIZFR_BLOCK_EFF,KEEP,KEEP8,LRLU)
      END IF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_152
      SUBROUTINE DAGMG_MUMPS_144( COMM_LOAD, ASS_IRECV,                      &
     &           N, INODE, FPERE, IW, LIW, A, LA,                       &
     &           UU, NOFFW,                                             &
     &           NPVW,                                                  &
     &             COMM, MYID, BUFR, LBUFR,LBUFR_BYTES,NBFIN,LEAF,      &
     &             IFLAG, IERROR, IPOOL,LPOOL,                          &
     &             SLAVEF, POSFAC, IWPOS, IWPOSCB, IPTRLU, LRLU,        &
     &             LRLUS, COMP,                                         &
     &             PTRIST, PTRAST, PTLUST_S, PTRFAC, STEP, PIMASTER,    &
     &             PAMASTER,                                            &
     &             NSTK_S,NBPROCFILS,PROCNODE_STEPS, root,              &
     &             OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,         &
     &             INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,        &
     &             LPTRAR, NELT, FRTPTR, FRTELT, SEUIL,                 &
     &             ISTEP_TO_INIV2, TAB_POS_IN_PERE, AVOID_DELAYED,      &
     &              DKEEP,PIVNUL_LIST,LPN_LIST)
      USE DAGMG_MUMPS_OOC_MAIN
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
      INTEGER COMM_LOAD, ASS_IRECV
      INTEGER N, INODE, FPERE, LIW, NOFFW, NPVW
      INTEGER(8) :: LA
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      DOUBLE PRECISION UU, SEUIL
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER COMM, MYID, LBUFR, LBUFR_BYTES
      INTEGER LPTRAR, NELT
      INTEGER ICNTL(40), KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER NBFIN, SLAVEF,                                            &
     &        IFLAG, IERROR, LEAF, LPOOL
      INTEGER(8) :: POSFAC, IPTRLU, LRLU, LRLUS
      INTEGER IWPOS, IWPOSCB, COMP
      INTEGER FRTPTR( N + 1 ), FRTELT( NELT )
      INTEGER BUFR( LBUFR ), IPOOL(LPOOL),                              &
     &        ITLOC(N), FILS(N),                                        &
     &        PTRARW(LPTRAR), PTRAIW(LPTRAR),                           &
     &        ND( KEEP(28) ), FRERE( KEEP(28) )
      INTEGER  INTARR(max(1,KEEP(14)))
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER PTRIST(KEEP(28)), PTLUST_S(KEEP(28)),                     &
     &        STEP(N), PIMASTER(KEEP(28)),                              &
     &        NSTK_S(KEEP(28)), NBPROCFILS(KEEP(28)),                   &
     &        PROCNODE_STEPS(KEEP(28))
      INTEGER ISTEP_TO_INIV2(KEEP(71)),                                 &
     &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      DOUBLE PRECISION OPASSW, OPELIW
      DOUBLE PRECISION DBLARR(max(1,KEEP(13)))
      LOGICAL AVOID_DELAYED
      INTEGER LPN_LIST
      INTEGER PIVNUL_LIST(LPN_LIST)
      DOUBLE PRECISION DKEEP(30)
      INTEGER INOPV, IFINB, NFRONT, NPIV, IBEGKJI, NBOLKJ,              &
     &        NBTLKJ, IBEG_BLOCK
      INTEGER(8) :: POSELT
      INTEGER NASS, NEL1, IEND, IOLDPS, dummy, allocok
      LOGICAL LASTBL
      DOUBLE PRECISION UUTEMP
      INTEGER , ALLOCATABLE, DIMENSION ( : ) :: IPIV
      INTEGER(8) :: LAFAC
      INTEGER LIWFAC, STRAT, TYPEFile, LNextPiv2beWritten,              &
     &        UNextPiv2beWritten, IFLAG_OOC,                            &
     &        PP_FIRST2SWAP_L, PP_FIRST2SWAP_U,                         &
     &        PP_LastPIVRPTRFilled_L, PP_LastPIVRPTRFilled_U
      TYPE(IO_BLOCK) :: MonBloc
      LOGICAL LAST_CALL
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      EXTERNAL DAGMG_MUMPS_224, DAGMG_MUMPS_233,                                  &
     &         DAGMG_MUMPS_225, DAGMG_MUMPS_232,                                  &
     &         DAGMG_MUMPS_294,                                              &
     &         DAGMG_MUMPS_44
      LOGICAL STATICMODE
      DOUBLE PRECISION SEUIL_LOC
      INOPV = 0
      SEUIL_LOC = SEUIL
      IF(KEEP(97) .EQ. 0) THEN
         STATICMODE = .FALSE.
      ELSE
         STATICMODE = .TRUE.
      ENDIF
      IF (AVOID_DELAYED) THEN
         STATICMODE = .TRUE.
         UUTEMP=UU
         SEUIL_LOC = max(SEUIL,epsilon(SEUIL))
      ELSE
         UUTEMP=UU
      ENDIF
      IBEG_BLOCK=1
      dummy  = 0
      IOLDPS = PTLUST_S(STEP( INODE ))
      POSELT = PTRAST(STEP( INODE ))
      NFRONT = IW(IOLDPS+KEEP(IXSZ))
      NASS   = iabs(IW(IOLDPS+2+KEEP(IXSZ)))
      IF (NASS .GT. KEEP(3)) THEN
        NBOLKJ = min( KEEP(6), NASS )
      ELSE
        NBOLKJ = min( KEEP(5),NASS )
      ENDIF
      NBTLKJ = NBOLKJ
      ALLOCATE( IPIV( NASS ), stat = allocok )
      IF ( allocok .GT. 0 ) THEN
        WRITE(*,*) MYID,' : FACTO_NIV2 :failed to allocate ',NASS,      &
     & ' integers'
        IFLAG  = -13
        IERROR =NASS
        GO TO 490
      END IF
      IF (KEEP(201).EQ.1) THEN
          CALL AGMG_MUMPS_729(LAFAC,IW(IOLDPS+XXR))
          LIWFAC    = IW(IOLDPS+XXI)
          TYPEFile  = TYPEF_U
          LNextPiv2beWritten = 1
          UNextPiv2beWritten = 1
          PP_FIRST2SWAP_L = LNextPiv2beWritten
          PP_FIRST2SWAP_U = UNextPiv2beWritten
          MonBloc%LastPanelWritten_L = 0
          MonBloc%LastPanelWritten_U = 0
          MonBloc%INODE    = INODE
          MonBloc%MASTER   = .TRUE.
          MonBloc%Typenode = 2
          MonBloc%NROW     = NASS
          MonBloc%NCOL     = NFRONT
          MonBloc%NFS      = NASS
          MonBloc%Last     = .FALSE.
          MonBloc%LastPiv  = -68877
          NULLIFY(MonBloc%INDICES)
      ENDIF
   50 CONTINUE
      IBEGKJI = IBEG_BLOCK
      CALL DAGMG_MUMPS_224(NFRONT,NASS,IBEGKJI, NASS, IPIV,                  &
     &                N,INODE,IW,LIW,A,LA,INOPV,NOFFW,                  &
     &                IFLAG,IOLDPS,POSELT,UU,SEUIL_LOC,KEEP,KEEP8,      &
     &                 DKEEP(1),PIVNUL_LIST(1),LPN_LIST,                &
     &     PP_FIRST2SWAP_L,  MonBloc%LastPanelWritten_L,                &
     &     PP_LastPIVRPTRFilled_L,                                      &
     &     PP_FIRST2SWAP_U,  MonBloc%LastPanelWritten_U,                &
     &     PP_LastPIVRPTRFilled_U)
      IF (IFLAG.LT.0) GOTO 490
      IF (INOPV.EQ.1) THEN
         IF(STATICMODE) THEN
            INOPV = -1
            GOTO 50
         ENDIF
      ENDIF
      IF (INOPV.GE.1) THEN
          LASTBL = (INOPV.EQ.1)
          IEND = IW(IOLDPS+1+KEEP(IXSZ))
          CALL DAGMG_MUMPS_294( COMM_LOAD, ASS_IRECV,                        &
     &             N, INODE, FPERE, IW, LIW,                            &
     &             IOLDPS, POSELT, A, LA, NFRONT,                       &
     &             IBEGKJI, IEND, IPIV, NASS,LASTBL, dummy,             &
     &             COMM, MYID, BUFR, LBUFR, LBUFR_BYTES,NBFIN,LEAF,     &
     &             IFLAG, IERROR, IPOOL,LPOOL,                          &
     &             SLAVEF, POSFAC, IWPOS, IWPOSCB, IPTRLU, LRLU,        &
     &             LRLUS, COMP,                                         &
     &             PTRIST, PTRAST, PTLUST_S, PTRFAC, STEP,              &
     &             PIMASTER, PAMASTER,                                  &
     &             NSTK_S,NBPROCFILS,PROCNODE_STEPS, root,              &
     &             OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,         &
     &             INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,        &
     &             LPTRAR, NELT, FRTPTR, FRTELT,                        &
     &             ISTEP_TO_INIV2, TAB_POS_IN_PERE )
          IF ( IFLAG .LT. 0 ) GOTO 500
      ENDIF
      IF (INOPV.EQ.1) GO TO 500
      IF (INOPV.EQ.2) THEN
         CALL DAGMG_MUMPS_233(IBEG_BLOCK,NFRONT,NASS,N,INODE,IW,LIW,A,LA,    &
     &            IOLDPS,POSELT,NBOLKJ,NBTLKJ,KEEP(4),KEEP(IXSZ))
         GOTO 50
      ENDIF
      NPVW = NPVW + 1
      IF (NASS.LE.1) THEN
        IFINB = -1
      ELSE
         CALL DAGMG_MUMPS_225(IBEG_BLOCK,                                    &
     &             NFRONT, NASS, N,INODE,IW,LIW,A,LA,                   &
     &             IOLDPS,POSELT,IFINB,                                 &
     &             NBTLKJ,KEEP(4),KEEP(IXSZ))
      ENDIF
      IW(IOLDPS+1+KEEP(IXSZ)) = IW(IOLDPS+1+KEEP(IXSZ)) + 1
       IF (IFINB.EQ.0) GOTO 50
       IF ((IFINB.EQ.1).OR.(IFINB.EQ.-1)) THEN
          LASTBL = (IFINB.EQ.-1)
          IEND = IW(IOLDPS+1+KEEP(IXSZ))
          CALL DAGMG_MUMPS_294(COMM_LOAD, ASS_IRECV,                         &
     &             N, INODE, FPERE, IW, LIW,                            &
     &             IOLDPS, POSELT, A, LA, NFRONT,                       &
     &             IBEGKJI, IEND, IPIV, NASS, LASTBL, dummy,            &
     &             COMM, MYID, BUFR, LBUFR,LBUFR_BYTES,NBFIN,LEAF,      &
     &             IFLAG, IERROR, IPOOL,LPOOL,                          &
     &             SLAVEF, POSFAC, IWPOS, IWPOSCB, IPTRLU, LRLU,        &
     &             LRLUS, COMP,                                         &
     &             PTRIST, PTRAST, PTLUST_S, PTRFAC,                    &
     &             STEP, PIMASTER, PAMASTER,                            &
     &             NSTK_S,NBPROCFILS,PROCNODE_STEPS, root,              &
     &             OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,         &
     &             INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,        &
     &             LPTRAR, NELT, FRTPTR, FRTELT,                        &
     &             ISTEP_TO_INIV2, TAB_POS_IN_PERE )
          IF ( IFLAG .LT. 0 ) GOTO 500
       ENDIF
       IF (IFINB.EQ.(-1)) GOTO 500
       NPIV   = IW(IOLDPS+1+KEEP(IXSZ))
       NEL1   = NASS - NPIV
      CALL DAGMG_MUMPS_232(A,LA,                                             &
     &           NFRONT,NPIV,NASS,POSELT,NBTLKJ)
      IF (KEEP(201).EQ.1) THEN
          STRAT            = STRAT_TRY_WRITE
          MonBloc%LastPiv  = NPIV
          TYPEFile         = TYPEF_BOTH_LU
          LAST_CALL= .FALSE.
          CALL DAGMG_MUMPS_688                                               &
     &          ( STRAT, TYPEFile,                                      &
     &           A(POSELT), LAFAC, MonBloc,                             &
     &           LNextPiv2beWritten, UNextPiv2beWritten,                &
     &           IW(IOLDPS), LIWFAC,                                    &
     &           MYID, KEEP8(31), IFLAG_OOC,LAST_CALL )
          IF (IFLAG_OOC < 0 ) IFLAG=IFLAG_OOC
          IF (IFLAG<0) RETURN
      ENDIF
      GO TO 50
  490 CONTINUE
      CALL DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
  500 CONTINUE
      DEALLOCATE( IPIV )
      IF (KEEP(201).EQ.1) THEN
          STRAT        = STRAT_WRITE_MAX
          MonBloc%Last = .TRUE.
          MonBloc%LastPiv  = IW(IOLDPS+1+KEEP(IXSZ))
          TYPEFile     = TYPEF_BOTH_LU
          LAST_CALL = .TRUE.
          CALL DAGMG_MUMPS_688                                               &
     &          ( STRAT, TYPEFile,                                      &
     &           A(POSELT), LAFAC, MonBloc,                             &
     &           LNextPiv2beWritten, UNextPiv2beWritten,                &
     &           IW(IOLDPS), LIWFAC,                                    &
     &           MYID, KEEP8(31), IFLAG_OOC,LAST_CALL )
          IF (IFLAG_OOC < 0 ) IFLAG=IFLAG_OOC
          IF (IFLAG<0) RETURN
          CALL DAGMG_MUMPS_644(IWPOS,                                        &
     &      IOLDPS, IW, LIW, MonBloc , NFRONT, KEEP)
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_144
      SUBROUTINE DAGMG_MUMPS_176( COMM_LOAD, ASS_IRECV,                      &
     &    root, FRERE, IROOT,                                           &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM,                                          &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,                  &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND,                        &
     &    LPTRAR, NELT, FRTPTR, FRTELT,                                 &
     &    ISTEP_TO_INIV2, TAB_POS_IN_PERE  )
      USE DAGMG_MUMPS_COMM_BUFF
      IMPLICIT NONE
!
      TYPE DAGMG_MUMPS_ROOT_STRUC
        SEQUENCE
        INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
        INTEGER MYROW, MYCOL
        INTEGER ROOT_SIZE, TOT_ROOT_SIZE
        INTEGER :: CNTXT_BLACS, truc
        INTEGER, DIMENSION(:), POINTER :: RG2L_ROW
        INTEGER, DIMENSION(:), POINTER :: RG2L_COL
        INTEGER , DIMENSION(:), POINTER :: IPIV
        INTEGER, DIMENSION( 9 ) :: DESCRIPTOR, DESCB
        LOGICAL yes, gridinit_done
        INTEGER LPIV, brol
!       Used to access Schur easily from root structure
        DOUBLE PRECISION, DIMENSION(:), POINTER :: SCHUR_POINTER
        INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD, machin
!
!      Data for nullspace/QR
!
        DOUBLE PRECISION, DIMENSION(:), POINTER :: QR_TAU
        DOUBLE PRECISION     QR_RCOND
!
!      Givens rotations
!
        INTEGER MAXG, GIND
        DOUBLE PRECISION, DIMENSION(:),POINTER::GROW, GCOS, GSIN
!
!      RRRLU data
!
        INTEGER ELG_MAX,NULL_MAX
        INTEGER ELIND,EUIND,NLUPDATE,NUUPDATE
        INTEGER,DIMENSION(:),POINTER::PERM_ROW,PERM_COL
        INTEGER,DIMENSION(:),POINTER::ELROW, EUROW, PTREL, PTREU
        DOUBLE PRECISION, DIMENSION(:), POINTER :: ELELG, EUELG, DL
!
      END TYPE DAGMG_MUMPS_ROOT_STRUC
      TYPE (DAGMG_MUMPS_ROOT_STRUC) :: root
      INTEGER IROOT
      INTEGER ICNTL( 40 ), KEEP( 500 )
      INTEGER*8 KEEP8(150)
      INTEGER COMM_LOAD, ASS_IRECV
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER BUFR( LBUFR )
      INTEGER(8) :: POSFAC,IPTRLU, LRLU, LRLUS
      INTEGER IWPOS, IWPOSCB
      INTEGER(8) :: LA
      INTEGER N, LIW
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER PTRIST(KEEP(28)), PTLUST_S(KEEP(28))
      INTEGER STEP(N), PIMASTER(KEEP(28))
      INTEGER COMP
      INTEGER NSTK_S( KEEP(28) ), PROCNODE_STEPS( KEEP(28) )
      INTEGER NBPROCFILS( KEEP(28) )
      INTEGER IFLAG, IERROR, COMM
      INTEGER LPTRAR, NELT
      INTEGER FRTPTR( N+1 ), FRTELT( NELT )
      INTEGER LPOOL, LEAF
      INTEGER IPOOL( LPOOL )
      INTEGER MYID, SLAVEF, NBFIN
      INTEGER ISTEP_TO_INIV2(KEEP(71)),                                 &
     &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      DOUBLE PRECISION OPASSW, OPELIW
      INTEGER ITLOC( N ), FILS( N )
      INTEGER PTRARW( LPTRAR ), PTRAIW( LPTRAR )
      INTEGER ND(KEEP(28)), FRERE(KEEP(28))
      INTEGER INTARR( max(1,KEEP(14)) )
      DOUBLE PRECISION DBLARR( max(1,KEEP(13)) )
      INTEGER NELIM, NB_CONTRI_GLOBAL, NUMORG,                          &
     &        NFRONT, IROW, JCOL, PDEST, HF, IOLDPS,                    &
     &        IN, DEB_ROW, ILOC_ROW, IFSON, ILOC_COL,                   &
     &        IPOS_SON, NELIM_SON, NSLAVES_SON, HS,                     &
     &        IROW_SON, ICOL_SON, ISLAVE, IERR,                         &
     &        NELIM_SENT, IPOS_STATREC
      INTEGER AGMG_MUMPS_275
      EXTERNAL AGMG_MUMPS_275
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      NB_CONTRI_GLOBAL = KEEP(41)
      NUMORG    = root%ROOT_SIZE
      NELIM     = KEEP(42)
      NFRONT    = NUMORG + KEEP(42)
      DO IROW = 0, root%NPROW - 1
        DO JCOL = 0, root%NPCOL - 1
            PDEST = IROW * root%NPCOL + JCOL
          IF ( PDEST .NE. MYID ) THEN
           CALL DAGMG_MUMPS_73(NFRONT,                                       &
     &     NB_CONTRI_GLOBAL, PDEST, COMM, IERR)
              if (IERR.lt.0) then
                write(6,*) ' error detected by ',                       &
     &          'DMUMPS_73'
                CALL AGMG_MUMPS_ABORT()
               endif
           ENDIF
        END DO
      END DO
      CALL  DAGMG_MUMPS_270( NFRONT,                                         &
     &    NB_CONTRI_GLOBAL, root,                                       &
     &    BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,             &
     &    IWPOS, IWPOSCB, IPTRLU,                                       &
     &    LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                       &
     &    PTLUST_S, PTRFAC,                                             &
     &    PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,               &
     &    IFLAG, IERROR, COMM, COMM_LOAD,                               &
     &    NBPROCFILS,                                                   &
     &    IPOOL, LPOOL, LEAF,                                           &
     &    NBFIN, MYID, SLAVEF,                                          &
     &    OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,                  &
     &    INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND )
       IF (IFLAG < 0 ) RETURN
      HF = 6 + KEEP(IXSZ)
      IOLDPS = PTLUST_S(STEP(IROOT))
      IN = IROOT
      DEB_ROW = IOLDPS + HF
      ILOC_ROW    = DEB_ROW
      DO WHILE (IN.GT.0)
       IW(ILOC_ROW)           = IN
       IW(ILOC_ROW+NFRONT)    = IN
       ILOC_ROW = ILOC_ROW + 1
       IN = FILS(IN)
      END DO
      IFSON = -IN
      ILOC_ROW    = IOLDPS + HF + NUMORG
      ILOC_COL    = ILOC_ROW + NFRONT
      IF ( NELIM.GT.0 ) THEN
        IN = IFSON
        DO WHILE (IN.GT.0)
          IPOS_SON  = PIMASTER(STEP(IN))
          IF (IPOS_SON .EQ. 0) GOTO 100
          NELIM_SON   = IW(IPOS_SON+1+KEEP(IXSZ))
              if (NELIM_SON.eq.0) then
                write(6,*) ' error 1 in process_last_rtnelind'
                CALL AGMG_MUMPS_ABORT()
              endif
          NSLAVES_SON = IW(IPOS_SON+5+KEEP(IXSZ))
          HS          = 6 + NSLAVES_SON + KEEP(IXSZ)
          IROW_SON    = IPOS_SON + HS
          ICOL_SON    = IROW_SON + NELIM_SON
          IW(ILOC_ROW:ILOC_ROW+NELIM_SON-1) =                           &
     &            IW(IROW_SON:IROW_SON+NELIM_SON-1)
          IW(ILOC_COL:ILOC_COL+NELIM_SON-1) =                           &
     &            IW(ICOL_SON:ICOL_SON+NELIM_SON-1)
          NELIM_SENT = ILOC_ROW - IOLDPS - HF + 1
          DO ISLAVE = 0,NSLAVES_SON
            IF (ISLAVE.EQ.0) THEN
             PDEST= AGMG_MUMPS_275(STEP(IN),PROCNODE_STEPS,SLAVEF)
            ELSE
             PDEST = IW(IPOS_SON + 5 + ISLAVE+KEEP(IXSZ))
            ENDIF
            IF (PDEST.NE.MYID) THEN
             CALL DAGMG_MUMPS_74(IN, NELIM_SENT,                             &
     &        PDEST, COMM, IERR )
               if (IERR.lt.0) then
                write(6,*) ' error detected by ',                       &
     &          'DMUMPS_73'
                CALL AGMG_MUMPS_ABORT()
               endif
            ELSE
             CALL DAGMG_MUMPS_271( COMM_LOAD, ASS_IRECV,                     &
     &       IN, NELIM_SENT, root,                                      &
     &       BUFR, LBUFR, LBUFR_BYTES, PROCNODE_STEPS, POSFAC,          &
     &       IWPOS, IWPOSCB, IPTRLU,                                    &
     &       LRLU, LRLUS, N, IW, LIW, A, LA, PTRIST,                    &
     &       PTLUST_S, PTRFAC,                                          &
     &       PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S, COMP,            &
     &       IFLAG, IERROR, COMM,                                       &
     &       NBPROCFILS,                                                &
     &       IPOOL, LPOOL, LEAF,                                        &
     &       NBFIN, MYID, SLAVEF,                                       &
     &       OPASSW, OPELIW, ITLOC, FILS, PTRARW, PTRAIW,               &
     &       INTARR, DBLARR, ICNTL, KEEP,KEEP8, ND, FRERE,              &
     &       LPTRAR, NELT, FRTPTR, FRTELT,                              &
     &       ISTEP_TO_INIV2, TAB_POS_IN_PERE  )
             IF ( ISLAVE .NE. 0 ) THEN
               IF (KEEP(50) .EQ. 0) THEN
                IPOS_STATREC = PTRIST(STEP(IN))+6+KEEP(IXSZ)
               ELSE
                IPOS_STATREC = PTRIST(STEP(IN))+8+KEEP(IXSZ)
               ENDIF
               IF (IW(IPOS_STATREC).EQ. S_REC_CONTSTATIC) THEN
                  IW(IPOS_STATREC) = S_ROOT2SON_CALLED
               ELSE
                CALL DAGMG_MUMPS_626( N, IN, PTRIST, PTRAST,                 &
     &          IW, LIW, A, LA, LRLU, LRLUS, IWPOSCB,                   &
     &          IPTRLU, STEP, MYID, KEEP                                &
     &        )
               ENDIF
             ENDIF
             IPOS_SON  = PIMASTER(STEP(IN))
            ENDIF
          END DO
          CALL  DAGMG_MUMPS_152( .FALSE.,MYID,N, IPOS_SON,                   &
     &       PTRAST(STEP(IN)),                                          &
     &       IW, LIW,                                                   &
     &       LRLU, LRLUS, IPTRLU,                                       &
     &       IWPOSCB, LA, KEEP,KEEP8, .FALSE.                           &
     &         )
          ILOC_ROW = ILOC_ROW + NELIM_SON
          ILOC_COL = ILOC_COL + NELIM_SON
  100     CONTINUE
          IN = FRERE(STEP(IN))
        ENDDO
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_176
      SUBROUTINE DAGMG_MUMPS_268(MYID,BUFR, LBUFR,                           &
     &     LBUFR_BYTES,                                                 &
     &     PROCNODE_STEPS, SLAVEF,                                      &
     &     IWPOS, IWPOSCB, IPTRLU, LRLU, LRLUS,                         &
     &     N, IW, LIW, A, LA,                                           &
     &     PTRIST, PTRAST, STEP, PIMASTER, PAMASTER, NSTK_S,            &
     &     COMP,                                                        &
     &     IFLAG, IERROR, COMM, COMM_LOAD, NBPROCFILS,                  &
     &     IPOOL, LPOOL, LEAF, KEEP,KEEP8, ND, FILS, FRERE, ITLOC,      &
     &     ISTEP_TO_INIV2, TAB_POS_IN_PERE )
      USE DAGMG_MUMPS_LD
      IMPLICIT NONE
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      INTEGER IERR
      INTEGER MYID
      INTEGER KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER LBUFR, LBUFR_BYTES
      INTEGER BUFR( LBUFR )
      INTEGER SLAVEF
      INTEGER(8) :: IPTRLU, LRLU, LRLUS, LA
      INTEGER IWPOS, IWPOSCB
      INTEGER N, LIW
      INTEGER IW( LIW )
      DOUBLE PRECISION A( LA )
      INTEGER(8) :: PTRAST(KEEP(28))
      INTEGER(8) :: PTRFAC(KEEP(28))
      INTEGER(8) :: PAMASTER(KEEP(28))
      INTEGER PTRIST(KEEP(28)), STEP(N), PIMASTER(KEEP(28))
      INTEGER PROCNODE_STEPS( KEEP(28) ), ITLOC( N )
      INTEGER COMP
      INTEGER NSTK_S( KEEP(28) )
      INTEGER NBPROCFILS( KEEP(28) )
      INTEGER IFLAG, IERROR, COMM, COMM_LOAD
      INTEGER LPOOL, LEAF
      INTEGER IPOOL( LPOOL )
      INTEGER ND(KEEP(28)), FILS( N ), FRERE( KEEP(28) )
      INTEGER ISTEP_TO_INIV2(KEEP(71)),                                 &
     &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
      INTEGER POSITION, IFATH, ISON, NROW, NCOL, NELIM,                 &
     &        NSLAVES
      INTEGER(8) :: NOREAL
      INTEGER NOINT, INIV2, NCOL_EFF
      DOUBLE PRECISION FLOP1
      INTEGER NBROWS_ALREADY_SENT, NBROWS_PACKET
      INTEGER NOREAL_PACKET
      LOGICAL PERETYPE2
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER XXI, XXR, XXS, XXN, XXP
      PARAMETER(XXI=0,XXR=1,XXS=3,XXN=4,XXP=5)
      INTEGER XXNDIAG2W
      PARAMETER(XXNDIAG2W=6)
      INTEGER XSIZE_IC, XSIZE_OOC_SYM, XSIZE_OOC_UNSYM
      INTEGER XSIZE_OOC_NOPANEL
      PARAMETER (XSIZE_IC=6,XSIZE_OOC_SYM=7,XSIZE_OOC_UNSYM=7,          &
     &           XSIZE_OOC_NOPANEL=6)
      INTEGER IXSZ
      PARAMETER(IXSZ= 222)
      INTEGER S_CB1COMP
      PARAMETER (S_CB1COMP=314)
      INTEGER S_ACTIVE, S_ALL, S_NOLCBCONTIG,                           &
     &        S_NOLCBNOCONTIG, S_NOLCLEANED,                            &
     &        S_NOLCBNOCONTIG38, S_NOLCBCONTIG38,                       &
     &        S_NOLCLEANED38, C_FINI
      PARAMETER(S_ACTIVE=400, S_ALL=401, S_NOLCBCONTIG=402,             &
     &          S_NOLCBNOCONTIG=403, S_NOLCLEANED=404,                  &
     &          S_NOLCBNOCONTIG38=405, S_NOLCBCONTIG38=406,             &
     &          S_NOLCLEANED38=407,C_FINI=1)
      INTEGER S_FREE, S_NOTFREE
      PARAMETER(S_FREE=54321,S_NOTFREE=-123456)
      INTEGER TOP_OF_STACK
      PARAMETER(TOP_OF_STACK=-999999)
      INTEGER XTRA_SLAVES_SYM, XTRA_SLAVES_UNSYM
      PARAMETER(XTRA_SLAVES_SYM=3, XTRA_SLAVES_UNSYM=1)
         INTEGER S_ROOT2SON_CALLED, S_REC_CONTSTATIC,                   &
     &  S_ROOTBAND_INIT
         PARAMETER(S_ROOT2SON_CALLED=-341,S_REC_CONTSTATIC=1,           &
     &             S_ROOTBAND_INIT=0)
      INTEGER  AGMG_MUMPS_330
      EXTERNAL AGMG_MUMPS_330
      POSITION = 0
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      CALL AGMG_NOCALL('MPI_UNPACK')
      IF ( NSLAVES .NE. 0 .and. KEEP(50).ne.0 ) THEN
        NCOL_EFF = NROW
      ELSE
        NCOL_EFF = NCOL
      ENDIF
      NOREAL_PACKET = NBROWS_PACKET * NCOL_EFF
      IF (NBROWS_ALREADY_SENT .EQ. 0) THEN
        NOINT = 6 + NROW + NCOL + NSLAVES + KEEP(IXSZ)
        NOREAL= int(NROW,8) * int(NCOL_EFF,8)
        CALL DAGMG_MUMPS_22(.FALSE.,0_8,.FALSE.,.FALSE.,                     &
     &   MYID,N,KEEP,KEEP8,IW,LIW,A,LA,                                 &
     &   LRLU, IPTRLU,IWPOS,IWPOSCB,                                    &
     &   PTRIST,PTRAST,STEP, PIMASTER, PAMASTER, ITLOC,                 &
     &   NOINT, NOREAL, ISON, S_NOTFREE, .TRUE.,                        &
     &   COMP, LRLUS, IFLAG, IERROR                                     &
     &     )
        IF ( IFLAG .LT. 0 ) THEN
          RETURN
        ENDIF
        PIMASTER(STEP( ISON )) = IWPOSCB + 1
        PAMASTER(STEP( ISON )) = IPTRLU  + 1_8
        IW( IWPOSCB + 1 + KEEP(IXSZ) ) = NCOL
        NELIM = NROW
        IW( IWPOSCB + 2 + KEEP(IXSZ) ) = NELIM
        IW( IWPOSCB + 3 + KEEP(IXSZ) ) = NROW
        IF ( NSLAVES .NE. 0 .and. KEEP(50).ne.0 ) THEN
          IW( IWPOSCB + 4 + KEEP(IXSZ) ) = NROW - NCOL
          IF ( NROW - NCOL .GE. 0 ) THEN
            WRITE(*,*) 'Error in PROCESS_MAITRE2:',NROW,NCOL
            CALL AGMG_MUMPS_ABORT()
          END IF
        ELSE
          IW( IWPOSCB + 4 + KEEP(IXSZ) ) = 0
        END IF
        IW( IWPOSCB + 5 + KEEP(IXSZ) ) = 1
        IW( IWPOSCB + 6 + KEEP(IXSZ) ) = NSLAVES
        IF (NSLAVES.GT.0) THEN
         CALL AGMG_NOCALL('MPI_UNPACK')
        ENDIF
        CALL AGMG_NOCALL('MPI_UNPACK')
        CALL AGMG_NOCALL('MPI_UNPACK')
        IF ( ( KEEP(48).NE. 0 ).AND.(NSLAVES .GT. 0 )) THEN
          INIV2 = ISTEP_TO_INIV2 ( STEP(ISON) )
          CALL AGMG_NOCALL('MPI_UNPACK')
          TAB_POS_IN_PERE(SLAVEF+2,INIV2) = NSLAVES
        ENDIF
      ENDIF
      IF (NOREAL_PACKET.GT.0) THEN
        CALL AGMG_NOCALL('MPI_UNPACK')
      ENDIF
      IF ( NBROWS_ALREADY_SENT + NBROWS_PACKET .EQ. NROW ) THEN
        PERETYPE2 = ( AGMG_MUMPS_330(STEP(IFATH),PROCNODE_STEPS,             &
     &              SLAVEF) .EQ. 2 )
        NSTK_S( STEP(IFATH ))       = NSTK_S( STEP(IFATH) ) - 1
        IF ( NSTK_S( STEP(IFATH)) .EQ. 0 ) THEN
          CALL DAGMG_MUMPS_507(N, IPOOL, LPOOL, PROCNODE_STEPS,              &
     &         SLAVEF, KEEP(28), KEEP(76), KEEP(80), KEEP(47),          &
     &         STEP, IFATH )
          IF (KEEP(47) .GE. 3) THEN
             CALL DAGMG_MUMPS_500(                                           &
     &            IPOOL, LPOOL,                                         &
     &            PROCNODE_STEPS, KEEP,KEEP8, SLAVEF, COMM_LOAD,        &
     &            MYID, STEP, N, ND, FILS )
          ENDIF
          CALL AGMG_MUMPS_137( IFATH, N, PROCNODE_STEPS,                     &
     &                            SLAVEF, ND,                           &
     &                            FILS,FRERE, STEP, PIMASTER,           &
     &                            KEEP(28), KEEP(50),                   &
     &                            FLOP1,IW, LIW, KEEP(IXSZ) )
          IF (IFATH.NE.KEEP(20))                                        &
     &    CALL DAGMG_MUMPS_190(1, .FALSE., FLOP1, KEEP,KEEP8)
        END IF
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_268
      SUBROUTINE DAGMG_MUMPS_242(DATA, LDATA, MPITYPE, ROOT, COMMW, TAG,     &
     &SLAVEF)
      USE DAGMG_MUMPS_COMM_BUFF
      IMPLICIT NONE
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      INTEGER IERR
      INTEGER LDATA, ROOT, COMMW, TAG, MPITYPE, SLAVEF
      INTEGER DEST
      INTEGER DATA(LDATA)
      DO 10 DEST = 0, SLAVEF - 1
        IF (DEST .NE. ROOT) THEN
          IF ( LDATA .EQ. 1 .and. MPITYPE .EQ. AGMG_MPF_INTEGER ) THEN
            CALL DAGMG_MUMPS_62( DATA(1), DEST, TAG,                         &
     &                                COMMW, IERR )
          ELSE
            WRITE(*,*) 'Error : bad argument to DMUMPS_242'
            CALL AGMG_MUMPS_ABORT()
          END IF
        ENDIF
   10 END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_242
      SUBROUTINE DAGMG_MUMPS_44( MYID, SLAVEF, COMM )
      INTEGER MYID, SLAVEF, COMM
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
!
!  This file is part of MUMPS 4.9.2, built on Thu Nov  5 07:05:08 UTC 20
!
!
!  This version of MUMPS is provided to you free of charge. It is public
!  domain, based on public domain software developed during the Esprit I
!  European project PARASOL (1996-1999) by CERFACS, ENSEEIHT-IRIT and RA
!  Since this first public domain version in 1999, the developments are
!  supported by the following institutions: CERFACS, CNRS, INPT(ENSEEIHT
!  IRIT, and INRIA.
!
!  Current development team includes Patrick Amestoy, Alfredo Buttari,
!  Abdou Guermouche, Jean-Yves L'Excellent, Bora Ucar.
!
!  Up-to-date copies of the MUMPS package can be obtained
!  from the Web pages:
!  http://mumps.enseeiht.fr/  or  http://graal.ens-lyon.fr/MUMPS
!
!
!   THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
!   EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.
!
!
!  User documentation of any code that uses this software can
!  include this complete notice. You can acknowledge (using
!  references [1] and [2]) the contribution of this package
!  in any scientific publication dependent upon the use of the
!  package. You shall use reasonable endeavours to notify
!  the authors of the package of this publication.
!
!   [1] P. R. Amestoy, I. S. Duff, J. Koster and  J.-Y. L'Excellent,
!   A fully asynchronous multifrontal solver using distributed dynamic
!   scheduling, SIAM Journal of Matrix Analysis and Applications,
!   Vol 23, No 1, pp 15-41 (2001).
!
!   [2] P. R. Amestoy and A. Guermouche and J.-Y. L'Excellent and
!   S. Pralet, Hybrid scheduling for the parallel solution of linear
!   systems. Parallel Computing Vol 32 (2), pp 136-156 (2006).
!
      INTEGER ARROWHEAD, ARR_INT, ARR_REAL, ELT_INT, ELT_REAL
      PARAMETER ( ARROWHEAD = 20,                                       &
     &            ARR_INT = 29,                                         &
     &            ARR_REAL = 30,                                        &
     &            ELT_INT = 31,                                         &
     &            ELT_REAL = 32 )
      INTEGER COLLECT_NZ, COLLECT_IRN, COLLECT_JCN
      PARAMETER( COLLECT_NZ  = 35,                                      &
     &           COLLECT_IRN = 36,                                      &
     &           COLLECT_JCN = 37 )
      INTEGER RACINE,                                                   &
     &        NOEUD,                                                    &
     &        TERREUR,                                                  &
     &        MAITRE_DESC_BANDE,                                        &
     &        MAITRE2,                                                  &
     &        BLOC_FACTO,                                               &
     &        CONTRIB_TYPE2,                                            &
     &        MAPLIG,                                                   &
     &        FACTOR
      PARAMETER ( RACINE            = 2,                                &
     &            NOEUD             = 3,                                &
     &            MAITRE_DESC_BANDE = 4,                                &
     &            MAITRE2           = 5,                                &
     &            BLOC_FACTO        = 6,                                &
     &            CONTRIB_TYPE2     = 7,                                &
     &            MAPLIG            = 8,                                &
     &            FACTOR            = 9,                                &
     &            TERREUR           = 99 )
      INTEGER ROOT_NELIM_INDICES,                                       &
     &        ROOT_CONT_STATIC,                                         &
     &        ROOT_NON_ELIM_CB,                                         &
     &        ROOT_2SLAVE,                                              &
     &        ROOT_2SON
       PARAMETER( ROOT_NELIM_INDICES = 15,                              &
     &        ROOT_CONT_STATIC       = 16,                              &
     &        ROOT_NON_ELIM_CB       = 17,                              &
     &        ROOT_2SLAVE            = 18,                              &
     &        ROOT_2SON              = 19 )
      INTEGER RACINE_SOLVE,                                             &
     &        ContVec,                                                  &
     &        Master2Slave,                                             &
     &        GatherSol,                                                &
     &        ScatterRhsI,                                              &
     &        ScatterRhsR
      PARAMETER( RACINE_SOLVE = 10,                                     &
     &           ContVec      = 11,                                     &
     &           Master2Slave = 12,                                     &
     &           GatherSol    = 13,                                     &
     &           ScatterRhsI  = 54,                                     &
     &           ScatterRhsR  = 55)
      INTEGER FEUILLE,                                                  &
     &        BACKSLV_UPDATERHS,                                        &
     &        BACKSLV_MASTER2SLAVE
      PARAMETER( FEUILLE = 21,                                          &
     &           BACKSLV_UPDATERHS = 22,                                &
     &           BACKSLV_MASTER2SLAVE = 23 )
      INTEGER SYMMETRIZE
      PARAMETER ( SYMMETRIZE = 24 )
      INTEGER BLOC_FACTO_SYM,                                           &
     &        BLOC_FACTO_SYM_SLAVE, END_NIV2_LDLT
      PARAMETER ( BLOC_FACTO_SYM = 25,                                  &
     &            BLOC_FACTO_SYM_SLAVE = 26 ,                           &
     &            END_NIV2_LDLT = 33 )
      INTEGER UPDATE_LOAD
      PARAMETER ( UPDATE_LOAD = 27 )
      INTEGER DEFIC_TAG
      PARAMETER(  DEFIC_TAG = 28 )
      INTEGER TAG_SCHUR
      PARAMETER( TAG_SCHUR = 38 )
      INTEGER TAG_DUMMY
      PARAMETER( TAG_DUMMY = 39 )
      INTEGER ZERO_PIV
      PARAMETER( ZERO_PIV = 40 )
      INTEGER DUMMY (1)
      CALL DAGMG_MUMPS_242( DUMMY, 1, AGMG_MPF_INTEGER, MYID,                     &
     &                 COMM, TERREUR, SLAVEF )
      RETURN
      END SUBROUTINE DAGMG_MUMPS_44
      SUBROUTINE DAGMG_MUMPS_464( K34, K35, K16, K10 )
      IMPLICIT NONE
      INTEGER, INTENT(OUT) :: K34, K35, K10, K16
      INTEGER*4 SIZE_INT, SIZE_REAL_OR_DOUBLE
      INTEGER I(2)
      DOUBLE PRECISION R(2)
      !CALL AGMG_MUMPS_SIZE_C(I(1),I(2),SIZE_INT)
      !CALL AGMG_MUMPS_SIZE_C(R(1),R(2),SIZE_REAL_OR_DOUBLE)
          IF (HUGE(I(1)) > 1.0e10) THEN
             SIZE_INT=8
          ELSE
             SIZE_INT=4
          END IF
      K34 = SIZE_INT
      K10 = 8 / K34
      K16 = 8
      K35 = K16
      RETURN
      END SUBROUTINE DAGMG_MUMPS_464
      SUBROUTINE DAGMG_MUMPS_20( NPROCS, LWK_USER, CNTL, ICNTL,              &
     &                    KEEP,KEEP8,                                   &
     &                    INFO, INFOG, RINFO, RINFOG, SYM, PAR,         &
     &                    DKEEP)
      IMPLICIT NONE
      DOUBLE PRECISION    DKEEP(30)
      DOUBLE PRECISION    CNTL(15), RINFO(20), RINFOG(20)
      INTEGER ICNTL(40), KEEP(500), SYM, PAR, NPROCS
      INTEGER INFO(40), INFOG(40)
      INTEGER*8 KEEP8(150)
      INTEGER LWK_USER
!     Let $A_{preproc}$ be the preprocessed matrix to be factored (see
      LWK_USER = 0
      KEEP(1:500) = 0
      KEEP8(1:150)= 0_8
      INFO(1:40)  = 0
      INFOG(1:40) = 0
      ICNTL(1:40) = 0
      RINFO(1:20) = 0.0D0
      RINFOG(1:20)= 0.0D0
      CNTL(1:15)  = 0.0D0
      DKEEP(1:30) = 0.0D0
      KEEP( 50 ) = SYM
      IF ( KEEP(50).NE.1 .and. KEEP(50).NE.2 ) KEEP( 50 ) = 0
      IF ( KEEP(50) .NE. 1 ) THEN
        CNTL(1)   = 0.01D0
      ELSE
        CNTL(1)   = 0.0D0
      END IF
      CNTL(2) = sqrt(epsilon(0.0D0))
      CNTL(3) = 0.0D0
      CNTL(4) = -1.0D0
      CNTL(5) = 0.0D0
      CNTL(6) = -1.0D0
      KEEP(46) = PAR
      IF ( KEEP(46) .NE. 0 .AND.                                        &
     &     KEEP(46) .NE. 1 ) THEN
           KEEP(46) = 1
      END IF
      ICNTL(1)  = 6
      ICNTL(2)  = 0
      ICNTL(3)  = 6
      ICNTL(4)  = 2
      ICNTL(5)  = 0
      IF (SYM.NE.1) THEN
       ICNTL(6)  = 7
      ELSE
       ICNTL(6)  = 0
      ENDIF
      ICNTL(7) = 7
      ICNTL(8)  = 77
      ICNTL(9)  = 1
      ICNTL(10)  = 0
      ICNTL(11)  = 0
      IF(SYM .EQ. 2) THEN
         ICNTL(12)  = 0
      ELSE
         ICNTL(12)  = 1
      ENDIF
      ICNTL(13) = 0
      IF (SYM.eq.1.AND.NPROCS.EQ.1) THEN
        ICNTL(14) = 5
      ELSE IF (NPROCS .GT. 4) THEN
        ICNTL(14) = 30
      ELSE
        ICNTL(14) = 20
      END IF
      ICNTL(15) = 0
      ICNTL(16) = 0
      ICNTL(17) = 0
      ICNTL(18) = 0
      ICNTL(19) = 0
      ICNTL(20) = 0
      ICNTL(21) = 0
      ICNTL(22) = 0
      ICNTL(23) = 0
      ICNTL(24) = 0
      ICNTL(27) = -8
      ICNTL(28) = 1
      ICNTL(29) = 0
      ICNTL(39) = 1
      ICNTL(40)  = 0
      KEEP(12) = 0
      KEEP(11) = 2147483646
      KEEP(24) = 18
      KEEP(68) = 0
      KEEP(36) = 1
      KEEP(1) = 8
      KEEP(7)  = 150
      KEEP(8)  = 120
      KEEP(57) = 500
      KEEP(58) = 250
      IF ( SYM .eq. 0 ) THEN
        KEEP(4)  = 32
        KEEP(3)  = 96
        KEEP(5)  = 16
        KEEP(6)  = 32
        KEEP(9)  = 700
        KEEP(85) =  300
        KEEP(62) =  50
        IF (NPROCS.GE.128) KEEP(62)=200
        IF (NPROCS.GE.128) KEEP(9)=800
        IF (NPROCS.GE.256) KEEP(9)=900
      ELSE
        KEEP(4)  = 24
        KEEP(3)  = 96
        KEEP(5)  = 16
        KEEP(6)  = 48
        KEEP(9)  = 400
        KEEP(85) = 100
        KEEP(62) = 100
        IF (NPROCS.GE.128) KEEP(62)=150
        IF (NPROCS.GE.64) KEEP(9)=800
        IF (NPROCS.GE.128) KEEP(9)=900
      END IF
      KEEP(63) = 60
      KEEP(48) = 5
      KEEP(17) = 0
      CALL DAGMG_MUMPS_464( KEEP(34), KEEP(35),                              &
     &                            KEEP(16), KEEP(10) )
      KEEP(37) = max(800, 2*NPROCS)
      IF ( NPROCS > 256 ) THEN
        KEEP(39) = 10000
      ELSEIF ( NPROCS > 128 ) THEN
        KEEP(39) = 20000
      ELSEIF ( NPROCS > 64 ) THEN
        KEEP(39) = 40000
      ELSEIF ( NPROCS > 16 ) THEN
        KEEP(39) = 80000
      ELSE
        KEEP(39) = 160000
      END IF
      KEEP(40) = -1 - 456789
      KEEP(45) = 0
      KEEP(47) = 2
      KEEP( 51 )  = 48
      KEEP(64) = 10
      KEEP(69) = 4
      KEEP(75) = 1
      KEEP(76) = 2
      KEEP(77) = 30
      IF (NPROCS.GT.4) THEN
          KEEP(78)=max(                                                 &
     &       int(log(dble(NPROCS))/log(dble(2))) - 2                    &
     &       , 0         )
      ENDIF
      KEEP(210) = 2
      KEEP8(79) = -10_8
      KEEP(80) = 1
      KEEP(81) = 0
      KEEP(82) = 5
      KEEP(83) = min(8,NPROCS/4)
      KEEP(83) = max(min(4,NPROCS),max(KEEP(83),1))
      KEEP(86)=1
      KEEP(87)=0
      KEEP(88)=0
      KEEP(90)=1
      KEEP(91)=min(8, NPROCS)
      KEEP(91) = max(min(4,NPROCS),min(KEEP(83),KEEP(91)))
      IF(NPROCS.LT.48)THEN
         KEEP(102)=150
      ELSEIF(NPROCS.LT.128)THEN
         KEEP(102)=150
      ELSEIF(NPROCS.LT.256)THEN
         KEEP(102)=200
      ELSEIF(NPROCS.LT.512)THEN
         KEEP(102)=300
      ELSEIF(NPROCS.GE.512)THEN
         KEEP(102)=400
      ENDIF
      KEEP(99)=4
      KEEP(100)=0
      KEEP(204)=0
      KEEP(205)=0
      KEEP(209)=-1
      KEEP(104) = 16
      KEEP(107)=0
      KEEP(211)=2
      KEEP(213)=201
      KEEP(217)=0
      KEEP(215)=0
      KEEP(216)=1
      KEEP(218)=50
      KEEP(219)=1
      IF (KEEP(50).EQ.2) THEN
        KEEP(227)= max(2,32)
      ELSE
        KEEP(227)= max(1,32)
      ENDIF
      KEEP(231) = 1
      KEEP(232) = 3
      KEEP(233) = 0
      KEEP(239) = 1
      KEEP(240) = 10
      KEEP(241) = 0
      DKEEP(4) = -1.0D0
      DKEEP(5) = -1.0D0
      IF(NPROCS.LE.8)THEN
         KEEP(238)=12
      ELSE
         KEEP(238)=7
      ENDIF
      KEEP(234)= 1
      DKEEP(3)=-5.0D0
      KEEP(244) = ICNTL(28)
      KEEP(245) = ICNTL(29)
      KEEP(250) = 1
      RETURN
      END SUBROUTINE DAGMG_MUMPS_20
      SUBROUTINE DAGMG_MUMPS_195(N, NZ, IRN, ICN, LIW, IKEEP, PTRAR,         &
     &     IORD, NFSIZ, FILS, FRERE, LISTVAR_SCHUR, SIZE_SCHUR,         &
     &     ICNTL, INFO, KEEP,KEEP8, NSLAVES, SYM, PIV, id)
      USE DAGMG_MUMPS_STRUC_DF
      IMPLICIT NONE
      INTEGER N,NZ,LIW,IORD,SIZE_SCHUR, NSLAVES, SYM
      INTEGER PTRAR(N,4), NFSIZ(N), FILS(N), FRERE(N)
      INTEGER IKEEP(N,3)
      INTEGER  LISTVAR_SCHUR(SIZE_SCHUR)
      INTEGER INFO(40), ICNTL(40), KEEP(500)
      INTEGER*8 KEEP8(150)
      TYPE (DAGMG_MUMPS_STRUC) :: id
      INTEGER IRN(NZ), ICN(NZ)
      INTEGER, DIMENSION(:), ALLOCATABLE :: IW
      INTEGER IERR
      INTEGER K,I,L1,L2,IWFR,NCMPA,LLIW, IN, IFSON
      INTEGER NEMIN, LP, MP, LDIAG, ITEMP, symmetry
      INTEGER MedDens, NBQD, AvgDens
      LOGICAL PROK, COMPRESS_SCHUR
      INTEGER NBBUCK
      INTEGER, DIMENSION(:), ALLOCATABLE :: HEAD
      INTEGER NUMFLAG
      INTEGER OPT_METIS_SIZE
      INTEGER, DIMENSION(:), ALLOCATABLE :: OPTIONS_METIS
      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: COLSCA_TEMP
      INTEGER THRESH, IVersion
      LOGICAL AGG6
      INTEGER MINSYM
      PARAMETER (MINSYM=50)
      INTEGER(8) :: K79REF
      PARAMETER(K79REF=12000000_8)
      INTEGER PIV(N)
      INTEGER MTRANS, COMPRESS,NCMP,IERROR,J,JPERM,NCST
      INTEGER TOTEL
      LOGICAL IDENT,SPLITROOT
      EXTERNAL AGMG_MUMPS_197, DAGMG_MUMPS_198,                                   &
     &     DAGMG_MUMPS_199, DAGMG_MUMPS_351,                                      &
     &     DAGMG_MUMPS_557, DAGMG_MUMPS_201
      EXTERNAL DAGMG_MUMPS_623
      EXTERNAL DAGMG_MUMPS_547, DAGMG_MUMPS_550,                                  &
     &     DAGMG_MUMPS_556
      ALLOCATE( IW ( LIW ), stat = IERR )
      IF ( IERR .GT. 0 ) THEN
         INFO( 1 ) = -7
         INFO( 2 ) = LIW
         RETURN
      ENDIF
      LLIW = LIW - 2*N - 1
      L1 = LLIW + 1
      L2 = L1 + N
      LP    = ICNTL(1)
      MP    = ICNTL(3)
      PROK  = (MP.GT.0)
      LDIAG = ICNTL(4)
      COMPRESS_SCHUR = .FALSE.
      IF (KEEP(1).LT.0) KEEP(1) = 0
      NEMIN = KEEP(1)
      IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
         WRITE (MP,99999) N, NZ, LIW, INFO(1)
         K = min0(10,NZ)
         IF (LDIAG.EQ.4) K = NZ
         IF (K.GT.0) WRITE (MP,99998) (IRN(I),ICN(I),I=1,K)
         K = min0(10,N)
         IF (LDIAG.EQ.4) K = N
         IF (IORD.EQ.1 .AND. K.GT.0) THEN
            WRITE (MP,99997) (IKEEP(I,1),I=1,K)
         ENDIF
      ENDIF
      NCMP    = N
      IF (KEEP(60).NE.0) THEN
         IF ((SIZE_SCHUR.LE.0 ).OR.                                     &
     &        (SIZE_SCHUR.GE.N) ) GOTO 90
      ENDIF
         CALL DAGMG_MUMPS_351(N,NZ,IRN, ICN, IW(1), LLIW,                    &
     &        IW(L2), PTRAR(1,2),                                       &
     &        PTRAR, IW(L1), IWFR, KEEP(113), KEEP(114),                &
     &        INFO(1), INFO(2), ICNTL, symmetry,                        &
     &        SYM, MedDens, NBQD, AvgDens)
      INFO(8) = symmetry
      IF(NBQD .GT. 0) THEN
         IF( KEEP(50) .EQ. 2 .AND. ICNTL(12) .LE. 1 ) THEN
            IF(KEEP(95) .NE. 1) THEN
               IF ( PROK )                                              &
     &              WRITE( MP,*)                                        &
     &              'Compressed/constrained ordering set OFF'
               KEEP(95) = 1
            ENDIF
         ENDIF
      ENDIF
      IF ( (KEEP(60).NE.0) .AND. (IORD.GT.1) .AND.                      &
     &     .NOT. COMPRESS_SCHUR ) THEN
         IORD = 0
      ENDIF
      CALL DAGMG_MUMPS_701( N, SYM, NSLAVES, IORD,                           &
     &     symmetry, MedDens, NBQD, AvgDens,                            &
     &     PROK, MP )
      IF(SYM .EQ. 2) THEN
         IF(KEEP(95) .EQ. 3 .AND. IORD .NE. 2) THEN
            IF (PROK) WRITE(MP,*)                                       &
     &           'WARNING: ANAL_F constrained ordering not available ', &
     &           'with selected ordering'
            KEEP(95) = 2
         ENDIF
         IF(KEEP(95) .EQ. 2 .AND. IORD .EQ. 0) THEN
            IF (PROK) WRITE(MP,*)                                       &
     &           'WARNING: ANAL_F AMD not available with ',             &
     &           'compressed ordering -> move to QAMD'
            IORD = 6
         ENDIF
      ELSE
         KEEP(95) = 1
      ENDIF
      MTRANS = KEEP(23)
      COMPRESS = KEEP(95) - 1
      IF(COMPRESS .GT. 0 .AND. KEEP(52) .EQ. -2) THEN
         IF(id%CNTL(4) .GE. 0.0D0) THEN
            IF (KEEP(1).LE.8) THEN
               NEMIN = 16
            ELSE
               NEMIN = 2*KEEP(1)
            ENDIF
            IF (PROK)                                                   &
     &           WRITE(MP,*) 'Setting static pivoting ON, COMPRESS =',  &
     &           COMPRESS
         ENDIF
      ENDIF
      IF(MTRANS .GT. 0 .AND. KEEP(50) .EQ. 2) THEN
         KEEP(23) = 0
      ENDIF
      IF(COMPRESS .EQ. 2) THEN
         IF (IORD.NE.2) THEN
            WRITE(*,*) "IORD not compatible with COMPRESS:",            &
     &           IORD, COMPRESS
            CALL AGMG_MUMPS_ABORT()
         ENDIF
         CALL  DAGMG_MUMPS_556(                                              &
     &        N,PIV,FRERE,FILS,NFSIZ,IKEEP,                             &
     &        NCST,KEEP,KEEP8,id)
      ENDIF
      IF ( IORD .NE. 1 ) THEN
         IF(COMPRESS .GE. 1) THEN
            CALL DAGMG_MUMPS_547(                                            &
     &           N,NZ, IRN, ICN, PIV,                                   &
     &           NCMP, IW(1), LLIW, IW(L2),PTRAR(1,2),PTRAR,            &
     &           IW(L1), FILS, IWFR,                                    &
     &           IERROR, KEEP,KEEP8, ICNTL)
            symmetry = 100
         ENDIF
         IF ( (symmetry.LT.MINSYM).AND.(SYM.EQ.0) ) THEN
            IF(KEEP(23) .EQ. 7 ) THEN
               KEEP(23) = -5
               DEALLOCATE (IW)
               RETURN
            ELSE IF(KEEP(23) .EQ. -9876543) THEN
               IDENT = .TRUE.
               KEEP(23) = 5
               IF (PROK) WRITE(MP,'(A)')                                &
     &              ' ... Apply column permutation (already computed)'
               DO J=1,N
                  JPERM = PIV(J)
                  FILS(JPERM) = J
                  IF (JPERM.NE.J) IDENT = .FALSE.
               ENDDO
               IF (.NOT.IDENT) THEN
                  DO K=1,NZ
                     J = ICN(K)
                     IF ((J.LE.0).OR.(J.GT.N)) CYCLE
                     ICN(K) = FILS(J)
                  ENDDO
                  ALLOCATE(COLSCA_TEMP(N), stat=IERR)
                  IF ( IERR > 0 ) THEN
                     INFO( 1 ) = -7
                     INFO( 2 ) = LIW
                     RETURN
                  ENDIF
                  DO J = 1, N
                     COLSCA_TEMP(J)=id%COLSCA(J)
                  ENDDO
                  DO J=1, N
                     id%COLSCA(FILS(J))=COLSCA_TEMP(J)
                  ENDDO
                  DEALLOCATE(COLSCA_TEMP)
                  IF (MP.GT.0 .AND. ICNTL(4).GE.2)                      &
     &                 WRITE(MP,'(/A)')                                 &
     &                 ' WARNING input matrix data modified'
                  CALL DAGMG_MUMPS_351                                       &
     &                 (N,NZ,IRN, ICN, IW(1), LLIW, IW(L2), PTRAR(1,2), &
     &                 PTRAR, IW(L1), IWFR, KEEP(113), KEEP(114),       &
     &                 INFO(1), INFO(2), ICNTL, symmetry, SYM,          &
     &                 MedDens, NBQD, AvgDens)
                  INFO(8) = symmetry
                  NCMP = N
               ELSE
                  KEEP(23) = 0
               ENDIF
            ENDIF
         ELSE IF (KEEP(23) .EQ. 7 .OR. KEEP(23) .EQ. -9876543 ) THEN
            IF (PROK) WRITE(MP,'(A)')                                   &
     &           ' ... No column permutation'
            KEEP(23) = 0
         ENDIF
      ENDIF
      IF (IORD.NE.1 .AND. IORD.NE.5) THEN
         IF (PROK) THEN
            IF (IORD.EQ.2) THEN
               WRITE(MP,'(A)') ' Ordering based on AMF '
            ELSE IF (IORD.EQ.6) THEN
               WRITE(MP,'(A)') ' Ordering based on QAMD '
            ELSE
               WRITE(MP,'(A)') ' Ordering based on AMD '
            ENDIF
         ENDIF
         IF ( KEEP(60) .NE. 0 ) THEN
            CALL AGMG_MUMPS_162(N, LLIW, IW(L2), IWFR, PTRAR(1,2), IW(1),    &
     &           IW(L1), IKEEP,                                         &
     &           IKEEP(1,2), NCMPA, FILS, IKEEP(1,3), PTRAR, PTRAR(1,3),&
     &           LISTVAR_SCHUR, SIZE_SCHUR)
            IF (KEEP(60)==1) THEN
               KEEP(20) = LISTVAR_SCHUR(1)
            ELSE
               KEEP(38) = LISTVAR_SCHUR(1)
            ENDIF
         ELSE
            IF ( .FALSE. ) THEN
            ELSEIF (IORD .EQ. 2) THEN
               NBBUCK = 2*N
               ALLOCATE( HEAD ( 0: NBBUCK + 1), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                  INFO( 1 ) = -7
                  INFO( 2 ) = NBBUCK+2
                  RETURN
               ENDIF
               IF(COMPRESS .GE. 1) THEN
                  DO I=L1,L1-1+KEEP(93)/2
                     IW(I) = 2
                  ENDDO
                  DO I=L1+KEEP(93)/2,L1+NCMP-1
                     IW(I) = 1
                  ENDDO
               ELSE
                  IW(L1) = -1
               ENDIF
               IF(COMPRESS .LE. 1) THEN
                  CALL AGMG_MUMPS_337(NCMP, NBBUCK, LLIW, IW(L2),            &
     &                 IWFR, PTRAR(1,2),                                &
     &                 IW(1), IW(L1), IKEEP, IKEEP(1,2), NCMPA, FILS,   &
     &                 IKEEP(1,3), PTRAR, PTRAR(1,3), HEAD)
               ELSE
                  IF(PROK) WRITE(MP,'(A)')                              &
     &                 ' Constrained Ordering based on AMF'
                  CALL AGMG_MUMPS_560(NCMP, NBBUCK, LLIW, IW(L2),            &
     &                 IWFR, PTRAR(1,2),                                &
     &                 IW(1), IW(L1), IKEEP, IKEEP(1,2), NCMPA, FILS,   &
     &                 IKEEP(1,3), PTRAR, PTRAR(1,3), HEAD,             &
     &                 NFSIZ, FRERE)
               ENDIF
               DEALLOCATE(HEAD)
            ELSEIF (IORD .EQ. 6) THEN
               ALLOCATE( HEAD ( N ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                  INFO( 1 ) = -7
                  INFO( 2 ) = N
                  RETURN
               ENDIF
               THRESH = 1
               IVersion = 2
               IF(COMPRESS .EQ. 1) THEN
                  DO I=L1,L1-1+KEEP(93)/2
                     IW(I) = 2
                  ENDDO
                  DO I=L1+KEEP(93)/2,L1+NCMP-1
                     IW(I) = 1
                  ENDDO
                  TOTEL = KEEP(93)+KEEP(94)
               ELSE
                  IW(L1) = -1
                  TOTEL = N
               ENDIF
               CALL AGMG_MUMPS_421(TOTEL,IVersion, THRESH, HEAD,             &
     &              NCMP, LLIW, IW(L2), IWFR, PTRAR(1,2), IW(1),        &
     &              IW(L1), IKEEP, IKEEP(1,2), NCMPA, FILS,             &
     &              IKEEP(1,3), PTRAR, PTRAR(1,3))
               DEALLOCATE(HEAD)
            ELSE
               CALL AGMG_MUMPS_197(NCMP, LLIW, IW(L2), IWFR, PTRAR(1,2),     &
     &              IW(1), IW(L1), IKEEP, IKEEP(1,2), NCMPA, FILS,      &
     &              IKEEP(1,3), PTRAR, PTRAR(1,3))
            ENDIF
         ENDIF
         IF(COMPRESS .GE. 1) THEN
            CALL DAGMG_MUMPS_550(N,NCMP,KEEP(94),KEEP(93),                   &
     &           PIV,IKEEP(1,1),IKEEP(1,2))
            COMPRESS = -1
         ENDIF
      ENDIF
      IF (PROK) THEN
         IF (IORD.EQ.1) THEN
            WRITE(MP,'(A)') ' Ordering given is used'
         ENDIF
      ENDIF
      IF ((IORD.EQ.1)                                                   &
     &     ) THEN
         DO K=1,N
            PTRAR(K,1) = 0
         ENDDO
         DO K=1,N
            IF ((IKEEP(K,1).LE.0).OR.(IKEEP(K,1).GT.N))                 &
     &           GO TO 40
            IF (PTRAR(IKEEP(K,1),1).EQ.1) THEN
               GOTO 40
            ELSE
               PTRAR(IKEEP(K,1),1) = 1
            ENDIF
         ENDDO
      ENDIF
      IF (IORD.EQ.1 .OR. IORD.EQ.5 .OR. COMPRESS.EQ.-1) THEN
         IF (KEEP(106)==1) THEN
            IF ( COMPRESS .EQ. -1 ) THEN
               CALL DAGMG_MUMPS_351(N,NZ,IRN, ICN, IW(1), LLIW,              &
     &              IW(L2), PTRAR(1,2),                                 &
     &              PTRAR, IW(L1), IWFR, KEEP(113), KEEP(114),          &
     &              INFO(1), INFO(2), ICNTL, symmetry, SYM,             &
     &              MedDens, NBQD, AvgDens)
               INFO(8) = symmetry
            ENDIF
            COMPRESS = 0
            ALLOCATE( HEAD ( 2*N ), stat = IERR )
            IF ( IERR .GT. 0 ) THEN
               INFO( 1 ) = -7
               INFO( 2 ) = 2*N
               RETURN
            ENDIF
            THRESH = -1
            IF (KEEP(60) == 0) THEN
               ITEMP = 0
            ELSE
               ITEMP = SIZE_SCHUR
               IF (KEEP(60)==1) THEN
                  KEEP(20) = LISTVAR_SCHUR(1)
               ELSE
                  KEEP(38) = LISTVAR_SCHUR(1)
               ENDIF
            ENDIF
            AGG6 = ( NSLAVES == 1 )
            CALL AGMG_MUMPS_422(THRESH, HEAD,                                &
     &           N, LLIW, IW(L2), IWFR, PTRAR(1,2), IW,                 &
     &           IW(L1), HEAD(N+1),                                     &
     &           IKEEP(1,2), NCMPA, FILS, IKEEP(1,3), PTRAR, PTRAR(1,3),&
     &           IKEEP(1,1), LISTVAR_SCHUR, ITEMP, AGG6)
            DEALLOCATE(HEAD)
         ELSE
            CALL DAGMG_MUMPS_198(N, NZ, IRN, ICN, IKEEP, IW(1),              &
     &           LLIW, IW(L2),                                          &
     &           PTRAR(1,2), IW(L1), IWFR,                              &
     &           INFO(1),INFO(2), KEEP(11), MP)
            IF (KEEP(60) .EQ. 0) THEN
               ITEMP = 0
               CALL DAGMG_MUMPS_199(N, IW(L2), IW, LLIW, IWFR, IKEEP,        &
     &              IKEEP(1,2), IW(L1),                                 &
     &              PTRAR, NCMPA, ITEMP)
            ELSE
               CALL DAGMG_MUMPS_199(N, IW(L2), IW, LLIW, IWFR, IKEEP,        &
     &              IKEEP(1,2), IW(L1),                                 &
     &              PTRAR, NCMPA, SIZE_SCHUR)
               IF (KEEP(60) .EQ. 1) THEN
                  KEEP(20) = LISTVAR_SCHUR(1)
               ELSE
                  KEEP(38) = LISTVAR_SCHUR(1)
               ENDIF
            ENDIF
         ENDIF
      ENDIF
      CALL DAGMG_MUMPS_557                                                   &
     &     (N, IW(L2), IW(L1), IKEEP(1,1), IKEEP(1,2), IKEEP(1,3),      &
     &     NFSIZ, PTRAR, INFO(6), FILS, FRERE,                          &
     &     PTRAR(1,3), NEMIN, PTRAR(1,4), KEEP(60),                     &
     &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50),       &
     &     ICNTL(13), KEEP(37), NSLAVES, KEEP(250).EQ.1)
      IF (KEEP(60).NE.0)  THEN
         IF (KEEP(60)==1) THEN
            IN = KEEP(20)
         ELSE
            IN = KEEP(38)
         ENDIF
         DO WHILE (IN.GT.0)
            IN = FILS (IN)
         END DO
         IFSON = -IN
         IF (KEEP(60)==1) THEN
            IN = KEEP(20)
         ELSE
            IN = KEEP(38)
         ENDIF
         DO I=2,SIZE_SCHUR
            FILS(IN) = LISTVAR_SCHUR (I)
            IN       = FILS(IN)
            FRERE (IN) = N+1
         ENDDO
         FILS(IN) = -IFSON
      ENDIF
      CALL DAGMG_MUMPS_201(IKEEP(1,2),                                       &
     &     PTRAR(1,3), INFO(6),                                         &
     &     INFO(5), KEEP(2), KEEP(50),                                  &
     &     KEEP(101),KEEP(108),KEEP(5),                                 &
     &     KEEP(6), KEEP(226))
      IF ( KEEP(53) .NE. 0 ) THEN
         CALL AGMG_MUMPS_209( N, FRERE, FILS, NFSIZ, KEEP(20) )
      END IF
      IF (  (KEEP(48) == 4 .AND. KEEP8(21).GT.0_8)                      &
     &     .OR.                                                         &
     &     (KEEP (48)==5 .AND. KEEP8(21) .GT. 0_8 )                     &
     &     .OR.                                                         &
     &     (KEEP(24).NE.0.AND.KEEP8(21).GT.0_8) ) THEN
         CALL DAGMG_MUMPS_510(KEEP8(21), KEEP(2),                            &
     &        KEEP(48), KEEP(50), NSLAVES)
      END IF
      IF (KEEP(210).LT.0.OR.KEEP(210).GT.2) KEEP(210)=0
      IF (KEEP(210).EQ.0.AND.KEEP(201).GT.0) KEEP(210)=1
      IF (KEEP(210).EQ.0.AND.KEEP(201).EQ.0) KEEP(210)=2
      IF (KEEP(210).EQ.2) KEEP8(79)=huge(KEEP8(79))
      IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         IF ( huge(KEEP8(79)) / K79REF + 1_8 .GE. int(NSLAVES,8) ) THEN
            KEEP8(79)=huge(KEEP8(79))
         ELSE
            KEEP8(79)=K79REF * int(NSLAVES,8)
         ENDIF
      ENDIF
      IF (KEEP(210).EQ.1) THEN
         SPLITROOT = .FALSE.
         IF ( KEEP(62).GE.1) THEN
            CALL DAGMG_MUMPS_97(N, FRERE, FILS, NFSIZ,INFO(6),               &
     &           NSLAVES, KEEP,KEEP8, SPLITROOT,                        &
     &           MP, LDIAG,INFO(1),INFO(2))
            IF (INFO(1).LT.0) RETURN
         ENDIF
      ENDIF
      SPLITROOT = ((ICNTL(13).GT.0 .AND. NSLAVES.GT.ICNTL(13)) .OR.     &
     &     ICNTL(13).EQ.-1 )                                            &
     &     .AND. (KEEP(60).EQ.0)
      IF (SPLITROOT) THEN
         CALL DAGMG_MUMPS_97(N, FRERE, FILS, NFSIZ,INFO(6),                  &
     &        NSLAVES, KEEP,KEEP8, SPLITROOT,                           &
     &        MP, LDIAG,INFO(1),INFO(2))
         IF (INFO(1).LT.0) RETURN
      ENDIF
!     $        IKEEP(1,3), IKEEP(1,2), IRN, ICN, PTRAR, KEEP)
      IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
         K = min0(10,N)
         IF (LDIAG.EQ.4) K = N
         IF (K.GT.0) WRITE (MP,99997) (IKEEP(I,1),I=1,K)
         IF (K.GT.0) WRITE (MP,99991) (IKEEP(I,2),I=1,K)
         IF (K.GT.0) WRITE (MP,99990) (IKEEP(I,3),I=1,K)
         IF (K.GT.0) WRITE (MP,99986) (PTRAR(I,1),I=1,K)
         IF (K.GT.0) WRITE (MP,99985) (PTRAR(I,2),I=1,K)
         IF (K.GT.0) WRITE (MP,99984) (PTRAR(I,3),I=1,K)
         IF (K.GT.0) WRITE (MP,99987) (NFSIZ(I),I=1,K)
         IF (K.GT.0) WRITE (MP,99989) (FILS(I),I=1,K)
         IF (K.GT.0) WRITE (MP,99988) (FRERE(I),I=1,K)
      ENDIF
      GO TO 90
   40 INFO(1) = -4
      INFO(2) = K
      IF ((LP.GT.0).AND.(ICNTL(4).GE.1)) WRITE (LP,99996) INFO(1)
      IF ((LP.GT.0).AND.(ICNTL(4).GE.1)) WRITE (LP,99982) INFO(2)
      GOTO 90
   90 CONTINUE
      DEALLOCATE(IW)
      RETURN
99999 FORMAT (/'Entering analysis phase with ...'/                      &
     &     '                N         NZ         LIW       INFO(1)'/,   &
     &     9X, I8, I11, I12, I14)
99998 FORMAT ('Matrix entries:    IRN()   ICN()'/                       &
     &     (I12, I7, I12, I7, I12, I7))
99997 FORMAT ('IKEEP(.,1)=', 10I6/(12X, 10I6))
99996 FORMAT (/'** Error return ** from Analysis *  INFO(1)=', I3)
99991 FORMAT ('IKEEP(.,2)=', 10I6/(12X, 10I6))
99990 FORMAT ('IKEEP(.,3)=', 10I6/(12X, 10I6))
99989 FORMAT ('FILS (.)  =', 10I6/(12X, 10I6))
99988 FORMAT ('FRERE(.)  =', 10I6/(12X, 10I6))
99987 FORMAT ('NFSIZ(.)  =', 10I6/(12X, 10I6))
99986 FORMAT ('PTRAR(.,1)=', 10I6/(12X, 10I6))
99985 FORMAT ('PTRAR(.,2)=', 10I6/(12X, 10I6))
99984 FORMAT ('PTRAR(.,3)=', 10I6/(12X, 10I6))
99982 FORMAT ('Error in permutation array KEEP   INFO(2)=', I3)
      END SUBROUTINE DAGMG_MUMPS_195
      SUBROUTINE DAGMG_MUMPS_199(N,IPE,IW, LW, IWFR, IPS, IPV, NV, FLAG,     &
     &                  NCMPA, SIZE_SCHUR)
      INTEGER N,LW,IWFR,NCMPA,SIZE_SCHUR
      INTEGER FLAG(N)
      INTEGER IPS(N), IPV(N)
      INTEGER IW(LW), NV(N), IPE(N)
      INTEGER I,J,ML,MS,ME,IP,MINJS,IE,KDUMMY,JP
      INTEGER LN,JP1,JS,LWFR,JP2,JE
      DO 10 I=1,N
        FLAG(I) = 0
        NV(I) = 0
        J = IPS(I)
        IPV(J) = I
   10 END DO
      NCMPA = 0
      DO 100 ML=1,N-SIZE_SCHUR
        MS = IPV(ML)
        ME = MS
        FLAG(MS) = ME
        IP = IWFR
        MINJS = N
        IE = ME
        DO 70 KDUMMY=1,N
          JP = IPE(IE)
          LN = 0
          IF (JP.LE.0) GO TO 60
          LN = IW(JP)
          DO 50 JP1=1,LN
            JP = JP + 1
            JS = IW(JP)
            IF (FLAG(JS).EQ.ME) GO TO 50
            FLAG(JS) = ME
            IF (IWFR.LT.LW) GO TO 40
            IPE(IE) = JP
            IW(JP) = LN - JP1
            CALL DAGMG_MUMPS_194(N, IPE, IW, IP-1, LWFR,NCMPA)
            JP2 = IWFR - 1
            IWFR = LWFR
            IF (IP.GT.JP2) GO TO 30
            DO 20 JP=IP,JP2
              IW(IWFR) = IW(JP)
              IWFR = IWFR + 1
   20       CONTINUE
   30       IP = LWFR
            JP = IPE(IE)
   40       IW(IWFR) = JS
            MINJS = min0(MINJS,IPS(JS)+0)
            IWFR = IWFR + 1
   50     CONTINUE
   60     IPE(IE) = -ME
          JE = NV(IE)
          NV(IE) = LN + 1
          IE = JE
          IF (IE.EQ.0) GO TO 80
   70   CONTINUE
   80   IF (IWFR.GT.IP) GO TO 90
        IPE(ME) = 0
        NV(ME) = 1
!        GO TO 100
        CYCLE
   90   MINJS = IPV(MINJS)
        NV(ME) = NV(MINJS)
        NV(MINJS) = ME
        IW(IWFR) = IW(IP)
        IW(IP) = IWFR - IP
        IPE(ME) = IP
        IWFR = IWFR + 1
  100 END DO
      IF (SIZE_SCHUR == 0) RETURN
      DO ML = N-SIZE_SCHUR+1,N
        ME = IPV(ML)
        IE = ME
        DO KDUMMY=1,N
          JP = IPE(IE)
          LN = 0
          IF (JP.LE.0) GO TO 160
          LN = IW(JP)
  160     IPE(IE) = -IPV(N-SIZE_SCHUR+1)
          JE = NV(IE)
          NV(IE) = LN + 1
          IE = JE
          IF (IE.EQ.0) GO TO 190
        ENDDO
  190   NV(ME) = 0
        IPE(ME) = -IPV(N-SIZE_SCHUR+1)
      ENDDO
      ME = IPV(N-SIZE_SCHUR+1)
      IPE(ME) = 0
      NV(ME) = SIZE_SCHUR
      RETURN
      END SUBROUTINE DAGMG_MUMPS_199
      SUBROUTINE DAGMG_MUMPS_198(N, NZ, IRN, ICN, PERM,                      &
     & IW, LW, IPE, IQ, FLAG,                                           &
     & IWFR, IFLAG, IERROR, IOVFLO, MP)
      INTEGER N,NZ,LW,IWFR,IFLAG,IERROR
      INTEGER PERM(N)
      INTEGER IQ(N)
      INTEGER IRN(NZ), ICN(NZ)
      INTEGER IPE(N), IW(LW), FLAG(N)
      INTEGER MP
      INTEGER IOVFLO
      INTEGER I,J,K,LBIG,L,ID,IN,LEN,JDUMMY,K1,K2
      IERROR = 0
      DO 10 I=1,N
        IQ(I) = 0
   10 END DO
      DO 80 K=1,NZ
        I = IRN(K)
        J = ICN(K)
        IW(K) = -I
        IF (I.EQ.J) GOTO 40
        IF (I.GT.J) GOTO 30
        IF (I.GE.1 .AND. J.LE.N) GO TO 60
        GO TO 50
   30   IF (J.GE.1 .AND. I.LE.N) GO TO 60
        GO TO 50
   40   IW(K) = 0
!        IF (I.GE.1 .AND. I.LE.N) GO TO 80
        IF (I.GE.1 .AND. I.LE.N) CYCLE
   50   IERROR = IERROR + 1
        IW(K) = 0
        IF (IERROR.LE.1 .AND. MP.GT.0) WRITE (MP,99999)
        IF (IERROR.LE.10 .AND. MP.GT.0) WRITE (MP,99998) K, I, J
!        GO TO 80
        CYCLE
   60   IF (PERM(J).GT.PERM(I)) GO TO 70
        IQ(J) = IQ(J) + 1
!        GO TO 80
        CYCLE
   70   IQ(I) = IQ(I) + 1
   80 END DO
      IF (IERROR.GE.1) THEN
        IF (mod(IFLAG,2) .EQ. 0) IFLAG = IFLAG+1
      ENDIF
      IWFR = 1
      LBIG = 0
      DO 100 I=1,N
        L = IQ(I)
        LBIG = MAX0(L,LBIG)
        IWFR = IWFR + L
        IPE(I) = IWFR - 1
  100 END DO
      DO 140 K=1,NZ
        I = -IW(K)
!        IF (I.LE.0) GO TO 140
        IF (I.LE.0) CYCLE
        L = K
        IW(K) = 0
        DO 130 ID=1,NZ
          J = ICN(L)
          IF (PERM(I).LT.PERM(J)) GO TO 110
          L = IPE(J)
          IPE(J) = L - 1
          IN = IW(L)
          IW(L) = I
          GO TO 120
  110     L = IPE(I)
          IPE(I) = L - 1
          IN = IW(L)
          IW(L) = J
  120     I = -IN
          IF (I.LE.0) GO TO 140
  130   CONTINUE
  140 END DO
      K = IWFR - 1
      L = K + N
      IWFR = L + 1
      DO 170 I=1,N
        FLAG(I) = 0
        J = N + 1 - I
        LEN = IQ(J)
        IF (LEN.LE.0) GO TO 160
        DO 150 JDUMMY=1,LEN
          IW(L) = IW(K)
          K = K - 1
          L = L - 1
  150   CONTINUE
  160   IPE(J) = L
        L = L - 1
  170 END DO
      IF (LBIG.GE.IOVFLO) GO TO 190
      DO 180 I=1,N
        K = IPE(I)
        IW(K) = IQ(I)
        IF (IQ(I).EQ.0) IPE(I) = 0
  180 END DO
      GO TO 230
  190 IWFR = 1
      DO 220 I=1,N
        K1 = IPE(I) + 1
        K2 = IPE(I) + IQ(I)
        IF (K1.LE.K2) GO TO 200
        IPE(I) = 0
!        GO TO 220
        CYCLE
  200   IPE(I) = IWFR
        IWFR = IWFR + 1
        DO 210 K=K1,K2
          J = IW(K)
!          IF (FLAG(J).EQ.I) GO TO 210
          IF (FLAG(J).EQ.I) CYCLE
          IW(IWFR) = J
          IWFR = IWFR + 1
          FLAG(J) = I
  210   CONTINUE
        K = IPE(I)
        IW(K) = IWFR - K - 1
  220 END DO
  230 RETURN
99999 FORMAT (' *** WARNING MESSAGE FROM DMUMPS_198 ***' )
99998 FORMAT (I6, ' NON-ZERO (IN ROW, I6, 11H AND COLUMN ', I6,         &
     & ') IGNORED')
      END SUBROUTINE DAGMG_MUMPS_198
      SUBROUTINE DAGMG_MUMPS_194(N, IPE, IW, LW, IWFR,NCMPA)
      INTEGER N,LW,IWFR,NCMPA
      INTEGER IPE(N)
      INTEGER   IW(LW)
      INTEGER I,K1,LWFR,IR,K,K2
      NCMPA = NCMPA + 1
      DO 10 I=1,N
        K1 = IPE(I)
!        IF (K1.LE.0) GO TO 10
        IF (K1.LE.0) CYCLE
        IPE(I) = IW(K1)
        IW(K1) = -I
   10 END DO
      IWFR = 1
      LWFR = IWFR
      DO 60 IR=1,N
        IF (LWFR.GT.LW) GO TO 70
        DO 20 K=LWFR,LW
          IF (IW(K).LT.0) GO TO 30
   20   CONTINUE
        GO TO 70
   30   I = -IW(K)
        IW(IWFR) = IPE(I)
        IPE(I) = IWFR
        K1 = K + 1
        K2 = K + IW(IWFR)
        IWFR = IWFR + 1
        IF (K1.GT.K2) GO TO 50
        DO 40 K=K1,K2
          IW(IWFR) = IW(K)
          IWFR = IWFR + 1
   40   CONTINUE
   50   LWFR = K2 + 1
   60 END DO
   70 RETURN
      END SUBROUTINE DAGMG_MUMPS_194
      SUBROUTINE DAGMG_MUMPS_557(N, IPE, NV, IPS, NE, NA, NFSIZ,             &
     &               NODE, NSTEPS,                                      &
     &               FILS, FRERE, ND, NEMIN, SUBORD, KEEP60,            &
     &               KEEP20, KEEP38, NAMALG,NAMALGMAX,                  &
     &               CUMUL,KEEP50, ICNTL13, KEEP37, NSLAVES,            &
     &               ALLOW_AMALG_TINY_NODES)
      IMPLICIT NONE
      INTEGER N, NSTEPS, KEEP60, KEEP20, KEEP38, KEEP50
      INTEGER ND(N), NFSIZ(N)
      INTEGER IPE(N), FILS(N), FRERE(N), SUBORD(N)
      INTEGER NV(N), IPS(N), NE(N), NA(N), NODE(N)
      INTEGER NEMIN,AMALG_COUNT
      INTEGER NAMALG(N),NAMALGMAX, CUMUL(N)
      DOUBLE PRECISION ACCU, FLOPS_FATHER, FLOPS_SON,                   &
     &                  FLOPS_AVANT, FLOPS_APRES
      INTEGER ICNTL13, KEEP37, NSLAVES
      LOGICAL ALLOW_AMALG_TINY_NODES
      INTEGER I,IF,IS,NR,NR1,INS,INL,INB,INF,INFS,INSW
      INTEGER K,L,ISON,IN,IFSON,INO
      INTEGER INOS,IB,IL,INT
      INTEGER IPERM
      INTEGER DADI
      LOGICAL AMALG_TO_father_OK
      AMALG_COUNT = 0
      DO 10 I=1,N
        CUMUL(I)= 0
        IPS(I)  = 0
        NE(I)   = 0
        NODE(I) = 1
        SUBORD(I) = 0
        NAMALG(I) = 0
   10 END DO
      FRERE(1:N) = IPE(1:N)
      NR = N + 1
      DO 50 I=1,N
        IF = -FRERE(I)
        IF (NV(I).EQ.0) THEN
          IF (SUBORD(IF).NE.0) SUBORD(I) = SUBORD(IF)
          SUBORD(IF) = I
          NODE(IF) = NODE(IF)+1
        ELSE
          IF (IF.NE.0) THEN
            IS = -IPS(IF)
            IF (IS.GT.0) FRERE(I) = IS
            IPS(IF) = -I
          ELSE
            NR = NR - 1
            NE(NR) = I
          ENDIF
        ENDIF
   50 END DO
 1151 DO 51 I=1,N
       FILS(I) = IPS(I)
   51 END DO
      IS = 1
      I = 0
      IPERM = 1
      DO 160 K=1,N
        AMALG_TO_father_OK=.FALSE.
        IF (I.LE.0) THEN
         IF (NR.GT.N) EXIT
         I = NE(NR)
         NE(NR) = 0
         NR = NR + 1
         IL = N
         NA(N) = 0
        ENDIF
        DO 70 L=1,N
          IF (IPS(I).GE.0) EXIT
          ISON = -IPS(I)
          IPS(I) = 0
          I = ISON
          IL = IL - 1
          NA(IL) = 0
   70   CONTINUE
        DADI = -IPE(I)
        IF ( (DADI.NE.0) .AND.                                          &
     &      (                                                           &
     &       (KEEP60.EQ.0).OR.                                          &
     &       ( (KEEP20.NE.DADI).AND.(KEEP38.NE.DADI) )                  &
     &      )                                                           &
     &     ) THEN
           ACCU =                                                       &
     &     ( dble(20000)*                                               &
     &       dble(NODE(I))*dble(NV(DADI)-NV(I)+NODE(I))                 &
     &      )                                                           &
     &      /                                                           &
     &          ( dble(NV(DADI)+NODE(I))*                               &
     &              dble(NV(DADI)+NODE(I))  )
           ACCU = ACCU + dble(CUMUL(I) )
           AMALG_TO_father_OK = ( (NODE(I).LE.NEMIN).OR.                &
     &         (NODE(DADI).LE.NEMIN) )
           AMALG_TO_father_OK = ( AMALG_TO_father_OK .AND.              &
     &       (                                                          &
     &        ( dble(2*(NODE(I)))*                                      &
     &         dble((NV(DADI)-NV(I)+NODE(I)))                           &
     &        ) .LT.                                                    &
     &        (  dble(NV(DADI)+NODE(I))*                                &
     &         dble(NV(DADI)+NODE(I))*dble(NEMIN)/dble(100)             &
     &        )                                                         &
     &       ) )
           AMALG_TO_father_OK = ( AMALG_TO_father_OK .AND.              &
     &     ( ACCU .LE. dble(NEMIN)*dble(100) )                          &
     &                           )
           IF (AMALG_TO_father_OK) THEN
              CALL AGMG_MUMPS_511(NV(I),NODE(I),NODE(I),                     &
     &                                  KEEP50,1,FLOPS_SON)
              CALL AGMG_MUMPS_511(NV(DADI),NODE(DADI),                       &
     &                             NODE(DADI),                          &
     &                             KEEP50,1,FLOPS_FATHER)
              FLOPS_AVANT = FLOPS_FATHER+FLOPS_SON                      &
     &                      + max(dble(200.0) * dble(NV(I)-NODE(I))     &
     &                            * dble(NV(I)-NODE(I)),                &
     &                            dble(10000.0))
              CALL AGMG_MUMPS_511(NV(DADI)+NODE(I),                          &
     &                             NODE(DADI)+NODE(I),                  &
     &                             NODE(DADI)+NODE(I),                  &
     &                             KEEP50,1,FLOPS_APRES)
              IF(FLOPS_APRES .GT. FLOPS_AVANT) THEN
                 AMALG_TO_father_OK = .FALSE.
              ENDIF
           ENDIF
           IF ( (NV(I).GT. 50*NV(DADI)).AND. (NSLAVES.GT.1)             &
     &          .AND. (ICNTL13.LE.0)                                    &
     &          .AND. (NV(I).GT. KEEP37) )  THEN
             AMALG_TO_father_OK = .TRUE.
           ENDIF
           IF ( ALLOW_AMALG_TINY_NODES .AND.                            &
     &     NODE(I) * 900 .LE. NV(DADI) - NAMALG(DADI)) THEN
             IF ( NAMALG(DADI) < (NV(DADI)-NAMALG(DADI))/50 ) THEN
                AMALG_TO_father_OK = .TRUE.
                NAMALG(DADI) = NAMALG(DADI) + NODE(I)
           ENDIF
        ENDIF
      AMALG_TO_father_OK = (AMALG_TO_father_OK .OR.                     &
     &                       ( NV(I)-NODE(I).EQ.NV(DADI)) )
           IF (AMALG_TO_father_OK) THEN
             CUMUL(DADI)=CUMUL(DADI)+nint(ACCU)
             NAMALG(DADI) = NAMALG(DADI) + NAMALG(I)
             AMALG_COUNT = AMALG_COUNT+1
             IN = DADI
   75        IF (SUBORD(IN).EQ.0) GOTO 76
               IN = SUBORD(IN)
               GOTO 75
   76        CONTINUE
             SUBORD(IN) = I
             NV(I)      = 0
             IFSON = -FILS(DADI)
             IF (IFSON.EQ.I) THEN
              IF (FILS(I).LT.0) THEN
                FILS(DADI) =  FILS(I)
                GOTO 78
              ELSE
                IF (FRERE(I).GT.0) THEN
                  FILS(DADI) = -FRERE(I)
                ELSE
                  FILS(DADI) = 0
                ENDIF
                GOTO 90
              ENDIF
             ENDIF
             IN = IFSON
   77        INS = IN
             IN = FRERE(IN)
             IF (IN.NE.I) GOTO 77
             IF (FILS(I) .LT.0) THEN
               FRERE(INS) = -FILS(I)
             ELSE
               FRERE(INS) = FRERE(I)
               GOTO 90
             ENDIF
   78        CONTINUE
             IN = -FILS(I)
   79        INO = IN
             IN = FRERE(IN)
             IF (IN.GT.0) GOTO 79
             FRERE(INO) = FRERE(I)
   90        CONTINUE
             NODE(DADI) = NODE(DADI)+ NODE(I)
             NV(DADI)   = NV(DADI) +  NODE(I)
             NA(IL+1)   = NA(IL+1) + NA(IL)
             GOTO 120
           ENDIF
        ENDIF
        NE(IS) = NE(IS) + NODE(I)
        IF (IL.LT.N) NA(IL+1) = NA(IL+1) + 1
        NA(IS) = NA(IL)
        ND(IS) = NV(I)
        NODE(I) = IS
        IPS(I) = IPERM
        IPERM = IPERM + 1
        IN = I
  777   IF (SUBORD(IN).EQ.0) GO TO 778
          IN = SUBORD(IN)
          NODE(IN) = IS
          IPS(IN) = IPERM
          IPERM = IPERM + 1
          GO TO 777
  778   IF (NA(IS).LE.0) GO TO 110
  110   IS = IS + 1
  120   IB = FRERE(I)
        IF (IB.GE.0) THEN
          IF (IB.GT.0) NA(IL) = 0
          I = IB
        ELSE
          I = -IB
          IL = IL + 1
        ENDIF
  160 END DO
      NSTEPS = IS - 1
      DO I=1, N
        IF (NV(I).EQ.0) THEN
          FRERE(I) = N+1
        ELSE
          NFSIZ(I) = ND(NODE(I))
          IF (SUBORD(I) .NE.0) THEN
           INOS = -FILS(I)
           INO = I
           DO WHILE (SUBORD(INO).NE.0)
             IS = SUBORD(INO)
             FILS(INO) = IS
             INO = IS
           END DO
           FILS(INO) = -INOS
          ENDIF
        ENDIF
      ENDDO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_557
      SUBROUTINE DAGMG_MUMPS_201(NE, ND, NSTEPS,                             &
     & MAXFR, MAXELIM, K50, MAXFAC, MAXNPIV,                            &
     & K5,K6,PANEL_SIZE)
      IMPLICIT NONE
      INTEGER NSTEPS,MAXNPIV
      INTEGER MAXFR, MAXELIM, K50, MAXFAC
      INTEGER K5,K6,PANEL_SIZE
      INTEGER NE(NSTEPS), ND(NSTEPS)
      INTEGER ITREE, NFR, NELIM
      INTEGER LKJIB
      LKJIB   = max(k5,k6)
      MAXFR   = 0
      MAXFAC  = 0
      MAXELIM = 0
      MAXNPIV = 0
      PANEL_SIZE = 0
      DO ITREE=1,NSTEPS
        NELIM = NE(ITREE)
        NFR = ND(ITREE)
        IF (NFR.GT.MAXFR)         MAXFR   = NFR
        IF (NFR-NELIM.GT.MAXELIM) MAXELIM = NFR - NELIM
        IF (NELIM .GT. MAXNPIV) THEN
           IF(NFR .NE. NELIM) MAXNPIV = NELIM
        ENDIF
        IF (K50.EQ.0) THEN
          MAXFAC = max(MAXFAC, (2*NFR - NELIM)*NELIM )
          PANEL_SIZE = max(PANEL_SIZE, NFR*LKJIB)
        ELSE
         MAXFAC = max(MAXFAC, NFR * NELIM)
         PANEL_SIZE = max(PANEL_SIZE, NELIM*LKJIB)
         PANEL_SIZE = max(PANEL_SIZE, (NFR-NELIM)*LKJIB)
        ENDIF
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_201
      SUBROUTINE DAGMG_MUMPS_348( N, FILS, FRERE,                            &
     & NSTK, NA )
      IMPLICIT NONE
      INTEGER, INTENT(IN)    :: N
      INTEGER, INTENT(IN)    :: FILS(N), FRERE(N)
      INTEGER, INTENT(INOUT) ::  NSTK(N), NA(N)
      INTEGER NBROOT, NBLEAF, ILEAF, I, IN, ISON
      NA   = 0
      NSTK = 0
      NBROOT  = 0
      ILEAF   = 1
      DO 11 I=1,N
         IF (FRERE(I).EQ. N+1) CYCLE
         IF (FRERE(I).EQ.0) NBROOT = NBROOT + 1
         IN = I
   12    IN = FILS(IN)
         IF (IN.GT.0) GO TO 12
         IF (IN.EQ.0) THEN
            NA(ILEAF) = I
            ILEAF     = ILEAF + 1
            CYCLE
         ENDIF
         ISON = -IN
   13    NSTK(I) = NSTK(I) + 1
         ISON = FRERE(ISON)
         IF (ISON.GT.0) GO TO 13
   11 END DO
      NBLEAF = ILEAF-1
      IF (N.GT.1) THEN
         IF (NBLEAF.GT.N-2) THEN
            IF (NBLEAF.EQ.N-1) THEN
               NA(N-1) = -NA(N-1)-1
               NA(N)   = NBROOT
            ELSE
               NA(N) = -NA(N)-1
            ENDIF
         ELSE
            NA(N-1) = NBLEAF
            NA(N)   = NBROOT
         ENDIF
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_348
      SUBROUTINE DAGMG_MUMPS_202( N, NZ, PERM, IRN, ICN, PTRAR, KEEP )
      IMPLICIT NONE
      INTEGER, INTENT(IN)      :: N, NZ
      INTEGER, INTENT(IN)      :: KEEP(500)
      INTEGER, TARGET          :: PTRAR(N,2)
      INTEGER, INTENT(IN)      :: IRN(NZ), ICN(NZ), PERM(N)
      INTEGER I
      INTEGER IOLD, K, JOLD, INEW, JNEW, ISHIFT
      DO 50 IOLD=1,N
         PTRAR(IOLD,1) = 0
         PTRAR(IOLD,2) = 0
   50 END DO
      DO 70 K=1,NZ
         IOLD = IRN(K)
         JOLD = ICN(K)
!         IF ( (IOLD.GT.N).OR.(JOLD.GT.N).OR.(IOLD.LT.1)                 &
!     &        .OR.(JOLD.LT.1) ) GOTO 70
         IF ( (IOLD.GT.N).OR.(JOLD.GT.N).OR.(IOLD.LT.1)                 &
     &        .OR.(JOLD.LT.1) ) CYCLE
         IF (IOLD.NE.JOLD) THEN
            INEW = PERM(IOLD)
            JNEW = PERM(JOLD)
            IF ( KEEP( 50 ) .EQ. 0 ) THEN
               IF (INEW.LT.JNEW) THEN
                  PTRAR(IOLD,2) = PTRAR(IOLD,2) + 1
               ELSE
                  PTRAR(JOLD,1) = PTRAR(JOLD,1) + 1
               ENDIF
            ELSE
               IF ( INEW .LT. JNEW ) THEN
                  PTRAR( IOLD, 1 ) = PTRAR( IOLD, 1 ) + 1
               ELSE
                  PTRAR( JOLD, 1 ) = PTRAR( JOLD, 1 ) + 1
               END IF
            ENDIF
         ENDIF
   70 END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_202
      SUBROUTINE DAGMG_MUMPS_203( N, NZ, MTRANS, PERM,                       &
     &     id, ICNTL, INFO)
      USE DAGMG_MUMPS_STRUC_DF
      IMPLICIT NONE
      TYPE (DAGMG_MUMPS_STRUC) :: id
      INTEGER N, NZ, LIWG
      INTEGER PERM(N)
      INTEGER MTRANS
      INTEGER ICNTL(40), INFO(40)
      INTEGER  allocok
      INTEGER, ALLOCATABLE, DIMENSION(:) :: IW
      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: S2
      TARGET :: S2
      INTEGER LS2,LSC
      INTEGER ICNTL64(10), INFO64(10)
      INTEGER ICNTL_SYM_MWM(10),INFO_SYM_MWM(10)
      DOUBLE PRECISION CNTL64(10)
      INTEGER LDW, LDWMIN
      INTEGER MPRINT,LP, MP, IPIW, LIW, LIWMIN
      INTEGER JPERM
      INTEGER NUMNZ, I, J, JPOS, K, NZREAL
      INTEGER PLENR, IP, IRNW,RSPOS,CSPOS
      LOGICAL PROK, IDENT, DUPPLI
      INTEGER NZTOT, K50, KER_SIZE, NZER_DIAG, MTRANSLOC,RZ_DIAG
      LOGICAL SCALINGLOC
      INTEGER,POINTER,DIMENSION(:) :: ZERODIAG
      INTEGER,POINTER,DIMENSION(:) :: STR_KER
      INTEGER,POINTER,DIMENSION(:) :: MARKED
      INTEGER,POINTER,DIMENSION(:) :: FLAG
      INTEGER,POINTER,DIMENSION(:) :: PIV_OUT
      DOUBLE PRECISION THEMIN, THEMAX, COLNORM,MAXDBL
      DOUBLE PRECISION ZERO,TWO,ONE
      PARAMETER(ZERO = 0.0D0,TWO = 2.0D0,ONE = 1.0D0)
      MPRINT = ICNTL(3)
      LP     = ICNTL(1)
      MP     = ICNTL(2)
      PROK = (MPRINT.GT.0)
      IF (PROK) WRITE(MPRINT,101)
  101 FORMAT(/'****** Preprocessing of original matrix '/)
      K50 = id%KEEP(50)
      SCALINGLOC = .FALSE.
      IF(id%KEEP(52) .EQ. -2) THEN
         IF(.not.associated(id%A)) THEN
            INFO(1) = -22
            INFO(2) = 4
            GOTO 500
         ELSE
            SCALINGLOC = .TRUE.
         ENDIF
      ELSE IF(id%KEEP(52) .EQ. 77) THEN
         SCALINGLOC = .TRUE.
         IF(K50 .NE. 2) THEN
            IF( MTRANS .NE. 5 .AND. MTRANS .NE. 6                       &
     &           .AND. MTRANS .NE. 7) THEN
               SCALINGLOC = .FALSE.
               IF (PROK)                                                &
     &              WRITE(MPRINT,*) 'Analysis: auto scaling set OFF'
            ENDIF
         ENDIF
         IF(.not.associated(id%A)) THEN
            SCALINGLOC = .FALSE.
            IF (PROK)                                                   &
     &           WRITE(MPRINT,*) 'Analysis: auto scaling set OFF'
         ENDIF
      ENDIF
      IF(SCALINGLOC) THEN
         IF (PROK) WRITE(MPRINT,*)                                      &
     &        'Scaling will be computed during analysis'
      ENDIF
      MTRANSLOC = MTRANS
      IF (MTRANS.LT.0 .OR. MTRANS.GT.7) GO TO 500
      IF (K50 .EQ. 0) THEN
         IF(.NOT. SCALINGLOC .AND. MTRANS .EQ. 7) THEN
            GO TO 500
         ENDIF
         IF(SCALINGLOC) THEN
            MTRANSLOC = 5
         ENDIF
      ELSE
         IF (MTRANS .EQ. 7) MTRANSLOC = 5
      ENDIF
      IF(SCALINGLOC .AND. MTRANSLOC .NE. 5 .AND.                        &
     &     MTRANSLOC .NE. 6 ) THEN
         IF (PROK) WRITE(MPRINT,*)                                      &
     &        'WARNING scaling required: set MTRANS option to 5'
         MTRANSLOC = 5
      ENDIF
      IF (N.EQ.1) THEN
        MTRANS=0
        GO TO 500
      ENDIF
      IF(K50 .EQ. 2) THEN
         NZTOT = 2*NZ+N
      ELSE
         NZTOT = NZ
      ENDIF
      ZERODIAG => id%IS1(N+1:2*N)
      STR_KER => id%IS1(2*N+1:3*N)
      CALL DAGMG_MUMPS_448(ICNTL64,CNTL64)
      ICNTL64(1) = ICNTL(1)
      ICNTL64(2) = ICNTL(2)
      ICNTL64(3) = ICNTL(2)
      ICNTL64(4) = -1
      IF (ICNTL(4).EQ.3) ICNTL64(4) = 0
      IF (ICNTL(4).EQ.4) ICNTL64(4) = 1
      ICNTL64(5) = -1
      IF (PROK) THEN
         WRITE(MPRINT,'(A,I3)')                                         &
     &     'Compute maximum matching (Maximum Transversal):',           &
     &        MTRANSLOC
         IF (MTRANSLOC.EQ.1)                                            &
     &   WRITE(MPRINT,'(A,I3)')' ... JOB =',MTRANSLOC
         IF (MTRANSLOC.EQ.2)                                            &
     &   WRITE(MPRINT,'(A,I3,A)')                                       &
     &     ' ... JOB =',MTRANSLOC,': BOTTLENECK THESIS'
         IF (MTRANSLOC.EQ.3)                                            &
     &   WRITE(MPRINT,'(A,I3,A)')                                       &
     &     ' ... JOB =',MTRANSLOC,': BOTTLENECK SIMAX'
         IF (MTRANSLOC.EQ.4)                                            &
     &   WRITE(MPRINT,'(A,I3,A)')                                       &
     &     ' ... JOB =',MTRANSLOC,': MAXIMIZE SUM DIAGIONAL'
         IF (MTRANSLOC.EQ.5 .OR. MTRANSLOC.EQ.6)                        &
     &   WRITE(MPRINT,'(A,I3,A)')                                       &
     &     ' ... JOB =',MTRANSLOC,                                      &
     &     ': MAXIMIZE PRODUCT DIAGONAL AND SCALE'
      ENDIF
      id%INFOG(23) = MTRANSLOC
      CNTL64(2) = huge(CNTL64(2))
      IRNW = 1
      IP = IRNW + NZTOT
      PLENR = IP + N + 1
      IPIW = PLENR
      IF (MTRANSLOC.EQ.1) LIWMIN = 5*N
      IF (MTRANSLOC.EQ.2) LIWMIN = 4*N
      IF (MTRANSLOC.EQ.3) LIWMIN = 10*N + NZTOT
      IF (MTRANSLOC.EQ.4) LIWMIN = 5*N
      IF (MTRANSLOC.EQ.5) LIWMIN = 5*N
      IF (MTRANSLOC.EQ.6) LIWMIN = 5*N + NZTOT
      LIW = LIWMIN
      LIWG  = LIW + (NZTOT + N + 1)
      ALLOCATE(IW(LIWG), stat=allocok)
      IF (allocok .GT. 0 ) GOTO 410
      IF (MTRANSLOC.EQ.1) THEN
       LDWMIN = N+3
      ENDIF
      IF (MTRANSLOC.EQ.2) LDWMIN = max(N+NZTOT,N+3)
      IF (MTRANSLOC.EQ.3) LDWMIN = max(NZTOT+1,N+3)
      IF (MTRANSLOC.EQ.4) LDWMIN = 2*N + max(NZTOT,N+3)
      IF (MTRANSLOC.EQ.5) LDWMIN = 3*N + NZTOT
      IF (MTRANSLOC.EQ.6) LDWMIN = 4*N + NZTOT
      LDW   = LDWMIN
      ALLOCATE(S2(LDW), stat=allocok)
      IF(MTRANSLOC .NE. 1) LDW = LDW-NZTOT
      RSPOS = NZTOT
      CSPOS = RSPOS+N
      IF (allocok .GT. 0 ) GOTO 430
      NZREAL = 0
      DO 5 J=1,N
        IW(PLENR+J-1) = 0
    5 END DO
      IF(K50 .EQ. 0) THEN
         DO 10 K=1,NZ
            I = id%IRN(K)
            J = id%JCN(K)
            IF ( (J.LE.N).AND.(J.GE.1).AND.                             &
     &           (I.LE.N).AND.(I.GE.1) ) THEN
               IW(PLENR+J-1) = IW(PLENR+J-1) + 1
               NZREAL = NZREAL + 1
            ENDIF
   10    CONTINUE
      ELSE
         ZERODIAG = 0
         NZER_DIAG = N
         RZ_DIAG = 0
         DO K=1,NZ
            I = id%IRN(K)
            J = id%JCN(K)
            IF ( (J.LE.N).AND.(J.GE.1).AND.                             &
     &           (I.LE.N).AND.(I.GE.1) ) THEN
               IW(PLENR+J-1) = IW(PLENR+J-1) + 1
               NZREAL = NZREAL + 1
               IF(I .NE. J) THEN
                  IW(PLENR+I-1) = IW(PLENR+I-1) + 1
                  NZREAL = NZREAL + 1
               ELSE
                  IF(ZERODIAG(I) .EQ. 0) THEN
                     ZERODIAG(I) = K
                     IF(associated(id%A)) THEN
                        IF(abs(id%A(K)) .EQ. dble(0.0D0)) THEN
                           RZ_DIAG = RZ_DIAG + 1
                        ENDIF
                     ENDIF
                     NZER_DIAG = NZER_DIAG - 1
                  ENDIF
               ENDIF
            ENDIF
         ENDDO
         IF(MTRANSLOC .GE. 4) THEN
            DO I =1, N
               IF(ZERODIAG(I) .EQ. 0) THEN
                  IW(PLENR+I-1) = IW(PLENR+I-1) + 1
                  NZREAL = NZREAL + 1
               ENDIF
            ENDDO
         ENDIF
      ENDIF
      IW(IP)   = 1
      DO 20 J=1,N
        IW(IP+J)   = IW(IP+J-1)+IW(PLENR+J-1)
   20 END DO
      DO 25 J=1, N
        IW(PLENR+J-1 ) = IW(IP+J-1 )
   25 END DO
      IF(K50 .EQ. 0) THEN
         IF (MTRANSLOC.EQ.1) THEN
            DO 30 K=1,NZ
               I = id%IRN(K)
               J = id%JCN(K)
               IF ( (J.LE.N).AND.(J.GE.1) .AND.                         &
     &              (I.LE.N).AND.(I.GE.1)) THEN
                  JPOS            = IW(PLENR+J-1)
                  IW(IRNW+JPOS-1) = I
                  IW(PLENR+J-1)   = IW(PLENR+J-1) + 1
              ENDIF
   30       CONTINUE
         ELSE
            IF ( .not.associated(id%A)) THEN
               INFO(1) = -22
               INFO(2) = 4
               GOTO 500
            ENDIF
            DO 35 K=1,NZ
               I = id%IRN(K)
               J = id%JCN(K)
               IF ( (J.LE.N).AND.(J.GE.1) .AND.                         &
     &              (I.LE.N).AND.(I.GE.1)) THEN
                  JPOS            = IW(PLENR+J-1)
                  IW(IRNW+JPOS-1) = I
                  S2(JPOS)         = abs(id%A(K))
                  IW(PLENR+J-1)   = IW(PLENR+J-1) + 1
               ENDIF
   35       CONTINUE
         ENDIF
      ELSE
         IF (MTRANSLOC.EQ.1) THEN
            DO K=1,NZ
               I = id%IRN(K)
               J = id%JCN(K)
               IF ( (J.LE.N).AND.(J.GE.1) .AND.                         &
     &              (I.LE.N).AND.(I.GE.1)) THEN
                  JPOS            = IW(PLENR+J-1)
                  IW(IRNW+JPOS-1) = I
                  IW(PLENR+J-1)   = IW(PLENR+J-1) + 1
                  IF(I.NE.J) THEN
                     JPOS            = IW(PLENR+I-1)
                     IW(IRNW+JPOS-1) = J
                     IW(PLENR+I-1)   = IW(PLENR+I-1) + 1
                  ENDIF
               ENDIF
            ENDDO
         ELSE
            IF ( .not.associated(id%A)) THEN
               INFO(1) = -22
               INFO(2) = 4
               GOTO 500
            ENDIF
            K = 1
            THEMIN = ZERO
            DO
               IF(THEMIN .NE. ZERO) EXIT
               THEMIN = abs(id%A(K))
               K = K+1
            ENDDO
            THEMAX = THEMIN
            DO K=1,NZ
               I = id%IRN(K)
               J = id%JCN(K)
               IF ( (J.LE.N).AND.(J.GE.1) .AND.                         &
     &              (I.LE.N).AND.(I.GE.1)) THEN
                  JPOS            = IW(PLENR+J-1)
                  IW(IRNW+JPOS-1) = I
                  S2(JPOS)         = abs(id%A(K))
                  IW(PLENR+J-1)   = IW(PLENR+J-1) + 1
                  IF(abs(id%A(K)) .GT. THEMAX) THEN
                     THEMAX = abs(id%A(K))
                  ELSE IF(abs(id%A(K)) .LT. THEMIN                      &
     &                    .AND. abs(id%A(K)).GT. ZERO) THEN
                     THEMIN = abs(id%A(K))
                  ENDIF
                  IF(I.NE.J) THEN
                     JPOS            = IW(PLENR+I-1)
                     IW(IRNW+JPOS-1) = J
                     S2(JPOS)         = abs(id%A(K))
                     IW(PLENR+I-1)   = IW(PLENR+I-1) + 1
                  ENDIF
               ENDIF
            ENDDO
            DO I =1, N
               IF(ZERODIAG(I) .EQ. 0) THEN
                  JPOS            = IW(PLENR+I-1)
                  IW(IRNW+JPOS-1) = I
                  S2(JPOS)         = ZERO
                  IW(PLENR+I-1)   = IW(PLENR+I-1) + 1
               ENDIF
            ENDDO
            CNTL64(2) = (log(THEMAX/THEMIN))*(dble(N))                  &
     &           - log(THEMIN) + ONE
         ENDIF
      ENDIF
      DUPPLI = .FALSE.
      I = NZREAL
      FLAG => id%IS1(3*N+1:4*N)
      IF(MTRANSLOC.NE.1) THEN
         CALL DAGMG_MUMPS_563(N,NZREAL,IW(IP),IW(IRNW),S2,                   &
     &        PERM,FLAG)
      ELSE
         CALL DAGMG_MUMPS_562(N,NZREAL,IW(IP),IW(IRNW),                      &
     &        PERM,FLAG)
      ENDIF
      IF(NZREAL .NE. I) DUPPLI = .TRUE.
      LS2 = NZTOT
      IF ( MTRANSLOC .EQ. 1 ) THEN
         LS2 = 1
         LDW = 1
      ENDIF
      CALL DAGMG_MUMPS_559(MTRANSLOC ,N, N, NZREAL,                          &
     &     IW(IP), IW(IRNW), S2(1), LS2,                                &
     &     NUMNZ, PERM, LIW, IW(IPIW), LDW, S2(LS2+1),                  &
     &     ICNTL64, CNTL64, INFO64)
      IF (INFO64(1).LT.0) THEN
         IF (LP.GT.0 .AND. ICNTL(4).GE.1)                               &
     &        WRITE(LP,'(A,I5)')                                        &
     &   ' INTERNAL ERROR in MAXTRANS INFO(1)=',INFO64(1)
         INFO(1) = -9964
         INFO(2) = INFO64(1)
         GO TO 500
      ENDIF
      IF (INFO64(1).GT.0) THEN
         IF (MP.GT.0 .AND. ICNTL(4).GE.2)                               &
     &        WRITE(MP,'(A,I5)')                                        &
     &        ' WARNING in MAXTRANS INFO(1)=',INFO64(1)
      ENDIF
      KER_SIZE = 0
      IF(K50 .EQ. 2) THEN
         DO I=1,N
            IF(ZERODIAG(I) .EQ. 0) THEN
               IF(PERM(I) .EQ. I) THEN
                  KER_SIZE = KER_SIZE + 1
                  PERM(I) = -I
                  STR_KER(KER_SIZE) = I
               ENDIF
            ENDIF
         ENDDO
      ENDIF
      IF (NUMNZ.LT.N) GO TO 400
      IF(KER_SIZE .GT. 0) GOTO 400
      IF(K50 .EQ. 0) THEN
         IDENT = .TRUE.
         IF (MTRANS .EQ. 0 ) GOTO 102
         DO 80 J=1,N
            JPERM = PERM(J)
            IW(PLENR+JPERM-1) = J
            IF (JPERM.NE.J) IDENT = .FALSE.
   80    CONTINUE
         IF(IDENT) THEN
            MTRANS = 0
         ELSE
            IF(MTRANS .EQ. 7) THEN
               MTRANS = -9876543
               GOTO 102
            ENDIF
            IF (PROK) WRITE(MPRINT,'(A)')                               &
     &           ' ... Apply column permutation'
            DO 100 K=1,NZ
               J = id%JCN(K)
               IF ((J.LE.0).OR.(J.GT.N)) GO TO 100
               id%JCN(K) = IW(PLENR+J-1)
  100       CONTINUE
            IF (MP.GT.0 .AND. ICNTL(4).GE.2)                            &
     &           WRITE(MP,'(/A)')                                       &
     &           ' WARNING input matrix data modified'
         ENDIF
  102    CONTINUE
         IF (SCALINGLOC) THEN
            IF ( associated(id%COLSCA))                                 &
     &           DEALLOCATE( id%COLSCA )
            IF ( associated(id%ROWSCA))                                 &
     &           DEALLOCATE( id%ROWSCA )
            ALLOCATE( id%COLSCA(N), stat=allocok)
            IF (allocok .GT.0) THEN
               id%INFO(1)=-5
               id%INFO(2)=N
               IF ((LP.GE.0).AND.(ICNTL(4).GE.1)) THEN
                  WRITE (LP,'(/A)') '** Error in DMUMPS_203'
                  WRITE (LP,'(A)')                                      &
     &                 '** Failure during allocation of COLSCA'
                  GOTO 500
               ENDIF
            ENDIF
            ALLOCATE( id%ROWSCA(N), stat=allocok)
            IF (allocok .GT.0) THEN
               id%INFO(1)=-5
               id%INFO(2)=N
               IF ((LP.GE.0).AND.(ICNTL(4).GE.1)) THEN
                  WRITE (LP,'(/A)') '** Error in DMUMPS_203'
                  WRITE (LP,'(A)')                                      &
     &                 '** Failure during allocation of ROWSCA'
                  GOTO 500
               ENDIF
            ENDIF
            id%KEEP(52) = -2
            id%KEEP(74) = 1
            MAXDBL = log(huge(MAXDBL))
            DO J=1,N
               IF(S2(RSPOS+J) .GT. MAXDBL) THEN
                  S2(RSPOS+J) = ZERO
               ENDIF
               IF(S2(CSPOS+J) .GT. MAXDBL) THEN
                  S2(CSPOS+J)= ZERO
               ENDIF
            ENDDO
            DO 105 J=1,N
               id%ROWSCA(J) = exp(S2(RSPOS+J))
               IF(id%ROWSCA(J) .EQ. ZERO) THEN
                  id%ROWSCA(J) = ONE
               ENDIF
               IF ( MTRANS .EQ.  -9876543 .OR. MTRANS.EQ. 0 ) THEN
                 id%COLSCA(J)= exp(S2(CSPOS+J))
                 IF(id%COLSCA(J) .EQ. ZERO) THEN
                   id%COLSCA(J) = ONE
                 ENDIF
               ELSE
                 id%COLSCA(IW(PLENR+J-1))= exp(S2(CSPOS+J))
                 IF(id%COLSCA(IW(PLENR+J-1)) .EQ. ZERO) THEN
                   id%COLSCA(IW(PLENR+J-1)) = ONE
                 ENDIF
               ENDIF
  105       CONTINUE
         ENDIF
      ELSE
         IDENT = .FALSE.
         IF(SCALINGLOC) THEN
            IF ( associated(id%COLSCA)) DEALLOCATE( id%COLSCA )
            IF ( associated(id%ROWSCA)) DEALLOCATE( id%ROWSCA )
            ALLOCATE( id%COLSCA(N), stat=allocok)
            IF (allocok .GT.0) THEN
               id%INFO(1)=-5
               id%INFO(2)=N
               IF ((LP.GE.0).AND.(ICNTL(4).GE.1)) THEN
                  WRITE (LP,'(/A)') '** Error in DMUMPS_203'
                  WRITE (LP,'(A)')                                      &
     &                 '** Failure during allocation of COLSCA'
                  GOTO 500
               ENDIF
            ENDIF
            ALLOCATE( id%ROWSCA(N), stat=allocok)
            IF (allocok .GT.0) THEN
               id%INFO(1)=-5
               id%INFO(2)=N
               IF ((LP.GE.0).AND.(ICNTL(4).GE.1)) THEN
                  WRITE (LP,'(/A)') '** Error in DMUMPS_203'
                  WRITE (LP,'(A)')                                      &
     &                 '** Failure during allocation of ROWSCA'
                  GOTO 500
               ENDIF
            ENDIF
            id%KEEP(52) = -2
            id%KEEP(74) = 1
            MAXDBL = log(huge(MAXDBL))
            DO J=1,N
               IF(S2(RSPOS+J)+S2(CSPOS+J) .GT. MAXDBL) THEN
                  S2(RSPOS+J) = ZERO
                  S2(CSPOS+J)= ZERO
               ENDIF
            ENDDO
            DO J=1,N
               IF(PERM(J) .GT. 0) THEN
                  id%ROWSCA(J) =                                        &
     &                 exp((S2(RSPOS+J)+S2(CSPOS+J))/TWO)
                  IF(id%ROWSCA(J) .EQ. ZERO) THEN
                     id%ROWSCA(J) = ONE
                  ENDIF
                  id%COLSCA(J)= id%ROWSCA(J)
               ENDIF
            ENDDO
            DO JPOS=1,KER_SIZE
               I = STR_KER(JPOS)
               COLNORM = ZERO
               DO J = IW(IP+I-1),IW(IP+J) - 1
                  COLNORM = max(COLNORM,S2(J))
               ENDDO
               COLNORM = exp(COLNORM)
               id%ROWSCA(I) = ONE / COLNORM
               id%COLSCA(I) = id%ROWSCA(I)
            ENDDO
         ENDIF
         IF(MTRANS .EQ. 7 .OR. id%KEEP(95) .EQ. 0) THEN
            IF( (NZER_DIAG+RZ_DIAG) .LT. (N/10)                         &
     &           .AND. id%KEEP(95) .EQ. 0) THEN
               MTRANS = 0
               id%KEEP(95) = 1
               GOTO 390
            ELSE
               IF(id%KEEP(95) .EQ. 0) THEN
                 IF(SCALINGLOC) THEN
                  id%KEEP(95) = 3
                 ELSE
                  id%KEEP(95) = 2
                 ENDIF
               ENDIF
               IF(MTRANS .EQ. 7) MTRANS = 5
            ENDIF
         ENDIF
         IF(MTRANS .EQ. 0) GOTO 390
         ICNTL_SYM_MWM = 0
         INFO_SYM_MWM = 0
         IF(MTRANS .EQ. 5 .OR. MTRANS .EQ. 6 .OR.                       &
     &        MTRANS .EQ. 7) THEN
            ICNTL_SYM_MWM(1) = 0
            ICNTL_SYM_MWM(2) = 1
         ELSE IF(MTRANS .EQ. 4) THEN
            ICNTL_SYM_MWM(1) = 2
            ICNTL_SYM_MWM(2) = 1
         ELSE
            ICNTL_SYM_MWM(1) = 0
            ICNTL_SYM_MWM(2) = 1
         ENDIF
         MARKED => id%IS1(2*N+1:3*N)
         FLAG => id%IS1(3*N+1:4*N)
         PIV_OUT => id%IS1(4*N+1:5*N)
         IF(MTRANSLOC .LT. 4) THEN
            LSC = 1
         ELSE
            LSC = 2*N
         ENDIF
         CALL DAGMG_MUMPS_551(                                               &
     &        N, NZREAL, IW(IP), IW(IRNW), S2(1),LSC, PERM, ZERODIAG,   &
     &        ICNTL_SYM_MWM, S2(LSC+1),MARKED,FLAG,                     &
     &        PIV_OUT, INFO_SYM_MWM)
         IF(INFO_SYM_MWM(1) .NE. 0) THEN
            WRITE(*,*) '** Error in DMUMPS_203'
            RETURN
         ENDIF
         IF(INFO_SYM_MWM(3) .EQ. N) THEN
            IDENT = .TRUE.
         ELSEIF( (N-INFO_SYM_MWM(4)-INFO_SYM_MWM(3)) .GT. N/10          &
     &           ) THEN
            IDENT = .TRUE.
            id%KEEP(95) = 1
         ELSE
            DO I=1,N
               PERM(I) = PIV_OUT(I)
            ENDDO
         ENDIF
         id%KEEP(93) = INFO_SYM_MWM(4)
         id%KEEP(94) = INFO_SYM_MWM(3)
         IF (IDENT) MTRANS=0
      ENDIF
  390 IF(MTRANS .EQ. 0) THEN
         id%KEEP(95) = 1
         IF (PROK) THEN
           WRITE (MPRINT,'(A)')                                         &
     &  ' ... Column permutation not used'
         ENDIF
      ENDIF
      GO TO 500
  400 IF ((LP.GE.0).AND.(ICNTL(4).GE.1))                                &
     &   WRITE (LP,'(/A)') '** Error: Matrix is structurally singular'
      INFO(1) = -6
      INFO(2) = NUMNZ
      GOTO 500
  410 IF ((LP.GE.0).AND.(ICNTL(4).GE.1)) THEN
       WRITE (LP,'(/A)') '** Error in DMUMPS_203'
       WRITE (LP,'(A,I9)')                                              &
     & '** Failure during allocation of INTEGER array of size ',        &
     & LIWG
      ENDIF
      INFO(1) = -5
      INFO(2) = LIWG
      GOTO 500
  430 IF ((LP.GE.0).AND.(ICNTL(4).GE.1)) THEN
       WRITE (LP,'(/A)') '** Error in DMUMPS_203'
       WRITE (LP,'(A)') '** Failure during allocation of S2'
      ENDIF
      INFO(1) = -5
      INFO(2) = LDW
  500 CONTINUE
      IF (allocated(IW)) DEALLOCATE(IW)
      IF (allocated(S2)) DEALLOCATE(S2)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_203
      SUBROUTINE DAGMG_MUMPS_21( N, MYID,PROCNODE, ND,                       &
     &                         SSARBR, NBSA, FRERE, FILS,               &
     &                         SLAVEF,                                  &
     &                         KEEP,KEEP8, ICNTL, INFO )
      IMPLICIT NONE
      INTEGER KEEP(500), ICNTL(40), INFO(40)
      INTEGER*8 KEEP8(150)
      INTEGER N, NBSA, SLAVEF, MYID
      INTEGER PROCNODE( N ), ND( N )
      INTEGER SSARBR( NBSA ), FRERE( N ), FILS( N )
      LOGICAL  AGMG_MUMPS_167, AGMG_MUMPS_283
      INTEGER  AGMG_MUMPS_330, AGMG_MUMPS_275, AGMG_MUMPS_497
      EXTERNAL AGMG_MUMPS_330, AGMG_MUMPS_275,                                    &
     &         AGMG_MUMPS_167, AGMG_MUMPS_283, AGMG_MUMPS_497
      INTEGER I, INODE, INODEROOT, IN, NPIV, NFRONT, NFR, NB_NIV2
      INTEGER IROOTTREE, SIZEROOT, PROCVAL, NSLAVES, KMAX
      INTEGER NNODE, ICT, TPN, MP, allocok
      LOGICAL ONE_LEVEL2
      INTEGER, ALLOCATABLE :: NUMNODE( : ), COST( : ),                  &
     &                        MEMUSED( : ), NODEMAP(:)
      MP = ICNTL(3)
      SIZEROOT  = -1
      IROOTTREE = -1
      NB_NIV2  = 0
      IF ( SLAVEF .eq. 1 ) THEN
       DO INODE = 1, N
          PROCNODE(INODE) = PROCNODE( INODE ) - SLAVEF
       END DO
      ELSE
       DO I = 1, NBSA
         INODEROOT = SSARBR( I )
         PROCNODE( INODEROOT ) = PROCNODE( INODEROOT )                  &
     &                         - SLAVEF
         INODE = INODEROOT
   30    CONTINUE
         IN = INODE
         DO WHILE ( IN .NE. 0 )
           INODE = IN
           DO WHILE ( IN .GT. 0 )
             IN = FILS( IN )
           END DO
           IF ( IN .LT. 0 ) IN = - IN
         END DO
   10    CONTINUE
         IF ( INODE .EQ. INODEROOT ) GOTO 100
         PROCNODE( INODE ) = PROCNODE( INODE ) - 2 * SLAVEF
         IN = FRERE( INODE )
         INODE = abs( IN )
         IF ( IN .LT. 0 ) THEN
             GO TO 10
         ELSE
             GO TO 30
         END IF
  100    CONTINUE
        END DO
      END IF
      ONE_LEVEL2 = .FALSE.
      DO INODE = 1, N
        IF ( FRERE( INODE ) .LT. N + 1 .AND.                            &
     &     .NOT. AGMG_MUMPS_167( INODE, PROCNODE, SLAVEF ) ) THEN
          IN = INODE
          NPIV = 0
          DO WHILE ( IN.GT.0 )
            IN = FILS( IN )
            NPIV = NPIV + 1
          END DO
          NFRONT = ND( INODE )
          IF ( (AGMG_MUMPS_283( INODE,PROCNODE,SLAVEF).AND.                  &
     &     (IN.NE.0.OR.NFRONT.NE.NPIV )) .OR. SLAVEF.EQ.1 ) GOTO 991
          IF ( NFRONT-NPIV > KEEP(9) .AND.                              &
     &         ( NPIV > KEEP(4) .OR. KEEP(45) .EQ. 0 )                  &
     &         .AND. ICNTL(40) .EQ. 0 ) THEN
            PROCNODE( INODE ) = PROCNODE( INODE ) + SLAVEF
            ONE_LEVEL2 = .TRUE.
            NB_NIV2 = NB_NIV2 + 1
          END IF
          IF ( NFRONT .EQ. NPIV ) THEN
            IF ( NFRONT .GT. SIZEROOT ) THEN
              IROOTTREE = INODE
              SIZEROOT  = NFRONT
            END IF
          END IF
        END IF
  991   CONTINUE
        IF ( ( SLAVEF .eq. 1 .OR.                                       &
     &         AGMG_MUMPS_283( INODE, PROCNODE, SLAVEF ) )                   &
     &         .AND. KEEP(53) .NE. 0 .AND.                              &
     &         FRERE( INODE ) .LT. N + 1 ) THEN
          IN = INODE
          NPIV = 0
          DO WHILE ( IN.GT.0 )
            IN = FILS( IN )
            NPIV = NPIV + 1
          END DO
          NFRONT = ND( INODE )
          IF ( NFRONT .EQ. NPIV ) THEN
            IF ( NFRONT .GT. SIZEROOT ) THEN
              IROOTTREE = INODE
              SIZEROOT  = NFRONT
            END IF
          END IF
        END IF
      END DO
      KEEP ( 56 ) = NB_NIV2
      IF ( SIZEROOT .GT. KEEP( 37 )                                     &
     &       .and. (ICNTL(13) .LE. 0 )                                  &
     &       .and. KEEP(60) .EQ. 0                                      &
     &       .and. KEEP(53) .eq. 0                                      &
     &  ) THEN
         IF ( MP .GT. 0 )                                               &
     &   WRITE( MP, * ) 'A root of estimated size ',SIZEROOT,           &
     &   ' has been selected for Scalapack'
        KEEP(38) = IROOTTREE
        PROCNODE( IROOTTREE ) = 1 + 2 * SLAVEF
      ELSE IF (KEEP(60) .EQ. 2 .OR. KEEP(60).EQ.3) THEN
        PROCNODE( KEEP(38) ) = 1 + 2 * SLAVEF
        IF ( MP .GT. 0 )                                                &
     &  WRITE( MP, * ) ' Largest root node of size ',SIZEROOT
      ELSE
        KEEP(38) = 0
        IF ( MP .GT. 0 )                                                &
     &  WRITE( MP, * ) ' Largest root node of size ',SIZEROOT
      END IF
      DO INODE = 1, N
        IF ( FRERE( INODE ) .LT. N + 1 ) THEN
          IN = FILS( INODE )
          DO WHILE ( IN > 0 )
            PROCNODE( IN ) = PROCNODE( INODE )
            IN = FILS( IN )
          END DO
        END IF
      END DO
      IF ( KEEP( 45 ) .NE. 0 ) RETURN
      NNODE = 0
      DO INODE = 1, N
        IF ( FRERE( INODE ) .LT. N + 1 ) THEN
          TPN = AGMG_MUMPS_330( INODE, PROCNODE, SLAVEF )
          IF ( TPN .NE. 3 .AND.                                         &
     &         .not. AGMG_MUMPS_283( INODE, PROCNODE, SLAVEF ) .AND.         &
     &         .not. AGMG_MUMPS_167( INODE, PROCNODE, SLAVEF ) ) THEN
               NNODE = NNODE + 1
          END IF
        END IF
      END DO
      IF ( NNODE .GT. 0 ) THEN
        ALLOCATE( NUMNODE( NNODE  ), stat = allocok )
        if (allocok .gt. 0) THEN
          INFO(1) = -7
          INFO(2) = NNODE
          RETURN
        endif
        ALLOCATE( NODEMAP( NNODE  ), stat = allocok )
        if (allocok .gt. 0) THEN
          INFO(1) = -7
          INFO(2) = NNODE
          RETURN
        endif
        ALLOCATE( COST   ( NNODE  ), stat = allocok )
        if (allocok .gt. 0) THEN
          INFO(1) = -7
          INFO(2) = NNODE
          RETURN
        endif
        ALLOCATE( MEMUSED( SLAVEF ), stat = allocok )
        if (allocok .gt. 0) THEN
          INFO(1) = -7
          INFO(2) = SLAVEF
          RETURN
        endif
        MEMUSED( 1: SLAVEF ) = 0
        ICT = 0
        DO INODE = 1, N
        IF ( FRERE( INODE ) .LT. N + 1 ) THEN
          TPN = AGMG_MUMPS_330( INODE, PROCNODE, SLAVEF )
          IF ( TPN .NE. 3 .AND.                                         &
     &       .not. AGMG_MUMPS_283( INODE, PROCNODE, SLAVEF ) .AND.           &
     &       .not. AGMG_MUMPS_167( INODE, PROCNODE, SLAVEF ) ) THEN
             ICT            = ICT + 1
             NUMNODE( ICT ) = INODE
             NFR  = ND( INODE )
             NPIV = 0
             IN   = INODE
             DO WHILE ( IN .GT. 0 )
               NPIV = NPIV + 1
               IN = FILS( IN )
             END DO
             IF ( TPN .eq. 1 ) THEN
               IF ( KEEP( 50 ) .eq. 0 ) THEN
                 COST( ICT ) = NPIV * ( 2 * NFR - NPIV )
               ELSE
                 COST( ICT ) = NPIV * NFR
               END IF
             ELSE
               KMAX  = AGMG_MUMPS_497( KEEP8(21), NFR - NPIV)
               NSLAVES     = max( min((NFR-NPIV)/KMAX, SLAVEF-1),       &
     &                            1 )
               IF ( KEEP(50) .eq. 0 ) THEN
                 COST( ICT ) = NPIV * NFR - NPIV *                      &
     &           ( ( NFR - NPIV ) / NSLAVES )
               ELSE
                 COST( ICT ) = NPIV * NPIV - NPIV *                     &
     &           ( ( NFR - NPIV ) / NSLAVES )
               END IF
             END IF
          ELSE IF ( AGMG_MUMPS_283( INODE, PROCNODE, SLAVEF ) .OR.           &
     &              AGMG_MUMPS_167( INODE, PROCNODE, SLAVEF )  ) THEN
               NFR  = ND( INODE )
               NPIV = 0
               IN   = INODE
               DO WHILE ( IN .GT. 0 )
                 NPIV = NPIV + 1
                 IN = FILS( IN )
               END DO
               IF ( KEEP( 50 ) .eq. 0 ) THEN
                 MEMUSED(1+AGMG_MUMPS_275( INODE, PROCNODE, SLAVEF))         &
     &           = MEMUSED(1+AGMG_MUMPS_275( INODE, PROCNODE, SLAVEF))       &
     &           + NPIV * ( 2 * NFR - NPIV )
               ELSE
                 MEMUSED(1+AGMG_MUMPS_275( INODE, PROCNODE, SLAVEF))         &
     &           = MEMUSED(1+AGMG_MUMPS_275( INODE, PROCNODE, SLAVEF))       &
     &           + NPIV * NFR
               END IF
          END IF
        END IF
        END DO
        CALL DAGMG_MUMPS_212( N, NNODE, NUMNODE, COST, MEMUSED,              &
     &                               PROCNODE, SLAVEF, NODEMAP )
        DO I = 1, NNODE
          INODE   = NUMNODE( I )
          PROCVAL = PROCNODE( INODE ) + ( NODEMAP( I ) - 1 )            &
     &            - AGMG_MUMPS_275( INODE, PROCNODE, SLAVEF )
          IN = INODE
          DO WHILE ( IN > 0 )
            PROCNODE( IN ) = PROCVAL
            IN = FILS( IN )
          END DO
        END DO
        DEALLOCATE( NUMNODE )
        DEALLOCATE( NODEMAP )
        DEALLOCATE( COST    )
        DEALLOCATE( MEMUSED )
      END IF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_21
      SUBROUTINE DAGMG_MUMPS_212( N, NNODE, NUMNODE, COST,                   &
     &       MEMUSED, PROCNODE, SLAVEF, NODEMAP )
      IMPLICIT NONE
      INTEGER N, NNODE, SLAVEF
      INTEGER PROCNODE( N )
      INTEGER NUMNODE( NNODE ), COST( NNODE ), NODEMAP( NNODE )
      INTEGER MEMUSED( SLAVEF )
      INTEGER IMAXLOAD, IMINLOAD, IPROC, INODE
      CALL DAGMG_MUMPS_149                                                   &
     &       ( MEMUSED, SLAVEF, IMINLOAD, IMAXLOAD )
      CALL DAGMG_MUMPS_260( NNODE, NUMNODE, COST )
      DO INODE = 1, NNODE
        IF ( COST( INODE ) > 0 ) THEN
          IPROC = IMINLOAD
        ELSE
          IPROC = IMAXLOAD
        END IF
        MEMUSED( IPROC ) = MEMUSED( IPROC ) + COST( INODE )
        NODEMAP( INODE ) = IPROC
        CALL DAGMG_MUMPS_149                                                 &
     &       ( MEMUSED, SLAVEF, IMINLOAD, IMAXLOAD )
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_212
      SUBROUTINE DAGMG_MUMPS_149                                             &
     &           ( MEMUSED, SLAVEF, IMINLOAD, IMAXLOAD )
      INTEGER SLAVEF, IMINLOAD, IMAXLOAD
      INTEGER MEMUSED( SLAVEF )
      INTEGER MINLOAD, MAXLOAD, IPROC
      MINLOAD = MEMUSED( 1 )
      MAXLOAD = MEMUSED( 1 )
      IMINLOAD = 1
      IMAXLOAD = 1
      DO IPROC = 2, SLAVEF
        IF ( MEMUSED( IPROC ) .GT. MAXLOAD ) THEN
          MAXLOAD  = MEMUSED( IPROC )
          IMAXLOAD = IPROC
        END IF
        IF ( MEMUSED( IPROC ) .LT. MINLOAD ) THEN
          MINLOAD  = MEMUSED( IPROC )
          IMINLOAD = IPROC
        END IF
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_149
      SUBROUTINE DAGMG_MUMPS_260( NNODE, NUMNODE, COST )
      IMPLICIT NONE
      INTEGER NNODE
      INTEGER NUMNODE( NNODE ), COST( NNODE )
      LOGICAL FIN
      INTEGER I, LOC_COST, LOC_NUM
      FIN = .FALSE.
      DO WHILE ( .NOT. FIN )
        FIN = .TRUE.
        DO I = 1, NNODE - 1
          IF ( abs( COST( I ) ) .LT. abs( COST( I + 1 ) ) ) THEN
            LOC_COST      = COST( I )
            COST( I )     = COST( I + 1 )
            COST( I + 1 ) = LOC_COST
            LOC_NUM          = NUMNODE( I )
            NUMNODE( I )     = NUMNODE( I + 1 )
            NUMNODE( I + 1 ) = LOC_NUM
            FIN = .FALSE.
          END IF
        END DO
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_260
      SUBROUTINE DAGMG_MUMPS_100                                             &
     &( MYID, COMM, KEEP,KEEP8, INFO, INFOG, RINFO, RINFOG, ICNTL )
      IMPLICIT NONE
      INTEGER COMM, MYID, KEEP(500), INFO(40), ICNTL(40), INFOG(40)
      INTEGER*8 KEEP8(150)
      DOUBLE PRECISION RINFO(20), RINFOG(20)
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      INTEGER MASTER, IERR_MPI, MPG
      PARAMETER( MASTER = 0 )
      MPG = ICNTL(3)
      IF ( MYID.eq.MASTER.and.MPG.GT.0) THEN
       WRITE(MPG, 99992) INFO(1), INFO(2),                              &
     &  KEEP8(109), KEEP8(111), INFOG(4),                               &
     &  INFOG(5), KEEP(28), INFOG(32), INFOG(7), KEEP(23), ICNTL(7),    &
     &  KEEP(12), KEEP(56), KEEP(61), RINFOG(1)
       IF (KEEP(95).GT.1)                                               &
     &                    WRITE(MPG, 99993) KEEP(95)
       IF (KEEP(54).GT.0) WRITE(MPG, 99994) KEEP(54)
       IF (KEEP(60).GT.0) WRITE(MPG, 99995) KEEP(60)
      ENDIF
      RETURN
99992 FORMAT(/'Leaving analysis phase with  ...'/                       &
     &       'INFOG(1)                                       =',I16/    &
     &       'INFOG(2)                                       =',I16/    &
     &       ' -- (20) Number of entries in factors (estim.) =',I16/    &
     &       ' --  (3) Storage of factors  (REAL, estimated) =',I16/    &
     &       ' --  (4) Storage of factors  (INT , estimated) =',I16/    &
     &       ' --  (5) Maximum frontal size      (estimated) =',I16/    &
     &       ' --  (6) Number of nodes in the tree           =',I16/    &
     &       ' -- (32) Type of analysis effectively used     =',I16/    &
     &       ' --  (7) Ordering option effectively used      =',I16/    &
     &       'ICNTL(6) Maximum transversal option            =',I16/    &
     &       'ICNTL(7) Pivot order option                    =',I16/    &
     &       'Percentage of memory relaxation (effective)    =',I16/    &
     &       'Number of level 2 nodes                        =',I16/    &
     &       'Number of split nodes                          =',I16/    &
     &   'RINFOG(1) Operations during elimination (estim)=  ',1PD10.3)
99993 FORMAT('Ordering compressed/constrained (ICNTL(12))    =',I16)
99994 FORMAT('Distributed matrix entry format (ICNTL(18))    =',I16)
99995 FORMAT('Effective Schur option (ICNTL(19))             =',I16)
      END SUBROUTINE DAGMG_MUMPS_100
      SUBROUTINE DAGMG_MUMPS_97                                              &
     &           ( N, FRERE, FILS, NFSIZ, NSTEPS, NSLAVES,              &
     &             KEEP, KEEP8, SPLITROOT, MP, LDIAG, INFO1, INFO2 )
      IMPLICIT NONE
      INTEGER N, NSTEPS, NSLAVES, KEEP(500)
      INTEGER*8 KEEP8(150)
      INTEGER FRERE( N ), FILS( N ), NFSIZ( N )
      LOGICAL SPLITROOT
      INTEGER MP, LDIAG
      INTEGER INFO1, INFO2
      INTEGER, DIMENSION(:), ALLOCATABLE :: IPOOL
      INTEGER INODE, DEPTH, I, IBEG, IEND, IIPOOL, NROOT
      INTEGER MAX_DEPTH, ISON, TOT_CUT, MAX_CUT, STRAT
      INTEGER(8) :: K79
      INTEGER NFRONT, K82, allocok
      K79  = KEEP8(79)
      K82  = abs(KEEP(82))
      STRAT=KEEP(62)
      IF (KEEP(210).EQ.1) THEN
        MAX_DEPTH = 2*NSLAVES*K82
        STRAT     = STRAT/4
      ELSE
        IF (( NSLAVES .eq. 1 ).AND. (.NOT. SPLITROOT) ) RETURN
        MAX_DEPTH = int( log( dble( NSLAVES - 1 ) )                     &
     &                 / log(2.0D0) )
      ENDIF
      ALLOCATE(IPOOL(NSTEPS+1), stat=allocok)
      IF (allocok.GT.0) THEN
        INFO1= -7
        INFO2= NSTEPS+1
        RETURN
      ENDIF
      NROOT = 0
      DO INODE = 1, N
        IF ( FRERE(INODE) .eq. 0 ) THEN
          NROOT = NROOT + 1
          IPOOL( NROOT ) = INODE
        END IF
      END DO
      IBEG = 1
      IEND = NROOT
      IIPOOL   = NROOT + 1
      IF (SPLITROOT) MAX_DEPTH=1
      DO DEPTH = 1, MAX_DEPTH
        DO I = IBEG, IEND
          INODE = IPOOL( I )
          ISON = INODE
          DO WHILE ( ISON .GT. 0 )
            ISON = FILS( ISON )
          END DO
          ISON = - ISON
          DO WHILE ( ISON .GT. 0 )
            IPOOL( IIPOOL ) = ISON
            IIPOOL = IIPOOL + 1
            ISON = FRERE( ISON )
          END DO
        END DO
        IPOOL( IBEG ) = -IPOOL( IBEG )
        IBEG = IEND + 1
        IEND = IIPOOL - 1
      END DO
      IPOOL( IBEG ) = -IPOOL( IBEG )
      TOT_CUT = 0
      IF (SPLITROOT) THEN
        MAX_CUT = NROOT*max(K82,2)
        INODE = abs(IPOOL(1))
        NFRONT = NFSIZ( INODE )
        K79 = max(                                                      &
     &         int(NFRONT,8)*int(NFRONT,8)/(int(K82+1,8)*int(K82+1,8)), &
     &         1_8)
      ELSE
         MAX_CUT = 2 * NSLAVES
         IF (KEEP(210).EQ.1) THEN
            MAX_CUT = 4 * (MAX_CUT + 4)
         ENDIF
      ENDIF
      DEPTH   = -1
      DO I = 1, IIPOOL - 1
        INODE = IPOOL( I )
        IF ( INODE .LT. 0 ) THEN
          INODE = -INODE
          DEPTH = DEPTH + 1
        END IF
        CALL DAGMG_MUMPS_313                                                 &
     &           ( INODE, N, FRERE, FILS, NFSIZ, NSTEPS, NSLAVES,       &
     &             KEEP,KEEP8, TOT_CUT, STRAT, DEPTH,                   &
     &             K79, SPLITROOT, MP, LDIAG )
        IF ( TOT_CUT > MAX_CUT )  EXIT
      END DO
      KEEP(61) = TOT_CUT
      DEALLOCATE(IPOOL)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_97
      RECURSIVE SUBROUTINE DAGMG_MUMPS_313                                   &
     & ( INODE, N, FRERE, FILS, NFSIZ, NSTEPS, NSLAVES, KEEP,KEEP8,     &
     &   TOT_CUT, STRAT, DEPTH, K79, SPLITROOT, MP, LDIAG )
      IMPLICIT NONE
      INTEGER(8) :: K79
      INTEGER INODE, N, NSTEPS, NSLAVES, KEEP(500), STRAT,              &
     &        DEPTH, TOT_CUT, MP, LDIAG
      INTEGER*8 KEEP8(150)
      INTEGER FRERE( N ), FILS( N ), NFSIZ( N )
      LOGICAL SPLITROOT
      INTEGER I, IN, NPIV, NFRONT, NSLAVES_ESTIM
      DOUBLE PRECISION WK_SLAVE, WK_MASTER
      INTEGER INODE_SON, INODE_FATH, IN_SON, IN_FATH, IN_GRANDFATH
      INTEGER NPIV_SON, NPIV_FATH, MAX_CUT
      INTEGER NCB, KAVERAGE, NSLAVESMIN, NSLAVESMAX
      INTEGER  AGMG_MUMPS_50,                                                &
     &         AGMG_MUMPS_52
      EXTERNAL  AGMG_MUMPS_50,                                               &
     &         AGMG_MUMPS_52
      IF  ( (KEEP(210).EQ.1.AND.KEEP(60).EQ.0) .OR.                     &
     &       (SPLITROOT) ) THEN
        IF ( FRERE ( INODE ) .eq. 0 ) THEN
          NFRONT = NFSIZ( INODE )
          NPIV = NFRONT
          NCB = 0
          IF (int(NFRONT,8)*int(NFRONT,8).GT.K79) THEN
           GOTO 333
          ELSE IF ( (SPLITROOT).AND.                                    &
     &      (MP.GT.0 .AND. LDIAG.GE.2)) THEN
             WRITE(MP,'(A,I11)')                                        &
     &        ' Order of root node after splitting : ',                 &
     &        NFRONT
          ENDIF
        ENDIF
      ENDIF
      IF ( FRERE ( INODE ) .eq. 0 ) RETURN
      NFRONT = NFSIZ( INODE )
      IN = INODE
      NPIV = 0
      DO WHILE( IN > 0 )
        IN = FILS( IN )
        NPIV = NPIV + 1
      END DO
      NCB = NFRONT - NPIV
      IF ( (NFRONT - (NPIV/2)) .LE. KEEP(9)) RETURN
      IF ((KEEP(50) == 0.and.int(NFRONT,8) * int(NPIV,8) > K79 ) .OR.   &
     &(KEEP(50) .NE.0.and.int(NPIV,8) * int(NPIV,8) > K79 )) GOTO 333
      IF (KEEP(210).EQ.1) THEN
        NSLAVESMIN    = 1
        NSLAVESMAX    = 64
        NSLAVES_ESTIM = 32+NSLAVES
      ELSE
        NSLAVESMIN = AGMG_MUMPS_50                                           &
     &         ( NSLAVES, KEEP(48), KEEP8(21), KEEP(50),                &
     &         NFRONT, NCB)
        NSLAVESMAX = AGMG_MUMPS_52                                           &
     &        ( NSLAVES, KEEP(48), KEEP8(21), KEEP(50),                 &
     &          NFRONT, NCB)
        NSLAVES_ESTIM = max (1,                                         &
     &   nint( dble(NSLAVESMAX-NSLAVESMIN)/dble(3) )                    &
     &                    )
        NSLAVES_ESTIM = min (NSLAVES_ESTIM, NSLAVES-1)
      ENDIF
      IF ( KEEP(50) .eq. 0 ) THEN
       WK_MASTER = 0.6667D0 *                                           &
     &                dble(NPIV)*dble(NPIV)*dble(NPIV) +                &
     &                dble(NPIV)*dble(NPIV)*dble(NCB)
       WK_SLAVE  = dble( NPIV ) * dble( NCB ) *                         &
     &         ( 2.0D0 * dble(NFRONT) - dble(NPIV) )                    &
     &         / dble(NSLAVES_ESTIM)
      ELSE
       WK_MASTER = dble(NPIV)*dble(NPIV)*dble(NPIV) / dble(3)
       WK_SLAVE  =                                                      &
     &           (dble(NPIV)*dble(NCB)*dble(NFRONT))                    &
     &           / dble(NSLAVES_ESTIM)
      ENDIF
      IF (KEEP(210).EQ.1) THEN
        IF ( dble( 100 + STRAT )                                        &
     &        * WK_SLAVE / dble(100) .GE. WK_MASTER ) RETURN
      ELSE
        IF ( dble( 100 + STRAT * max( DEPTH-1, 1 ) )                    &
     &        * WK_SLAVE / dble(100) .GE. WK_MASTER ) RETURN
      ENDIF
  333 CONTINUE
      IF (NPIV .LE. 1 ) RETURN
       NSTEPS  = NSTEPS + 1
       TOT_CUT = TOT_CUT + 1
       NPIV_SON  = max(NPIV/2,1)
       NPIV_FATH = NPIV - NPIV_SON
       INODE_SON = INODE
       IN_SON = INODE
       DO I = 1, NPIV_SON - 1
         IN_SON = FILS( IN_SON )
       END DO
       INODE_FATH = FILS( IN_SON )
       IF ( INODE_FATH .LT. 0 ) THEN
       write(*,*) 'Error: INODE_FATH < 0 ', INODE_FATH
       END IF
       IN_FATH = INODE_FATH
       DO WHILE ( FILS( IN_FATH ) > 0 )
         IN_FATH = FILS( IN_FATH )
       END DO
       FRERE( INODE_FATH ) = FRERE( INODE_SON )
       FRERE( INODE_SON  ) = - INODE_FATH
       FILS ( IN_SON     ) = FILS( IN_FATH )
       FILS ( IN_FATH    ) = - INODE_SON
       IN = FRERE( INODE_FATH )
       DO WHILE ( IN > 0 )
           IN = FRERE( IN )
       END DO
       IF ( IN .eq. 0 )  GO TO 10
       IN = -IN
       DO WHILE ( FILS( IN ) > 0 )
           IN = FILS( IN )
       END DO
       IN_GRANDFATH = IN
       IF ( FILS( IN_GRANDFATH ) .eq. - INODE_SON ) THEN
           FILS( IN_GRANDFATH ) = -INODE_FATH
       ELSE
           IN = IN_GRANDFATH
           IN = - FILS ( IN )
           DO WHILE ( FRERE( IN ) > 0 )
             IF ( FRERE( IN ) .eq. INODE_SON ) THEN
               FRERE( IN ) = INODE_FATH
               GOTO 10
             END IF
             IN = FRERE( IN )
           END DO
           WRITE(*,*) 'ERROR 2 in SPLIT NODE',                          &
     &          IN_GRANDFATH, IN, FRERE(IN)
       END IF
   10  CONTINUE
       NFSIZ(INODE_SON) = NFRONT
       NFSIZ(INODE_FATH) = NFRONT - NPIV_SON
       KEEP(2) = max( KEEP(2), NFRONT - NPIV_SON )
      CALL DAGMG_MUMPS_313                                                   &
     &  ( INODE_FATH, N, FRERE, FILS, NFSIZ, NSTEPS,                    &
     &   NSLAVES, KEEP,KEEP8, TOT_CUT, STRAT, DEPTH,                    &
     &   K79, SPLITROOT, MP, LDIAG )
      IF (.NOT. SPLITROOT) THEN
        CALL DAGMG_MUMPS_313                                                 &
     &   ( INODE_SON, N, FRERE, FILS, NFSIZ, NSTEPS,                    &
     &   NSLAVES, KEEP,KEEP8, TOT_CUT, STRAT, DEPTH,                    &
     &   K79, SPLITROOT, MP, LDIAG )
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_313
      SUBROUTINE DAGMG_MUMPS_351                                             &
     & (N,NZ, IRN, ICN, IW, LW, IPE, LEN,                               &
     & IQ, FLAG, IWFR,                                                  &
     & NRORM, NIORM, IFLAG,IERROR, ICNTL,                               &
     & symmetry, SYM, MedDens, NBQD, AvgDens)
      INTEGER N,NZ,LW,IFLAG,IERROR,NRORM,NIORM,IWFR
      INTEGER symmetry, SYM
      INTEGER MedDens, NBQD, AvgDens
      INTEGER ICNTL(40)
      INTEGER  IRN(NZ), ICN(NZ)
      INTEGER LEN(N)
      INTEGER IPE(N+1)
      INTEGER FLAG(N), IW(LW)
      INTEGER IQ(N)
      INTEGER MP, MPG
      INTEGER I,K,J,N1,LAST,NDUP,K1,K2,L
      INTEGER NBERR, THRESH
      INTEGER NZOFFA, NDIAGA
      DOUBLE PRECISION RSYM
      INTRINSIC nint
      MP = ICNTL(2)
      MPG= ICNTL(3)
      NIORM  = 3*N
      NDIAGA = 0
      IERROR = 0
      DO 10 I=1,N
        IPE(I) = 0
   10 END DO
      DO 50 K=1,NZ
        I = IRN(K)
        J = ICN(K)
        IF ((I.GT.N).OR.(J.GT.N).OR.(I.LT.1)                            &
     &                          .OR.(J.LT.1)) THEN
           IERROR = IERROR + 1
        ELSE
          IF (I.NE.J) THEN
           IPE(I) = IPE(I) + 1
           IPE(J) = IPE(J) + 1
           NIORM  = NIORM + 1
          ELSE
           NDIAGA = NDIAGA + 1
          ENDIF
        ENDIF
   50 END DO
      NZOFFA  = NIORM - 3*N
      IF (IERROR.GE.1) THEN
         NBERR  = 0
         IF (mod(IFLAG,2) .EQ. 0) IFLAG = IFLAG+1
         IF ((MP.GT.0).AND.(ICNTL(4).GE.2))  THEN
          WRITE (MP,99999)
          DO 70 K=1,NZ
           I = IRN(K)
           J = ICN(K)
           IF ((I.GT.N).OR.(J.GT.N).OR.(I.LT.1)                         &
     &                            .OR.(J.LT.1)) THEN
            NBERR = NBERR + 1
            IF (NBERR.LE.10)  THEN
               IF (mod(K,10).GT.3 .OR. mod(K,10).EQ.0 .OR.              &
     &             (10.LE.K .AND. K.LE.20)) THEN
                 WRITE (MP,'(I8,A,I8,A,I8,A)')                          &
     &             K,'th entry (in row',I,' and column',J,') ignored'
               ELSE
                 IF (mod(K,10).EQ.1) WRITE(MP,'(I8,A,I8,A,I8,A)')       &
     &             K,'st entry (in row',I,' and column',J,') ignored'
                 IF (mod(K,10).EQ.2) WRITE(MP,'(I8,A,I8,A,I8,A)')       &
     &             K,'nd entry (in row',I,' and column',J,') ignored'
                 IF (mod(K,10).EQ.3) WRITE(MP,'(I8,A,I8,A,I8,A)')       &
     &             K,'rd entry (in row',I,' and column',J,') ignored'
               ENDIF
            ELSE
               GO TO 100
            ENDIF
           ENDIF
   70     CONTINUE
         ENDIF
      ENDIF
  100 NRORM = NIORM - 2*N
      IQ(1) = 1
      N1 = N - 1
      IF (N1.GT.0) THEN
        DO 110 I=1,N1
            IQ(I+1) = IPE(I) + IQ(I)
  110   CONTINUE
      ENDIF
      LAST = max(IPE(N)+IQ(N)-1,IQ(N))
      FLAG(1:N) = 0
      IPE(1:N)  = IQ(1:N)
      IW(1:LAST) = 0
      IWFR = LAST + 1
      DO 200 K=1,NZ
         I = IRN(K)
         J = ICN(K)
         IF (I.NE.J) THEN
          IF (I.LT.J) THEN
            IF ((I.GE.1).AND.(J.LE.N)) THEN
             IW(IQ(I)) = -J
             IQ(I)     = IQ(I) + 1
            ENDIF
          ELSE
            IF ((J.GE.1).AND.(I.LE.N)) THEN
             IW(IQ(J)) = -I
             IQ(J)     = IQ(J) + 1
            ENDIF
          ENDIF
         ENDIF
  200 END DO
      NDUP = 0
      DO 260 I=1,N
        K1 = IPE(I)
        K2 = IQ(I) -1
        IF (K1.GT.K2) THEN
         LEN(I) = 0
         IQ(I)  = 0
        ELSE
         DO 240 K=K1,K2
           J     = -IW(K)
           IF (J.LE.0) GO TO 250
           L     = IQ(J)
           IQ(J) = L + 1
           IF (FLAG(J).EQ.I) THEN
            NDUP = NDUP + 1
            IW(L) = 0
            IW(K) = 0
           ELSE
            IW(L)   = I
            IW(K)   = J
            FLAG(J) = I
           ENDIF
  240    CONTINUE
  250    IQ(I) = IQ(I) - IPE(I)
         IF (NDUP.EQ.0) LEN(I) = IQ(I)
        ENDIF
  260 END DO
      IF (NDUP.NE.0) THEN
       IWFR = 1
       DO 280 I=1,N
         IF (IQ(I).EQ.0) THEN
             LEN(I) = 0
            IPE(I) = IWFR
            GOTO 280
         ENDIF
         K1 = IPE(I)
         K2 = K1 + IQ(I) - 1
         L = IWFR
         IPE(I) = IWFR
         DO 270 K=K1,K2
           IF (IW(K).NE.0) THEN
            IW(IWFR) = IW(K)
            IWFR     = IWFR + 1
           ENDIF
  270    CONTINUE
         LEN(I) = IWFR - L
  280  CONTINUE
      ENDIF
      IPE(N+1) = IPE(N) + LEN(N)
      IWFR = IPE(N+1)
      IF (SYM.EQ.0) THEN
      RSYM =  dble(NDIAGA+2*NZOFFA - (IWFR-1))/                         &
     &            dble(NZOFFA+NDIAGA)
      symmetry = nint (100.0D0*RSYM)
         IF (MPG .GT. 0)                                                &
     &  write(MPG,'(A,I5)')                                             &
     &  ' ... Structural symmetry (in percent)=', symmetry
        IF (MP.GT.0 .AND. MPG.NE.MP)                                    &
     &  write(MP,'(A,I5)')                                              &
     &  ' ... Structural symmetry (in percent)=', symmetry
      ELSE
       symmetry = 100
      ENDIF
      AvgDens = nint(dble(IWFR-1)/dble(N))
      THRESH  = AvgDens*50 - AvgDens/10 + 1
      NBQD    = 0
      IF (N.GT.2) THEN
        IQ(1:N) = 0
        DO I= 1, N
          K = max(LEN(I),1)
          IQ(K) = IQ(K) + 1
          IF (K.GT.THRESH) NBQD = NBQD+1
        ENDDO
        K = 0
        MedDens = 0
        DO WHILE (K .LT. (N/2))
         MedDens = MedDens + 1
         K       = K+IQ(MedDens)
        ENDDO
      ELSE
        MedDens = AvgDens
      ENDIF
         IF (MPG .GT. 0)                                                &
     &  write(MPG,'(A,3I5)')                                            &
     &  ' Density: NBdense, Average, Median   =',                       &
     &  NBQD, AvgDens, MedDens
        IF (MP.GT.0 .AND. MPG.NE.MP)                                    &
     &  write(MP,'(A,3I5)')                                             &
     &  ' Density: NBdense, Average, Median   =',                       &
     &  NBQD, AvgDens, MedDens
      RETURN
99999 FORMAT (/'*** Warning message from analysis routine ***')
      END SUBROUTINE DAGMG_MUMPS_351
      SUBROUTINE DAGMG_MUMPS_701(N, SYM, NPROCS, IORD,                       &
     &                       symmetry,MedDens, NBQD, AvgDens,           &
     &                       PROK, MP)
      IMPLICIT NONE
      INTEGER, intent(in)    :: N, NPROCS, SYM
      INTEGER, intent(in)    :: symmetry,MedDens, NBQD, AvgDens, MP
      LOGICAL, intent(in)    :: PROK
      INTEGER, intent(inout)   :: IORD
      INTEGER MAXQD
      PARAMETER (MAXQD=2)
      INTEGER SMALLSYM, SMALLUNS
      PARAMETER (SMALLUNS=5000, SMALLSYM=10000)
      IF ( IORD .EQ. 5 ) THEN
        IF (PROK) WRITE(MP,*)                                           &
     &  'WARNING: METIS not available. Ordering set to default.'
        IORD = 7
      END IF
      IF ( IORD .EQ. 4 ) THEN
        IF (PROK) WRITE(MP,*)                                           &
     &  'WARNING: PORD not available. Ordering set to default.'
        IORD = 7
      END IF
      IF ( IORD .EQ. 3 ) THEN
        IF (PROK) WRITE(MP,*)                                           &
     &  'WARNING: SCOTCH not available. Ordering set to default.'
        IORD = 7
      END IF
      IF (IORD.EQ.7) THEN
        IF (SYM.NE.0) THEN
          IF ( N.LE.SMALLSYM ) THEN
             IF (NBQD.GE.MAXQD) THEN
               IORD = 6
             ELSE
               IORD = 2
             ENDIF
          ELSE
             IF (NBQD.GE.MedDens*NPROCS) THEN
               IORD = 6
               RETURN
             ENDIF
               IORD = 6
          ENDIF
        ELSE
          IF ( N.LE.SMALLUNS ) THEN
            IF (NBQD.GE.MAXQD) THEN
              IORD = 6
            ELSE
              IORD = 2
            ENDIF
          ELSE
            IF (NBQD.GE.MedDens*NPROCS) THEN
              IORD = 6
              RETURN
            ENDIF
              IORD = 6
          ENDIF
        ENDIF
      ENDIF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_701
      SUBROUTINE DAGMG_MUMPS_510                                             &
     &     (KEEP821, KEEP2, KEEP48 ,KEEP50, NSLAVES)
      IMPLICIT NONE
      INTEGER NSLAVES, KEEP2, KEEP48, KEEP50
      INTEGER (8) :: KEEP821
      INTEGER(8) KEEP2_SQUARE, NSLAVES8
      NSLAVES8= int(NSLAVES,8)
      KEEP2_SQUARE = int(KEEP2,8) * int(KEEP2,8)
      KEEP821 = max(KEEP821*int(KEEP2,8),1_8)
      KEEP821 = min(2000000_8, KEEP821)
      IF (NSLAVES.GT.64) THEN
         KEEP821 =                                                      &
     &        min(6_8*KEEP2_SQUARE/NSLAVES8+1_8, KEEP821)
      ELSE
         KEEP821 =                                                      &
     &        min(4_8*KEEP2_SQUARE/NSLAVES8+1_8, KEEP821)
      ENDIF
         IF (KEEP50 .EQ. 0 ) THEN
            KEEP821 = max(KEEP821,(7_8*KEEP2_SQUARE /                   &
     &          4_8 / int(max(NSLAVES-1,1),8)) + int(KEEP2,8))
         ELSE
            KEEP821 = max(KEEP821,(7_8*KEEP2_SQUARE /                   &
     &          4_8 / int(max(NSLAVES-1,1),8)) + int(KEEP2,8))
         ENDIF
      IF (KEEP50 .EQ. 0 ) THEN
         KEEP821 = max(KEEP821,300000_8)
      ELSE
         KEEP821 = max(KEEP821,80000_8)
      ENDIF
      KEEP821 = -KEEP821
      RETURN
      END SUBROUTINE DAGMG_MUMPS_510
      SUBROUTINE DAGMG_MUMPS_559(JOB,M,N,NE,                                 &
     &     IP,IRN,A,LA,NUM,PERM,LIW,IW,LDW,DW,                          &
     &     ICNTL,CNTL,INFO)
      IMPLICIT NONE
      INTEGER NICNTL, NCNTL, NINFO
      PARAMETER (NICNTL=10, NCNTL=10, NINFO=10)
      INTEGER JOB,M,N,NE,NUM,LIW,LDW
      INTEGER IP(N+1),IRN(NE),PERM(M),IW(LIW)
      INTEGER ICNTL(NICNTL),INFO(NINFO)
      INTEGER LA
      DOUBLE PRECISION A(LA)
      DOUBLE PRECISION DW(LDW),CNTL(NCNTL)
      INTEGER I,J,K,WARN1,WARN2,WARN4
      DOUBLE PRECISION FACT,ZERO,ONE,RINF,RINF2,RINF3
      PARAMETER (ZERO=0.0D+00,ONE=1.0D+0)
      EXTERNAL DAGMG_MUMPS_457,DAGMG_MUMPS_444,DAGMG_MUMPS_451,                        &
     &         DAGMG_MUMPS_452,DAGMG_MUMPS_454
      INTRINSIC abs,log
      RINF = CNTL(2)
      RINF2 = huge(RINF2)/dble(2*N)
      RINF3 = 0.0D0
      WARN1 = 0
      WARN2 = 0
      WARN4 = 0
      IF (JOB.LT.1 .OR. JOB.GT.6) THEN
         INFO(1) = -1
         INFO(2) = JOB
         IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9001) INFO(1),'JOB',JOB
         GO TO 99
      ENDIF
      IF (M.LT.1 .OR. M.LT.N) THEN
         INFO(1) = -2
         INFO(2) = M
         IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9001) INFO(1),'M',M
         GO TO 99
      ENDIF
      IF (N.LT.1) THEN
         INFO(1) = -2
         INFO(2) = N
         IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9001) INFO(1),'N',N
         GO TO 99
      ENDIF
      IF (NE.LT.1) THEN
         INFO(1) = -3
         INFO(2) = NE
         IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9001) INFO(1),'NE',NE
         GO TO 99
      ENDIF
      IF (JOB.EQ.1) K = 4*N +   M
      IF (JOB.EQ.2) K = 2*N + 2*M
      IF (JOB.EQ.3) K = 8*N + 2*M + NE
      IF (JOB.EQ.4) K = 3*N + 2*M
      IF (JOB.EQ.5) K = 3*N + 2*M
      IF (JOB.EQ.6) K = 3*N + 2*M + NE
      IF (LIW.LT.K) THEN
         INFO(1) = -4
         INFO(2) = K
         IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9004) INFO(1),K
         GO TO 99
      ENDIF
      IF (JOB.GT.1) THEN
         IF (JOB.EQ.2) K =       M
         IF (JOB.EQ.3) K = 1
         IF (JOB.EQ.4) K =     2*M
         IF (JOB.EQ.5) K = N + 2*M
         IF (JOB.EQ.6) K = N + 3*M
         IF (LDW.LT.K) THEN
            INFO(1) = -5
            INFO(2) = K
            IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9005) INFO(1),K
            GO TO 99
         ENDIF
      ENDIF
      IF (ICNTL(5).EQ.0) THEN
         DO 3 I = 1,M
            IW(I) = 0
    3    CONTINUE
         DO 6 J = 1,N
            DO 4 K = IP(J),IP(J+1)-1
               I = IRN(K)
               IF (I.LT.1 .OR. I.GT.M) THEN
                  INFO(1) = -6
                  INFO(2) = J
                  IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9006) INFO(1),J,I
                  GO TO 99
               ENDIF
               IF (IW(I).EQ.J) THEN
                  INFO(1) = -7
                  INFO(2) = J
                  IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9007) INFO(1),J,I
                  GO TO 99
               ELSE
                  IW(I) = J
               ENDIF
    4       CONTINUE
    6    CONTINUE
      ENDIF
      IF (ICNTL(3).GE.0) THEN
         IF (ICNTL(4).EQ.0 .OR. ICNTL(4).EQ.1) THEN
            WRITE(ICNTL(3),9020) JOB,M,N,NE
            IF (ICNTL(4).EQ.0) THEN
               WRITE(ICNTL(3),9021) (IP(J),J=1,min(10,N+1))
               WRITE(ICNTL(3),9022) (IRN(J),J=1,min(10,NE))
               IF (JOB.GT.1) WRITE(ICNTL(3),9023) (A(J),J=1,min(10,NE))
            ELSEIF (ICNTL(4).EQ.1) THEN
               WRITE(ICNTL(3),9021) (IP(J),J=1,N+1)
               WRITE(ICNTL(3),9022) (IRN(J),J=1,NE)
               IF (JOB.GT.1) WRITE(ICNTL(3),9023) (A(J),J=1,NE)
            ENDIF
            WRITE(ICNTL(3),9024) (ICNTL(J),J=1,NICNTL)
            WRITE(ICNTL(3),9025) (CNTL(J),J=1,NCNTL)
         ENDIF
      ENDIF
      DO 8 I=1,NINFO
         INFO(I) = 0
    8 END DO
      IF (JOB.EQ.1) THEN
         DO 10 J = 1,N
            IW(J) = IP(J+1) - IP(J)
   10    CONTINUE
         CALL DAGMG_MUMPS_457(M,N,IRN,NE,IP,IW(1),PERM,NUM,                  &
     &        IW(N+1),IW(2*N+1),IW(3*N+1),IW(3*N+M+1))
         GO TO 90
      ENDIF
      IF (JOB.EQ.2) THEN
         DW(1) = max(ZERO,CNTL(1))
         CALL DAGMG_MUMPS_444(M,N,NE,IP,IRN,A,PERM,NUM,                      &
     &        IW(1),IW(N+1),IW(2*N+1),IW(2*N+M+1),DW,RINF2)
         GO TO 90
      ENDIF
      IF (JOB.EQ.3) THEN
         DO 20 K = 1,NE
            IW(K) = IRN(K)
   20    CONTINUE
         CALL DAGMG_MUMPS_451(N,NE,IP,IW,A)
         FACT = max(ZERO,CNTL(1))
         CALL DAGMG_MUMPS_452(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1),           &
     &        IW(NE+N+1),IW(NE+2*N+1),IW(NE+3*N+1),IW(NE+4*N+1),        &
     &        IW(NE+5*N+1),IW(NE+5*N+M+1),FACT,RINF2)
         GO TO 90
      ENDIF
      IF (JOB.EQ.4) THEN
         DO 50 J = 1,N
            FACT = ZERO
            DO 30 K = IP(J),IP(J+1)-1
               IF (abs(A(K)).GT.FACT) FACT = abs(A(K))
   30       CONTINUE
            IF(FACT .GT. RINF3) RINF3 = FACT
            DO 40 K = IP(J),IP(J+1)-1
               A(K) = FACT - abs(A(K))
   40       CONTINUE
   50    CONTINUE
         DW(1) = max(ZERO,CNTL(1))
         DW(2) = RINF3
         IW(1) = JOB
         CALL DAGMG_MUMPS_454(M,N,NE,IP,IRN,A,PERM,NUM,                      &
     &        IW(1),IW(N+1),IW(2*N+1),IW(3*N+1),IW(3*N+M+1),            &
     &        DW(1),DW(M+1),RINF2)
         GO TO 90
      ENDIF
      IF (JOB.EQ.5 .or. JOB.EQ.6) THEN
         RINF3=ONE
         IF (JOB.EQ.5) THEN
            DO 75 J = 1,N
               FACT = ZERO
               DO 60 K = IP(J),IP(J+1)-1
                  IF (A(K).GT.FACT) FACT = A(K)
   60          CONTINUE
               DW(2*M+J) = FACT
               IF (FACT.NE.ZERO) THEN
                  FACT = log(FACT)
                  IF(FACT .GT. RINF3) RINF3=FACT
                  DO 70 K = IP(J),IP(J+1)-1
                     IF (A(K).NE.ZERO) THEN
                        A(K) = FACT - log(A(K))
                        IF(A(K) .GT. RINF3) RINF3=A(K)
                     ELSE
                        A(K) = FACT + RINF
                     ENDIF
   70             CONTINUE
               ELSE
                  DO 71 K = IP(J),IP(J+1)-1
                     A(K) = ONE
   71             CONTINUE
               ENDIF
   75       CONTINUE
         ENDIF
         IF (JOB.EQ.6) THEN
            DO 175 K = 1,NE
               IW(3*N+2*M+K) = IRN(K)
  175       CONTINUE
            DO 61 I = 1,M
               DW(2*M+N+I) = ZERO
   61       CONTINUE
            DO 63 J = 1,N
               DO 62 K = IP(J),IP(J+1)-1
                  I = IRN(K)
                  IF (A(K).GT.DW(2*M+N+I)) THEN
                     DW(2*M+N+I) = A(K)
                  ENDIF
   62          CONTINUE
   63       CONTINUE
            DO 64 I = 1,M
               IF (DW(2*M+N+I).NE.ZERO) THEN
                  DW(2*M+N+I) = 1.0D0/DW(2*M+N+I)
               ENDIF
   64       CONTINUE
            DO 66 J = 1,N
               DO 65 K = IP(J),IP(J+1)-1
                  I = IRN(K)
                  A(K) = DW(2*M+N+I) * A(K)
   65          CONTINUE
   66       CONTINUE
            CALL DAGMG_MUMPS_451(N,NE,IP,IW(3*N+2*M+1),A)
            DO 176 J = 1,N
               IF (IP(J).NE.IP(J+1)) THEN
                  FACT = A(IP(J))
               ELSE
                  FACT = ZERO
               ENDIF
               DW(2*M+J) = FACT
               IF (FACT.NE.ZERO) THEN
                  FACT = log(FACT)
                  DO 170 K = IP(J),IP(J+1)-1
                     IF (A(K).NE.ZERO) THEN
                        A(K) = FACT - log(A(K))
                        IF(A(K) .GT. RINF3) RINF3=A(K)
                     ELSE
                        A(K) = FACT + RINF
                     ENDIF
  170             CONTINUE
               ELSE
                  DO 171 K = IP(J),IP(J+1)-1
                     A(K) = ONE
  171             CONTINUE
               ENDIF
  176       CONTINUE
         ENDIF
         DW(1) = max(ZERO,CNTL(1))
         RINF3 = RINF3+ONE
         DW(2) = RINF3
         IW(1) = JOB
         IF (JOB.EQ.5) THEN
            CALL DAGMG_MUMPS_454(M,N,NE,IP,IRN,A,PERM,NUM,                   &
     &           IW(1),IW(N+1),IW(2*N+1),IW(3*N+1),IW(3*N+M+1),         &
     &           DW(1),DW(M+1),RINF2)
         ENDIF
         IF (JOB.EQ.6) THEN
            CALL DAGMG_MUMPS_454(M,N,NE,IP,IW(3*N+2*M+1),A,PERM,NUM,         &
     &           IW(1),IW(N+1),IW(2*N+1),IW(3*N+1),IW(3*N+M+1),         &
     &           DW(1),DW(M+1),RINF2)
         ENDIF
         IF (JOB.EQ.6) THEN
            DO 79 I = 1,M
               IF (DW(2*M+N+I).NE.0.0D0) THEN
                  DW(I) = DW(I) + log(DW(2*M+N+I))
               ENDIF
   79       CONTINUE
         ENDIF
         IF (NUM.EQ.N) THEN
            DO 80 J = 1,N
               IF (DW(2*M+J).NE.ZERO) THEN
                  DW(M+J) = DW(M+J) - log(DW(2*M+J))
               ELSE
                  DW(M+J) = ZERO
               ENDIF
   80       CONTINUE
         ENDIF
         FACT = 0.5D0*log(RINF2)
         DO 86 I = 1,M
            IF (DW(I).LT.FACT) GO TO 86
            WARN2 = 2
            GO TO 90
   86    CONTINUE
         DO 87 J = 1,N
            IF (DW(M+J).LT.FACT) GO TO 87
            WARN2 = 2
            GO TO 90
   87    CONTINUE
      ENDIF
   90 IF (NUM.LT.N) WARN1 = 1
      IF (JOB.EQ.4 .OR. JOB.EQ.5 .OR. JOB.EQ.6) THEN
         IF (CNTL(1).LT.ZERO) WARN4 = 4
      ENDIF
      IF (INFO(1).EQ.0) THEN
         INFO(1) = WARN1 + WARN2 + WARN4
         IF (INFO(1).GT.0 .AND. ICNTL(2).GT.0) THEN
            WRITE(ICNTL(2),9010) INFO(1)
            IF (WARN1.EQ.1) WRITE(ICNTL(2),9011)
            IF (WARN2.EQ.2) WRITE(ICNTL(2),9012)
            IF (WARN4.EQ.4) WRITE(ICNTL(2),9014)
         ENDIF
      ENDIF
      IF (ICNTL(3).GE.0) THEN
         IF (ICNTL(4).EQ.0 .OR. ICNTL(4).EQ.1) THEN
            WRITE(ICNTL(3),9030) (INFO(J),J=1,2)
            WRITE(ICNTL(3),9031) NUM
            IF (ICNTL(4).EQ.0) THEN
               WRITE(ICNTL(3),9032) (PERM(J),J=1,min(10,M))
               IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                  WRITE(ICNTL(3),9033) (DW(J),J=1,min(10,M))
                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,min(10,N))
               ENDIF
            ELSEIF (ICNTL(4).EQ.1) THEN
               WRITE(ICNTL(3),9032) (PERM(J),J=1,M)
               IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                  WRITE(ICNTL(3),9033) (DW(J),J=1,M)
                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,N)
               ENDIF
            ENDIF
         ENDIF
      ENDIF
   99 RETURN
 9001 FORMAT (' ****** Error in DMUMPS_443. INFO(1) = ',I2,             &
     &     ' because ',(A),' = ',I10)
 9004 FORMAT (' ****** Error in DMUMPS_443. INFO(1) = ',I2/             &
     &     '        LIW too small, must be at least ',I8)
 9005 FORMAT (' ****** Error in DMUMPS_443. INFO(1) = ',I2/             &
     &     '        LDW too small, must be at least ',I8)
 9006 FORMAT (' ****** Error in DMUMPS_443. INFO(1) = ',I2/             &
     &     '        Column ',I8,                                        &
     &     ' contains an entry with invalid row index ',I8)
 9007 FORMAT (' ****** Error in DMUMPS_443. INFO(1) = ',I2/             &
     &     '        Column ',I8,                                        &
     &     ' contains two or more entries with row index ',I8)
 9008 FORMAT (' ****** Error in DMUMPS_443. INFO(1) = ',I2/             &
     &     '        CNTL(2) is negative or zero.')
 9010 FORMAT (' ****** Warning from DMUMPS_443. INFO(1) = ',I2)
 9011 FORMAT ('        - The matrix is structurally singular.')
 9012 FORMAT ('        - Some scaling factors may be too large.')
 9014 FORMAT ('        - CNTL(1) is negative and was treated as zero.')
 9020 FORMAT (' ****** Input parameters for DMUMPS_443:'/               &
     &     ' JOB =',I10/' M   =',I10/' N   =',I10/' NE  =',I10)
 9021 FORMAT (' IP(1:N+1)   = ',8I8/(15X,8I8))
 9022 FORMAT (' IRN(1:NE)   = ',8I8/(15X,8I8))
 9023 FORMAT (' A(1:NE)     = ',4(1PD14.4)/(15X,4(1PD14.4)))
 9024 FORMAT (' ICNTL(1:10) = ',8I8/(15X,2I8))
 9025 FORMAT (' CNTL(1:10)  = ',4(1PD14.4)/(15X,4(1PD14.4)))
 9030 FORMAT (' ****** Output parameters for DMUMPS_443:'/              &
     &     ' INFO(1:2)   = ',2I8)
 9031 FORMAT (' NUM         = ',I8)
 9032 FORMAT (' PERM(1:M)   = ',8I8/(15X,8I8))
 9033 FORMAT (' DW(1:M)     = ',5(F11.3)/(15X,5(F11.3)))
 9034 FORMAT (' DW(M+1:M+N) = ',5(F11.3)/(15X,5(F11.3)))
      END SUBROUTINE DAGMG_MUMPS_559
      SUBROUTINE DAGMG_MUMPS_563(N,NZ,IP,IRN,A,FLAG,POSI)
      IMPLICIT NONE
      INTEGER N,NZ
      INTEGER IP(N+1),IRN(NZ)
      DOUBLE PRECISION A(NZ)
      INTEGER WR_POS,BEG_COL,ROW,COL,K,SV_POS
      INTEGER FLAG(N), POSI(N)
      INTEGER ierr
      FLAG = 0
      WR_POS = 1
      DO COL=1,N
         BEG_COL = WR_POS
         DO K=IP(COL),IP(COL+1)-1
            ROW = IRN(K)
            IF(FLAG(ROW) .NE. COL) THEN
               IRN(WR_POS) = ROW
               A(WR_POS) = A(K)
               FLAG(ROW) = COL
               POSI(ROW) = WR_POS
               WR_POS = WR_POS+1
            ELSE
               SV_POS = POSI(ROW)
               A(SV_POS) = A(SV_POS) + A(K)
            ENDIF
         ENDDO
         IP(COL) = BEG_COL
      ENDDO
      IP(N+1) = WR_POS
      NZ = WR_POS-1
      RETURN
      END SUBROUTINE DAGMG_MUMPS_563
      SUBROUTINE DAGMG_MUMPS_562(N,NZ,IP,IRN,FLAG,POSI)
      IMPLICIT NONE
      INTEGER N,NZ
      INTEGER IP(N+1),IRN(NZ)
      INTEGER WR_POS,BEG_COL,ROW,COL,K,SV_POS
      INTEGER FLAG(N), POSI(N)
      INTEGER ierr
      FLAG = 0
      WR_POS = 1
      DO COL=1,N
         BEG_COL = WR_POS
         DO K=IP(COL),IP(COL+1)-1
            ROW = IRN(K)
            IF(FLAG(ROW) .NE. COL) THEN
               IRN(WR_POS) = ROW
               FLAG(ROW) = COL
               POSI(ROW) = WR_POS
               WR_POS = WR_POS+1
            ENDIF
         ENDDO
         IP(COL) = BEG_COL
      ENDDO
      IP(N+1) = WR_POS
      NZ = WR_POS-1
      RETURN
      END SUBROUTINE DAGMG_MUMPS_562
      SUBROUTINE DAGMG_MUMPS_181( N, POOL, NSTK,                             &
     &          PERM, FILS,                                             &
     &          DAD_STEPS, STEP, NSTEPS)
      IMPLICIT NONE
      INTEGER, INTENT(IN)  ::  N, NSTEPS
      INTEGER, INTENT(IN)  ::  FILS( N )
      INTEGER, INTENT(IN)  ::  DAD_STEPS ( NSTEPS ), STEP ( N )
      INTEGER, INTENT(INOUT) :: POOL(N), NSTK(N)
      INTEGER, INTENT(OUT) ::  PERM( N )
      INTEGER  :: IPERM, INODE, IN, I
      INTEGER  :: INBLEAF, INBROOT
      IF (N.GT.1) THEN
         IF(POOL(N-1) .LT. 0) THEN
            INBLEAF = N-1
            INBROOT = POOL(N)
            POOL(N-1) = -POOL(N-1)-1
         ELSE IF ((POOL(N-1) .GT. 0) .AND.                              &
     &           (POOL(N) .LT. 0)) THEN
            INBLEAF = N
            INBROOT = N
            POOL(N) = -POOL(N)-1
         ELSE
            INBLEAF = POOL(N-1)
            INBROOT = POOL(N)
         END IF
      END IF
      IPERM = 1
      DO WHILE ( INBLEAF .NE. 0 )
        INODE = POOL( INBLEAF )
        INBLEAF = INBLEAF - 1
        IN = INODE
        DO WHILE ( IN .GT. 0 )
          PERM ( IN ) = IPERM
          IPERM = IPERM + 1
          IN = FILS( IN )
        END DO
        IN = DAD_STEPS(STEP( INODE ))
        IF ( IN .eq. 0 ) THEN
          INBROOT = INBROOT - 1
        ELSE
          NSTK( IN ) = NSTK( IN ) - 1
          IF ( NSTK( IN ) .eq. 0 ) THEN
            INBLEAF = INBLEAF + 1
            POOL( INBLEAF ) = IN
          END IF
        END IF
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_181
      SUBROUTINE DAGMG_MUMPS_746( ID, PTRAR )
      USE DAGMG_MUMPS_STRUC_DF
      IMPLICIT NONE
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      TYPE(DAGMG_MUMPS_STRUC), INTENT(IN), TARGET :: ID
      INTEGER, TARGET          :: PTRAR(ID%N,2)
      INTEGER          :: I, IERR
      INTEGER          :: IOLD, K, JOLD, INEW, JNEW, ISHIFT, INZ
      INTEGER, POINTER :: IIRN(:), IJCN(:), IWORK1(:), IWORK2(:)
      LOGICAL          :: IDO, PARANAL
      PARANAL = .TRUE.
      IF (PARANAL) THEN
         IF(ID%KEEP(54) .EQ. 3) THEN
            IIRN => ID%IRN_LOC
            IJCN => ID%JCN_LOC
            INZ  =  ID%NZ_LOC
            IWORK1 => PTRAR(1:ID%N,2)
            allocate(IWORK2(ID%N))
            IDO = .TRUE.
         ELSE
            IIRN => ID%IRN
            IJCN => ID%JCN
            INZ  =  ID%NZ
            IWORK1 => PTRAR(1:ID%N,1)
            IWORK2 => PTRAR(1:ID%N,2)
            IDO = ID%MYID .EQ. 0
         END IF
      ELSE
         IIRN => ID%IRN
         IJCN => ID%JCN
         INZ  =  ID%NZ
         IWORK1 => PTRAR(1:ID%N,1)
         IWORK2 => PTRAR(1:ID%N,2)
         IDO = ID%MYID .EQ. 0
      END IF
      DO 50 IOLD=1,ID%N
         IWORK1(IOLD) = 0
         IWORK2(IOLD) = 0
   50 END DO
      IF(IDO) THEN
         DO 70 K=1,INZ
            IOLD = IIRN(K)
            JOLD = IJCN(K)
            IF ( (IOLD.GT.ID%N).OR.(JOLD.GT.ID%N).OR.(IOLD.LT.1)        &
     &           .OR.(JOLD.LT.1) ) GOTO 70
            IF (IOLD.NE.JOLD) THEN
               INEW = ID%SYM_PERM(IOLD)
               JNEW = ID%SYM_PERM(JOLD)
               IF ( ID%KEEP( 50 ) .EQ. 0 ) THEN
                  IF (INEW.LT.JNEW) THEN
                     IWORK2(IOLD) = IWORK2(IOLD) + 1
                  ELSE
                     IWORK1(JOLD) = IWORK1(JOLD) + 1
                  ENDIF
               ELSE
                  IF ( INEW .LT. JNEW ) THEN
                     IWORK1( IOLD ) = IWORK1( IOLD ) + 1
                  ELSE
                     IWORK1( JOLD ) = IWORK1( JOLD ) + 1
                  END IF
               ENDIF
            ENDIF
   70    CONTINUE
      END IF
      IF(PARANAL .AND. (ID%KEEP(54) .EQ. 3) ) THEN
         CALL AGMG_COPY(IWORK1, PTRAR(:,1), ID%N, AGMG_MPF_INTEGER, IERR )
         CALL AGMG_COPY(IWORK2, PTRAR(:,2), ID%N, AGMG_MPF_INTEGER, IERR )
         deallocate(IWORK2)
      ELSE
         CALL AGMG_SETIERR( IERR )
      END IF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_746
      MODULE DAGMG_MUMPS_PLL_ANAL
      USE DAGMG_MUMPS_STRUC_DF
      USE TOOLS_COMM
!
      INTEGER AGMG_MPF_2DOUBLE_PRECISION
      INTEGER AGMG_MPF_2INTEGER
      INTEGER AGMG_MPF_2REAL
      INTEGER AGMG_MPF_ANY_SOURCE
      INTEGER AGMG_MPF_ANY_TAG
      INTEGER AGMG_MPF_BYTE
      INTEGER AGMG_MPF_CHARACTER
      INTEGER AGMG_MPF_COMM_NULL
      INTEGER AGMG_MPF_COMM_WORLD
      INTEGER AGMG_MPF_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_COMPLEX
      INTEGER AGMG_MPF_DOUBLE_PRECISION
      INTEGER AGMG_MPF_INTEGER
      INTEGER AGMG_MPF_LOGICAL
      INTEGER AGMG_MPF_MAX
      INTEGER AGMG_MPF_MAX_PROCESSOR_NAME
      INTEGER AGMG_MPF_MAXLOC
      INTEGER AGMG_MPF_MIN
      INTEGER AGMG_MPF_MINLOC
      INTEGER AGMG_MPF_PACKED
      INTEGER AGMG_MPF_PROD
      INTEGER AGMG_MPF_REAL
      INTEGER AGMG_MPF_REPLACE
      INTEGER AGMG_MPF_REQUEST_NULL
      INTEGER AGMG_MPF_SOURCE
      INTEGER AGMG_MPF_STATUS_SIZE
      INTEGER AGMG_MPF_SUM
      INTEGER AGMG_MPF_TAG
      INTEGER AGMG_MPF_UNDEFINED
      INTEGER AGMG_MPF_WTIME_IS_GLOBAL
      INTEGER AGMG_MPF_LOR
      INTEGER AGMG_MPF_LAND
      INTEGER AGMG_MPF_INTEGER8
      INTEGER AGMG_MPF_REAL8
      INTEGER AGMG_MPF_BSEND_OVERHEAD
      PARAMETER (AGMG_MPF_2DOUBLE_PRECISION=1)
      PARAMETER (AGMG_MPF_2INTEGER=2)
      PARAMETER (AGMG_MPF_2REAL=3)
      PARAMETER (AGMG_MPF_ANY_SOURCE=4)
      PARAMETER (AGMG_MPF_ANY_TAG=5)
      PARAMETER (AGMG_MPF_BYTE=6)
      PARAMETER (AGMG_MPF_CHARACTER=7)
      PARAMETER (AGMG_MPF_COMM_NULL=8)
      PARAMETER (AGMG_MPF_COMM_WORLD=9)
      PARAMETER (AGMG_MPF_COMPLEX=10)
      PARAMETER (AGMG_MPF_DOUBLE_COMPLEX=11)
      PARAMETER (AGMG_MPF_DOUBLE_PRECISION=12)
      PARAMETER (AGMG_MPF_INTEGER=13)
      PARAMETER (AGMG_MPF_LOGICAL=14)
      PARAMETER (AGMG_MPF_MAX=15)
      PARAMETER (AGMG_MPF_MAX_PROCESSOR_NAME=31)
      PARAMETER (AGMG_MPF_MAXLOC=16)
      PARAMETER (AGMG_MPF_MIN=17)
      PARAMETER (AGMG_MPF_MINLOC=18)
      PARAMETER (AGMG_MPF_PACKED=19)
      PARAMETER (AGMG_MPF_PROD=20)
      PARAMETER (AGMG_MPF_REAL=21)
      PARAMETER (AGMG_MPF_REPLACE=22)
      PARAMETER (AGMG_MPF_REQUEST_NULL=23)
      PARAMETER (AGMG_MPF_SOURCE=1)
      PARAMETER (AGMG_MPF_STATUS_SIZE=2)
      PARAMETER (AGMG_MPF_SUM=26)
      PARAMETER (AGMG_MPF_TAG=2)
      PARAMETER (AGMG_MPF_UNDEFINED=28)
      PARAMETER (AGMG_MPF_WTIME_IS_GLOBAL=30)
      PARAMETER (AGMG_MPF_LOR=31)
      PARAMETER (AGMG_MPF_LAND=32)
      PARAMETER (AGMG_MPF_INTEGER8=33)
      PARAMETER (AGMG_MPF_REAL8=34)
      PARAMETER (AGMG_MPF_BSEND_OVERHEAD=0)
      DOUBLE PRECISION AGMG_MPF_WTIME
      EXTERNAL AGMG_MPF_WTIME
      INTERFACE AGMG_COPY
      SUBROUTINE AGMG_COPY_INTEGER( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_INTEGER
      SUBROUTINE AGMG_COPY_INTEGER1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R(N)
      END SUBROUTINE AGMG_COPY_INTEGER1
      SUBROUTINE AGMG_COPY_INTEGER11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S,R
      END SUBROUTINE AGMG_COPY_INTEGER11
      SUBROUTINE AGMG_COPY_INTEGER1_81( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER(8) :: S
      INTEGER:: R
      END SUBROUTINE AGMG_COPY_INTEGER1_81
      SUBROUTINE AGMG_COPY_INTEGER10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      INTEGER :: S(N),R
      END SUBROUTINE AGMG_COPY_INTEGER10
      SUBROUTINE AGMG_COPY_INTEGER21( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N(*), DATATYPE, IERR
      INTEGER :: S(N(1),1),R(N(1))
      END SUBROUTINE AGMG_COPY_INTEGER21
      SUBROUTINE AGMG_COPY_REAL( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_REAL
      SUBROUTINE AGMG_COPY_REAL1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R(N)
      END SUBROUTINE AGMG_COPY_REAL1
      SUBROUTINE AGMG_COPY_REAL11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S,R
      END SUBROUTINE AGMG_COPY_REAL11
      SUBROUTINE AGMG_COPY_REAL10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      REAL :: S(N),R
      END SUBROUTINE AGMG_COPY_REAL10
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION1
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION11
      SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE PRECISION :: S(N),R
      END SUBROUTINE AGMG_COPY_DOUBLE_PRECISION10
      SUBROUTINE AGMG_COPY_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_COMPLEX
      SUBROUTINE AGMG_COPY_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_COMPLEX1
      SUBROUTINE AGMG_COPY_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_COMPLEX11
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S(*),R(*)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R(N)
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX1
      SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11( S, R, N, DATATYPE, IERR )
      IMPLICIT NONE
      INTEGER :: N, DATATYPE, IERR
      DOUBLE COMPLEX :: S,R
      END SUBROUTINE AGMG_COPY_DOUBLE_COMPLEX11
      END INTERFACE
      PUBLIC DAGMG_MUMPS_715
      INTERFACE DAGMG_MUMPS_715
      MODULE PROCEDURE DAGMG_MUMPS_715
      END INTERFACE
      PRIVATE
      TYPE ORD_TYPE
      INTEGER           :: CBLKNBR, N
      INTEGER, POINTER  :: PERMTAB(:) => null()
      INTEGER, POINTER  :: PERITAB(:) => null()
      INTEGER, POINTER  :: RANGTAB(:) => null()
      INTEGER, POINTER  :: TREETAB(:) => null()
      INTEGER, POINTER  :: BROTHER(:) => null()
      INTEGER, POINTER  :: SON(:) => null()
      INTEGER, POINTER  :: NW(:) => null()
      INTEGER, POINTER  :: FIRST(:) => null()
      INTEGER, POINTER  :: LAST(:) => null()
      INTEGER, POINTER  :: TOPNODES(:) => null()
      INTEGER           :: COMM, COMM_NODES, NPROCS, NSLAVES, MYID
      INTEGER           :: TOPSTRAT, SUBSTRAT, ORDTOOL, TOPVARS
      LOGICAL           :: IDO
      END TYPE ORD_TYPE
      TYPE GRAPH_TYPE
      INTEGER           :: NZ_LOC, N, COMM
      INTEGER, POINTER  :: IRN_LOC(:) => null()
      INTEGER, POINTER  :: JCN_LOC(:) => null()
      END TYPE GRAPH_TYPE
      TYPE ARRPNT
      INTEGER, POINTER :: BUF(:) => null()
      END TYPE ARRPNT
      INTEGER :: MEMCNT, MAXMEM, MP, MPG, LP, NRL, TOPROWS
      LOGICAL :: PROK, PROKG
      CONTAINS
      SUBROUTINE DAGMG_MUMPS_715(id, WORK1, WORK2, NFSIZ, FILS,              &
     &     FRERE)
      USE DAGMG_MUMPS_STRUC_DF
      IMPLICIT NONE
      TYPE(DAGMG_MUMPS_STRUC)   :: id
      INTEGER, POINTER     :: WORK1(:), WORK2(:),                       &
     &     NFSIZ(:), FILS(:), FRERE(:)
      TYPE(ORD_TYPE)       :: ord
      INTEGER, POINTER     :: IPE(:), NV(:),                            &
     &     NE(:), NA(:), NODE(:),                                       &
     &     ND(:), SUBORD(:), NAMALG(:),                                 &
     &     IPS(:), CUMUL(:),                                            &
     &     SAVEIRN(:), SAVEJCN(:)
      INTEGER              :: MYID, NPROCS, IERR, NEMIN, LDIAG
      LOGICAL              :: SPLITROOT
      INTEGER(8), PARAMETER :: K79REF=12000000_8
      nullify(IPE, NV, NE, NA, NODE, ND, SUBORD, NAMALG, IPS,           &
     &     CUMUL, SAVEIRN, SAVEJCN)
      CALL AGMG_SETIERR2( MYID, IERR)
      CALL AGMG_SETIERR12( NPROCS, IERR)
      LP    = id%ICNTL(1)
      MP    = id%ICNTL(2)
      MPG   = id%ICNTL(3)
      PROK  = (MP.GT.0)
      PROKG = (MPG.GT.0) .AND. (MYID .EQ. 0)
      LDIAG = id%ICNTL(4)
      ord%PERMTAB => WORK1(1        : id%N)
      ord%PERITAB => WORK1(id%N+1   : 2*id%N)
      ord%TREETAB => WORK1(2*id%N+1 : 3*id%N)
      IF(id%KEEP(54) .NE. 3) THEN
         IF(MYID.EQ.0) THEN
            SAVEIRN    => id%IRN_LOC
            SAVEJCN    => id%JCN_LOC
            id%IRN_LOC => id%IRN
            id%JCN_LOC => id%JCN
            id%NZ_LOC  =  id%NZ
         ELSE
            id%NZ_LOC = 0
         END IF
      END IF
      MAXMEM=0
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      CALL DAGMG_MUMPS_716(id, ord)
      id%INFOG(7) = id%KEEP(245)
      CALL AGMG_MUMPS_276( id%ICNTL, id%INFO,                                &
     &     id%COMM, id%MYID )
      IF ( id%INFO(1) .LT. 0 ) RETURN
      CALL DAGMG_MUMPS_717(id, ord, WORK2)
      CALL AGMG_MUMPS_276( id%ICNTL, id%INFO,                                &
     &     id%COMM, id%MYID )
      IF ( id%INFO(1) .LT. 0 ) RETURN
      IF(id%MYID .EQ. 0) THEN
         CALL AGMG_MUMPS_733(IPE, id%N, id%INFO, LP, FORCE=.FALSE.,          &
     &        COPY=.FALSE., STRING='',                                  &
     &        MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(NV, id%N, id%INFO, LP,                          &
     &        MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      END IF
      ord%SUBSTRAT = 0
      ord%TOPSTRAT = 0
      CALL DAGMG_MUMPS_720(id, ord, IPE, NV, WORK2)
      IF(id%KEEP(54) .NE. 3) THEN
         IF(MYID.EQ.0) THEN
            id%IRN_LOC => SAVEIRN
            id%JCN_LOC => SAVEJCN
         END IF
      END IF
      CALL AGMG_MUMPS_276( id%ICNTL, id%INFO,                                &
     &     id%COMM, id%MYID )
      IF ( id%INFO(1) .LT. 0 ) RETURN
      NULLIFY(ord%PERMTAB)
      NULLIFY(ord%PERITAB)
      NULLIFY(ord%TREETAB)
      CALL AGMG_MUMPS_734(ord%FIRST, ord%LAST, MEMCNT=MEMCNT)
      IF (MYID .EQ. 0) THEN
         IPS => WORK1(1:id%N)
         NE     => WORK1(id%N+1   : 2*id%N)
         NA     => WORK1(2*id%N+1 : 3*id%N)
         NODE   => WORK2(1        : id%N  )
         ND     => WORK2(id%N+1   : 2*id%N)
         SUBORD => WORK2(2*id%N+1 : 3*id%N)
         NAMALG => WORK2(3*id%N+1 : 4*id%N)
      CALL AGMG_MUMPS_733(CUMUL, id%N, id%INFO, LP,                          &
     &     STRING='CUMUL', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
         NEMIN  = id%KEEP(1)
         CALL DAGMG_MUMPS_557(id%N, IPE, NV, IPS, NE, NA, NFSIZ, NODE,       &
     &        id%INFOG(6), FILS, FRERE, ND, NEMIN, SUBORD, id%KEEP(60), &
     &        id%KEEP(20),id%KEEP(38), NAMALG, id%KEEP(104), CUMUL,     &
     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%NSLAVES,       &
     &        id%KEEP(250).EQ.1)
         CALL AGMG_MUMPS_734(CUMUL, NV, IPE, MEMCNT=MEMCNT)
         CALL DAGMG_MUMPS_201(NE, ND, id%INFOG(6), id%INFOG(5),              &
     &        id%KEEP(2), id%KEEP(50), id%KEEP(101), id%KEEP(108),      &
     &        id%KEEP(5), id%KEEP(6), id%KEEP(226))
         IF ( id%KEEP(53) .NE. 0 ) THEN
            CALL AGMG_MUMPS_209(id%N, FRERE, FILS, NFSIZ, id%KEEP(20))
         END IF
         IF (  (id%KEEP(48) == 4 .AND. id%KEEP8(21).GT.0_8)             &
     &        .OR.                                                      &
     &        (id%KEEP (48)==5 .AND. id%KEEP8(21) .GT. 0_8 )            &
     &        .OR.                                                      &
     &        (id%KEEP(24).NE.0.AND.id%KEEP8(21).GT.0_8) ) THEN
            CALL DAGMG_MUMPS_510(id%KEEP8(21), id%KEEP(2),                   &
     &           id%KEEP(48), id%KEEP(50), id%NSLAVES)
         END IF
         IF ((id%KEEP(210).LT.0) .OR. (id%KEEP(210).GT.2))              &
     &        id%KEEP(210)=0
         IF ((id%KEEP(210).EQ.0) .AND. (id%KEEP(201).GT.0))             &
     &        id%KEEP(210)=1
         IF ((id%KEEP(210).EQ.0) .AND. (id%KEEP(201).EQ.0))             &
     &        id%KEEP(210)=2
         IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
         IF ((id%KEEP(210).EQ.1) .AND. (id%KEEP8(79).LE.0_8)) THEN
            IF ( huge(id%KEEP8(79)) / K79REF + 1_8 .GE.                 &
     &                                 int(id%NSLAVES,8) ) THEN
               id%KEEP8(79)=huge(id%KEEP8(79))
            ELSE
               id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
            ENDIF
         ENDIF
         IF (id%KEEP(210).EQ.1) THEN
            SPLITROOT = .FALSE.
            IF ( id%KEEP(62).GE.1) THEN
               CALL DAGMG_MUMPS_97(id%N, FRERE, FILS, NFSIZ,                 &
     &              id%INFOG(6),                                        &
     &              id%NSLAVES, id%KEEP,id%KEEP8, SPLITROOT,            &
     &              MP, LDIAG, id%INFOG(1), id%INFOG(2))
               IF (id%INFOG(1).LT.0) RETURN
            ENDIF
         ENDIF
         SPLITROOT = (((id%ICNTL(13).GT.0) .AND.                        &
     &        (id%NSLAVES.GT.id%ICNTL(13))) .OR.                        &
     &        (id%ICNTL(13).EQ.-1)) .AND. (id%KEEP(60).EQ.0)
         IF (SPLITROOT) THEN
            CALL DAGMG_MUMPS_97(id%N, FRERE, FILS, NFSIZ, id%INFOG(6),       &
     &           id%NSLAVES, id%KEEP, id%KEEP8, SPLITROOT,              &
     &           MP, LDIAG, id%INFOG(1), id%INFOG(2))
            IF (id%INFOG(1).LT.0) RETURN
         ENDIF
      END IF
!     $     associated(NE), associated(NA), associated(NODE),
!     $     associated(ND), associated(SUBORD), associated(NAMALG),
!     $     associated(IPS), associated(CUMUL)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_715
      SUBROUTINE DAGMG_MUMPS_716(id, ord)
      TYPE(DAGMG_MUMPS_STRUC)  :: id
      TYPE(ORD_TYPE)      :: ord
      INTEGER  :: IERR, I, COLOR, BASE
      LOGICAL  :: IDO
      IF(id%MYID .EQ. 0) id%KEEP(245) = id%ICNTL(29)
      CALL AGMG_SETIERR( IERR )
      IF ((id%KEEP(245) .LT. 0) .OR. (id%KEEP(245) .GT. 2)) THEN
         id%KEEP(245) = 0
      END IF
      IF (id%KEEP(245) .EQ. 0) THEN
         id%INFO(1)  = -38
         id%INFOG(1) = -38
         IF(id%MYID .EQ.0 ) THEN
            WRITE(LP,                                                   &
     &           '("No parallel ordering tools available.")')
            WRITE(LP,                                                   &
     &           '("Please install PT-SCOTCH or ParMETIS.")')
         END IF
         RETURN
      ELSE IF (id%KEEP(245) .EQ. 1) THEN
         id%INFOG(1) = -38
         id%INFO(1)  = -38
         IF(id%MYID .EQ.0 ) WRITE(LP,                                   &
     &        '("PT-SCOTCH not available.")')
         RETURN
      ELSE IF (id%KEEP(245) .EQ. 2) THEN
         id%INFOG(1) = -38
         id%INFO(1)  = -38
         IF(id%MYID .EQ.0 ) WRITE(LP,                                   &
     &        '("ParMETIS not available.")')
         RETURN
      END IF
      END SUBROUTINE DAGMG_MUMPS_716
      SUBROUTINE DAGMG_MUMPS_717(id, ord, WORK)
      IMPLICIT NONE
      TYPE(DAGMG_MUMPS_STRUC)            :: id
      TYPE(ORD_TYPE)                :: ord
      INTEGER, POINTER              :: WORK(:)
      IF (ord%ORDTOOL .EQ. 1) THEN
         id%INFOG(1) = -38
         id%INFO(1)  = -38
         WRITE(LP,*)'PT-SCOTCH not available. Aborting...'
         CALL AGMG_MUMPS_ABORT()
      ELSE IF (ord%ORDTOOL .EQ. 2) THEN
         id%INFOG(1) = -38
         id%INFO(1)  = -38
         WRITE(LP,*)'ParMETIS not available. Aborting...'
         CALL AGMG_MUMPS_ABORT()
      END IF
      RETURN
      END SUBROUTINE DAGMG_MUMPS_717
      FUNCTION DAGMG_MUMPS_STOP_DESCENT(id, ord, NACTIVE, ANODE, RPROC,      &
     &     ALIST, LIST, PEAKMEM, NNODES, CHECKMEM)
      IMPLICIT NONE
      LOGICAL              :: DAGMG_MUMPS_STOP_DESCENT
      INTEGER              :: NACTIVE, RPROC, ANODE, PEAKMEM, NNODES
      INTEGER              :: ALIST(NNODES), LIST(NNODES)
      TYPE(ORD_TYPE)       :: ord
      TYPE(DAGMG_MUMPS_STRUC)   :: id
      LOGICAL, OPTIONAL    :: CHECKMEM
      INTEGER              :: IPEAKMEM, BIG, MAX_NROWS, MIN_NROWS
      INTEGER              :: TOPROWS, NRL, HOSTMEM, SUBMEM, IMEM
      INTEGER              :: I, NZ_ROW, WEIGHT
      LOGICAL              :: ICHECKMEM
      IF(present(CHECKMEM)) THEN
         ICHECKMEM = CHECKMEM
      ELSE
         ICHECKMEM = .FALSE.
      END IF
      DAGMG_MUMPS_STOP_DESCENT = .FALSE.
      IF(NACTIVE .GE. RPROC) THEN
         DAGMG_MUMPS_STOP_DESCENT = .TRUE.
         RETURN
      END IF
      IF(NACTIVE .EQ. 0) THEN
         DAGMG_MUMPS_STOP_DESCENT = .TRUE.
         RETURN
      END IF
      IF(.NOT. ICHECKMEM) RETURN
      BIG = ALIST(NACTIVE)
      IF(NACTIVE .GT. 1) THEN
         MAX_NROWS = ord%NW(ALIST(NACTIVE-1))
         MIN_NROWS = ord%NW(ALIST(1))
      ELSE
         MAX_NROWS = 0
         MIN_NROWS = id%N
      END IF
      DO I=1, ANODE
         WEIGHT = ord%NW(LIST(I))
         IF(WEIGHT .GT. MAX_NROWS) MAX_NROWS = WEIGHT
         IF(WEIGHT .LT. MIN_NROWS) MIN_NROWS = WEIGHT
      END DO
      I = ord%SON(BIG)
      DO
         WEIGHT = ord%NW(I)
         IF(WEIGHT .GT. MAX_NROWS) MAX_NROWS = WEIGHT
         IF(WEIGHT .LT. MIN_NROWS) MIN_NROWS = WEIGHT
         IF(ord%BROTHER(I) .EQ. -1) EXIT
         I = ord%BROTHER(I)
      END DO
      TOPROWS = ord%TOPNODES(2)+ord%RANGTAB(BIG+1)-ord%RANGTAB(BIG)
      SUBMEM  = 7 *id%N
      HOSTMEM = 12*id%N
      NZ_ROW = 2*(id%NZ/id%N)
      IF(id%PAR .EQ. 0) THEN
         NRL = 0
      ELSE
         NRL = MIN_NROWS
      END IF
      HOSTMEM = HOSTMEM + 2*TOPROWS*NZ_ROW
      HOSTMEM = HOSTMEM +NRL
      HOSTMEM = HOSTMEM + MAX(NRL,TOPROWS)*(NZ_ROW+2)
      HOSTMEM = HOSTMEM + 6*MAX(NRL,TOPROWS)
      HOSTMEM = HOSTMEM + 3*TOPROWS
      NRL = MAX_NROWS
      SUBMEM = SUBMEM +NRL
      SUBMEM = SUBMEM + NRL*(NZ_ROW+2)
      SUBMEM = SUBMEM + 6*NRL
      IPEAKMEM = MAX(HOSTMEM, SUBMEM)
      IF((IPEAKMEM .GT. PEAKMEM) .AND.                                  &
     &     (PEAKMEM .NE. 0)) THEN
         DAGMG_MUMPS_STOP_DESCENT = .TRUE.
         RETURN
      ELSE
         DAGMG_MUMPS_STOP_DESCENT = .FALSE.
         PEAKMEM = IPEAKMEM
         RETURN
      END IF
      END FUNCTION DAGMG_MUMPS_STOP_DESCENT
      FUNCTION DAGMG_MUMPS_CNT_KIDS(NODE, ord)
      IMPLICIT NONE
      INTEGER :: DAGMG_MUMPS_CNT_KIDS
      INTEGER :: NODE
      TYPE(ORD_TYPE) :: ord
      INTEGER :: CURR
      DAGMG_MUMPS_CNT_KIDS = 0
      IF(ord%SON(NODE) .EQ. -1) THEN
         RETURN
      ELSE
         DAGMG_MUMPS_CNT_KIDS = 1
         CURR = ord%SON(NODE)
         DO
            IF(ord%BROTHER(CURR) .NE. -1) THEN
               DAGMG_MUMPS_CNT_KIDS = DAGMG_MUMPS_CNT_KIDS+1
               CURR = ord%BROTHER(CURR)
            ELSE
               EXIT
            END IF
         END DO
      END IF
      RETURN
      END FUNCTION DAGMG_MUMPS_CNT_KIDS
      SUBROUTINE DAGMG_MUMPS_GET_SUBTREES(ord, id)
      USE TOOLS_COMM
      IMPLICIT NONE
      TYPE(ORD_TYPE)     :: ord
      TYPE(DAGMG_MUMPS_STRUC) :: id
      INTEGER, ALLOCATABLE :: ALIST(:), AWEIGHTS(:), LIST(:), WORK(:)
      INTEGER  :: NNODES, BIG, CURR, ND, NACTIVE, RPROC, ANODE, BASE, I,&
     &     NS, INFO, NK, PEAKMEM
      LOGICAL  :: SD
      NNODES = ord%NSLAVES
      ALLOCATE(ALIST(NNODES), AWEIGHTS(NNODES), LIST(NNODES),           &
     &     WORK(0:NNODES+1))
      ALIST(1)    = ord%CBLKNBR
      AWEIGHTS(1) = ord%NW(ord%CBLKNBR)
      NACTIVE     = 1
      RPROC       = NNODES
      ANODE       = 0
      PEAKMEM      = 0
      CALL AGMG_MUMPS_733(ord%TOPNODES, 2*max(NNODES,2), id%INFO, LP,        &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(ord%FIRST, id%NPROCS, id%INFO, LP,                 &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(ord%LAST, id%NPROCS, id%INFO, LP,                  &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      ord%TOPNODES = 0
      IF((ord%CBLKNBR .EQ. 1) .OR.                                      &
     &     ( RPROC .LT. DAGMG_MUMPS_CNT_KIDS(ord%CBLKNBR, ord) )) THEN
         ord%TOPNODES(1) = 1
         ord%TOPNODES(2) = ord%RANGTAB(ord%CBLKNBR+1) - ord%RANGTAB(1)
         ord%TOPNODES(3) = ord%RANGTAB(1)
         ord%TOPNODES(4) = ord%RANGTAB(ord%CBLKNBR+1)-1
         ord%FIRST = 0
         ord%LAST  = -1
         RETURN
      END IF
      DO
         IF(NACTIVE .EQ. 0) EXIT
         BIG = ALIST(NACTIVE)
         NK  = DAGMG_MUMPS_CNT_KIDS(BIG, ord)
         IF((NK .GT. (RPROC-NACTIVE+1)) .OR. (NK .EQ. 0)) THEN
            ANODE       = ANODE+1
            LIST(ANODE) = BIG
            NACTIVE     = NACTIVE-1
            RPROC       = RPROC-1
            CYCLE
         END IF
         SD = DAGMG_MUMPS_STOP_DESCENT(id, ord, NACTIVE, ANODE,              &
     &        RPROC, ALIST, LIST, PEAKMEM, NNODES, CHECKMEM=.TRUE.)
         IF ( SD )                                                      &
     &        THEN
            IF(NACTIVE.GT.0) THEN
               LIST(ANODE+1:ANODE+NACTIVE) = ALIST(1:NACTIVE)
               ANODE = ANODE+NACTIVE
            END IF
            EXIT
         END IF
         ord%TOPNODES(1) = ord%TOPNODES(1)+1
         ord%TOPNODES(2) = ord%TOPNODES(2) +                            &
     &        ord%RANGTAB(BIG+1) - ord%RANGTAB(BIG)
         ord%TOPNODES(2+2*(ord%TOPNODES(1)-1)+1) = ord%RANGTAB(BIG)
         ord%TOPNODES(2+2*(ord%TOPNODES(1)-1)+2) =                      &
     &        ord%RANGTAB(BIG+1)-1
         CURR              = ord%SON(BIG)
         ALIST(NACTIVE)    = CURR
         AWEIGHTS(NACTIVE) = ord%NW(CURR)
         DO
            IF(ord%BROTHER(CURR) .EQ. -1) EXIT
            NACTIVE           = NACTIVE+1
            CURR              = ord%BROTHER(CURR)
            ALIST(NACTIVE)    = CURR
            AWEIGHTS(NACTIVE) = ord%NW(CURR)
         END DO
         CALL DAGMG_MUMPS_MERGESORT(NACTIVE, AWEIGHTS(1:NACTIVE),            &
     &        WORK(0:NACTIVE+1))
         CALL DAGMG_MUMPS_MERGESWAP(NACTIVE, WORK(0:NACTIVE+1),              &
     &        AWEIGHTS(1:NACTIVE),                                      &
     &        ALIST(1:NACTIVE))
      END DO
      DO I=1, ANODE
         AWEIGHTS(I) = ord%NW(LIST(I))
      END DO
      CALL DAGMG_MUMPS_MERGESORT(ANODE, AWEIGHTS(1:ANODE), WORK(0:ANODE+1))
      CALL DAGMG_MUMPS_MERGESWAP(ANODE, WORK(0:ANODE+1), AWEIGHTS(1:ANODE),  &
     &     ALIST(1:ANODE))
      IF (id%PAR .EQ. 1) THEN
         BASE = 0
      ELSE
         ord%FIRST(1) = 0
         ord%LAST(1)  = -1
         BASE = 1
      END IF
      DO I=1, ANODE
         CURR = LIST(I)
         ND = CURR
         IF(ord%SON(ND) .NE. -1) THEN
            ND = ord%SON(ND)
            DO
               IF((ord%SON(ND) .EQ. -1) .AND.                           &
     &              (ord%BROTHER(ND).EQ.-1)) THEN
                  EXIT
               ELSE IF(ord%BROTHER(ND) .EQ. -1) THEN
                  ND = ord%SON(ND)
               ELSE
                  ND = ord%BROTHER(ND)
               END IF
            END DO
         END IF
         ord%FIRST(BASE+I) = ord%RANGTAB(ND)
         ord%LAST(BASE+I)  = ord%RANGTAB(CURR+1)-1
      END DO
      DO I=ANODE+1, id%NSLAVES
         ord%FIRST(BASE+I) = id%N+1
         ord%LAST(BASE+I) = id%N
      END DO
      DEALLOCATE(LIST, ALIST, AWEIGHTS, WORK)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_GET_SUBTREES
      SUBROUTINE DAGMG_MUMPS_720(id, ord, GPE, GNV, WORK)
      IMPLICIT NONE
      TYPE(DAGMG_MUMPS_STRUC)   :: id
      TYPE(ORD_TYPE)       :: ord
      INTEGER, POINTER     :: GPE(:), GNV(:)
      INTEGER, POINTER     :: WORK(:)
      TYPE(GRAPH_TYPE)     :: top_graph
      INTEGER, POINTER     :: PE(:), IPE(:),                            &
     &     LENG(:), I_HALO_MAP(:)
      INTEGER, POINTER     :: NDENSE(:), LAST(:),                       &
     &     DEGREE(:), W(:), PERM(:),                                    &
     &     LISTVAR_SCHUR(:), NEXT(:),                                   &
     &     HEAD(:), NV(:), ELEN(:),                                     &
     &     RCVCNT(:), LSTVAR(:)
      INTEGER, POINTER     :: NROOTS(:), MYLIST(:),                     &
     &     MYNVAR(:), LVARPT(:),                                        &
     &     DISPLS(:),  LPERM(:),                                        &
     &     LIPERM(:),                                                   &
     &     IPET(:), NVT(:), BUF_PE1(:),                                 &
     &     BUF_PE2(:), BUF_NV1(:),                                      &
     &     BUF_NV2(:), ROOTPERM(:),                                     &
     &     TMP1(:), TMP2(:), BWORK(:)
      INTEGER              :: HIDX, NCMPA, I, J, SIZE_SCHUR, MYID,      &
     &     NPROCS, IERR, NROWS_LOC, GLOB_IDX, MYNROOTS, PNT, TMP,       &
     &     NCLIQUES, NTVAR, PFREES, PFREET, TGSIZE, MAXS, RHANDPE,      &
     &     RHANDNV, STATUSPE(AGMG_MPF_STATUS_SIZE),                          &
     &     STATUSNV(AGMG_MPF_STATUS_SIZE), RIDX, PROC, NBBUCK, MEMS, MEMP,   &
     &     TOT, TOT1, PES, PFS_SAVE, PFT_SAVE
      LOGICAL              :: AGG6, SYMQAMD
      INTEGER              :: THRESH, NSTEPS
      CHARACTER            :: STRING*60
      nullify(PE, IPE, LENG, I_HALO_MAP)
      nullify(NDENSE, LAST, DEGREE, W, PERM, LISTVAR_SCHUR,             &
     &     NEXT, HEAD, NV, ELEN, RCVCNT, LSTVAR)
      nullify(NROOTS, MYLIST, MYNVAR, LVARPT, DISPLS,                   &
     &     LPERM, LIPERM, IPET, NVT, BUF_PE1, BUF_PE2,                  &
     &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK)
      CALL AGMG_SETIERR2( MYID, IERR)
      CALL AGMG_SETIERR12( NPROCS, IERR)
      IF(AGMG_MUMPS_GETSIZE(WORK) .LT. 4*id%N) THEN
         WRITE(LP,*)'Insufficient workspace in DMUMPS_720'
         CALL AGMG_MUMPS_ABORT()
      ELSE
         HEAD => WORK(       1 :   id%N)
         ELEN => WORK(  id%N+1 : 2*id%N)
         LENG => WORK(2*id%N+1 : 3*id%N)
         PERM => WORK(3*id%N+1 : 4*id%N)
      END IF
      CALL DAGMG_MUMPS_GET_SUBTREES(ord, id)
      CALL AGMG_MUMPS_734(ord%SON, ord%BROTHER, ord%NW,                      &
     &     ord%RANGTAB, MEMCNT=MEMCNT)
      NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
      NRL = NROWS_LOC
      TOPROWS = ord%TOPNODES(2)
      BWORK => WORK(1 : 2*id%N)
      CALL DAGMG_MUMPS_BUILD_LOC_GRAPH(id, ord, HIDX, IPE, PE, LENG,         &
     &     I_HALO_MAP, top_graph, BWORK)
      TMP = id%N
      DO I=1, NPROCS
         TMP = TMP-(ord%LAST(I)-ord%FIRST(I)+1)
      END DO
      TMP = ceiling(dble(TMP)*1.10D0)
      IF(MYID .EQ. 0) THEN
         TMP = max(max(TMP, HIDX),1)
      ELSE
         TMP = max(HIDX,1)
      END IF
      SIZE_SCHUR = HIDX - NROWS_LOC
      CALL AGMG_MUMPS_733(NDENSE, TMP, id%INFO, LP,                          &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(LAST, TMP, id%INFO, LP,                            &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(NEXT, TMP, id%INFO, LP,                            &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(DEGREE, TMP, id%INFO, LP,                          &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(W, TMP, id%INFO, LP,                               &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(NV, TMP, id%INFO, LP,                              &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(LISTVAR_SCHUR, SIZE_SCHUR, id%INFO, LP,            &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      DO I=1, SIZE_SCHUR
         LISTVAR_SCHUR(I) = NROWS_LOC+I
      END DO
      THRESH = -1
      AGG6   = .TRUE.
      PFREES = IPE(NROWS_LOC+1)
      PFS_SAVE = PFREES
      IF (ord%SUBSTRAT .EQ. 0) THEN
         DO I=1, HIDX
            PERM(I) = I
         END DO
         CALL AGMG_MUMPS_420(1, THRESH, NDENSE, HIDX,                        &
     &        AGMG_MUMPS_GETSIZE(PE), IPE, PFREES, LENG, PE, NV, ELEN,       &
     &        LAST, NCMPA, DEGREE, HEAD, NEXT, W, PERM, LISTVAR_SCHUR,  &
     &        SIZE_SCHUR, AGG6)
      ELSE
         NBBUCK = 2*TMP
         CALL AGMG_MUMPS_419 (ord%SUBSTRAT, 1, .FALSE., HIDX, NBBUCK,        &
     &        AGMG_MUMPS_GETSIZE(PE), IPE, PFREES, LENG, PE, NV, ELEN, LAST, &
     &        NCMPA, DEGREE, PERM, NEXT, W, HEAD, AGG6, SIZE_SCHUR,     &
     &        LISTVAR_SCHUR )
         DO I=1, HIDX
            PERM(I) = I
         END DO
      END IF
      CALL AGMG_MUMPS_733(W, 2*NPROCS, id%INFO,                              &
     &     LP, STRING='W', MEMCNT=MEMCNT, ERRCODE=-7)
      if(memcnt .gt. maxmem) maxmem=memcnt
      NROOTS => W
      DISPLS => W(NPROCS+1:2*NPROCS)
      MYNVAR => DEGREE
      MYLIST => NDENSE
      LVARPT => NEXT
      RCVCNT => HEAD
      LSTVAR => LAST
      NULLIFY(W, DEGREE, NDENSE, NEXT, HEAD, LAST)
      MYNROOTS = 0
      PNT = 0
      DO I=1, HIDX
         IF(IPE(I) .GT. 0) THEN
            PNT = PNT+LENG(I)
            MYNROOTS = MYNROOTS+1
         END IF
      END DO
      CALL AGMG_MUMPS_733(MYLIST, PNT, id%INFO,                              &
     &     LP, STRING='MYLIST', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      MYNROOTS = 0
      PNT = 0
      DO I=1, HIDX
         IF(IPE(I) .GT. 0) THEN
            MYNROOTS = MYNROOTS+1
            MYNVAR(MYNROOTS) =  LENG(I)
            MYLIST(PNT+1:PNT+LENG(I)) = I_HALO_MAP(PE(IPE(I):IPE(I)+    &
     &           LENG(I)-1)-NROWS_LOC)
            PNT = PNT+LENG(I)
         END IF
      END DO
      CALL AGMG_SETIERR( IERR)
      CALL AGMG_COPY(MYNROOTS, NROOTS, 1, AGMG_MPF_INTEGER, IERR)
      IF(MYID .EQ.0) THEN
         DISPLS(1) = 0
         DO I=2, NPROCS
            DISPLS(I) = DISPLS(I-1)+NROOTS(I-1)
         END DO
         NCLIQUES = sum(NROOTS(1:NPROCS))
         CALL AGMG_MUMPS_733(LVARPT, NCLIQUES+1, id%INFO,                    &
     &        LP, STRING='LVARPT', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      ELSE
         CALL AGMG_MUMPS_733(LVARPT, 2, id%INFO,                             &
     &        LP, STRING='LVARPT', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      END IF
      CALL AGMG_COPY(MYNVAR, LVARPT(2), MYNROOTS, AGMG_MPF_INTEGER, IERR)
      IF(MYID .EQ. 0) THEN
         DO I=1, NPROCS
            RCVCNT(I) = sum(LVARPT(2+DISPLS(I):2+DISPLS(I)+NROOTS(I)-1))
            IF(I .EQ. 1) THEN
               DISPLS(I) = 0
            ELSE
               DISPLS(I) = DISPLS(I-1)+RCVCNT(I-1)
            END IF
         END DO
         CALL AGMG_MUMPS_733(LSTVAR, SUM(RCVCNT(1:NPROCS)), id%INFO,         &
     &     LP, STRING='LSTVAR', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      END IF
      CALL AGMG_COPY(MYLIST, LSTVAR, PNT, AGMG_MPF_INTEGER, IERR)
      NULLIFY(DISPLS)
      IF(MYID .EQ. 0) THEN
         LVARPT(1) = 1
         DO I=2, NCLIQUES+1
            LVARPT(I) = LVARPT(I-1) + LVARPT(I)
         END DO
         LPERM => WORK(3*id%N+1 : 4*id%N)
         NTVAR   = ord%TOPNODES(2)
         CALL DAGMG_MUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
         CALL DAGMG_MUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,     &
     &        top_graph, NCLIQUES, LSTVAR, LVARPT, IPET, PE, LENG, ELEN)
         TGSIZE = ord%TOPNODES(2)+NCLIQUES
         PFREET = IPET(TGSIZE+1)
         PFT_SAVE = PFREET
         nullify(LPERM)
         CALL AGMG_MUMPS_734(top_graph%IRN_LOC,                              &
     &        top_graph%JCN_LOC, ord%TOPNODES, MEMCNT=MEMCNT)
         W       => NROOTS
         DEGREE  => MYNVAR
         NDENSE  => MYLIST
         NEXT    => LVARPT
         HEAD    => RCVCNT
         LAST    => LSTVAR
         NULLIFY(NROOTS, MYNVAR, MYLIST, LVARPT, RCVCNT, LSTVAR)
         CALL AGMG_MUMPS_733(PE, PFREET+TGSIZE, id%INFO, LP,                 &
     &        COPY=.TRUE., STRING='J2:PE', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(NDENSE, TGSIZE, id%INFO, LP,                    &
     &        STRING='J2:NDENSE', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(NVT, TGSIZE, id%INFO, LP,                       &
     &        STRING='J2:NVT', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(LAST, TGSIZE, id%INFO, LP,                      &
     &        STRING='J2:LAST', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(DEGREE, TGSIZE, id%INFO, LP,                    &
     &        STRING='J2:DEGREE', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(NEXT, TGSIZE, id%INFO, LP,                      &
     &        STRING='J2:NEXT', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(W, TGSIZE, id%INFO, LP,                         &
     &        STRING='J2:W', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(LISTVAR_SCHUR, NCLIQUES, id%INFO, LP,           &
     &        STRING='J2:LVSCH', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
         DO I=1, NCLIQUES
            LISTVAR_SCHUR(I) = NTVAR+I
         END DO
         THRESH = -1
         IF(ord%TOPSTRAT .EQ. 0) THEN
            CALL AGMG_MUMPS_733(HEAD, TGSIZE, id%INFO,                       &
     &        LP, STRING='J2:HEAD', MEMCNT=MEMCNT, ERRCODE=-7)
            CALL AGMG_MUMPS_733(PERM, TGSIZE, id%INFO,                       &
     &           LP, COPY=.TRUE., STRING='J2:PERM',                     &
     &           MEMCNT=MEMCNT, ERRCODE=-7)
            IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
            DO I=NROWS_LOC+1, TGSIZE
               PERM(I) = I
            END DO
            CALL AGMG_MUMPS_420(2, -1, NDENSE, TGSIZE,                       &
     &           AGMG_MUMPS_GETSIZE(PE), IPET, PFREET, LENG, PE, NVT, ELEN,  &
     &           LAST, NCMPA, DEGREE, HEAD, NEXT, W, PERM,              &
     &           LISTVAR_SCHUR, NCLIQUES, AGG6)
         ELSE
            NBBUCK = 2*TGSIZE
            CALL AGMG_MUMPS_733(HEAD,      NBBUCK+2, id%INFO,                &
     &        LP, STRING='J2:HEAD', MEMCNT=MEMCNT, ERRCODE=-7)
            CALL AGMG_MUMPS_733(PERM,      TGSIZE, id%INFO,                  &
     &        LP, STRING='J2:PERM', MEMCNT=MEMCNT, ERRCODE=-7)
            IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
            CALL AGMG_MUMPS_419 (ord%TOPSTRAT, 2, .FALSE., TGSIZE,           &
     &           NBBUCK, AGMG_MUMPS_GETSIZE(PE), IPET, PFREET, LENG, PE, NVT,&
     &           ELEN, LAST, NCMPA, DEGREE, PERM, NEXT, W, HEAD, AGG6,  &
     &           NCLIQUES, LISTVAR_SCHUR )
         END IF
      END IF
      CALL AGMG_SETIERR( IERR)
      CALL AGMG_MUMPS_734(LISTVAR_SCHUR, PE, MEMCNT=MEMCNT)
      IF(MYID .EQ. 0) THEN
         BUF_PE1 => WORK(       1 :   id%N)
         BUF_PE2 => WORK(  id%N+1 : 2*id%N)
         BUF_NV1 => WORK(2*id%N+1 : 3*id%N)
         BUF_NV2 => WORK(3*id%N+1 : 4*id%N)
         MAXS = NROWS_LOC
         DO I=2, NPROCS
            IF((ord%LAST(I)-ord%FIRST(I)+1) .GT. MAXS)                  &
     &           MAXS = (ord%LAST(I)-ord%FIRST(I)+1)
         END DO
         CALL AGMG_MUMPS_733(BUF_PE1, MAXS, id%INFO,                         &
     &        LP, STRING='BUF_PE1', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(BUF_PE2, MAXS, id%INFO,                         &
     &        LP, STRING='BUF_PE2', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(BUF_NV1, MAXS, id%INFO,                         &
     &        LP, STRING='BUF_NV1', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(BUF_NV2, MAXS, id%INFO,                         &
     &        LP, STRING='BUF_NV2', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(GPE, id%N, id%INFO,                             &
     &        LP, STRING='GPE', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(GNV, id%N, id%INFO,                             &
     &        LP, STRING='GNV', MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(ROOTPERM, NCLIQUES, id%INFO,                    &
     &        LP, STRING='ROOTPERM', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
         RIDX = 0
         TMP1    => BUF_PE1
         TMP2    => BUF_NV1
         NULLIFY(BUF_PE1, BUF_NV1)
         BUF_PE1 => IPE
         BUF_NV1 => NV
         DO PROC=0, NPROCS-2
            CALL AGMG_SETIERR( IERR)
            CALL AGMG_SETIERR( IERR)
            DO I=1, ord%LAST(PROC+1)-ord%FIRST(PROC+1)+1
               GLOB_IDX = ord%PERITAB(I+ord%FIRST(PROC+1)-1)
               IF(BUF_PE1(I) .GT. 0) THEN
                  RIDX=RIDX+1
                  ROOTPERM(RIDX) = GLOB_IDX
                  GNV(GLOB_IDX) = BUF_NV1(I)
               ELSE IF (BUF_PE1(I) .EQ. 0) THEN
                  GPE(GLOB_IDX) = 0
                  GNV(GLOB_IDX) = BUF_NV1(I)
               ELSE
                  GPE(GLOB_IDX) = -ord%PERITAB(-BUF_PE1(I)+             &
     &                 ord%FIRST(PROC+1)-1)
                  GNV(GLOB_IDX) = BUF_NV1(I)
               END IF
            END DO
            CALL AGMG_NOCALL('MPI_WAIT')
            CALL AGMG_NOCALL('MPI_WAIT')
            IF(PROC .NE. 0) THEN
               TMP1    => BUF_PE1
               TMP2    => BUF_NV1
            END IF
            BUF_PE1 => BUF_PE2
            BUF_NV1 => BUF_NV2
            NULLIFY(BUF_PE2, BUF_NV2)
            BUF_PE2 => TMP1
            BUF_NV2 => TMP2
            NULLIFY(TMP1, TMP2)
         END DO
         DO I=1, ord%LAST(PROC+1)-ord%FIRST(PROC+1)+1
            GLOB_IDX = ord%PERITAB(I+ord%FIRST(PROC+1)-1)
            IF(BUF_PE1(I) .GT. 0) THEN
               RIDX=RIDX+1
               ROOTPERM(RIDX) = GLOB_IDX
               GNV(GLOB_IDX) = BUF_NV1(I)
            ELSE IF (BUF_PE1(I) .EQ. 0) THEN
               GPE(GLOB_IDX) = 0
               GNV(GLOB_IDX) = BUF_NV1(I)
            ELSE
               GPE(GLOB_IDX) = -ord%PERITAB(-BUF_PE1(I)+                &
     &              ord%FIRST(PROC+1)-1)
               GNV(GLOB_IDX) = BUF_NV1(I)
            END IF
         END DO
         DO I=1, NTVAR
            GLOB_IDX = LIPERM(I)
            IF(IPET(I) .EQ. 0) THEN
               GPE(GLOB_IDX) = 0
               GNV(GLOB_IDX) = NVT(I)
            ELSE
               GPE(GLOB_IDX) = -LIPERM(-IPET(I))
               GNV(GLOB_IDX) = NVT(I)
            END IF
         END DO
         DO I=1, NCLIQUES
            GLOB_IDX      = ROOTPERM(I)
            GPE(GLOB_IDX) = -LIPERM(-IPET(NTVAR+I))
         END DO
      ELSE
         CALL AGMG_NOCALL('MPI_SEND')
         CALL AGMG_NOCALL('MPI_SEND')
      END IF
      CALL AGMG_MUMPS_734(PE, IPE, I_HALO_MAP, NDENSE,                       &
     &     LAST, DEGREE, MEMCNT=MEMCNT)
      CALL AGMG_MUMPS_734(W, LISTVAR_SCHUR, NEXT,                            &
     &     NV, MEMCNT=MEMCNT)
      CALL AGMG_MUMPS_734(LSTVAR, NROOTS, MYLIST, MYNVAR,                    &
     &     LVARPT, MEMCNT=MEMCNT)
      CALL AGMG_MUMPS_734(LPERM, LIPERM, IPET, NVT,                          &
     &     MEMCNT=MEMCNT)
      CALL AGMG_MUMPS_734(ROOTPERM, TMP1, TMP2, MEMCNT=MEMCNT)
      NULLIFY(HEAD, ELEN, LENG, PERM, RCVCNT)
!     $     associated(LENG), associated(I_HALO_MAP),
!     $     associated(NDENSE), associated(LAST), associated(DEGREE),
!     $     associated(W), associated(PERM), associated(LISTVAR_SCHUR),
!     $     associated(NEXT), associated(HEAD), associated(NV),
!     $     associated(ELEN), associated(RCVCNT), associated(LSTVAR),
!     $     associated(NROOTS), associated(MYLIST), associated(MYNVAR),
!     $     associated(LVARPT), associated(DISPLS),  associated(LPERM),
!     $     associated(LIPERM), associated(IPET), associated(NVT),
!     $     associated(BUF_PE1), associated(BUF_PE2),
!     $     associated(BUF_NV1), associated(BUF_NV2),
!     $     associated(ROOTPERM), associated(TMP1), associated(TMP2)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_720
      SUBROUTINE DAGMG_MUMPS_MAKE_LOC_IDX(id, TOPNODES, LPERM, LIPERM, ord)
      IMPLICIT NONE
      TYPE(DAGMG_MUMPS_STRUC)   :: id
      INTEGER, POINTER  :: TOPNODES(:), LPERM(:), LIPERM(:)
      TYPE(ORD_TYPE)    :: ord
      INTEGER           :: I, J, K, GIDX
      CHARACTER         :: STRING*30
      CALL AGMG_MUMPS_733(LPERM , ord%N, id%INFO,                            &
     &        LP, STRING='LIDX:LPERM', MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(LIPERM, TOPNODES(2), id%INFO,                      &
     &        LP, STRING='LIDX:LIPERM', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      LPERM = 0
      K = 1
      DO I=1, TOPNODES(1)
         DO J=TOPNODES(2*I+1), TOPNODES(2*I+2)
            GIDX        = ord%PERITAB(J)
            LPERM(GIDX) = K
            LIPERM(K)   = GIDX
            K           = K+1
         END DO
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_MAKE_LOC_IDX
      SUBROUTINE DAGMG_MUMPS_ASSEMBLE_TOP_GRAPH(id, NLOCVARS, LPERM,         &
     &     top_graph, NCLIQUES, LSTVAR, LVARPT, IPE, PE, LENG, ELEN)
      IMPLICIT NONE
      TYPE(DAGMG_MUMPS_STRUC) :: id
      TYPE(GRAPH_TYPE)   :: top_graph
      INTEGER, POINTER   :: LPERM(:), LSTVAR(:), LVARPT(:),             &
     &     IPE(:), PE(:), LENG(:), ELEN(:)
      INTEGER            :: NCLIQUES, IERR
      INTEGER            :: I, J, IDX, NLOCVARS, PNT, SAVEPNT
      CHARACTER          :: STRING*30
      CALL AGMG_MUMPS_733(LENG, NLOCVARS+NCLIQUES  , id%INFO,                &
     &        LP, STRING='ATG:LENG', MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(ELEN, NLOCVARS+NCLIQUES  , id%INFO,                &
     &        LP, STRING='ATG:ELEN', MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(IPE , NLOCVARS+NCLIQUES+1, id%INFO,                &
     &        LP, STRING='ATG:IPE', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      LENG = 0
      ELEN = 0
      DO I=1, top_graph%NZ_LOC
         IF((LPERM(top_graph%JCN_LOC(I)) .NE. 0) .AND.                  &
     &        (top_graph%JCN_LOC(I) .NE. top_graph%IRN_LOC(I))) THEN
            LENG(LPERM(top_graph%IRN_LOC(I))) =                         &
     &           LENG(LPERM(top_graph%IRN_LOC(I))) + 1
         END IF
      END DO
      DO I=1, NCLIQUES
         DO J=LVARPT(I), LVARPT(I+1)-1
            ELEN(LPERM(LSTVAR(J))) = ELEN(LPERM(LSTVAR(J)))+1
            LENG(NLOCVARS+I) = LENG(NLOCVARS+I)+1
         END DO
      END DO
      IPE(1) = 1
      DO I=1, NLOCVARS+NCLIQUES
         IPE(I+1) = IPE(I)+LENG(I)+ELEN(I)
      END DO
      CALL AGMG_MUMPS_733(PE, IPE(NLOCVARS+NCLIQUES+1)+NLOCVARS+NCLIQUES,    &
     &     id%INFO, LP, STRING='ATG:PE', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      LENG = 0
      ELEN = 0
      DO I=1, NCLIQUES
         DO J=LVARPT(I), LVARPT(I+1)-1
            IDX = LPERM(LSTVAR(J))
            PE(IPE(IDX)+ELEN(IDX)) = NLOCVARS+I
            PE(IPE(NLOCVARS+I)+LENG(NLOCVARS+I)) = IDX
            ELEN(LPERM(LSTVAR(J))) = ELEN(LPERM(LSTVAR(J)))+1
            LENG(NLOCVARS+I) = LENG(NLOCVARS+I)+1
         end do
      end do
      DO I=1, top_graph%NZ_LOC
         IF((LPERM(top_graph%JCN_LOC(I)) .NE. 0) .AND.                  &
     &        (top_graph%JCN_LOC(I) .NE. top_graph%IRN_LOC(I))) THEN
            PE(IPE(LPERM(top_graph%IRN_LOC(I)))+                        &
     &           ELEN(LPERM(top_graph%IRN_LOC(I))) +                    &
     &           LENG(LPERM(top_graph%IRN_LOC(I)))) =                   &
     &           LPERM(top_graph%JCN_LOC(I))
            LENG(LPERM(top_graph%IRN_LOC(I))) =                         &
     &           LENG(LPERM(top_graph%IRN_LOC(I))) + 1
         END IF
      END DO
      LENG(1:NLOCVARS+NCLIQUES) = LENG(1:NLOCVARS+NCLIQUES)+            &
     &     ELEN(1:NLOCVARS+NCLIQUES)
      SAVEPNT = 1
      PNT = 0
      LPERM(1:NLOCVARS+NCLIQUES) = 0
      DO I=1, NLOCVARS+NCLIQUES
         DO J=IPE(I), IPE(I+1)-1
            IF(LPERM(PE(J)) .EQ. I) THEN
               LENG(I) = LENG(I)-1
            ELSE
               LPERM(PE(J)) = I
               PNT = PNT+1
               PE(PNT) = PE(J)
            END IF
         END DO
         IPE(I) = SAVEPNT
         SAVEPNT = PNT+1
      END DO
      IPE(NLOCVARS+NCLIQUES+1) = SAVEPNT
      RETURN
      END SUBROUTINE DAGMG_MUMPS_ASSEMBLE_TOP_GRAPH
      SUBROUTINE DAGMG_MUMPS_BUILD_SCOTCH_GRAPH(id, FIRST, LAST, IPE,        &
     &     PE, WORK)
      IMPLICIT NONE
      TYPE(DAGMG_MUMPS_STRUC)      :: id
      INTEGER, POINTER        :: FIRST(:), LAST(:), IPE(:), PE(:),      &
     &     WORK(:)
      INTEGER                 :: IERR, MYID, NPROCS
      INTEGER                 :: M, N, NNZ, IVAL, I, PROC, LOCNNZ,      &
     &     NEW_LOCNNZ, J, LOC_ROW
      INTEGER                 :: SENDSIZE, IDX, TOP_CNT, TIDX,          &
     &     NROWS_LOC, DUPS, TOTDUPS, OFFDIAG
      INTEGER                 :: STATUS(AGMG_MPF_STATUS_SIZE)
      INTEGER, POINTER        :: MAPTAB(:),                             &
     &     SNDCNT(:), RCVCNT(:), SDISPL(:)
      INTEGER, POINTER        :: RDISPL(:),                             &
     &     MSGCNT(:), SIPES(:,:), LENG(:)
      INTEGER, POINTER        :: PCNT(:), TSENDI(:),                    &
     &     TSENDJ(:), RCVBUF(:)
      TYPE(ARRPNT), POINTER   :: APNT(:)
      INTEGER                 :: BUFSIZE, SOURCE, RCVPNT, MAXS, PNT,    &
     &     SAVEPNT
      INTEGER, PARAMETER      :: ITAG=30
      LOGICAL                 :: FLAG
      DOUBLE PRECISION        :: SYMMETRY
      nullify(MAPTAB, SNDCNT, RCVCNT, SDISPL)
      nullify(RDISPL, MSGCNT, SIPES, LENG)
      nullify(PCNT, TSENDI, TSENDJ, RCVBUF, APNT)
      CALL AGMG_SETIERR2( MYID, IERR)
      CALL AGMG_SETIERR12( NPROCS, IERR)
      IF(AGMG_MUMPS_GETSIZE(WORK) .LT. id%N*2) THEN
         WRITE(LP,                                                      &
     &        '("Insufficient workspace inside BUILD_SCOTCH_GRAPH")')
         CALL AGMG_MUMPS_ABORT()
      END IF
      CALL AGMG_MUMPS_733(SNDCNT, NPROCS, id%INFO, LP,                       &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(RCVCNT, NPROCS, id%INFO, LP,                       &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(MSGCNT, NPROCS, id%INFO, LP,                       &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      ALLOCATE(APNT(NPROCS))
      SNDCNT = 0
      TOP_CNT = 0
      BUFSIZE = 1000
      LOCNNZ = id%NZ_LOC
      NROWS_LOC = LAST(MYID+1)-FIRST(MYID+1)+1
      MAPTAB => WORK(     1 :   id%N)
      LENG   => WORK(id%N+1 : 2*id%N)
      MAXS = 0
      DO I=1, NPROCS
         IF((LAST(I)-FIRST(I)+1) .GT. MAXS) THEN
            MAXS = LAST(I)-FIRST(I)+1
         END IF
         DO J=FIRST(I), LAST(I)
            MAPTAB(J) = I
         END DO
      END DO
      ALLOCATE(SIPES(max(1,MAXS), NPROCS))
      OFFDIAG=0
      SIPES=0
      DO I=1, id%NZ_LOC
         IF(id%IRN_LOC(I) .NE. id%JCN_LOC(I)) THEN
            OFFDIAG = OFFDIAG+1
            PROC = MAPTAB(id%IRN_LOC(I))
            LOC_ROW = id%IRN_LOC(I)-FIRST(PROC)+1
            SIPES(LOC_ROW, PROC) = SIPES(LOC_ROW, PROC)+1
            SNDCNT(PROC) = SNDCNT(PROC)+1
            PROC = MAPTAB(id%JCN_LOC(I))
            LOC_ROW = id%JCN_LOC(I)-FIRST(PROC)+1
            SIPES(LOC_ROW, PROC) = SIPES(LOC_ROW, PROC)+1
            SNDCNT(PROC) = SNDCNT(PROC)+1
         END IF
      END DO
      CALL AGMG_COPY(OFFDIAG, id%KEEP(114), 1, AGMG_MPF_INTEGER, IERR)
      id%KEEP(114) = id%KEEP(114)+3*id%N
      id%KEEP(113) = id%KEEP(114)-2*id%N
      CALL AGMG_MPF_ALLTOALL(SNDCNT, 1, AGMG_MPF_INTEGER, RCVCNT, 1,              &
     &     AGMG_MPF_INTEGER, id%COMM, IERR)
      SNDCNT(:) = MAXS
      CALL AGMG_COPY( SIPES, LENG, SNDCNT, AGMG_MPF_INTEGER, IERR )
      DEALLOCATE(SIPES)
      CALL AGMG_MUMPS_733(IPE, NROWS_LOC+1, id%INFO,                         &
     &        LP, STRING='IPE', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      IPE(1) = 1
      DO I=1, NROWS_LOC
         IPE(I+1) = IPE(I) + LENG(I)
      END DO
      CALL AGMG_MUMPS_733(PE, IPE(NROWS_LOC+1)-1, id%INFO,                   &
     &        LP, STRING='PE', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      LENG(:) = 0
      CALL DAGMG_MUMPS_SEND_BUF(APNT, PROC, NPROCS, BUFSIZE, IPE, PE, LENG,  &
     &     RCVBUF, MSGCNT, SNDCNT, id%COMM)
      NEW_LOCNNZ = sum(RCVCNT)
      MSGCNT = RCVCNT/BUFSIZE
      RCVPNT = 1
      SNDCNT = 0
      TIDX   = 0
      DO I=1, id%NZ_LOC
         IF(mod(I,BUFSIZE/10) .EQ. 0) THEN
            CALL AGMG_MPF_IPROBE( AGMG_MPF_ANY_SOURCE, ITAG, AGMG_MPF_COMM_WORLD,      &
     &           FLAG, STATUS, IERR )
            IF(FLAG) THEN
               SOURCE = STATUS(AGMG_MPF_SOURCE)
               CALL AGMG_NOCALL('MPI_RECV')
               CALL DAGMG_MUMPS_ASSEMBLE_MSG(BUFSIZE, RCVBUF, IPE, PE, LENG)
               MSGCNT(SOURCE+1)=MSGCNT(SOURCE+1)-1
               RCVPNT = RCVPNT + BUFSIZE
            END IF
         END IF
         IF(id%IRN_LOC(I) .NE. id%JCN_LOC(I)) THEN
            PROC = MAPTAB(id%IRN_LOC(I))
            APNT(PROC)%BUF(2*SNDCNT(PROC)+1) = id%IRN_LOC(I)-           &
     &           FIRST(PROC)+1
            APNT(PROC)%BUF(2*SNDCNT(PROC)+2) = id%JCN_LOC(I)
            SNDCNT(PROC) = SNDCNT(PROC)+1
            IF(SNDCNT(PROC) .EQ. BUFSIZE) THEN
               CALL DAGMG_MUMPS_SEND_BUF(APNT, PROC, NPROCS, BUFSIZE, IPE,   &
     &              PE, LENG, RCVBUF, MSGCNT, SNDCNT, id%COMM)
            END IF
            PROC = MAPTAB(id%JCN_LOC(I))
            APNT(PROC)%BUF(2*SNDCNT(PROC)+1) = id%JCN_LOC(I)-           &
     &           FIRST(PROC)+1
            APNT(PROC)%BUF(2*SNDCNT(PROC)+2) = id%IRN_LOC(I)
            SNDCNT(PROC) = SNDCNT(PROC)+1
            IF(SNDCNT(PROC) .EQ. BUFSIZE) THEN
               CALL DAGMG_MUMPS_SEND_BUF(APNT, PROC, NPROCS, BUFSIZE, IPE,   &
     &              PE, LENG, RCVBUF, MSGCNT, SNDCNT, id%COMM)
            END IF
         END IF
      END DO
      CALL DAGMG_MUMPS_SEND_BUF(APNT, -1, NPROCS, BUFSIZE, IPE, PE, LENG,    &
     &     RCVBUF, MSGCNT, SNDCNT, id%COMM)
      DUPS = 0
      PNT = 0
      SAVEPNT = 1
      MAPTAB = 0
      DO I=1, NROWS_LOC
         DO J=IPE(I),IPE(I+1)-1
            IF(MAPTAB(PE(J)) .EQ. I) THEN
               DUPS = DUPS+1
            ELSE
               MAPTAB(PE(J)) = I
               PNT = PNT+1
               PE(PNT) = PE(J)
            END IF
         END DO
         IPE(I) = SAVEPNT
         SAVEPNT = PNT+1
      END DO
      CALL AGMG_COPY( DUPS, TOTDUPS, 1, AGMG_MPF_INTEGER, IERR )
      SYMMETRY = dble(TOTDUPS)/(dble(id%NZ)-dble(id%N))
      IF(MYID .EQ. 0) THEN
         IF(id%SYM .GE. 1) SYMMETRY = 1.d0
         IF(PROKG) WRITE(MPG,'("Structual symmetry is:",i3,"%")')       &
     &        CEILING(SYMMETRY*100.d0)
      id%INFOG(8) = ceiling(SYMMETRY*100.0D0)
      END IF
      IPE(NROWS_LOC+1) = SAVEPNT
      CALL AGMG_MUMPS_734(SNDCNT, RCVCNT, MSGCNT, MEMCNT=MEMCNT)
      DEALLOCATE(APNT)
!     $     associated(SNDCNT), associated(RCVCNT),
!     $     associated(SDISPL), associated(RDISPL), associated(MSGCNT),
!     $     associated(SIPES), associated(LENG), associated(PCNT),
!     $     associated(TSENDI), associated(TSENDJ), associated(RCVBUF),
!     $     associated(APNT)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_BUILD_SCOTCH_GRAPH
      SUBROUTINE DAGMG_MUMPS_BUILD_LOC_GRAPH(id, ord, GSIZE, IPE, PE, LENG,  &
     &     I_HALO_MAP, top_graph, WORK)
      IMPLICIT NONE
      TYPE(DAGMG_MUMPS_STRUC)   :: id
      TYPE(ORD_TYPE)       :: ord
      TYPE(GRAPH_TYPE)     :: top_graph
      INTEGER, POINTER     :: IPE(:), PE(:), LENG(:),                   &
     &     I_HALO_MAP(:), WORK(:)
      INTEGER              :: GSIZE
      INTEGER                :: IERR, MYID, NPROCS
      INTEGER                :: M, N, NNZ, IVAL, I, PROC, LOCNNZ,       &
     &     NEW_LOCNNZ, J, LOC_ROW
      INTEGER                :: SENDSIZE, IDX, TOP_CNT, TOTDUPS,        &
     &     IIDX, JJDX
      INTEGER                :: HALO_SIZE, TIDX, NROWS_LOC, DUPS
      INTEGER                :: STATUS(AGMG_MPF_STATUS_SIZE)
      INTEGER, POINTER       :: MAPTAB(:),                              &
     &     SNDCNT(:), RCVCNT(:),                                        &
     &     SDISPL(:), HALO_MAP(:)
      INTEGER, POINTER       :: RDISPL(:),                              &
     &     MSGCNT(:), SIPES(:,:)
      INTEGER, POINTER       :: PCNT(:), TSENDI(:),                     &
     &     TSENDJ(:), RCVBUF(:)
      TYPE(ARRPNT), POINTER  :: APNT(:)
      INTEGER                :: BUFSIZE, SOURCE, RCVPNT, MAXS, PNT,     &
     &     SAVEPNT
      INTEGER, PARAMETER     :: ITAG=30
      LOGICAL                :: FLAG
      DOUBLE PRECISION       :: SYMMETRY
      nullify(MAPTAB, SNDCNT, RCVCNT, SDISPL, HALO_MAP)
      nullify(RDISPL, MSGCNT, SIPES)
      nullify(PCNT, TSENDI, TSENDJ, RCVBUF, APNT)
      CALL AGMG_SETIERR2( MYID, IERR)
      CALL AGMG_SETIERR12( NPROCS, IERR)
      IF(AGMG_MUMPS_GETSIZE(WORK) .LT. id%N*2) THEN
         WRITE(LP,                                                      &
     &        '("Insufficient workspace inside BUILD_LOC_GRAPH")')
         CALL AGMG_MUMPS_ABORT()
      END IF
      MAPTAB   => WORK(     1 :   id%N)
      HALO_MAP => WORK(id%N+1 : 2*id%N)
      CALL AGMG_MUMPS_733(SNDCNT, NPROCS, id%INFO, LP,                       &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(RCVCNT, NPROCS, id%INFO, LP,                       &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(MSGCNT, NPROCS, id%INFO, LP,                       &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      ALLOCATE(APNT(NPROCS))
      SNDCNT = 0
      TOP_CNT = 0
      BUFSIZE = 10000
      LOCNNZ = id%NZ_LOC
      NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
      MAPTAB = 0
      MAXS = 0
      DO I=1, NPROCS
         IF((ord%LAST(I)-ord%FIRST(I)+1) .GT. MAXS) THEN
            MAXS = ord%LAST(I)-ord%FIRST(I)+1
         END IF
         DO J=ord%FIRST(I), ord%LAST(I)
            MAPTAB(ord%PERITAB(J)) = I
         END DO
      END DO
      ALLOCATE(SIPES(max(1,MAXS), NPROCS))
      SIPES(:,:)  = 0
      TOP_CNT     = 0
      DO I=1, id%NZ_LOC
         IF(id%IRN_LOC(I) .NE. id%JCN_LOC(I)) THEN
            PROC = MAPTAB(id%IRN_LOC(I))
            IF(PROC .EQ. 0) THEN
               TOP_CNT = TOP_CNT+1
            ELSE
               IIDX = ord%PERMTAB(id%IRN_LOC(I))
               LOC_ROW = IIDX-ord%FIRST(PROC)+1
               SIPES(LOC_ROW, PROC) = SIPES(LOC_ROW, PROC)+1
               SNDCNT(PROC) = SNDCNT(PROC)+1
            END IF
            PROC = MAPTAB(id%JCN_LOC(I))
            IF(PROC .EQ. 0) THEN
               TOP_CNT = TOP_CNT+1
            ELSE
               IIDX = ord%PERMTAB(id%JCN_LOC(I))
               LOC_ROW = IIDX-ord%FIRST(PROC)+1
               SIPES(LOC_ROW, PROC) = SIPES(LOC_ROW, PROC)+1
               SNDCNT(PROC) = SNDCNT(PROC)+1
            END IF
         END IF
      END DO
      CALL AGMG_MPF_ALLTOALL(SNDCNT, 1, AGMG_MPF_INTEGER, RCVCNT, 1,              &
     &     AGMG_MPF_INTEGER, id%COMM, IERR)
      I = ceiling(dble(MAXS)*1.20D0)
      CALL AGMG_MUMPS_733(LENG, I, id%INFO,                                  &
     &        LP, STRING='B_L_G:LENG', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      SNDCNT(:) = MAXS
      CALL AGMG_COPY( SIPES, LENG, SNDCNT, AGMG_MPF_INTEGER, IERR )
      DEALLOCATE(SIPES)
      I = ceiling(dble(NROWS_LOC+1)*1.20D0)
      CALL AGMG_MUMPS_733(IPE, I, id%INFO,                                   &
     &        LP, STRING='B_L_G:IPE', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      IPE(1) = 1
      DO I=1, NROWS_LOC
         IPE(I+1) = IPE(I) + LENG(I)
      END DO
      CALL AGMG_MUMPS_733(TSENDI, TOP_CNT, id%INFO, LP,                      &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      CALL AGMG_MUMPS_733(TSENDJ, TOP_CNT, id%INFO, LP,                      &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      LENG(:) = 0
      CALL DAGMG_MUMPS_SEND_BUF(APNT, PROC, NPROCS, BUFSIZE, IPE, PE,        &
     &     LENG, RCVBUF, MSGCNT, SNDCNT, id%COMM)
      NEW_LOCNNZ = sum(RCVCNT)
      MSGCNT = RCVCNT/BUFSIZE
      CALL AGMG_MUMPS_733(PE, NEW_LOCNNZ+2*NROWS_LOC, id%INFO,               &
     &        LP, STRING='B_L_G:PE', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      RCVPNT = 1
      SNDCNT = 0
      TIDX   = 0
      DO I=1, id%NZ_LOC
         IF(mod(I,BUFSIZE/10) .EQ. 0) THEN
            CALL AGMG_MPF_IPROBE( AGMG_MPF_ANY_SOURCE, ITAG, AGMG_MPF_COMM_WORLD,      &
     &           FLAG, STATUS, IERR )
            IF(FLAG) THEN
               SOURCE = STATUS(AGMG_MPF_SOURCE)
               CALL AGMG_NOCALL('MPI_RECV')
               CALL DAGMG_MUMPS_ASSEMBLE_MSG(BUFSIZE, RCVBUF, IPE, PE, LENG)
               MSGCNT(SOURCE+1)=MSGCNT(SOURCE+1)-1
               RCVPNT = RCVPNT + BUFSIZE
            END IF
         END IF
         IF(id%IRN_LOC(I) .NE. id%JCN_LOC(I)) THEN
            PROC = MAPTAB(id%IRN_LOC(I))
            IF(PROC .EQ. 0) THEN
               TIDX = TIDX+1
               TSENDI(TIDX) = id%IRN_LOC(I)
               TSENDJ(TIDX) = id%JCN_LOC(I)
            ELSE
               IIDX = ord%PERMTAB(id%IRN_LOC(I))
               JJDX = ord%PERMTAB(id%JCN_LOC(I))
               APNT(PROC)%BUF(2*SNDCNT(PROC)+1) =IIDX-ord%FIRST(PROC)+1
               IF( (JJDX .GE. ord%FIRST(PROC)) .AND.                    &
     &              (JJDX .LE. ord%LAST(PROC)) ) THEN
               APNT(PROC)%BUF(2*SNDCNT(PROC)+2) = JJDX-ord%FIRST(PROC)+1
            ELSE
               APNT(PROC)%BUF(2*SNDCNT(PROC)+2) = -id%JCN_LOC(I)
            END IF
            SNDCNT(PROC) = SNDCNT(PROC)+1
            IF(SNDCNT(PROC) .EQ. BUFSIZE) THEN
               CALL DAGMG_MUMPS_SEND_BUF(APNT, PROC, NPROCS, BUFSIZE, IPE,   &
     &              PE, LENG, RCVBUF, MSGCNT, SNDCNT, id%COMM)
            END IF
         END IF
         PROC = MAPTAB(id%JCN_LOC(I))
         IF(PROC .EQ. 0) THEN
            TIDX = TIDX+1
            TSENDI(TIDX) = id%JCN_LOC(I)
            TSENDJ(TIDX) = id%IRN_LOC(I)
         ELSE
            IIDX = ord%PERMTAB(id%JCN_LOC(I))
            JJDX = ord%PERMTAB(id%IRN_LOC(I))
            APNT(PROC)%BUF(2*SNDCNT(PROC)+1) = IIDX-ord%FIRST(PROC)+1
            IF( (JJDX .GE. ord%FIRST(PROC)) .AND.                       &
     &           (JJDX .LE. ord%LAST(PROC)) ) THEN
            APNT(PROC)%BUF(2*SNDCNT(PROC)+2) = JJDX-ord%FIRST(PROC)+1
         ELSE
            APNT(PROC)%BUF(2*SNDCNT(PROC)+2) = -id%IRN_LOC(I)
         END IF
         SNDCNT(PROC) = SNDCNT(PROC)+1
         IF(SNDCNT(PROC) .EQ. BUFSIZE) THEN
            CALL DAGMG_MUMPS_SEND_BUF(APNT, PROC, NPROCS, BUFSIZE, IPE, PE,  &
     &           LENG, RCVBUF, MSGCNT, SNDCNT, id%COMM)
         END IF
      END IF
      END IF
      END DO
      CALL DAGMG_MUMPS_SEND_BUF(APNT, -1, NPROCS, BUFSIZE, IPE, PE, LENG,    &
     &     RCVBUF, MSGCNT, SNDCNT, id%COMM)
      DUPS = 0
      PNT = 0
      SAVEPNT = 1
      MAPTAB(:) = 0
      HALO_MAP(:) = 0
      HALO_SIZE = 0
      DO I=1, NROWS_LOC
         DO J=IPE(I),IPE(I+1)-1
            IF(PE(J) .LT. 0) THEN
               IF(HALO_MAP(-PE(J)) .EQ. 0) THEN
                  HALO_SIZE = HALO_SIZE+1
                  HALO_MAP(-PE(J)) = NROWS_LOC+HALO_SIZE
               END IF
               PE(J) = HALO_MAP(-PE(J))
            END IF
            IF(MAPTAB(PE(J)) .EQ. I) THEN
               DUPS = DUPS+1
               LENG(I) = LENG(I)-1
            ELSE
               MAPTAB(PE(J)) = I
               PNT = PNT+1
               PE(PNT) = PE(J)
            END IF
         END DO
         IPE(I) = SAVEPNT
         SAVEPNT = PNT+1
      END DO
      IPE(NROWS_LOC+1) = SAVEPNT
      CALL AGMG_MUMPS_733(I_HALO_MAP, HALO_SIZE, id%INFO, LP,                &
     &     MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      J=0
      DO I=1, id%N
         IF(HALO_MAP(I) .GT. 0) THEN
            J = J+1
            I_HALO_MAP(HALO_MAP(I)-NROWS_LOC) = I
         END IF
         IF(J .EQ. HALO_SIZE) EXIT
      END DO
      CALL AGMG_MUMPS_733(LENG, NROWS_LOC+HALO_SIZE, id%INFO,                &
     &     LP, COPY=.TRUE.,                                             &
     &     STRING='lcgrph:leng', MEMCNT=MEMCNT, ERRCODE=-7)
      LENG(NROWS_LOC+1:NROWS_LOC+HALO_SIZE) = 0
      CALL AGMG_MUMPS_733(IPE, NROWS_LOC+HALO_SIZE+1, id%INFO,               &
     &     LP, COPY=.TRUE.,                                             &
     &     STRING='lcgrph:ipe', MEMCNT=MEMCNT, ERRCODE=-7)
      IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      IPE(NROWS_LOC+2:NROWS_LOC+HALO_SIZE+1) = IPE(NROWS_LOC+1)
      GSIZE = NROWS_LOC + HALO_SIZE
      CALL AGMG_COPY(TOP_CNT, RCVCNT, 1, AGMG_MPF_INTEGER, IERR)
      RDISPL => MSGCNT
      NULLIFY(MSGCNT)
      IF(MYID.EQ.0) THEN
         NEW_LOCNNZ = sum(RCVCNT)
         RDISPL(1) = 0
         DO I=2, NPROCS
            RDISPL(I) = RDISPL(I-1)+RCVCNT(I-1)
         END DO
         top_graph%NZ_LOC = NEW_LOCNNZ
         top_graph%COMM = id%COMM
         CALL AGMG_MUMPS_733(top_graph%IRN_LOC, NEW_LOCNNZ, id%INFO,         &
     &        LP, MEMCNT=MEMCNT, ERRCODE=-7)
         CALL AGMG_MUMPS_733(top_graph%JCN_LOC, NEW_LOCNNZ, id%INFO,         &
     &        LP, MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
      ELSE
         ALLOCATE(top_graph%IRN_LOC(1), top_graph%JCN_LOC(1))
      END IF
      CALL AGMG_COPY(TSENDI, top_graph%IRN_LOC, TOP_CNT, AGMG_MPF_INTEGER, IERR)
      CALL AGMG_COPY(TSENDJ, top_graph%JCN_LOC, TOP_CNT, AGMG_MPF_INTEGER, IERR)
      CALL AGMG_MUMPS_734(SNDCNT, RCVCNT, RDISPL,                            &
     &        TSENDI, TSENDJ, MEMCNT=MEMCNT)
      DEALLOCATE(APNT)
      RETURN
      END SUBROUTINE DAGMG_MUMPS_BUILD_LOC_GRAPH
      SUBROUTINE DAGMG_MUMPS_SEND_BUF(APNT, PROC, NPROCS, BUFSIZE, IPE, PE,  &
     &     LENG, RCVBUF, MSGCNT, SNDCNT, COMM)
      IMPLICIT NONE
      INTEGER                 :: NPROCS, PROC, COMM
      TYPE(ARRPNT)            :: APNT(NPROCS)
      INTEGER                 :: BUFSIZE
      INTEGER, POINTER        :: RCVBUF(:), LENG(:), PE(:), IPE(:)
      INTEGER                 :: MSGCNT(NPROCS), SNDCNT(NPROCS)
      LOGICAL, SAVE           :: INIT = .TRUE.
      INTEGER, POINTER, SAVE  :: SPACE(:,:,:)
      LOGICAL, POINTER, SAVE  :: PENDING(:)
      INTEGER, POINTER, SAVE  :: REQ(:), CPNT(:)
      INTEGER                 :: IERR, MYID, I, SOURCE, J, TOTMSG
      LOGICAL                 :: FLAG, TFLAG
      INTEGER                 :: STATUS(AGMG_MPF_STATUS_SIZE),               &
     &     TSTATUS(AGMG_MPF_STATUS_SIZE)
      INTEGER, PARAMETER      :: ITAG=30, FTAG=31
      INTEGER, POINTER        :: TMPI(:), RCVCNT(:)
      CALL AGMG_SETIERR2( MYID, IERR)
      CALL AGMG_SETIERR12( NPROCS, IERR)
      IF(INIT) THEN
         ALLOCATE(SPACE(2*BUFSIZE, 2, NPROCS))
         ALLOCATE(RCVBUF(2*BUFSIZE))
         ALLOCATE(PENDING(NPROCS), CPNT(NPROCS))
         ALLOCATE(REQ(NPROCS))
         PENDING = .FALSE.
         DO I=1, NPROCS
            APNT(I)%BUF => SPACE(:,1,I)
            CPNT(I)   = 1
         END DO
         INIT = .FALSE.
         RETURN
      END IF
      IF(PROC .EQ. -1) THEN
         TOTMSG = sum(MSGCNT)
         DO
            IF(TOTMSG .EQ. 0) EXIT
            CALL AGMG_NOCALL('MPI_RECV')
            CALL DAGMG_MUMPS_ASSEMBLE_MSG(BUFSIZE, RCVBUF, IPE, PE, LENG)
            SOURCE = STATUS(AGMG_MPF_SOURCE)
            TOTMSG = TOTMSG-1
            MSGCNT(SOURCE+1)=MSGCNT(SOURCE+1)-1
         END DO
         DO I=1, NPROCS
            IF(PENDING(I)) THEN
               CALL AGMG_NOCALL('MPI_WAIT')
            END IF
         END DO
         ALLOCATE(RCVCNT(NPROCS))
         CALL AGMG_MPF_ALLTOALL(SNDCNT, 1, AGMG_MPF_INTEGER, RCVCNT, 1,           &
     &        AGMG_MPF_INTEGER, COMM, IERR)
         DO I=1, NPROCS
            IF(SNDCNT(I) .GT. 0) THEN
               TMPI => APNT(I)%BUF(:)
               CALL AGMG_NOCALL('MPI_ISEND')
            END IF
         END DO
         DO I=1, NPROCS
            IF(RCVCNT(I) .GT. 0) THEN
               CALL AGMG_NOCALL('MPI_RECV')
               CALL DAGMG_MUMPS_ASSEMBLE_MSG(RCVCNT(I), RCVBUF,              &
     &              IPE, PE, LENG)
            END IF
         END DO
         DO I=1, NPROCS
            IF(SNDCNT(I) .GT. 0) THEN
               CALL AGMG_NOCALL('MPI_WAIT')
            END IF
         END DO
         DEALLOCATE(SPACE)
         DEALLOCATE(PENDING, CPNT)
         DEALLOCATE(REQ)
         DEALLOCATE(RCVBUF, RCVCNT)
         nullify(SPACE, PENDING, CPNT, REQ, RCVBUF, RCVCNT)
         INIT = .TRUE.
         RETURN
      END IF
      IF(PENDING(PROC)) THEN
         DO
            CALL AGMG_MPF_TEST(REQ(PROC), TFLAG, TSTATUS, IERR)
            IF(TFLAG) THEN
               PENDING(PROC) = .FALSE.
               EXIT
            ELSE
               CALL AGMG_MPF_IPROBE( AGMG_MPF_ANY_SOURCE, ITAG, COMM,             &
     &              FLAG, STATUS, IERR )
               IF(FLAG) THEN
                  SOURCE = STATUS(AGMG_MPF_SOURCE)
                  CALL AGMG_NOCALL('MPI_RECV')
                  CALL DAGMG_MUMPS_ASSEMBLE_MSG(BUFSIZE, RCVBUF, IPE,        &
     &                 PE, LENG)
                  MSGCNT(SOURCE+1)=MSGCNT(SOURCE+1)-1
               END IF
            END IF
         END DO
      END IF
      TMPI => APNT(PROC)%BUF(:)
      CALL AGMG_NOCALL('MPI_ISEND')
      PENDING(PROC) = .TRUE.
      CPNT(PROC) = mod(CPNT(PROC),2)+1
      APNT(PROC)%BUF => SPACE(:,CPNT(PROC),PROC)
      SNDCNT(PROC)  = 0
      RETURN
      END SUBROUTINE DAGMG_MUMPS_SEND_BUF
      SUBROUTINE DAGMG_MUMPS_ASSEMBLE_MSG(BUFSIZE, RCVBUF, IPE, PE, LENG)
      IMPLICIT NONE
      INTEGER          :: BUFSIZE
      INTEGER, POINTER :: RCVBUF(:), IPE(:), PE(:), LENG(:)
      INTEGER          :: I, ROW, COL, IERR
      DO I=1, 2*BUFSIZE, 2
         ROW = RCVBUF(I)
         COL = RCVBUF(I+1)
         PE(IPE(ROW)+LENG(ROW)) = COL
         LENG(ROW) = LENG(ROW) + 1
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_ASSEMBLE_MSG
      SUBROUTINE DAGMG_MUMPS_BUILD_TREE(ord)
      TYPE(ORD_TYPE)  :: ord
      INTEGER :: I
      ord%SON     = -1
      ord%BROTHER = -1
      ord%NW      = 0
      DO I=1, ord%CBLKNBR
         ord%NW(I) = ord%NW(I)+ord%RANGTAB(I+1) - ord%RANGTAB(I)
         IF (ord%TREETAB(I) .NE. -1) THEN
            IF (ord%SON(ord%TREETAB(I)) .EQ. -1) THEN
               ord%SON(ord%TREETAB(I)) = I
            ELSE
               ord%BROTHER(I) = ord%SON(ord%TREETAB(I))
               ord%SON(ord%TREETAB(I)) = I
            END IF
            ord%NW(ord%TREETAB(I)) = ord%NW(ord%TREETAB(I))+ ord%NW(I)
         END IF
      END DO
      RETURN
      END SUBROUTINE DAGMG_MUMPS_BUILD_TREE
      SUBROUTINE DAGMG_MUMPS_MERGESWAP(N, L, A1, A2)
      INTEGER   :: I, LP, ISWAP, N
      INTEGER   :: L(0:N+1), A1(N), A2(N)
      LP = L(0)
      I  = 1
      DO
         IF ((LP==0).OR.(I>N)) EXIT
         DO
            IF (LP >= I) EXIT
            LP = L(LP)
         END DO
         ISWAP    = A1(LP)
         A1(LP)   = A1(I)
         A1(I)    = ISWAP
         ISWAP    = A2(LP)
         A2(LP)   = A2(I)
         A2(I)    = ISWAP
         ISWAP    = L(LP)
         L(LP) = L(I)
         L(I)  = LP
         LP = ISWAP
         I  = I + 1
      ENDDO
      END SUBROUTINE DAGMG_MUMPS_MERGESWAP
      SUBROUTINE DAGMG_MUMPS_MERGESORT(N, K, L)
      INTEGER    :: N
      INTEGER    :: K(N), L(0:N+1)
      INTEGER    :: P, Q, S, T, I
  100 CONTINUE
      L(0) = 1
      T = N + 1
      DO  P = 1,N - 1
         IF (K(P) <= K(P+1)) THEN
            L(P) = P + 1
         ELSE
            L(T) = - (P+1)
            T = P
       END IF
      END DO
      L(T) = 0
      L(N) = 0
      IF (L(N+1) == 0) THEN
         RETURN
      ELSE
         L(N+1) = IABS(L(N+1))
      END IF
  200 CONTINUE
      S = 0
      T = N+1
      P = L(S)
      Q = L(T)
      IF(Q .EQ. 0) RETURN
  300 CONTINUE
      IF(K(P) .GT. K(Q)) GOTO 600
  400 CONTINUE
      L(S) = SIGN(P,L(S))
      S = P
      P = L(P)
      IF (P .GT. 0) GOTO 300
  500 CONTINUE
      L(S) = Q
      S = T
      DO
         T = Q
         Q = L(Q)
         IF (Q .LE. 0) EXIT
      END DO
      GOTO 800
  600 CONTINUE
      L(S) = SIGN(Q, L(S))
      S = Q
      Q = L(Q)
      IF (Q .GT. 0) GOTO 300
  700 CONTINUE
      L(S) = P
      S = T
      DO
         T = P
         P = L(P)
         IF (P .LE. 0) EXIT
      END DO
  800 CONTINUE
      P = -P
      Q = -Q
      IF(Q.EQ.0) THEN
         L(S) = SIGN(P, L(S))
         L(T) = 0
         GOTO 200
      END IF
      GOTO 300
      END SUBROUTINE DAGMG_MUMPS_MERGESORT
      FUNCTION AGMG_MUMPS_GETSIZE(A)
      INTEGER, POINTER :: A(:)
      INTEGER          :: AGMG_MUMPS_GETSIZE
      IF(ASSOCIATED(A)) THEN
         AGMG_MUMPS_GETSIZE = SIZE(A)
      ELSE
         AGMG_MUMPS_GETSIZE = 0
      END IF
      RETURN
      END FUNCTION AGMG_MUMPS_GETSIZE
      SUBROUTINE AGMG_MUMPS_734(A1, A2, A3, A4, A5, A6, A7, MEMCNT)
      INTEGER, POINTER :: A1(:)
      INTEGER, POINTER, OPTIONAL :: A2(:), A3(:), A4(:), A5(:),         &
     &     A6(:), A7(:)
      INTEGER, OPTIONAL :: MEMCNT
      INTEGER :: IMEMCNT
      IMEMCNT = 0
      IF(ASSOCIATED(A1)) THEN
         IMEMCNT = IMEMCNT+SIZE(A1)
         DEALLOCATE(A1)
      END IF
      IF(PRESENT(A2)) THEN
         IF(ASSOCIATED(A2)) THEN
            IMEMCNT = IMEMCNT+SIZE(A2)
            DEALLOCATE(A2)
         END IF
      END IF
      IF(PRESENT(A3)) THEN
         IF(ASSOCIATED(A3)) THEN
            IMEMCNT = IMEMCNT+SIZE(A3)
            DEALLOCATE(A3)
         END IF
      END IF
      IF(PRESENT(A4)) THEN
         IF(ASSOCIATED(A4)) THEN
            IMEMCNT = IMEMCNT+SIZE(A4)
            DEALLOCATE(A4)
         END IF
      END IF
      IF(PRESENT(A5)) THEN
         IF(ASSOCIATED(A5)) THEN
            IMEMCNT = IMEMCNT+SIZE(A5)
            DEALLOCATE(A5)
         END IF
      END IF
      IF(PRESENT(A6)) THEN
         IF(ASSOCIATED(A6)) THEN
            IMEMCNT = IMEMCNT+SIZE(A6)
            DEALLOCATE(A6)
         END IF
      END IF
      IF(PRESENT(A7)) THEN
         IF(ASSOCIATED(A7)) THEN
            IMEMCNT = IMEMCNT+SIZE(A7)
            DEALLOCATE(A7)
         END IF
      END IF
      IF(PRESENT(MEMCNT)) MEMCNT = MEMCNT-IMEMCNT
      RETURN
      END SUBROUTINE AGMG_MUMPS_734
      END MODULE
